Lua_ScrollBoardCell = class("Lua_ScrollBoardCell", Lua_DisplayObject);
function Lua_ScrollBoardCell:ctor(p, skin)
	self.frameBuild = false;
	self:superCall("ctor", p, skin, false);
	self.boxW = 0;
	self.boxH = 0;
	self.itemX = 0;
	self.itemY = 0;
end

function Lua_ScrollBoardCell:checkSaveParam(key)
	if key == "onBuildingItem" or key == "checkSaveParam" or key == "saveFunKey" or key == "saveParam" or key == "setLocation" or key == "setBoxSize" then
		return false;
	end
	return self.skinBuilded == false;
end

function Lua_ScrollBoardCell:setLocation(posX, posY, posZ)
	self:superCall("setLocation", posX, posY, posZ);
	self.itemX = posX;
	self.itemY = posY;
	self:updateBound();
end

function Lua_ScrollBoardCell:updateBound()
	self.minX = self.itemX - self.boxW * self.scaleX / 2;
	self.maxX = self.itemX + self.boxW * self.scaleX / 2;
	self.minY = self.itemY - self.boxH * self.scaleY / 2;
	self.maxY = self.itemY + self.boxH * self.scaleY / 2;
end

function Lua_ScrollBoardCell:setLocationOffset(posX, posY, posZ)
    self:setLocation(self.itemX + posX, self.itemY + posY, posZ);
end

function Lua_ScrollBoardCell:isBounds(posX, posY)
	if posX >= self.minX and posX <= self.maxX and posY >= self.minY and posY <= self.maxY then
		return true;
	end
	return false;
end

function Lua_ScrollBoardCell:setBoxSize(boxW, boxH)
	self.boxW = boxW or 0;
	self.boxH = boxH or 0;
end	

function Lua_ScrollBoardCell:setData(data)
	
end

function Lua_ScrollBoardCell.Set:showIndex(value)
	self._showIndex = value;
	self.content.name = self.classname..tostring(self._showIndex);
end

function Lua_ScrollBoardCell.Get:showIndex()
	return self._showIndex;
end

function Lua_ScrollBoardCell:onPressClick(idx)
    
end

function Lua_ScrollBoardCell:dispose()
	self:superCall("dispose");
end