--联盟系统 联盟Data
checkRequire("Lua_AllianceMemberVo");
checkRequire("Lua_AllianceScienceConfigVo");
checkRequire("Lua_AllianceScienceTypeVo");
checkRequire("Lua_AllianceBossStageVo");
checkRequire("Lua_AllianceTreasuryVo");
checkRequire("Lua_AllianceRedPacketVo");
checkRequire("Lua_AllianceDealTypeVo");
Lua_AllianceData = class("Lua_AllianceData");

--联盟职位
Lua_AllianceData.COMMANDER = 1;      -- 会长
Lua_AllianceData.VICE_COMMANDER = 2; -- 副会长
Lua_AllianceData.ELITE_MEMBER = 3;   -- 精英
Lua_AllianceData.GENERAL_MEMBER = 4; -- 普通成员
--联盟操作
Lua_AllianceData.AUTH_VICE_COMMANDER = 1; -- 授权副会长
Lua_AllianceData.AUTH_ELITE_POSITION = 2; -- 授权精英职位
Lua_AllianceData.AUTH_GENERAL_MEMBER = 3; -- 授权普通成员
Lua_AllianceData.EXPEL_ALLIANCE = 4;      -- 逐出联盟
Lua_AllianceData.APPLY_HANDEL = 5;        -- 申请处理
Lua_AllianceData.HADN_OVER = 6;           -- 移交会长
Lua_AllianceData.MODIF_NOTICE = 7;        -- 修改公告
Lua_AllianceData.ENTER_ACTIVITY = 8;      -- 报名活动
Lua_AllianceData.DISMISS = 9;             -- 解散
Lua_AllianceData.MODIF_HEAD = 10;         -- 修改头像
Lua_AllianceData.SET_LEAGUE_INFO = 11;    -- 设置联盟信息
Lua_AllianceData.OPEN_LEAGUE_DARE = 12;   -- 开启联盟挑战
Lua_AllianceData.VIEW_MEMBER_INFO = 13;   -- 查看成员信息
Lua_AllianceData.EXIT_LEAGUE = 14;        -- 自愿退出联盟
Lua_AllianceData.MASS_LEAGUE_MAIL = 15;   -- 群发邮件
Lua_AllianceData.BOSS_ASSEMBLY = 16;      -- Boss集结号角
--红包主类型
Lua_AllianceData.RED_PACKET_LEAGUE = 1;  -- 联盟红包
Lua_AllianceData.RED_PACKET_WELFARE = 2; -- 福利红包
--宝库主类型
Lua_AllianceData.TREASURY_TYPE_ITEM = 1;  -- 1:道具
Lua_AllianceData.TREASURY_TYPE_CHIP = 2;  -- 2:碎片
Lua_AllianceData.TREASURY_TYPE_EQUIP = 3; -- 3:装备
Lua_AllianceData.TREASURY_TYPE_RUNE = 4;  -- 4:符文
--科技显示节点
Lua_AllianceData.SCIENTCE_POINT_NUM = 6;

function Lua_AllianceData:ctor()
	self:dispose();
end

function Lua_AllianceData:dispose()
	if self.leagueArr ~= nil then
		self.leagueArr:dispose();
		self.leagueArr = nil;
	end
	if self.leagueLimitArr ~= nil then
		self.leagueLimitArr:dispose();
		self.leagueLimitArr = nil;
	end
	self.leagueDic = nil;
	self.lastQuitTick = 0;

	self.myLeagueInfo = nil;
	self.curTreasuryType = nil;
	self.myContribTime = 0;

	self._redStateDic = nil;
	self._scienceInfoDic = nil;

	self.leagueRedPacketNum = 0;
	self.welfareRedPacketNum = 0;

	self.playRedPacketArr = nil;
	self.playRedPacketList = nil;

	-- 交易行
	self.curSelectType = 1;
	self.selectHeroVo = nil;
	self.selectHeroDic = {};
	self.convertHeroUid = nil;

	-- 心愿墙
	self._leftHelpTimes = nil;
	self._myWish = nil;
	self._openTick = nil;
	self._totalHelpTimes = nil;
	self._shareTimes = nil;
	self.isNeedSort = nil;
	self.isFirstAssistRed = nil;

	if self._allyWishDic ~= nil then
		for k,v in pairs(self._allyWishDic) do
			v = nil;
		end
	end
	self._allyWishDic = nil;

	if self._allyWishIdArr ~= nil then
		self._allyWishIdArr:dispose();
		self._allyWishIdArr:clear();
		self._allyWishIdArr = nil;
	end
	self._allyWishIdArr = nil;
	self:removeTimer();

	self:allianceFightDispose();
end

-------------------------------外部调用-------------------------------

function Lua_AllianceData.Get:isOpenKuafu()
	return DataCenter.funcOpenData:isOpened(10251);
end















-------------------------------主界面-------------------------------

function Lua_AllianceData:setLeagueDic(data)
	if self.leagueDic == nil then
		self.leagueDic = {};
	end
	self.leagueDic[data.id] = data;
end

function Lua_AllianceData:getLeagueDic(id)
	if self.leagueDic ~= nil then
		return self.leagueDic[id];
	end
	return nil;
end

function Lua_AllianceData:resetLeagueDic()
	if self.leagueDic ~= nil then
		self.leagueDic = {};
	end
	if self.leagueArr ~= nil then
		self.leagueArr:clear();
		self.leagueLimitArr:clear();
	end
end

function Lua_AllianceData:fromServer50106001(msg)--请求联盟列表(返回)
	self.lastQuitTick = tonumber(msg.last_quit_tick);
	self.isPageEnd = msg.is_last_num == 1; -- 是否是最后一页 1：是最后一页 0：不是

	if self.leagueArr == nil then
		self.leagueArr = Array();
		self.leagueLimitArr = Array();
	end
	for k, v in ipairs(msg.league_list) do
		if v.member_amount < v.max_member then
			self.leagueLimitArr:add(v.id);
		end
		self.leagueArr:add(v.id);
		self:setLeagueDic(v);
	end

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LIST");
end

function Lua_AllianceData:fromServer50106032(msg)--请求联盟搜索(返回)
	if self.leagueSearchArr == nil then
		self.leagueSearchArr = Array();
		self.leagueSearchLimitArr = Array();
	else
		self.leagueSearchArr:clear();
		self.leagueSearchLimitArr:clear();
	end

	for k, v in ipairs(msg.league) do
		if v.member_amount < v.max_member then
			self.leagueSearchLimitArr:add(v.id);
		end
		self.leagueSearchArr:add(v.id);
		self:setLeagueDic(v);
	end

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_SEARCH_LIST");
end

function Lua_AllianceData:fromServer50106004(msg)--请求申请加入联盟(返回)
	local data;
	for k, v in ipairs(msg.league_info) do
		data = self:getLeagueDic(v.id);
		if data ~= nil then
			data.has_apply = v.has_apply;
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LIST_APPLY");
end

function Lua_AllianceData:setLeagueInfo(msg)
	self.id = tonumber(tostring(msg.id));--联盟id
	self.head = msg.head;--联盟头像
	self.name = msg.name;--联盟名称
	self.level = msg.level;--联盟等级
	self.memberAmount = msg.member_amount;--当前成员数
	self.maxMember = msg.max_member;--最大成员数上限
	self.force = tonumber(tostring(msg.force));--战力
	self.rank = msg.rank;--排名
	self.hasApply = msg.has_apply;--是否已申请加入该联盟, 0 未申请，1 已申请
	self.levelCond = msg.level_cond;--等级条件
	self.forceCond = msg.force_cond;--战力条件
	self.autoJoin = msg.auto_join;--自动加入 1:自动加入 0：不自动加入
	self.declaration = msg.declaration;--联盟宣言
	self.leaderName = msg.leader_name;--会长名字
	self.buildExp = tonumber(tostring(msg.build_val));--建设值
	self.leftMailNum = msg.left_mail_num;--当日群发邮件次数
	self.startDiscussTick = tonumber(tostring(msg.start_discuss_tick));--开始解散联盟时间
	self.serverFlag = msg.server_flag; -- 服务器标识
	self.serverPrev = msg.server_prev; -- 服务器前缀
end


function Lua_AllianceData:fromServer50106002(msg)--请求联盟界面信息(返回)
	self.leaderInfoList = msg.leader_info;
	self.active_value = msg.active_value;
	self:setLeagueInfo(msg.league);

	self.logList = msg.log_list;--日志列表
	table.sort(self.logList, function(a, b) return a.log_tick >= b.log_tick end)

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
end

function Lua_AllianceData:fromServer50106018(msg)--请求联盟群发邮件返回
	self.leftMailNum = msg.left_mail_num; -- 剩余群发邮件次数
end

function Lua_AllianceData:fromServer80106009(msg)--通知玩家联盟信息
	print("公会更新类型：" .. msg.type)
	local types = msg.type;
	if types == 1 then--1.联盟头像变化
		self.head = msg.league_info.head;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	elseif types == 2 then--2.联盟等级变化
		DataCenter.roleData.league_level = msg.league_info.level;
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetAllianceInfo();
	elseif types == 5 then--5.联盟职位变化 
		DataCenter.roleData.league_position = msg.league_position;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_POSITION");
	elseif types >= 3 and types <= 8 and types ~= 5 then--3.加入联盟 4.退出联盟 6.创建联盟 7.踢出联盟通知 8.解散联盟通知
		self:setLeagueInfo(msg.league_info);
		DataCenter.roleData:updateAllianceInfo(self.id, self.name, msg.league_position, self.level);
		Lua_MsgUtil.callFunc("CHECK_LEAGUE_INFO");

		if types == 7 then
			OperateAlert.show(LanUtil.formateStr(201252, self.name));
		end
		if types == 3 or types == 6 then
			-- if DataCenter.funcOpenData:isOpened(10287) then -- 刷新交易行红点
			-- 	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance();
			-- end
			if DataCenter.funcOpenData:isOpened(10309) then -- 联盟-心愿墙
				Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueWishWallInfo(0);
				Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueWishWallTaskInfo();
			end
			if DataCenter.funcOpenData:isOpened(10277) then -- 公会对抗
				Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteInfo();
				Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteReward();
			end
		elseif types == 4 or types == 7 or types == 8 then
			Lua_MsgUtil.callFunc("CLOSE_LEAGUE_OTHER_WINDOW");

			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LeagueCompeteReward, false); -- 公会对抗奖励红点

			-- self:checkDealRedPoint(); -- 刷新公会交易行红点
			self:clearWishaWallRed();
		end

		self:updateRedPoint(); -- 刷新公会科技红点
	elseif types == 9 then -- 联盟活跃度更新
		self.active_value = msg.active_value;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_ACTIVE_VALUE");
	elseif types == 10 then -- 通知联盟建设值更新
		self.buildExp = msg.league_info.build_val;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	end
end

function Lua_AllianceData:fromServer80106066(msg)--更新红点
	if self._redStateDic == nil then
		self._redStateDic = {};
	end
	for k, v in ipairs(msg.red_state_list) do
		self._redStateDic[v.key] = v.value; -- value: 1：有红点 0：没有红点
	end

	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueRedPacketRob, self:getRedDotState(1));
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueRedPacketWelfare, self:getRedDotState(6));

	local state = self:getRedDotState(2) == 1 or self:getRedDotState(8) == 1; -- 挑战次数,抢夺次数和可抢夺
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LeagueCompeteNum, state);
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueCompeteLogUpdate, self:getRedDotState(4)); -- 公会对抗日志更新
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueCompeteLogSluff, self:getRedDotState(7)); -- 公会对抗日志回抢

	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueGrowth, self:getRedDotState(3));
	
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueBoss, self:getRedDotState(5));
end

function Lua_AllianceData:getRedDotState(key)
	if self._redStateDic == nil then
		return 0;
	end
	if self._redStateDic[key] == nil then
		self._redStateDic[key] = 0;
	end
	return self._redStateDic[key];
end


















-------------------------------成员管理-------------------------------

function Lua_AllianceData:fromServer50106008(msg)--请求解散联盟(返回)
	self.startDiscussTick = tonumber(msg.start_dismiss_tick);
	Lua_MsgUtil.callFunc("START_DISMISS_LEAGUE");
end

function Lua_AllianceData:fromServer50106010(msg)--请求联盟成员列表(返回)
	self.memberArr = Array();
	self.memberList = {};

	local vo;
	local viceLeaderNum = 0;
	local eliteNum = 0;
	for k, v in ipairs(msg.member_list) do
		vo = Lua_AllianceMemberVo.new(v);
		self.memberArr:add(vo);
		self.memberList[tonumber(vo.roleId)] = vo;

		if vo.position == Lua_AllianceData.VICE_COMMANDER then
			viceLeaderNum = viceLeaderNum + 1;
		elseif vo.position == Lua_AllianceData.ELITE_MEMBER then
			eliteNum = eliteNum + 1;
		end
	end
	self.memberArr:sort("sort", true);
	self.viceLeaderCount = viceLeaderNum;
	self.eliteCount = eliteNum;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:fromServer50106005(msg)--请求联盟申请审核(返回)
	-- 申请信息
	self:updataApplyList(msg.apply_member_info);

	-- 社区人数已满
	local limitNum = msg.is_over_limit;
	if limitNum ~= nil and limitNum == 1 then
		OperateAlert.showLangValue(201139);
	end

	-- 玩家已在其他联盟
	if msg.join_other_league_role_list ~= nil and #msg.join_other_league_role_list > 0 then
		for i = 1, #msg.join_other_league_role_list do
			OperateAlert.showLangValue(201233);
		end
	end

	self.memberAmount = msg.member_num; -- 成员数量
	self.force = tonumber(msg.force); -- 联盟战力
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
end

function Lua_AllianceData:fromServer50106007(msg)--请求逐玩家出联盟(返回)
	if self.memberArr ~= nil then
		local vo = self.memberList[tonumber(msg.member_id)];
		if vo ~= nil then
			self.memberArr:removeItem(vo);
			self.memberList[tonumber(msg.member_id)] = nil;
		end
	end

	self.memberAmount = msg.member_num; -- 成员数量
	self.force = tonumber(msg.force); -- 联盟战力
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");

	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:fromServer50106011(msg)--请求任命成员职务(返回)
	local vo = self.memberList[tonumber(msg.member_info.member_id)];
	if vo ~= nil then
		if vo.position == Lua_AllianceData.VICE_COMMANDER then
			self.viceLeaderCount = self.viceLeaderCount - 1;
		elseif vo.position == Lua_AllianceData.ELITE_MEMBER then
			self.eliteCount = self.eliteCount - 1;
		end

		vo.position = msg.member_info.member_position;

		if vo.position == Lua_AllianceData.VICE_COMMANDER then
			self.viceLeaderCount = self.viceLeaderCount + 1;
		elseif vo.position == Lua_AllianceData.ELITE_MEMBER then
			self.eliteCount = self.eliteCount + 1;
		end
	end
	self.memberArr:sort("sort", true);
	OperateAlert.showLangValue(201143);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:fromServer50106012(msg)--请求转让会长(返回)
	local vo;
    for k, v in ipairs(msg.member_info) do
    	vo = self.memberList[tonumber(v.member_id)];
    	if vo ~= nil then
    		vo.position = v.member_position;
    	end
    end
	self.memberArr:sort("sort", true);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");

	OperateAlert.showLangValue(201253);
end

function Lua_AllianceData:updataApplyList(data)--更新联盟申请列表
	local arr = Array();
	local vo;
	for k, v in ipairs(data) do--申请列表
		vo = Lua_AllianceMemberVo.new(v);
		arr:add(vo);
	end
	arr:sort("sortTime", true);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_APPLYLIST", arr);
end

function Lua_AllianceData:fromServer50106015(msg)--请求联盟日志列表(返回)
	local LogList = {};
	for k, v in ipairs(msg.log_list) do--日志列表
		if LogList[v.type] == nil then
			LogList[v.type] = Array();

			if LogList[0] == nil then
				LogList[0] = Array();
			end
		end
		LogList[0]:add(v);
		LogList[v.type]:add(v);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LOGLIST", LogList);
end

function Lua_AllianceData:fromServer50106028(msg)--请求联盟设置返回
	self.levelCond = msg.level_cond;
	self.forceCond = msg.force_cond;
	self.autoJoin = msg.auto_join;
	self.declaration = msg.declaration;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
end

function Lua_AllianceData.Get:getCurLevelVo()
	if self._curLevelVo == nil or self._curLevelVo.id ~= self.level then
		self._curLevelVo = Lua_AllianceLevelVo.new(self.level);
	end
	return self._curLevelVo;
end

function Lua_AllianceData.Get:getDiscussRemainTime()
	if self.startDiscussTick == nil or tonumber(self.startDiscussTick) <= 0 then
		return 0;
	end

	if self._dissolveSureTime == nil then
		self._dissolveSureTime = DataCenter.allianceUtil:getConstConfig("league_dissolve_sure_time", 1);
	end
	return self._dissolveSureTime - (DataCenter.roleData.serverTime - self.startDiscussTick);
end

function Lua_AllianceData.Get:showLeagueName()
	if self.isOpenKuafu and not strIsNullOrEmpty(self.serverPrev) then
		return LanUtil.formateStr(201249, self.name, self.serverPrev);
	else
		return self.name;
	end
end

function Lua_AllianceData:getCurDutyPower(type)
	return DataCenter.allianceUtil:getDutyPower(DataCenter.roleData.league_position, type);
end























-------------------------------联盟排名-------------------------------

function Lua_AllianceData:fromServer50106017(msg)--请求联盟排行信息返回
	self.curPage = msg.num; -- 第几页
	self.isPageEnd = msg.is_last_num == 1; -- 是否是最后一页 1：是最后一页 0：不是

	if self.curPage == 1 then
		self.leagueRankArr = Array();
	end
	for k, v in ipairs(msg.league_list) do
		self.leagueRankArr:add(v);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_RANK", msg);
end




















-------------------------------联盟科技-------------------------------

function Lua_AllianceData:updateScienceInfo(msg, isPlayEff)--请求联盟科技界面(返回)
	self.isPlayEff = isPlayEff;
	if msg.science_type ~= nil then
		if not self.isPlayEff or not self:checkSaveScience(msg) then
			self:setScienceInfoDic(msg);
		end
	else
		for i = 1, #msg do
			self:setScienceInfoDic(msg[i]);
		end
	end
	self:updateRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_SCIENCEINFO");
end

function Lua_AllianceData:resetScienceInfo(msg)
	self:updateScienceInfo(msg.league_science, false);

	-- 刷新公会交易行
	-- Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance();
end

function Lua_AllianceData:checkSaveScience(msg)
	local index = DataCenter.allianceUtil:getScienceNode(msg.science_id);
	if index == Lua_AllianceData.SCIENTCE_POINT_NUM then
		self._saveScienceMsg = msg;
		return true;
	end
	return false;
end

function Lua_AllianceData:refreshLastScienceInfo()
	if self._saveScienceMsg ~= nil then
		self:setScienceInfoDic(self._saveScienceMsg);
		self._saveScienceMsg = nil;
	end
end

function Lua_AllianceData:setScienceInfoDic(msg)
	if self._scienceInfoDic == nil then
		self._scienceInfoDic = {};
	end

	local _type = msg.science_type;
	if self._scienceInfoDic[_type] ~= nil then
		self._scienceInfoDic[_type]:fromServer(msg);
	else
		self._scienceInfoDic[_type] = Lua_AllianceScienceTypeVo.new(msg);
	end
end

function Lua_AllianceData:getScienceInfo(_type)
	if self._scienceInfoDic ~= nil then
		return self._scienceInfoDic[_type];
	end
	return nil;
end

function Lua_AllianceData:updateRedPoint()
	if self._scienceInfoDic ~= nil then
		local isJoin = DataCenter.roleData:isJoinTheLeague();
		local redDotId;
		for k, v in pairs(self._scienceInfoDic) do
			redDotId = DataCenter.allianceUtil:getScienceRedDot(k);
			DataCenter.redPointData:updateRedPointState(redDotId, isJoin and v:updateRedState());
		end
	end
end
























-------------------------------联盟Boss-------------------------------

function Lua_AllianceData:fromServer50106023(msg)--请求联盟BOSS界面(返回)
	self.showId = msg.show_id;--显示的关卡id
	self.topId = msg.top_id;--当前最高可挑战关卡id
	self.topState = msg.top_state;--当前最高关卡状态 0：未通关 1:已通关
	self.leftBlood = tonumber(tostring(msg.left_blood));--显示关卡的剩余血量
	self.maxBlood = tonumber(tostring(msg.max_blood));--boss最大血量
	self.leftTimes = msg.left_times;--剩余次数
	self.leftBuyTimes = msg.left_buy_times;--剩余可购次数
	self.lastHurt = msg.last_hurt;--上一轮挑战伤害
	self.buffAdd = msg.buff_add;--buff加成百分比
	self.buffLast = msg.buff_last;--buff剩余时间 单位秒
	self.coolEndTick = msg.cool_end_tick;--号角冷却结束时间
	self.topFight = msg.top_fight;--本人今日是否有挑战过当前最高关卡， 0 没有，1有
	self.rankList = msg.rank_list;--伤害前三
	self.is_have_kill = msg.is_have_kill; -- 是否击杀过本章boss 0未击杀过 1击杀过

	self.bossStageInfo = Lua_AllianceBossStageVo.new(self.showId);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer50106024(msg)--请求联盟BOSS的伤害排行(返回)
	self.rankStageId = msg.stage_id;
	self.leftPraiseNum = msg.left_praise_num;
	self.myBossHurtInfo = msg.self_rank;

	self.bossHurtArr = Array();
	self.bossHurtList = {};
	local vo;
	for k, v in ipairs(msg.rank_list) do
		vo = {};
		vo.rank = v.rank;
		vo.playerId = tonumber(v.player_id);
		vo.playerName = v.player_name;
		vo.headIcon = v.head_icon;
		vo.hurt = v.hurt;
		vo.fightRecordId = tonumber(v.fight_record_id);
		vo.praiseNum = tonumber(v.praise_num);
		vo.isPraised = v.is_praised;--是否有点赞 0未点赞 1已点赞
		self.bossHurtArr:add(vo);
		self.bossHurtList[vo.playerId] = vo;
	end
	self.bossHurtArr:sort("rank", false);

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSHURTRANK");
end

function Lua_AllianceData:fromServer50106026(msg)--请求联盟BOSS扫荡(返回)
	if self.showId ~= msg.stage_id then
		self.bossStageInfo = Lua_AllianceBossStageVo.new(msg.stage_id);
	end
	
	self.showId = msg.stage_id;
	self.topId = msg.top_stage_id;
	self.leftBlood = tonumber(tostring(msg.boss_left_blood));
	self.maxBlood = tonumber(tostring(msg.max_blood));
	self.leftTimes = msg.left_free_times;
	self.leftBuyTimes = msg.left_buy_times;
	self.rankList = msg.rank_list;
	self.lastHurt = msg.last_hurt;
	self.buffAdd = msg.buff_add;
	self.buffLast = msg.buff_add_expired_tick;
	self.is_have_kill = msg.is_have_kill;

	OperateAlert.show(LanUtil.formateStr(201180, msg.boss_hurt));

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer80106027(msg)--通知boss挑战结果
	if self.showId ~= msg.stage_id then
		self.bossStageInfo = Lua_AllianceBossStageVo.new(msg.stage_id);
	end
	
	self.showId = msg.stage_id;
	self.topId = msg.top_stage_id;
	self.leftBlood = tonumber(tostring(msg.left_blood));
	self.maxBlood = tonumber(tostring(msg.max_blood));
	self.leftTimes = msg.left_free_time;
	self.leftBuyTimes = msg.left_buy_time;
	self.coolEndTick = msg.cool_end_tick;
	self.buffAdd = msg.buff_add;
	self.buffLast = msg.buff_add_expired_tick;
	self.rankList = msg.rank_role_list;
	self.lastHurt = msg.boss_hurt;--boss伤害
	self.is_have_kill = msg.is_have_kill;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer50106030(msg)--请求联盟boss次数购买(返回)
	self.leftTimes = msg.left_free_times;
	self.leftBuyTimes = msg.left_buy_times;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer50106031(msg)--请求联盟boss集结(返回)
	self.coolEndTick = msg.cool_end_tick;--号角冷却结束时间
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_MASSCOOL");
end

function Lua_AllianceData:fromServer50106034(msg)--请请求增加联盟boss的buff效果(返回)
	self.buffAdd = msg.buff_add;
	self.buffLast = msg.buff_expired_tick;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSBUFF");
end

function Lua_AllianceData:fromServer50106036(msg)--请求伤害排行点赞返回
	self.leftPraiseNum = msg.left_praise_num;

	local vo;
	if self.bossHurtList ~= nil then
		vo = self.bossHurtList[tonumber(msg.role_id)];
	end
	if vo ~= nil then
		vo.praiseNum = tonumber(msg.praise_num);
		vo.isPraised = 1;--是否有点赞 0未点赞 1已点赞
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSHURTRANK");
end




















-------------------------------联盟成长-------------------------------

function Lua_AllianceData:fromServer50106038(msg)--请求联盟成长信息返回
	self.dailyBuildVal = msg.daily_build_val;--今日建设值
	self.weekBuildVal = msg.week_build_val;--本周建设值

	self.lvlRewardList = {};
	for k, v in ipairs(msg.lvl_reward) do --等级奖励 key:等级 value:0:不可领取 1可领取 2已领取
		self.lvlRewardList[v.key] = v;
	end

	self.taskTimeArr = {};
	for k, v in ipairs(msg.build_task_info) do--建设任务信息 key：任务Id value：完成次数
		self.taskTimeArr[v.key] = v.value;
	end

	self:updateContribInfo(msg.contrib_info);

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_GROWUPINFO");
end

function Lua_AllianceData:fromServer50106019(msg)--请求联盟捐献(返回)
	OperateAlert.showLangValue(201258);
end

function Lua_AllianceData:fromServer50106020(msg)--请求联盟领取捐献累积礼包(返回)
	self:updateContribInfo(msg.league_contrib);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REWARDGIFT");
end

function Lua_AllianceData:updateContribInfo(msg)
	self.curContribValue = msg.league_contrib;--联盟贡献值

	self.myContribTime = 0;--捐献次数
	if self.myContribInfo == nil then
		self.myContribInfo = {};--贡献信息
	end
	for k, v in ipairs(msg.contrib_info) do
		self.myContribInfo[v.key] = v.value;
		self.myContribTime = self.myContribTime + v.value;
	end
	self.isContribLimit = self.myContribTime >= DataCenter.allianceUtil:getConstConfig("daily_contri_limit", 1);--是否达到每日捐献上限

	if self.contribRewardInfo == nil then
		self.contribRewardInfo = {};--贡献奖励领取信息
	end
	for k, v in ipairs(msg.daily_contrib_reward) do
		self.contribRewardInfo[v.key] = v.value;
	end
end

function Lua_AllianceData:updateLevelRewardInfo(msg)
	self.lvlRewardList[msg.cur_lvl_reweard.key] = msg.cur_lvl_reweard;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LEVELREWARD");
end

function Lua_AllianceData.Get:getCurLevelReward()
	if self.lvlRewardList ~= nil then
		local noReward = nil;
		local hasReward = nil;
		local lastReward = nil;
		for k, v in pairs(self.lvlRewardList) do
			if v.value == 0 and noReward == nil then
				noReward = v;
			elseif v.value == 1 and hasReward == nil then
				hasReward = v;
			end
			lastReward = v;
		end

		if hasReward ~= nil then
			return hasReward;
		elseif noReward ~= nil then
			return noReward;
		else
			return lastReward;
		end
	end
	return nil;
end

function Lua_AllianceData:levelRewardState(level)
	local state = 0;
	if self.lvlRewardList ~= nil and self.lvlRewardList[level] then
		state = self.lvlRewardList[level].value;
	end
	return state;
end






























-------------------------------联盟宝库-------------------------------

function Lua_AllianceData:updateAllianceTreasuryInfo(msg)--请求联盟宝库信息返回
	local id;
	local vo;
	local treasuryVoList = {};
	self.treasuryNumList = {};
	for k, v in ipairs(msg.goods_info) do
		id = v.item.id;
		vo = Lua_AllianceTreasuryVo.new(id);
		vo:fromServer(v);

		if treasuryVoList[id] == nil then
			treasuryVoList[id] = Array();
		end
		treasuryVoList[id]:add(vo);

		if self.treasuryNumList[id] == nil then
			self.treasuryNumList[id] = 0;
		end
		self.treasuryNumList[id] = self.treasuryNumList[id] + 1;
	end

	self.treasuryLog = msg.transaction_record;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_TREASURY_INFO", treasuryVoList);
end

function Lua_AllianceData:showAllianceTreasuryItemInfo(msg)--请求联盟宝库商品信息返回
	local vo;
	if msg.treasury_type == Lua_AllianceData.TREASURY_TYPE_EQUIP then
		vo = Lua_ToolVo.new(msg.equip_info.id);
		vo:fromServer(msg.equip_info);
	elseif msg.treasury_type == Lua_AllianceData.TREASURY_TYPE_RUNE then
		vo = Lua_ToolVo.new(msg.rune_info.id);
		vo:fromServer(msg.rune_info);
	end

	if vo ~= nil then
		DataCenter.packUtil:showItemInfo(vo, false);
	end
end





















-------------------------------联盟红包-------------------------------

function Lua_AllianceData:fromServer80106037(msg)--通知联盟红包有联盟红包可领
	if self.playRedPacketArr == nil then
		self.playRedPacketArr = Array();
		self.playRedPacketList = {};
	end

	local uid = tonumber(msg.red_pack_uid); 
	if msg.is_draw_done == 0 then
		if self.playRedPacketList[uid] == nil and DataCenter.sceneData.curSceneId == Lua_SceneDefine.MAINCITY 
			and Lua_WindowUtil.isWindowShowing("Lua_MainMenuWindow") then

			self.playRedPacketArr:add(uid);
			self.playRedPacketList[uid] = msg;
			Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET_NOTICE");
		end
	else
		self:removePlayRedPacket(uid, true);
	end
end

function Lua_AllianceData:removePlayRedPacket(uid, isSend)
	if self.playRedPacketList ~= nil and self.playRedPacketList[uid] ~= nil then
		self.playRedPacketArr:removeItem(uid);
		self.playRedPacketList[uid] = nil;

		if isSend then
			Lua_MsgUtil.callFunc("REMOVE_LEAGUE_REDPACKET", uid);
		end
	end
end

function Lua_AllianceData:getPlayRedPacketArr()
	if self.playRedPacketArr ~= nil and self.playRedPacketArr:getSize() > 0 then
		local isCheck1 = self:getRedPacketLeftNum(Lua_AllianceData.RED_PACKET_LEAGUE) <= 0;
		local isCheck2 = self:getRedPacketLeftNum(Lua_AllianceData.RED_PACKET_WELFARE) <= 0;
		if isCheck1 or isCheck2 then
			local arr = Array();
			local data;
			for i = 1, self.playRedPacketArr:getSize() do
				data = self:getPlayRedPacketInfo(self.playRedPacketArr[i]);
				if (isCheck1 and data.red_pack_type == Lua_AllianceData.RED_PACKET_LEAGUE)
					or (isCheck2 and data.red_pack_type == Lua_AllianceData.RED_PACKET_WELFARE) then
					arr:add(self.playRedPacketArr[i]);
				end
			end

			for i = 1, arr:getSize() do
				self:removePlayRedPacket(arr[i], false);
			end
		end
	end
	return self.playRedPacketArr;
end

function Lua_AllianceData:getPlayRedPacketInfo(uid)
	if self.playRedPacketList ~= nil and self.playRedPacketList[uid] ~= nil then
		return self.playRedPacketList[uid];
	end
	return nil;
end

function Lua_AllianceData:clearAllPlayRedPacket()
	self.playRedPacketArr = nil;
	self.playRedPacketList = nil;
end

function Lua_AllianceData:fromServer50106047(msg)--请求联盟红包信息返回
	self.robRedPacketArr = Array();
	local vo;
	for k, v in ipairs(msg.red_pack_info) do
		vo = Lua_AllianceRedPacketVo.new(v.red_pack_conf_id, v.red_pack_type);
		vo:updateRobInfo(v);
		self.robRedPacketArr:add(vo);
	end

	local info = msg.left_red_pack_draw_times;
	for i = 1, #info do
		if info[i].key == Lua_AllianceData.RED_PACKET_LEAGUE then
			self.leagueRedPacketNum = info[i].value;
		elseif info[i].key == Lua_AllianceData.RED_PACKET_WELFARE then
			self.welfareRedPacketNum = info[i].value;
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_ROB_REDPACKET");
end

function Lua_AllianceData:fromServer50106049(msg)--请求领取联盟红包返回
	if self.robRedPacketArr ~= nil then
		for i = 1, self.robRedPacketArr:getSize() do
			if self.robRedPacketArr[i].redPackUid == tonumber(msg.red_pack_uid) then
				self.robRedPacketArr[i].state = msg.draw_state;
				break;
			end
		end
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_ROB_REDPACKET");
	end
	self:removePlayRedPacket(tonumber(msg.red_pack_uid), true);
end

function Lua_AllianceData:updateAllianceRedPacket(msg)--更新联盟红包信息
	local arr = Array();
	local vo;
	for k, v in ipairs(msg) do
		vo = Lua_AllianceRedPacketVo.new(v.key, Lua_AllianceData.RED_PACKET_LEAGUE);
		vo:updateSendInfo(v);
		arr:add(vo);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET", arr);
end

function Lua_AllianceData:updateWelfareRedPacket(msg)--更新福利红包信息
	local arr = DataCenter.allianceUtil:getWelfareRedPacketArr();
	for i = 1, arr:getSize() do
		arr[i]:dispose();
	end

	local vo;
	for k, v in ipairs(msg) do
		vo = DataCenter.allianceUtil:getWelfareRedPacketVo(v.key);
		vo:updateSendInfo(v);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_WELFARE_REDPACKET");
end

function Lua_AllianceData:fromServer80106067(msg)
	local lastNum;
	if msg.key == Lua_AllianceData.RED_PACKET_LEAGUE then
		lastNum = self.leagueRedPacketNum;
		self.leagueRedPacketNum = msg.value;
	elseif msg.key == Lua_AllianceData.RED_PACKET_WELFARE then
		lastNum = self.welfareRedPacketNum;
		self.welfareRedPacketNum = msg.value;
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET_LEFT_NUM");

	if lastNum ~= 0 and msg.value == 0 then
		Lua_MsgUtil.callFunc("REFRESH_LEAGUE_REDPACKET_NOTICE");
	end
end

function Lua_AllianceData:getRedPacketLeftNum(types)
	if types == Lua_AllianceData.RED_PACKET_LEAGUE then
		return self.leagueRedPacketNum;
	elseif types == Lua_AllianceData.RED_PACKET_WELFARE then
		return self.welfareRedPacketNum;
	end
	return 0;
end



























-------------------------------联盟挑战-------------------------------

function Lua_AllianceData:fromServer50106051(msg)--请求开启联盟挑战返回
	self.challengeId = msg.challenge_id;--联盟挑战id

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallenge(0);
end

function Lua_AllianceData:fromServer50106052(msg)--更新联盟挑战界面
	self.challengeId = msg.challenge_id;--联盟挑战id
	self.challengeStartTick = msg.challenge_start_tick;--挑战开始时间
	self.challengeLeftBlood = msg.boss_left_blood;--boss剩余血量
	self.lastChallengeHurt = msg.last_challenge_hurt;--上次挑战伤害
	self.challengeRanklist = msg.role_list;--伤害前三
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	self:updateChallengRewardInfo(msg.blood_reward_info);
	
	if tonumber(self.challengeId) == 0 then
		local defaultChallengeId;
		if self.challengeType ~= nil then
			defaultChallengeId = DataCenter.allianceUtil:getChallengeDefaultId(self.challengeType);
		else
			defaultChallengeId = DataCenter.allianceUtil:getChallengeDefaultId(1);
		end

		self.challengeInfo = DataCenter.allianceUtil:getChallengeConfigVo(defaultChallengeId);
		self.isOpenChallenge = false;
	else
		self.challengeInfo = DataCenter.allianceUtil:getChallengeConfigVo(self.challengeId);
		self.isOpenChallenge = self.judgeChallengeOpen;
	end
	self.challengeType = self.challengeInfo.boss_type;

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer50106056(msg)--请求联盟挑战扫荡返回
	self.challengeStartTick = msg.challenge_start_tick;--挑战开始时间
	self.challengeLeftBlood = msg.boss_left_blood;--boss剩余血量
	self.challengeRanklist = msg.role_list;--伤害前三
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	self:updateChallengRewardInfo(msg.blood_reward_info);

	self.isOpenChallenge = self.judgeChallengeOpen;
	
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer80106057(msg)--通知联盟挑战信息
	self.challengeId = msg.challenge_id;--联盟挑战id
	self.challengeLeftBlood = msg.boss_left_blood;--boss剩余血量
	self.lastChallengeHurt = msg.boss_hurt;--boss伤害
	self.challengeRanklist = msg.role_list;--伤害前三
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	self:updateChallengRewardInfo(msg.boss_blood_reward );

	self.challengeInfo = DataCenter.allianceUtil:getChallengeConfigVo(self.challengeId);
	self.challengeType = self.challengeInfo.boss_type;

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer50106059(msg)--购买联盟挑战次数返回
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer50106060(msg)--请求弹劾联盟主管返回
	local obj;
	local vo;
	for i = 1, #msg.member_info do
		obj = msg.member_info[i];
		vo = self.memberList[tonumber(obj.member_id)];
		if vo ~= nil then
			vo.position = obj.member_position;
		end
	end
	self.memberArr:sort("sort", true);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:updateChallengRewardInfo(msg)--更新联盟挑战奖励信息
	self.challengeRewardInfo = {};
	for k, v in ipairs(msg) do
		self.challengeRewardInfo[v.key] = v.value;
	end
end

function Lua_AllianceData.Get:judgeChallengeOpen()
	if self.challengeStartTick ~= nil and self.challengeStartTick ~= 0 then
		local time = DataCenter.roleData.serverTime - self.challengeStartTick;
		if time <= DataCenter.allianceUtil:getConstConfig("league_challenge_tick", 1) then
			return true;
		end
	end
	return false;
end














-------------------------------公会对抗-------------------------------

function Lua_AllianceData:fromServer50106062(msg)--请求公会对抗信息返回
	self.competeStage = msg.stage; --阶段 1：对抗期 2：休赛期
	self.competeJoinType = msg.join_ype; --1.参与公会对抗 2.本周创建的对抗未能参与 3.不满足活跃条件未能参数
	self.competeEndTick = msg.stage_end_tick; --阶段结束时间
	self.competeFightNum = msg.left_fight_times; --剩余挑战次数
	self.competeGrabNum = msg.left_grab_times; --剩余抢夺次数
	self.competeSluffbNum = msg.left_recapture_times; --剩余回抢次数
	self.competeBossId = msg.boss_id; --BossId
	self.competeMyRank = msg.self_rank; --自己排名信息
	self.competeOtherRank = msg.match_rank; --对方排名相等信息
	self.competeUsInfo = msg.self_league_info; --己方公会对抗排行信息
	self.competeMatchInfo = msg.match_league_info; --匹配的公会对抗排行信息
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_INFO");
end

function Lua_AllianceData:fromServer50106063(msg)--请求公会对抗日志返回
	self.competeLogType = msg.type;
	self.isPageEnd = msg.is_end == 1;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_LOG", msg.log_list);
end

function Lua_AllianceData:fromServer50106064(msg)--请求公会对抗伤害排名返回
	self.isPageEnd = msg.is_end == 1;
	self.competeUsInfo = msg.self_rank;
	self.competeMatchInfo = msg.match_rank;
	self.competeHurtList = msg.rank_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_RANK");
end

function Lua_AllianceData:fromServer50106065(msg)--请求公会对抗成员排名信息返回
	self.competeRankList = msg.rank_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_HURT");
end

function Lua_AllianceData:fromServer50106068(msg)
	if msg.result == 0 then
		if Lua_WindowUtil.isOpenWin("Lua_LeagueDuelLineupWindow") then return end

		self.enemyId = msg.grab_player_id;
		self.enemyFlag = msg.server_flag;

		local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB);
		DataCenter.preLoadData:preShowScene("Lua_LeagueDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
	else
		if msg.result == 1 then
			OperateAlert.showLangValue(201310);
		elseif msg.result == 2 then
			OperateAlert.showLangValue(201311);
		elseif msg.result == 3 or msg.result == 6 then
			OperateAlert.showLangValue(201312);
		elseif msg.result == 4 then
			OperateAlert.showLangValue(201314);
		elseif msg.result == 5 then
			OperateAlert.showLangValue(201315);
		end
	end
end

function Lua_AllianceData:onSceneShow(param, mp, success)
	if not success then return; end
	DataCenter.preLoadData:removeBySign("Lua_LeagueDuelLineupWindow", self, self.onSceneShow);

	local list = { templateId = Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB, enemyId = self.enemyId, 
				enemyFlag = self.enemyFlag, grabType = self.grabType, recordId = self.recordId };
	Lua_WindowUtil.openWin("Lua_LeagueDuelLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_AllianceData:setGrabInfo(roleId, recordId)
	self.grabType = tonumber(tostring(roleId)) == DataCenter.roleData.roleId and 2 or 1;
	self.recordId = recordId;
end

function Lua_AllianceData.Get:isDailyHurt()
	return DataCenter.allianceUtil:getConstConfig("combat_fight_times", 1) > self.competeFightNum;
end

function Lua_AllianceData:fromServer50106069(msg)
	self.competeHurtNum = tonumber(tostring(msg.hurt_value)); -- 伤害值
	self.competeHurtRewardList = msg.reward_info; -- key:奖励id value:奖励状态 0：不可领 1：可领 2：已领 sub: 伤害条件值

	local state = false;
	local num;
	local nextNum = 0;
	for i = 1, #self.competeHurtRewardList do
		if tonumber(self.competeHurtRewardList[i].value) == 1 then
			state = true;
		end

		num = tonumber(tostring(self.competeHurtRewardList[i].sub));
		if num > self.competeHurtNum then
			if nextNum == 0 or nextNum > num then
				nextNum = num;
			end
		end
	end
	self.hasCompeteHurtReward = state;
	self.nextCompeteHurt = nextNum;
	self.maxCompeteHurt = num;

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LeagueCompeteReward, state);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_HURT_REWARD");
end






















-------------------------------公会交易行-------------------------------

function Lua_AllianceData:fromServer50208001(msg)
	local arr = self.getDealTypeArr;
	for i = 1, arr:getSize() do
		arr:dispose();
	end

	local info = msg.transaction_times_info;
	for i = 1, #info do
		arr[info[i].type]:fromServer(info[i]);
	end
	self.activeNum = msg.active_value;
	self:checkDealRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_ENTRANCE");
end

function Lua_AllianceData.Get:getDealTypeArr()
	if self._dealTypeArr == nil then
		self._dealTypeArr = Array();
		local config = getConfig("league_transaction_type");
		local vo;
		for i = 1, #config do
			vo = Lua_AllianceDealTypeVo.new(i, config[i]);
			self._dealTypeArr:add(vo);
		end
	end
	return self._dealTypeArr;
end

function Lua_AllianceData.Get:getCurTypeInfo()
	return self.getDealTypeArr[self.curSelectType];
end

function Lua_AllianceData:fromServer50208002(msg)
	self.dealHeroNumDic = {};
	local info = msg.hero_info; 
	for i = 1, #info do
		self.dealHeroNumDic[tonumber(info[i].key)] = info[i].value;
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_INFO");
end

function Lua_AllianceData:getBuyHeroArr(campType)
	local arr = Array();
	local idArr = DataCenter.allianceUtil:getDealHeroIdArr(self.curSelectType, campType);
	local num;
	local sort;
	for i = 1, idArr:getSize() do
		num = self.dealHeroNumDic[idArr[i]];
		if num == nil then
			num = 0;
		end
		if num > 0 then
			sort = i - 1000;
		else
			sort = i;
		end
		arr:add({id = idArr[i], num = num, sort = sort});
		arr:sort("sort", false);
	end
	return arr;
end

function Lua_AllianceData:getDealPackHeroArr(campType)
    local duelArr = DataCenter.allianceUtil:getDealHeroIdArr(self.curSelectType, campType);
    local uidArr;
    local heroVo;
    local showHeroVo;
    local arr = Array();
    local selectId = self.selectHeroVo ~= nil and self.selectHeroVo.id or 0;
    for i = 1, duelArr:getSize() do
        uidArr = DataCenter.heroData:getHeroUidArrById(duelArr[i]);
        if uidArr ~= nil then
            for j = 1, uidArr:getSize() do
                heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[j]);
                if heroVo ~= nil and heroVo.id ~= selectId
                	and heroVo.isCultivateStar == false and heroVo.is_league_transaction == false and not heroVo.trial_state
                    and (campType == Lua_HeroUtil.All_TYPE or heroVo.campType == campType) then
                    showHeroVo = Lua_HeroVo.new(heroVo.id);
                   	showHeroVo:fromServer(heroVo);
                   	showHeroVo.is_resonance = heroVo.is_resonance;
                    arr:add(showHeroVo);
                end
            end
        end
    end
    return arr;
end

function Lua_AllianceData:fromServer50208003(msg)
	if #msg.role_list > 0 then
		Lua_WindowUtil.openWin("Lua_AllianceDealSellListWindow", Lua_WinParam.ACTION_OPEN, msg.role_list);
	else
		OperateAlert.showLangValue(201425);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealInfo(self.curSelectType, Lua_HeroUtil.All_TYPE);
	end
end

function Lua_AllianceData:fromServer50208004(msg)
	if msg.result == 1 then
		local vo = self.getDealTypeArr[msg.type];
		if vo ~= nil then
			vo.leftTime = msg.left_times;
		end
		self.activeNum = msg.active_value;

		OperateAlert.showLangValue(201426);
	end
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealInfo(self.curSelectType, Lua_HeroUtil.All_TYPE);
end

function Lua_AllianceData:fromServer50208005(msg)
	if msg.result == 1 then
		OperateAlert.showLangValue(201427);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealPlanInfo(self.curSelectType);
	else
		OperateAlert.showLangValue(201428);
	end
end

function Lua_AllianceData:fromServer50208006()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealPlanInfo(self.curSelectType);
end


function Lua_AllianceData:fromServer50208007(msg)
	self.schemeList = msg.scheme_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_PLAN");
end

function Lua_AllianceData:fromServer50208009(msg)
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_LOG", msg.log_list);
end

function Lua_AllianceData:fromServer80208011(msg)
	local vo = self.getDealTypeArr[msg.type];
	if vo ~= nil then
		vo.leftTime = msg.left_times;
	end
	self.schemeList = msg.scheme_list;
	self.activeNum = msg.active_value;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_REDRESH");
end

function Lua_AllianceData:isHeroRacking(heroId)
	for i = 1, #self.schemeList do
		if tonumber(self.schemeList[i].require_hero) == heroId then
			return true;
		end
	end
	return false;
end

function Lua_AllianceData:isHeroSelect(unique_id)
	local typeInfo = self.getCurTypeInfo;
	for i = 1, typeInfo.sell_hero_num do
		if self.selectHeroDic[i] ~= nil and self.selectHeroDic[i].unique_id == unique_id then
			return true;
		end
	end
	return false;
end

function Lua_AllianceData:setHeroSelectDic(heroVo)
	local typeInfo = self.getCurTypeInfo;
	local curIdx;
	local freeIdx;
	for i = 1, typeInfo.sell_hero_num do
		if self.selectHeroDic[i] ~= nil then
			if self.selectHeroDic[i].unique_id == heroVo.unique_id then
				curIdx = i;
			elseif self.selectHeroDic[i].id == heroVo.id then
				OperateAlert.showLangValue(201429);
				return;
			end
		else
			if freeIdx == nil then
				freeIdx = i;
			end
		end
	end

	if curIdx ~= nil then
		self.selectHeroDic[curIdx] = nil;
	elseif freeIdx ~= nil then
		local state, str = self:checkLineupNumState(self.checkLineupList, heroVo.unique_id);
		if state == false then
			OperateAlert.show(LanUtil.formateStr(201431, str));
			return;
		elseif heroVo.lock_state == true then
			local tipsData = {
				btnType = 1,
				des = LanUtil.getValue(201432),
				owner = self,
				sureFun = function()
					Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(heroVo.unique_id, 0);
					self.selectHeroDic[freeIdx] = heroVo;
					Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_HERO_SELECT");
				end
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
			return;
		end
		
		self.selectHeroDic[freeIdx] = heroVo;
	else
		OperateAlert.showLangValue(201430);
		return;
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_HERO_SELECT");
end

function Lua_AllianceData.Get:checkLineupList()
    local config;
    local lineupList = {};
    local lineupType;
    for _, v in pairs(self.selectHeroDic) do
    	if v.lineup_state_list ~= nil then
    		for i = 1, #v.lineup_state_list do
    			lineupType = v.lineup_state_list[i].key;
    			config = getConfig("hero_camp_lineup", lineupType);
    			if config ~= nil and config.can_nil ~= 1 then
    				if lineupList[lineupType] == nil then
    					lineupList[lineupType] = 1;
    				else
    					lineupList[lineupType] = lineupList[lineupType] + 1;
    				end
    			end
    		end
    	end
    end
    return lineupList;
end

function Lua_AllianceData:checkLineupNumState(lineupList, select_uid)
	if lineupList == nil then
		lineupList = {};
	end
	local hvo = DataCenter.heroData:getItemByUniqueId(select_uid);
	if hvo ~= nil and hvo.lineup_state_list ~= nil then
		local lineupType;
		local config;
		for i = 1, #v.lineup_state_list do
			lineupType = v.lineup_state_list[i].key;
			config = getConfig("hero_camp_lineup", lineupType);
			if config ~= nil and config.can_nil ~= 1 then
				if lineupList[lineupType] == nil then
					lineupList[lineupType] = 1;
				else
					lineupList[lineupType] = lineupList[lineupType] + 1;
				end

				if lineupList[lineupType] >= DataCenter.heroLineupData:getLineupHeroTotalNum(lineupType) then
					return false, config.name;
				end
			end
		end
	end
	return true;
end

function Lua_AllianceData:checkDealRedPoint()
	local arr = self.getDealTypeArr;
	for i = 1, arr:getSize() do
		arr[i]:checkRedPoint();
	end
end































-------------------------------公会心愿墙-------------------------------

function Lua_AllianceData:fromServer50219001(msg)
	if msg == nil then
		return;
	end
	if self._allyWishDic == nil then
		self._allyWishDic = {};
	else
		local arr = self._allyWishIdArr;
		for i = 1, arr:getSize() do
			self._allyWishDic[arr[i]] = nil;
		end
	end
	if self._allyWishIdArr == nil then
		self._allyWishIdArr = Array();
	else
		self._allyWishIdArr:clear();
	end
	self.isNeedSort = true;

	self._leftHelpTimes = msg.help_times; -- 每日剩余助力次数
	self._myWish = msg.my_wish; -- 我的心愿
	self._openTick = msg.open_tick; -- 功能开启时间戳

	local obj;
	for i = 1, #msg.league_wish do -- 盟友心愿
		obj = msg.league_wish[i];
		self._allyWishDic[tonumber(tostring(obj.player_id))] = obj;
		self._allyWishIdArr:add(tonumber(tostring(obj.player_id)));
	end
	local redState = self.openLeftTime <= 0 and self.myWish.reward_id == 0;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_NoSelectWish, redState);

	redState = false;
	if self.myWish.reward_id ~= 0 then
		local wishConfig = getConfig("wish_wall_reward", self.myWish.reward_id);
		redState = self.myWish.help_sum >= wishConfig.help_times;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_WishReward, redState);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_AssistTimes, self.leftHelpTimes > 0 and not self.isFirstAssistRed);

	if self.openLeftTime > 0 then
		Lua_CommonUtil.delayCall(self.openLeftTime, self, self.delayFun);
	end
end

function Lua_AllianceData:clearWishaWallRed()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_NoSelectWish, false);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_WishReward, false);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_Task, false);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_AssistTimes, false);
end

function Lua_AllianceData.Get:leftHelpTimes()
	return self._leftHelpTimes or 0;
end

function Lua_AllianceData.Get:myWish()
	return self._myWish or {};
end

function Lua_AllianceData.Get:openLeftTime()
	local tick = self._openTick or 0;
	local time = tick - DataCenter.roleData.serverTime;
	return time;
end

function Lua_AllianceData:delayFun()
	self:removeTimer();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueWishWallInfo(0);
end

function Lua_AllianceData:removeTimer()
	Lua_CommonUtil.removeTimer(self, self.delayFun);
end

function Lua_AllianceData:getSingleAllyWishInfo(playerId)
	if self._allyWishDic == nil or playerId == nil then
		return nil;
	end
	return self._allyWishDic[playerId];
end

function Lua_AllianceData.Get:allyWishIdArr()
	if self.isNeedSort then
		self.isNeedSort = false;
		self._allyWishIdArr:sortf(self, self.sortFun);
	end
	return self._allyWishIdArr;
end

function Lua_AllianceData:sortFun(a, b)
	local voA = self:getSingleAllyWishInfo(a);
	local voB = self:getSingleAllyWishInfo(b);
	local wishConfigh_a = getConfig("wish_wall_reward", voA.reward_id);
	local wishConfigh_b = getConfig("wish_wall_reward", voB.reward_id);
	local state_a, state_b;
	if voA.help_sum < wishConfigh_a.help_times then
		if voA.can_help == 0 then -- 不可被助力
			state_a = 1; -- 今日已满
		else
			state_a = 2; -- 可助力
		end
	else
		state_a = 0; -- 助力成功
	end
	if voB.help_sum < wishConfigh_b.help_times then
		if voB.can_help == 0 then -- 不可被助力
			state_b = 1;
		else
			state_b = 2;
		end
	else
		state_b = 0;
	end
	if state_a ~= state_b then
		return state_a > state_b;
	end
	return true;
end

function Lua_AllianceData:fromServer50219006(msg)
	if msg == nil then
		return;
	end

	self._totalHelpTimes = msg.help_times; -- 累积助力次数

	local obj;
	local redState = false;
	self._taskProgress = nil;
	for i = 1, #msg.task_reward do
		obj = msg.task_reward[i];
		if not redState and obj.value == 1 then -- value：0不可领取 1可领取 2已领取
			redState = true;
		end
		if obj.value == 0 and self._taskProgress == nil then
			self._taskProgress = obj.key;
		end
	end
	if self._taskProgress == nil then
		self._taskProgress = msg.task_reward[#msg.task_reward].key;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_Task, redState);
end

function Lua_AllianceData.Get:totalHelpTimes()
	return self._totalHelpTimes or 0;
end

function Lua_AllianceData.Get:taskProgress()
	return self._taskProgress or 0;
end

function Lua_AllianceData:fromServer80219001(msg)
	if msg == nil then
		return;
	end
	self._shareTimes = msg.share_times; -- 剩余分享次数
end

function Lua_AllianceData.Get:shareTimes()
	return self._shareTimes or 0;
end

function Lua_AllianceData:fromServer80219002(msg)
	if msg == nil then
		return;
	end
	-- 通知表示满足进入公会冷却CD，助力次数每日刷新所以大于0，首次登录 1是 0否
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_WishWall_AssistTimes, msg.first_login == 1);
end


























-------------------------------公会战------------------------------
-- 请求公会战主界面信息(返回)
function Lua_AllianceData:fromServer50220001(msg)
	self.allianceFightStep = msg.step; --阶段 0关闭 1备赛 2激战 3结算
	self._allianceFightStepTick = tonumber(msg.step_tick);
	self._allianceFightSelfStarNum = msg.our_star; -- 我方联盟获星数
	self._allianceFightEnemyStarNum = msg.enemy_star; --敌方联盟获星数
	self.allianceFightLeagueInfo = msg.fight_info; --联盟对战信息
	self._allianceFightMatchState = msg.match_state; --公会匹配状态 0未参赛 1轮空 2匹配
	self._allianceFightJoinState = msg.join_state; --个人参赛状态 0未参与 1已成功
	self._allianceFightIsWin = msg.is_win == 1; --结算胜利 0否1是

	self.allianceFightTopRankInfo = msg.three_ranker;
	self._allianceFightResidueBattleCount = msg.fight_times;-- 剩余进攻次数
	self._allianceFightPropIndex = tonumber(msg.buff_id);
	self._allianceFightProps = nil;

	local obj = msg.draw_state;
	for i = 1, #obj do
		self:updateResultRewardState(obj[i].key, obj[i].value);-- 战果宝箱领取 0不可领取 1可领取 2已领取
	end
	self._bShowFinalReward = #obj > 0;

	self:updateAllianceFightRobotIds(msg.robot_list);
	self:checkAFResidueFightNum();
	self:checkAFResultReward();
end

-- 请求成就奖励列表(返回)
function Lua_AllianceData:fromServer50220002(msg)
	if self.allianceFightRewardDic == nil then
		self.allianceFightRewardDic = {};
	end

	local data;
	local state;
	local rewardId;
	local curProcess;
	local obj = msg.reward_state;
	for i = 1, #obj do
		curProcess = obj[i].value;
		rewardId = tonumber(obj[i].key);
		state = obj[i].ex_value;
		data = self:getAllianceFightRewardById(rewardId);
		if data == nil then
			data = {rewardId = rewardId, state = state, curProcess = curProcess}; -- state: 0未领取 1可领取 2已领取
			self.allianceFightRewardDic[rewardId] = data
		else
			data.rewardId = rewardId;
			data.state = state;
			data.curProcess = curProcess;
		end
	end

	local task_type = msg.task_type;
	if task_type == 0 then
		task_type = Lua_AllianceUtil.LEAGUEFIGHT_PERSONTYPE; --个人成就
	elseif task_type == 1 then
		task_type = Lua_AllianceUtil.LEAGUEFIGHT_ALLIANCETYPE; --公会成就
	end
	self:sortAllianceFightRewardIds(task_type);
	self:checkAFRewardRedPoint();
end

-- 请求联盟对战列表(返回)
function Lua_AllianceData:fromServer50220004(msg)
	self.allianceFightLeagueInfo = msg.my_league_show; --联盟对战信息
end

-- 请求公会战战场界面信息(返回)
function Lua_AllianceData:fromServer50220005(msg)
	local type = msg.info_type;
	local obj = msg.fight_role;

	local len = #obj;
	for i = 1, len do 
		self:updatePointInfo(type, obj[i]);
	end

	local points = type == 0 and self.allianceFightEnemyPoints or self.allianceFightSelfPoints;
	if points and #points > len then
		for i = len + 1, #points do
			points[i] = nil;
		end
	end

	if type == 0 then --敌方
		Lua_MsgUtil.callFunc("UPDATE_ALLIANCE_FIGHT_ENEMY_POINT_INFO", obj);
	elseif type == 1 then -- 我方
		Lua_MsgUtil.callFunc("UPDATE_ALLIANCE_FIGHT_SELF_POINT_INFO", obj);
	end
end

-- 通知新buffId
function Lua_AllianceData:fromServer80220005(msg)
	self._allianceFightPropIndex = tonumber(msg.buff_id);
	self._allianceFightProps = nil;
end

function Lua_AllianceData:fromServer80220001(msg)
	self.allianceFightStep = msg.step; --阶段 0关闭 1备赛 2激战 3结算
	self._allianceFightStepTick = tonumber(msg.step_tick);
	self._allianceFightSelfStarNum = msg.our_star; -- 我方联盟获星数
	self._allianceFightEnemyStarNum = msg.enemy_star; --敌方联盟获星数

	self.allianceFightTopRankInfo = msg.three_ranker;
	self._allianceFightResidueBattleCount = msg.fight_times;-- 剩余进攻次数
	self._allianceFightPropIndex = tonumber(msg.buff_id);
	self._allianceFightProps = nil;
	

	local info = msg.fight_role;
	if info and info.fight_role and tonumber(info.fight_role.id) > 0 then
		local league_id = info.fight_role.league_id;
		local type = DataCenter.roleData:isSameAlliance(league_id) and 1 or 0;

		local pointIndex = self:updatePointInfo(type, info);
		if type == 0 then --敌方
			Lua_MsgUtil.callFunc("UPDATE_ALLIANCE_FIGHT_ENEMY_POINT_INFO", pointIndex);
		elseif type == 1 then -- 我方
			Lua_MsgUtil.callFunc("UPDATE_ALLIANCE_FIGHT_SELF_POINT_INFO", pointIndex);
		end
	end

	self:checkAFResidueFightNum();
	self:checkAFResultReward();
end

-- 请求领取战果宝箱(返回)
function Lua_AllianceData:fromServer50220012(msg)
	local id = tonumber(msg.reward_id);
	self:updateResultRewardState(id, msg.draw_state);-- 战果宝箱领取 0不可领取 1可领取 2已领取
	self:checkAFResultReward();
end

-- 请求公会战登陆状态信息(返回)红点
function Lua_AllianceData:fromServer50220013(msg)
	self.allianceFightLoginRPState = msg.falg == 1;

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Self_Defense, self.allianceFightLoginRPState);
end

-- -- 请求防守战报信息(返回)
-- function Lua_AllianceData:fromServer50220008(msg)
-- end

function Lua_AllianceData:allianceFightDispose()
	self._allianceFightStep = nil;
	self._allianceFightStepTick = nil;
	self._allianceFightSelfStarNum = nil;
	self._allianceFightEnemyStarNum = nil;
	self._allianceFightLeagueInfo = nil;
	self._allianceFightResidueBattleCount = nil;
	self._allianceFightPropIndex = nil;
	self._allianceFightMatchState = nil;
	self._allianceFightJoinState = nil;
	self._allianceFightIsWin = nil;
	self._allianceFightProps = nil;
	self.allianceFightTopRankInfo = nil;
	self.allianceFightResultRewardDic = nil;
	self.allianceFightLoginRPState = nil;
	self._allianceFightRobotIds = nil;
	self._bShowFinalReward = nil;

	if self.allianceFightRewardDic ~= nil then
		for k, v in pairs(self.allianceFightRewardDic) do
			v = nil;
		end
		self.allianceFightRewardDic = nil;
	end

	if self.allianceFightEnemyPoints ~= nil then
		for i = 1, #self.allianceFightEnemyPoints do
			self.allianceFightEnemyPoints[i] = nil;
		end
		self.allianceFightEnemyPoints = nil;
	end
	if self.allianceFightSelfPoints ~= nil then
		for i = 1, #self.allianceFightSelfPoints do
			self.allianceFightSelfPoints[i] = nil;
		end
		self.allianceFightSelfPoints = nil;
	end
end

function Lua_AllianceData:updatePointInfo(type, info)
	if self.allianceFightEnemyPoints == nil then
		self.allianceFightEnemyPoints = {}
	end
	if self.allianceFightSelfPoints == nil then
		self.allianceFightSelfPoints = {}
	end

	local dic;
	if type == 0 then
		dic = self.allianceFightEnemyPoints;
	elseif type == 1 then
		dic = self.allianceFightSelfPoints;
	end

	if dic == nil then
		return;
	end

	local pointIndex;
	if info ~= nil then
		pointIndex = info.index;
		dic[pointIndex] = info;
	end

	return pointIndex;
end

function Lua_AllianceData:updateResultRewardState(rewardId, state)
	if self.allianceFightResultRewardDic == nil then
		self.allianceFightResultRewardDic = {};
	end

	self.allianceFightResultRewardDic[rewardId] = state;
end

--阶段 0关闭 1备赛 2激战 3结算
function Lua_AllianceData.Get:allianceFightStep()
	if self._allianceFightStep == nil then
		self._allianceFightStep = 0;
	end
	return self._allianceFightStep;
end

function Lua_AllianceData.Set:allianceFightStep(value)
	if self._allianceFightStep == 3 and value == 0 then -- 由开启阶段到关闭
		self.allianceFightResultRewardDic = nil;
		self.allianceFightEnemyPoints = nil;
		self.allianceFightSelfPoints = nil;
		self:clearAllianceFightRedPoint();
	end
	self._allianceFightStep = value;
end

function Lua_AllianceData:getAllianceFightEPointByPIndex(pointIndex)
	if self.allianceFightEnemyPoints == nil or self.allianceFightEnemyPoints[pointIndex] == nil then
		return;
	end

	return self.allianceFightEnemyPoints[pointIndex];
end

function Lua_AllianceData:getAllianceFightSPointByPIndex(pointIndex)
	if self.allianceFightSelfPoints == nil or self.allianceFightSelfPoints[pointIndex] == nil then
		return;
	end

	return self.allianceFightSelfPoints[pointIndex];
end

function Lua_AllianceData:getAllianceFightRewardIdsByType(type)
	if self.allightFightRewardIds == nil then
		self.allightFightRewardIds = {};
	end

	local ids = self.allightFightRewardIds[type];
	if ids == nil then
		ids = DataCenter.allianceUtil:getFightTaskIdsByType(type);
		self.allightFightRewardIds[type] = ids;
	end

	return ids;
end

function Lua_AllianceData:sortAllianceFightRewardIds(type)
	local ids = self:getAllianceFightRewardIdsByType(type);
	if ids == nil then
		return;
	end

-- data = {rewardId = rewardId, state = state, curProcess = curProcess}; -- state: 0未领取 1可领取 2已领取
	table.sort( ids, function(a, b) 
		local AData = self:getAllianceFightRewardById(a);
		local BData = self:getAllianceFightRewardById(b);
		local aState = AData and AData.state or 0;
		local bState = BData and BData.state or 0;
		if aState ~= bState then
			if bState == 1 then
				return false;
			elseif aState ~= 1 and bState == 0 then
				return false;
			end
		else
			return a < b
		end

		return true; 
	end );
end

function Lua_AllianceData:getAllianceFightRewardById(id)
	if self.allianceFightRewardDic == nil or self.allianceFightRewardDic[id] == nil then
		return;
	end

	return self.allianceFightRewardDic[id];
end

function Lua_AllianceData:getAllianceFightResultRewardById(id)
	if self.allianceFightResultRewardDic == nil or self.allianceFightResultRewardDic[id] == nil then
		return;
	end

	return self.allianceFightResultRewardDic[id];
end

function Lua_AllianceData.Get:allianceFightLeagueInfo()
	return self._allianceFightLeagueInfo;
end

function Lua_AllianceData.Set:allianceFightLeagueInfo(value)
	self._allianceFightLeagueInfo = value;
end

function Lua_AllianceData:checkLeagueFightReadyStep()
	return self.allianceFightStep == 1;
end

function Lua_AllianceData:checkLeagueFightResidueNum()
	local bCheck = self.allianceFightResidueBattleCount > 0;
	return bCheck;
end

function Lua_AllianceData:getLeagueFightFightPersonNum()
	local num = self.allianceFightSelfPoints and #self.allianceFightSelfPoints or 0;
	return num;
end

function Lua_AllianceData.Get:allianceFightProps()
	if self._allianceFightProps == nil then
		self._allianceFightProps = DataCenter.allianceUtil:getAllianceFightProp(self.allianceFightPropIndex);
	end
	return self._allianceFightProps;
end

function Lua_AllianceData.Get:allianceFightPropIndex()
	return self._allianceFightPropIndex or 0;
end

function Lua_AllianceData.Get:allianceFightResidueBattleCount()
	return self._allianceFightResidueBattleCount or 0;
end

-- 我方联盟获星数
function Lua_AllianceData.Get:allianceFightSelfStarNum()
	return self._allianceFightSelfStarNum or 0;
end

-- 敌方联盟获星数
function Lua_AllianceData.Get:allianceFightEnemyStarNum()
	return self._allianceFightEnemyStarNum or 0;
end

-- 公会战阶段时间戳
function Lua_AllianceData.Get:allianceFightStepTick()
	return self._allianceFightStepTick or 0;
end

--公会匹配状态 0未参赛 1轮空 2匹配
function Lua_AllianceData.Get:allianceFightMatchState()
	return self._allianceFightMatchState or 0;
end

-- 个人参赛状态 0未参与 1已成功
function Lua_AllianceData.Get:allianceFightJoinState()
	return self._allianceFightJoinState or 0;
end

-- 结算胜利
function Lua_AllianceData.Get:allianceFightIsWin()
	return self._allianceFightIsWin or false;
end

function Lua_AllianceData.Get:bShowFinalReward()
	return self._bShowFinalReward or false;
end

-- 战果宝箱状态
function Lua_AllianceData:getAllianceFightRRewardStateByType(type) --type:1可领取 2：已领取（默认）
	if not self.bShowFinalReward then
		return false; 
	end

	local bCheck = false;
	local rewardIds;
	if self.allianceFightMatchState == 1 then 
		rewardIds = DataCenter.allianceUtil:getFightEndRewardIdsByType(3);
	elseif self.allianceFightIsWin then
		rewardIds = DataCenter.allianceUtil:getFightEndRewardIdsByType(1);
	else
		rewardIds = DataCenter.allianceUtil:getFightEndRewardIdsByType(2);
	end

	if rewardIds == nil or #rewardIds <= 0 then
		return bCheck;
	end

	local state;
	local targetState = type == 1 and 1 or 2;
	for i = 1, #rewardIds do
		state = self:getAllianceFightResultRewardById(rewardIds[i]); -- 战果宝箱领取 0不可领取 1可领取 2已领取
		if state == targetState then
			bCheck = true;
			break;
		end
	end

	return bCheck;
end

-- 战果宝箱显示状态
function Lua_AllianceData:checkShowAllianceFightRReward()
	if not self.bShowFinalReward then
		return false; 
	end

	local bShow = false;
	local rewardIds;
	if self.allianceFightMatchState == 1 then
		rewardIds = DataCenter.allianceUtil:getFightEndRewardIdsByType(3);
	elseif self.allianceFightIsWin then
		rewardIds = DataCenter.allianceUtil:getFightEndRewardIdsByType(1);
	else
		rewardIds = DataCenter.allianceUtil:getFightEndRewardIdsByType(2);
	end

	if rewardIds == nil or #rewardIds <= 0 then
		return bShow;
	end

	for i = 1, #rewardIds do
		state = self:getAllianceFightResultRewardById(rewardIds[i]); -- 战果宝箱领取 0不可领取 1可领取 2已领取
		if state ~= 2 then
			bShow = true;
			break;
		end
	end

	return bShow;
end

function Lua_AllianceData:checkAllianceFightShowSp()
	local bCheck = false;
	if self.allianceFightStep ~= 0 and self.allianceFightMatchState == 2 and self.allianceFightJoinState == 1 then
		bCheck = true;
	end

	return bCheck;
end

-- 当前是否可以战斗
function Lua_AllianceData:checkAllianceFightEnableFight()
	if self.allianceFightStep == 0 or self.allianceFightStep == 3 then 
		return false;
	end

	if self.allianceFightMatchState ~= 2 then
		return false;
	end

	if self.allianceFightJoinState ~= 1 then
		return false;
	end

	return true;
end

function Lua_AllianceData:updateAllianceFightRobotIds(robotIds)
	local robotId;
	self._allianceFightRobotIds = {};
	for i = 1, #robotIds do
		robotId = tonumber(robotIds[i]);
		self._allianceFightRobotIds[robotId] = robotId;
	end
end

function Lua_AllianceData:checkAllianceFightRobot(robotId)
	if self._allianceFightRobotIds == nil then
		return false;
	end

	robotId = tonumber(robotId);
	return self._allianceFightRobotIds[robotId];
end

function Lua_AllianceData:checkShowWaterAndSmokeEffect()
	local state = false;
	if not (self.allianceFightStep == 0 or self.allianceFightMatchState == 0 or self.allianceFightMatchState == 1) then -- 未开启、公会无资格、公会轮空
		state = true;
	end
	return state;
end

-- 红点
function Lua_AllianceData:checkAFResidueFightNum()
	local bCheck = false;
	if self.allianceFightStep == 2 then
		bCheck = self:checkLeagueFightResidueNum();
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Enemy_Attack, bCheck);
end

function Lua_AllianceData:checkAFRewardRedPoint()
	local bCheck = false;
	local ids = DataCenter.allianceUtil:getFightTaskIdsByType(Lua_AllianceUtil.LEAGUEFIGHT_ALLIANCETYPE);
	if ids and #ids > 0 then
		local data;
		for i = 1, #ids do
			data = self:getAllianceFightRewardById(ids[i]);
			if data and data.state == 1 then
				bCheck = true;
				break;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Self_AReward, bCheck);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Enemy_AReward, bCheck);

	bCheck = false;
	ids = DataCenter.allianceUtil:getFightTaskIdsByType(Lua_AllianceUtil.LEAGUEFIGHT_PERSONTYPE);
	if ids and #ids > 0 then
		local data;
		for i = 1, #ids do
			data = self:getAllianceFightRewardById(ids[i]);
			if data and data.state == 1 then
				bCheck = true;
				break;
			end
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Self_PReward, bCheck);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Enemy_PReward, bCheck);
end

function Lua_AllianceData:checkAFResultReward()
	local bCheck = self:getAllianceFightRRewardStateByType(1) --type:1可领取 2：已领取（默认）

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Self_Result_Reward, bCheck);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Enemy_Result_Reward, bCheck);
end

function Lua_AllianceData:clearAllianceFightRedPoint()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Self_Result_Reward, false);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.League_Fight_Enemy_Result_Reward, false);
end

