Lua_ChampionMatchData = class("Lua_ChampionMatchData")
function Lua_ChampionMatchData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ChampionMatchData:dispose()
	self._start_tick = 0;
	self._end_tick = 0;
	self._region_id = 0;
	self._is_buy_diamond_guess = 0;
end

function Lua_ChampionMatchData.Get:isInTime()
	return DataCenter.roleData:checkInTime(self.startTick, self.endTick);
end

-- 开始时间
function Lua_ChampionMatchData.Get:startTick()
	return self._start_tick or 0;
end

-- 结束时间
function Lua_ChampionMatchData.Get:endTick()
	return self._end_tick or 0;
end

-- 赛区id
function Lua_ChampionMatchData.Get:regionId()
	return self._region_id or 0;
end

-- 本轮是否购买了钻石竞猜 1：已购买 0：未购买
function Lua_ChampionMatchData.Get:isBuyDiamond()
	return self._is_buy_diamond_guess == 1;
end

function Lua_ChampionMatchData:getBetInfo(betType)
	if self._bet_info then
		for i = 1, #self._bet_info do
			if self._bet_info[i].type == betType then
				return self._bet_info[i];
			end
		end
	end
	return nil;
end

function Lua_ChampionMatchData:fromServer50216001(msg)
	self._start_tick = tonumber(msg.start_tick); -- 开始时间
	self._end_tick = tonumber(msg.end_tick); -- 结束时间
	self._region_id = msg.region_id; -- 赛区id
end

function Lua_ChampionMatchData:fromServer50216003(msg)
	self._bet_info = msg.bet_info; -- 下注信息
end

function Lua_ChampionMatchData:fromServer50216004(msg)
	self._start_tick = tonumber(msg.start_tick); -- 开始时间
	self._end_tick = tonumber(msg.end_tick); -- 结束时间
	self._is_buy_diamond_guess = msg.is_buy_diamond_guess; -- 本轮是否购买了钻石竞猜 1：已购买 0：未购买
	self._bet_info = msg.bet_info; -- 下注信息
end

function Lua_ChampionMatchData:fromServer50216005(msg)
	self._start_tick = tonumber(msg.start_tick); -- 开始时间
	self._end_tick = tonumber(msg.end_tick); -- 结束时间
end

function Lua_ChampionMatchData:fromServer50216016(msg)
	self._is_buy_diamond_guess = msg.is_buy_diamond_guess; -- 本轮是否购买了钻石竞猜 1：已购买 0：未购买
end

function Lua_ChampionMatchData:updateHonourRedPoint(msg)
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChampionMatch_Champagne, msg.left_champagne_times > 0);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChampionMatch_Toast, msg.left_toast_times > 0);
end

function Lua_ChampionMatchData:fromServer80216024(msg)
	if msg.type == 1 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChampionMatch_RedEnvelope, msg.state == 1);
	elseif msg.type == 2 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChampionMatch_MyCourse, msg.state == 1);
	end
end