checkRequire("Lua_ChampionMatchUtil");
checkRequire("Lua_ChampionMatchData");
Lua_ChampionMatchProxy = class("Lua_ChampionMatchProxy");
function Lua_ChampionMatchProxy:ctor()
	DataCenter.championMatchUtil = Lua_ChampionMatchUtil.new();
	DataCenter.championMatchData = Lua_ChampionMatchData.new();

	Lua_MsgUtil.addLuaMsg(50216001, self, self.rWinInfo); -- 请求冠军赛信息返回
	Lua_MsgUtil.addLuaMsg(50216002, self, self.rCourseInfo); -- 请求冠军赛赛程信息返回
	Lua_MsgUtil.addLuaMsg(50216003, self, self.rGuessBetting); -- 请求冠军赛竞猜下注返回
	Lua_MsgUtil.addLuaMsg(50216004, self, self.rGuessInfo); -- 请求冠军赛竞猜信息返回
	Lua_MsgUtil.addLuaMsg(50216005, self, self.rMateInfo); -- 请求赛区匹配信息返回
	Lua_MsgUtil.addLuaMsg(50216006, self, self.rRankInfo); -- 请求冠军赛排行信息返回
	Lua_MsgUtil.addLuaMsg(50216007, self, self.rRankLike); -- 请求冠军赛排行点赞返回
	Lua_MsgUtil.addLuaMsg(50216008, self, self.rReceiveEnvelope); -- 请求领取冠军赛竞猜红包返回
	Lua_MsgUtil.addLuaMsg(50216009, self, self.rGuessRecord); -- 请求冠军赛竞猜记录返回
	Lua_MsgUtil.addLuaMsg(50216010, self, self.rHonourInfo); -- 请求冠军赛荣耀殿堂信息返回
	Lua_MsgUtil.addLuaMsg(50216016, self, self.rBuyDiamond); -- 请求购买钻石竞猜返回
	Lua_MsgUtil.addLuaMsg(50216019, self, self.rFightDetails); -- 请求冠军赛战斗详细信息返回

	Lua_MsgUtil.addLuaMsg(80216011, self, self.onTopThree); -- 通知冠军赛前三
	Lua_MsgUtil.addLuaMsg(80216012, self, self.onEnd); -- 通知冠军赛玩家排名赛程信息
	Lua_MsgUtil.addLuaMsg(80216013, self, self.onResult); -- 通知冠军赛匹配结果信息
	Lua_MsgUtil.addLuaMsg(80216014, self, self.onPreView); -- 通知冠军赛开始
	Lua_MsgUtil.addLuaMsg(80216015, self, self.onTips); -- 通知冠军赛竞猜
	Lua_MsgUtil.addLuaMsg(80216018, self, self.onGuessResult); -- 通知冠军赛竞猜结果
	Lua_MsgUtil.addLuaMsg(80216020, self, self.updateBarrage); -- 通知冠军赛荣耀殿堂弹幕更新
	Lua_MsgUtil.addLuaMsg(80216023, self, self.updateCelebrateTimes); -- 通知荣耀殿堂香槟敬酒次数更新
	Lua_MsgUtil.addLuaMsg(80216024, self, self.updateRedPoint); -- 通知冠军赛红点信息
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行

-- 请求精英赛大厅信息
function Lua_ChampionMatchProxy:sWinInfo(region_id)
	local cmd = ProtoPublic_pb.Proto10216001();
	cmd.region_id = tonumber(region_id);
	sendMsg(10216001, cmd);
end

-- 请求冠军赛赛程信息
function Lua_ChampionMatchProxy:sCourseInfo()
	sendMsg(10216002);
end

-- 请求冠军赛竞猜下注
function Lua_ChampionMatchProxy:sGuessBetting(bet_player_id, bet_type, bet_val, score_type)
	local cmd = ProtoPublic_pb.Proto10216003();
	cmd.bet_player_id = tonumber(bet_player_id);
	cmd.type = bet_type;
	cmd.bet_val = bet_val;
	cmd.score_type = score_type;
	sendMsg(10216003, cmd);
end

-- 请求冠军赛竞猜信息
function Lua_ChampionMatchProxy:sGuessInfo()
	sendMsg(10216004);
end

-- 请求赛区匹配信息
function Lua_ChampionMatchProxy:sMateInfo(event_type, region, region_id)
	local cmd = ProtoPublic_pb.Proto10216005();
	cmd.event_type = event_type;
	cmd.region = region;
	cmd.region_id = tonumber(region_id);
	sendMsg(10216005, cmd);
end

-- 请求冠军赛排行信息
function Lua_ChampionMatchProxy:sRankInfo(page)
	local cmd = ProtoPublic_pb.Proto10216006();
	cmd.page = page;
	sendMsg(10216006, cmd);
end

-- 请求冠军赛排行点赞
function Lua_ChampionMatchProxy:sRankLike(role_id)
	local cmd = ProtoPublic_pb.Proto10216007();
	cmd.role_id = tonumber(role_id);
	sendMsg(10216007, cmd);
end

-- 请求领取冠军赛竞猜红包
function Lua_ChampionMatchProxy:sReceiveEnvelope()
	sendMsg(10216008);
end

-- 请求冠军赛竞猜记录
function Lua_ChampionMatchProxy:sGuessRecord()
	sendMsg(10216009);
end

-- 请求冠军赛荣耀殿堂信息
function Lua_ChampionMatchProxy:sHonourInfo()
	sendMsg(10216010);
end

-- 请求购买钻石竞猜
function Lua_ChampionMatchProxy:sBuyDiamond(nums)
	local cmd = ProtoPublic_pb.Proto10216016();
	cmd.nums = nums;
	sendMsg(10216016, cmd);
end

-- 请求发送冠军赛荣耀殿堂弹幕
function Lua_ChampionMatchProxy:sSendBarrage(barrage)
	local cmd = ProtoPublic_pb.Proto10216017();
	cmd.barrage = barrage;
	sendMsg(10216017, cmd);
end

-- 请求冠军赛战斗详细信息
function Lua_ChampionMatchProxy:sFightDetails(record_id)
	local cmd = ProtoPublic_pb.Proto10216019();
	cmd.record_id = tonumber(record_id);
	sendMsg(10216019, cmd);
end

-- 请求开启荣耀殿堂香槟
function Lua_ChampionMatchProxy:sChampagne()
	sendMsg(10216021);
end

-- 请求开启荣耀殿堂香槟
function Lua_ChampionMatchProxy:sToast()
	sendMsg(10216022);
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行

-- 请求冠军赛信息返回
function Lua_ChampionMatchProxy:rWinInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216001();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:fromServer50216001(msg);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_INFO", msg);
	end
end

-- 请求冠军赛赛程信息返回
function Lua_ChampionMatchProxy:rCourseInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216002();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_COURSE", msg);
	end
end

-- 请求冠军赛赛程信息返回
function Lua_ChampionMatchProxy:rGuessBetting(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216003();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:fromServer50216003(msg);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_BETTING", msg);
		Lua_WindowUtil.openWin("Lua_ChampionMatchBettingWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(774052);
	end
end

-- 请求冠军赛竞猜信息返回
function Lua_ChampionMatchProxy:rGuessInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216004();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:fromServer50216004(msg);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_GUESS", msg);
	end
end

-- 请求赛区匹配信息返回
function Lua_ChampionMatchProxy:rMateInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216005();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:fromServer50216005(msg);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_MATE", msg);
	end
end

-- 请求冠军赛排行信息返回
function Lua_ChampionMatchProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_RANK", msg);
	end
end

-- 请求冠军赛排行点赞返回
function Lua_ChampionMatchProxy:rRankLike(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_LIKE", msg);
	end
end

-- 请求领取冠军赛竞猜红包返回
function Lua_ChampionMatchProxy:rReceiveEnvelope(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216008();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_RED_ENVELOPE", msg);
		Lua_WindowUtil.openWin("Lua_ChampionMatchRedEnvelopeWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

-- 请求冠军赛竞猜记录返回
function Lua_ChampionMatchProxy:rGuessRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216009();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_GUESS_RECORD", msg);
	end
end

-- 请求冠军赛荣耀殿堂信息返回
function Lua_ChampionMatchProxy:rHonourInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216010();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:updateHonourRedPoint(msg);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_HONOUR", msg);
	end
end

-- 请求购买钻石竞猜返回
function Lua_ChampionMatchProxy:rBuyDiamond(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216016();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:fromServer50216016(msg);
		Lua_WindowUtil.openWin("Lua_ChampionMatchBuyCoinWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

-- 请求冠军赛战斗详细信息返回
function Lua_ChampionMatchProxy:rFightDetails(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50216019();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_FIGHT_DETAILS", msg);
	end
end

-- 通知冠军赛前三
function Lua_ChampionMatchProxy:onTopThree(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216011();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionMatchTopThreeWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

-- 通知冠军赛玩家排名赛程信息
function Lua_ChampionMatchProxy:onEnd(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216012();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionMatchEndWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

-- 通知冠军赛匹配结果信息
function Lua_ChampionMatchProxy:onResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216013();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionMatchResultWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

-- 通知冠军赛开始
function Lua_ChampionMatchProxy:onPreView(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216014();
		msg:ParseFromString(mp.data);
		if msg.type == 0 then
			Lua_WindowUtil.openWin("Lua_ChampionMatchPreViewWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

-- 通知冠军赛竞猜
function Lua_ChampionMatchProxy:onTips(mp)
	if mp.errno == 0 then
		if not Lua_WindowUtil.isWindowShowing("Lua_ChampionMatchWindow") then
			local msg = ProtoPublic_pb.Proto80216015();
			msg:ParseFromString(mp.data);
			Lua_WindowUtil.openWin("Lua_ChampionMatchTipsWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChampionMatch_Guess, true);
	end
end

-- 通知冠军赛竞猜结果
function Lua_ChampionMatchProxy:onGuessResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216018();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
			Lua_WindowUtil.openWin("Lua_ChampionMatchBettingResultWindow", Lua_WinParam.ACTION_OPEN, msg);
		else
			Lua_WindowUtil.openWin("Lua_ChampionMatchPredResultWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

-- 通知冠军赛荣耀殿堂弹幕更新
function Lua_ChampionMatchProxy:updateBarrage(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216020();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_BARRAGE", msg);
	end
end

-- 通知荣耀殿堂香槟敬酒次数更新
function Lua_ChampionMatchProxy:updateCelebrateTimes(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216023();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:updateHonourRedPoint(msg);
		Lua_MsgUtil.callFunc("CHAMPION_MATCH_CELEBRATE_TIMES", msg);
	end
end

-- 通知冠军赛红点信息
function Lua_ChampionMatchProxy:updateRedPoint(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80216024();
		msg:ParseFromString(mp.data);
		DataCenter.championMatchData:fromServer80216024(msg);
	end
end