Lua_ChampionMatchUtil = class("Lua_ChampionMatchUtil")
function Lua_ChampionMatchUtil:ctor()
	self:superCall("ctor");
end

function Lua_ChampionMatchUtil:dispose()

end

-- 点赞上限
function Lua_ChampionMatchUtil.Get:limitLikeTimes()
	return getConfig("championships_const", "daily_praise_times", "value") or 0;
end

function Lua_ChampionMatchUtil.Get:tabList()
	if self._tabList == nil then
		self._tabList = Array();
		self._tabList:add({ textAtlas = "championship_1", textNormalSprite = "xui_jys_zgnbutton_1_n", textSelectedSprite = "xui_jys_zgnbutton_1_p",
			panel = "Lua_ChampionMatchPanel" });
		self._tabList:add({ textAtlas = "championship_1", textNormalSprite = "xui_jys_zgnbutton_2_n", textSelectedSprite = "xui_jys_zgnbutton_2_p",
			panel = "Lua_ChampionMatchMyCoursePanel", redPointId = Lua_RedPointList.ChampionMatch_MyCourse });
		self._tabList:add({ textAtlas = "champion_match_1", textNormalSprite = "xui_gjs_zgnbutton_1_n", textSelectedSprite = "xui_gjs_zgnbutton_1_p",
			panel = "Lua_ChampionMatchGuessPanel", redPointId = Lua_RedPointList.ChampionMatch_GuessTab });
		self._tabList:add({ textAtlas = "champion_match_1", textNormalSprite = "xui_gjs_zgnbutton_2_n", textSelectedSprite = "xui_gjs_zgnbutton_2_p",
			panel = "Lua_ChampionMatchHonourPanel", redPointId = Lua_RedPointList.ChampionMatch_Honour });
		self._tabList:add({ textAtlas = "championship_1", textNormalSprite = "xui_jys_zgnbutton_4_n", textSelectedSprite = "xui_jys_zgnbutton_4_p",
			panel = "Lua_ChampionMatchCoursePanel" });
	end
	return self._tabList;
end

-- 比分列表
function Lua_ChampionMatchUtil.Get:scoreList()
	return getConfig("championships_const", "score_odds", "arr_value") or {};
end

-- 钻石竞猜下注数量
function Lua_ChampionMatchUtil.Get:diamondBetNum()
	return getConfig("championships_const", "diamond_guess_bet_num", "value") or 1;
end

-- 钻石竞猜下注上限
function Lua_ChampionMatchUtil.Get:diamondBetLimit()
	return getConfig("championships_const", "diamond_guess_bet_limit", "value") or 1;
end

-- 钻石竞猜购买上限
function Lua_ChampionMatchUtil.Get:diamondBuyLimit()
	return getConfig("championships_const", "diamond_guess_buy_limit", "value") or 1;
end

-- 钻石竞猜购买道具
function Lua_ChampionMatchUtil.Get:diamondBuyItemId()
	return getConfig("championships_const", "diamond_guess_buy_item", "arr_value", 1);
end

-- 钻石竞猜购买道具
function Lua_ChampionMatchUtil.Get:diamondBuyItemCount()
	return getConfig("championships_const", "diamond_guess_buy_item", "arr_value", 2);
end

-- 购买N个钻石竞猜币消耗
function Lua_ChampionMatchUtil.Get:diamondBuyCostId()
	return getConfig("championships_const", "diamond_guess_buy_cost", "arr_value", 1);
end

-- 购买N个钻石竞猜币消耗
function Lua_ChampionMatchUtil.Get:diamondBuyCostCount()
	return getConfig("championships_const", "diamond_guess_buy_cost", "arr_value", 2);
end

function Lua_ChampionMatchUtil.Get:guessItemId()
	return getConfig("championships_const", "round_init_coin", "arr_value", 1, 1);
end

function Lua_ChampionMatchUtil.Get:guessLimit()
	return getConfig("championships_const", "bet_limit", "value") or 0;
end

function Lua_ChampionMatchUtil.Get:barrageInputLimit()
	return getConfig("championships_const", "barrage_input_limit", "value") or 20;
end

function Lua_ChampionMatchUtil.Get:barrageLimit()
	return getConfig("championships_const", "barrage_limit", "value") or 50;
end

function Lua_ChampionMatchUtil.Get:courseList1()
	if self._courseList1 == nil then
		self._courseList1 = {
			{ rank = 256, style = 1, posX = -278, posY = 786.5, posX2 = -127, posY2 = 695 },
			{ rank = 256, style = 2, posX = 278, posY = 786.5, posX2 = 230, posY2 = 695 },
			{ rank = 256, style = 1, posX = -278, posY = 354, posX2 = -127, posY2 = 265.5 },
			{ rank = 256, style = 2, posX = 278, posY = 354, posX2 = 230, posY2 = 265.5 },
			{ rank = 256, style = 1, posX = -278, posY = -79.5, posX2 = -127, posY2 = -168 },
			{ rank = 256, style = 2, posX = 278, posY = -79.5, posX2 = 230, posY2 = -168 },
			{ rank = 256, style = 1, posX = -278, posY = -527, posX2 = -127, posY2 = -615 },
			{ rank = 256, style = 2, posX = 278, posY = -527, posX2 = 230, posY2 = -615 },

			{ rank = 128, style = 7, posX = -178, posY = 658.5, posX2 = 50, posY2 = 695 },
			{ rank = 128, style = 7, posX = -178, posY = 226, posX2 = 50, posY2 = 265.5 },
			{ rank = 128, style = 7, posX = -178, posY = -207.5, posX2 = 50, posY2 = -168 },
			{ rank = 128, style = 7, posX = -178, posY = -655, posX2 = 50, posY2 = -615 }
		};
	end
	return self._courseList1;
end

function Lua_ChampionMatchUtil.Get:courseList2()
	if self._courseList2 == nil then
		self._courseList2 = {
			{ rank = 64, style = 1, posX = -278, posY = 353.5, posX2 = -127, posY2 = 264 },
			{ rank = 64, style = 2, posX = 278, posY = 353.5, posX2 = 230, posY2 = 264 },
			{ rank = 64, style = 1, posX = -278, posY = -94.5, posX2 = -127, posY2 = -184 },
			{ rank = 64, style = 2, posX = 278, posY = -94.5, posX2 = 230, posY2 = -184 },
			{ rank = 32, style = 3, posX = -178, posY = 225.5, posX2 = 50, posY2 = 264 },
			{ rank = 32, style = 3, posX = -178, posY = -223, posX2 = 50, posY2 = -184 },
			{ rank = 16, style = 4, posX = 0, posY = 225.5, posX2 = 50, posY2 = 39 }
		};
	end
	return self._courseList2;
end

function Lua_ChampionMatchUtil.Get:courseList3()
	if self._courseList3 == nil then
		self._courseList3 = {
			{ rank = 8, style = 1, posX = -278, posY = 353.5, posX2 = -127, posY2 = 264 },
			{ rank = 8, style = 2, posX = 278, posY = 353.5, posX2 = 230, posY2 = 264 },
			{ rank = 8, style = 1, posX = -278, posY = -94.5, posX2 = -127, posY2 = -184 },
			{ rank = 8, style = 2, posX = 278, posY = -94.5, posX2 = 230, posY2 = -184 },
			{ rank = 4, style = 3, posX = -178, posY = 225.5, posX2 = 50, posY2 = 264 },
			{ rank = 4, style = 3, posX = -178, posY = -223, posX2 = 50, posY2 = -184 },
			{ rank = 2, style = 4, posX = 0, posY = 225.5, posX2 = 50, posY2 = 39 }
		};
	end
	return self._courseList3;
end

function Lua_ChampionMatchUtil:getStageLabel(type, round)
	if type == 3 then
		if round == 1 then -- 4强赛
			return 774026;
		elseif round == 2 then -- 半决赛
			return 774027;
		elseif round == 3 then
			return 774028;
		end
	elseif type == 2 then
		if round == 1 then -- 32强赛
			return 774023;
		elseif round == 2 then -- 16强赛
			return 774024;
		elseif round == 3 then -- 8强赛
			return 774025;
		end
	elseif type == 1 then
		if round == 1 then -- 128强赛
			return 774021;
		elseif round == 2 then -- 64强赛
			return 774022;
		end
	end
	return 774029;
end