checkRequire("Lua_ChatSoundItem");
checkRequire("Lua_ChatHeadIconItem");
checkRequire("Lua_ChatVipItem");
checkRequire("Lua_ChatInfoItem");
checkRequire("Lua_AllianceWishWallInfoItem");
checkRequire("Lua_CollectionBookSingleCardItem");
checkRequire("Lua_CollectBookCardItem");
Lua_ChatHeadLeftItem = class("Lua_ChatHeadLeftItem", Lua_DragContainerItem);
function Lua_ChatHeadLeftItem:ctor(p)
    self.type = 2;
	self:superCall("ctor", p, "ChatHeadLeftItem_skin", false);
end

function Lua_ChatHeadLeftItem:buildShowItem()
	self:superCall("buildShowItem"); 

	self.headIconItem = Lua_ChatHeadIconItem.new(self.content, true);
    self.headIconItem:setRectAnchor(1); 
    self.headIconItem:setLocation(-295, -49, 0);
end

function Lua_ChatHeadLeftItem:clean()
    self.chatData = nil;
    self.headIconItem:clean();
    if self.soundItem ~= nil then
        self.soundItem:clean();
    end
    if self.equipCopyItem ~= nil then
        self.equipCopyItem:clean();
    end
    if self.allianceWishWallItem ~= nil then
        self.allianceWishWallItem:clean();
    end
    if self.collectBookSingleCardItem ~= nil then
        self.collectBookSingleCardItem:clean();
    end
    if self.collectBookCardItem ~= nil then
        self.collectBookCardItem:clean();
    end
    if self.emjioEff ~= nil then
        self.emjioEff:setEnable(false);
    end
    if self.infoItem ~= nil then
        self.infoItem:clean();
    end
    self:superCall("clean");
end

function Lua_ChatHeadLeftItem:dispose()
    if self.headIconItem ~= nil then
        self.headIconItem:dispose();
        self.headIconItem = nil;
    end
    
    if self.infoItem ~= nil then
        self.infoItem:dispose();
        self.infoItem = nil;
    end

    if self.soundItem ~= nil then
        self.soundItem:dispose();
        self.soundItem = nil;
    end

    if self.equipCopyItem ~= nil then
        self.equipCopyItem:dispose();
        self.equipCopyItem = nil;
    end

    if self.allianceWishWallItem ~= nil then
        self.allianceWishWallItem:dispose();
        self.allianceWishWallItem = nil;
    end

    if self.collectBookSingleCardItem ~= nil then
        self.collectBookSingleCardItem:dispose();
        self.collectBookSingleCardItem = nil;
    end
    
    if self.collectBookCardItem ~= nil then
        self.collectBookCardItem:dispose();
        self.collectBookCardItem = nil;
    end

    if self.emjioEff ~= nil then
        self.emjioEff:dispose();
        self.emjioEff = nil;
    end
    self:superCall("dispose");
end

function Lua_ChatHeadLeftItem:getWidth()
    return 695;
end

function Lua_ChatHeadLeftItem:getHeight()
    if self.chatData.content_type == Lua_ChatData.CONTENT_EQUIP_COPY then--寂灭岛邀请分享
        return 196 + 15;
    elseif self.chatData.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD or self.chatData.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK then--收藏册
        return 376 + 15;
    elseif self.chatData.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
        return self.emojiHeight + 70 + 15;
    else
        local lineCount = Mathf.Ceil((self.height-24)/26);
        if lineCount <= 2 then
            return 127;
        else
            return 75 + (self.height-24) + 15;
        end
    end
end

function Lua_ChatHeadLeftItem:setData(vo)
    self.chatData = vo;
    local cellWidth = self:getWidth();
    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then -- 实时更新私聊目标的玩家信息
        local chatId = DataCenter.chatData.selectPrivate; 
        local friendInfo = DataCenter.chatData.lastestRoleAvatar[chatId].friendInfo;
        self.headIconItem:setData(friendInfo);
    else
        self.headIconItem:setData(vo.chat_player);
    end

    local nameStr = LanUtil.formateStr(171056, vo.chat_player.name);
    if vo.channel == Lua_ChatData.CHANNEL_LEAGUE then
        nameStr = LanUtil.formateStr(171057, DataCenter.allianceUtil:getLeagueIdentityByPosition(vo.chat_player.league_position), nameStr);
    end

    if (vo.channel == Lua_ChatData.CHANNEL_WORLD or vo.channel == Lua_ChatData.CHANNEL_LEAGUE ) and DataCenter.crossServerData.isOpened then
        local str = vo.chat_player.server_prev;--DataCenter.roleData:getShowServerName(vo.chat_player.server_name);
        nameStr = LanUtil.formateStr(171057, str, nameStr);
    end

    local bShowVip = false;
    if bShowVip == false then
        self.nameStr:setLocation(105, -21);
    end
    self.nameStr.text = nameStr;

    self.nameStr:resetSize();
    self.sexSp:setAltas("chat_atlas", "ui_liaotian_icon_0"..(3 - vo.chat_player.sex));
    self.sexSp:resetSize();
    self.sexSp:setLocation(self.nameStr.posX + 12 + self.nameStr.preferredWidth, -21, 0);-- 28 -11
    self:showVip(bShowVip, vo.chat_player.vip);


    --聊天展示Item
    self.contentBg:setEnable(false);
    if self.infoItem ~= nil then
        self.infoItem:setEnable(false);
    end
    if self.soundItem ~= nil then
        self.soundItem:setEnable(false);
    end
    if self.equipCopyItem ~= nil then
        self.equipCopyItem:setEnable(false);
    end
    if self.allianceWishWallItem ~= nil then
        self.allianceWishWallItem:setEnable(false);
    end
    if self.collectBookSingleCardItem ~= nil then
        self.collectBookSingleCardItem:setEnable(false);
    end
    if self.collectBookCardItem ~= nil then
        self.collectBookCardItem:setEnable(false);
    end
    if self.emjioEff ~= nil then
        self.emjioEff:setEnable(false);
    end
    if vo.content_type == Lua_ChatData.CONTENT_VOICE then--语音
        if self.soundItem == nil then
            self.soundItem = Lua_ChatSoundItem.new(self.content, 1);
            self.soundItem:setRectAnchor(1);
        end
        self.soundItem:setEnable(true);
        self.soundItem:setLocation(-211,-76,0);
        self.soundItem:setData(vo);
        self.contentBg:setEnable(false);
        self.height = 50;
    elseif vo.content_type == Lua_ChatData.CONTENT_EQUIP_COPY then--寂灭岛邀请分享
        if self.equipCopyItem == nil then
            self.equipCopyItem = Lua_EquipCopyInfoItem.new(self.content, 1);
            self.equipCopyItem:setRectAnchor(1);
        end
        self.equipCopyItem:setEnable(true);
        self.equipCopyItem:setData(vo);
        self.contentBg:setEnable(false);
        self.equipCopyItem:setLocation(33, -114, 0);
        -- self.height = self.equipCopyItem:getHeight();
    elseif vo.content_type == Lua_ChatData.CONTENT_ALLIANCE_WISHWALL then -- 公会-心愿墙 心愿助力
        if self.allianceWishWallItem == nil then
            self.allianceWishWallItem = Lua_AllianceWishWallInfoItem.new(self.content, 1);
            self.allianceWishWallItem:setRectAnchor(1);
        end
        self.allianceWishWallItem:setEnable(true);
        self.allianceWishWallItem:setData(vo);
        self.allianceWishWallItem:setLocation(-54, -45, 0);
        self.height = self.allianceWishWallItem:getHeight();
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD then--单卡牌分享
        if self.collectBookSingleCardItem == nil then
            self.collectBookSingleCardItem = Lua_CollectionBookSingleCardItem.new(self.content, 1);
            self.collectBookSingleCardItem:setRectAnchor(0); 
            self.collectBookSingleCardItem:setRectPivot(0);
        end
        self.collectBookSingleCardItem:setEnable(true);
        self.collectBookSingleCardItem:setData(vo);
        self.collectBookSingleCardItem:setLocation(99, -42, 0);
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK then--卡册分享
        if self.collectBookCardItem == nil then
            self.collectBookCardItem = Lua_CollectBookCardItem.new(self.content, 1);
            self.collectBookCardItem:setRectAnchor(1);
        end
        self.collectBookCardItem:setEnable(true);
        self.collectBookCardItem:setData(vo);
        self.collectBookCardItem:setLocation(-125, -208, 0);
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
        local emojiInfo = DataCenter.chatData:getConfigById(vo.content);
        if emojiInfo == nil then
            return;
        end
        self.emojiWidget = 101;
        self.emojiHeight = 101;
        if self.emjioEff == nil then
            self.emjioEff = UICreate.createUIEffect(self.content, nil, nil, -173, -65)
        end
        self.emjioEff:setEnable(true);
        self.emjioEff:setUrl(emojiInfo.url, emojiInfo.matName);
        self.contentBg:setEnable(true);
        self.contentBg:SetDimensions(self.emojiWidget + 41, self.emojiHeight + 19);
    else
        if self.infoItem == nil then
            self.infoItem = Lua_ChatInfoItem.new(self.content, cellWidth - 230);
            self.infoItem:setRectAnchor(1); 
        else
            self.infoItem:setEnable(true);
            self.infoItem:setTxtWidth(cellWidth - 230);
        end
        self.infoItem:setLocation(-223, -50, 0);
        self.infoItem:setChatData(vo);
        self.infoItem:setData("<color=#192e41>"..vo:getMsg(false, false).."</color>");

        local w = self.infoItem:getWidth() + 40;
        self.height = self.infoItem:getHeight() + 19;
        self.contentBg:setEnable(true);
        self.contentBg:SetDimensions(w, self.height);
    end
end

function Lua_ChatHeadLeftItem:onPressClick()
    if self.infoItem ~= nil then
        self.infoItem:checkUrlClick();
    end
end

function Lua_ChatHeadLeftItem:showVip(bShow, VIPLevel)
    if bShow then
        if self.vipItem == nil then
            self.vipItem = Lua_ChatVipItem.new(self.content);
            self.vipItem:setRectAnchor(0); 
        end
        self.vipItem:setVipLevel(VIPLevel);
        self.vipItem:setLocation(119, -21, 0);
        self.vipItem:setEnable(true);
    else
        if self.vipItem ~= nil then
            self.vipItem:setEnable(false);
        end
    end
end