-- 收藏册单个卡牌
checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionBookSingleCardItem = class("Lua_CollectionBookSingleCardItem", Lua_DisplayObject);
function Lua_CollectionBookSingleCardItem:ctor(p,t)
	self:superCall("ctor", p, "CollectionBookSingleCardItem_skin");
	self.dire = t;--1左边，2右边
end
function Lua_CollectionBookSingleCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setCallBack(self, self.onOpenSingleCardClick);
end

function Lua_CollectionBookSingleCardItem:clean()
	self.playerInfo = nil;
	self.flashItem:clean();
end

function Lua_CollectionBookSingleCardItem:getWidth()
	return 400;
end

function Lua_CollectionBookSingleCardItem:getHeight()
	return 322;
end

function Lua_CollectionBookSingleCardItem:setData(chatVo)
	local info = chatVo.recordInfo;
	if info == nil then
		return;
	end

	-- clean会将回调清空
	self.flashItem:setCallBack(self, self.onOpenSingleCardClick);

	-- self.playerInfo = chatVo.chat_player;
	self.cardId = tonumber(info.value);--;101000105201
	self.time = tonumber(info.sub);

	local cardCfg = Lua_CollectionBookConfigData.getConfig(self.cardId);
	if cardCfg == nil or cardCfg.bCompletion ~= true then
		return;
	end

	local flashId = cardCfg.flash_id;
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
	local facScale = flashInfo.showNewCard and 0.28 or 0.36;
	self.flashItem:setScale(facScale, facScale);
	self.flashItem:setData(flashInfo);
	--特效
	local bShowEffect = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.cardId);
	self:showEffect(bShowEffect);


	self.playerInfo = chatVo.chat_player;
	self.contentTxt.text = LanUtil.formateStr(410059, flashInfo.flash_card_name);
	self.contentTxt:resetSize();
	self.widget = self.contentTxt.preferredWidth;
	self.widget = self.widget <= 238 and 238 or self.widget;
	self.widget = self.widget + 30;
	self.bg:SetDimensions(self.widget, 322);
	self:setRectSize(self.widget, 322);

	if self.dire == 1 then
		self.bg:setAltas("chat_atlas", "ui_liaotian_window_003");
		self.flashItem:setRectAnchor(0);
		self.flashItem:setLocation(129, -176);
		self.contentTxt:setLocation(22, -7);
	else
		self.bg:setAltas("chat_atlas", "ui_liaotian_window_002");
		self.flashItem:setRectAnchor(2);
		self.flashItem:setLocation(-134, -176);
		self.contentTxt:setLocation(13, -7);
	end
end

function Lua_CollectionBookSingleCardItem:showEffect(bShow)
    if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.content, "/effects/uiEffects/ui_scc_sk_0002", "ui_scc_sk_0002", 0, 0);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end

function Lua_CollectionBookSingleCardItem:onOpenSingleCardClick()
	if self.playerInfo == nil then
		return;
	end

	DataCenter.collectionBookData:updateOtherPlayerSingleCard(self.cardId, self.time)
	DataCenter.collectionBookData:setOtherPlayerInfo(self.playerInfo);
	if DataCenter.collectionBookData.bShowOldVersion then
		Lua_WindowUtil.openWin("Lua_CollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, {cardId = self.cardId, isOpenFromChat = true});
	else
		Lua_WindowUtil.openWin("Lua_NewCollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, {cardId = self.cardId, isOpenFromChat = true});
	end
	Lua_WindowUtil.openWin("Lua_ChatWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_CollectionBookSingleCardItem:dispose()
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.effect ~= nil then
        self.effect:dispose();
        self.effect = nil;
    end
	self:superCall("dispose");
end
