-- 收藏册单张卡牌配置表数据
Lua_CollectionBookConfigData = class("Lua_CollectionBookConfigData");
function Lua_CollectionBookConfigData.getConfig(id)
	if id == nil then
		return nil;
	end
	
	id = tonumber(id);
	if Lua_CollectionBookConfigData.configDic == nil then
		Lua_CollectionBookConfigData.configDic = {};
	end

	if Lua_CollectionBookConfigData.configDic[id] == nil then
		local cfg = getConfig("collection_book", id);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_CollectionBookConfigData.configDic[id] = Lua_CollectionBookConfigData.new(id, cfg);
	end
	return Lua_CollectionBookConfigData.configDic[id];
end

function Lua_CollectionBookConfigData:ctor(id, config)
	self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
	    self.config = getConfig("collection_book", id);
	end
end

function Lua_CollectionBookConfigData.Get:bCompletion()
	return self.completion_card == 1;
end

function Lua_CollectionBookConfigData.Get:prop_add_desc()
	if self.prop_type == 0 then
		return LanUtil.getValue(410044);--"所有英雄加成：";
	elseif self.prop_type == 1 then
		return LanUtil.getValue(410045);--"灵州英雄加成：";
	elseif self.prop_type == 2 then
		return LanUtil.getValue(410046);--"云渊英雄加成："
	elseif self.prop_type == 3 then
		return LanUtil.getValue(410047);--"岚谷英雄加成：";
	elseif self.prop_type == 4 then
		return LanUtil.getValue(410048);--"武境英雄加成：";
	end
end

-- 普卡&&是否是英雄系统收集
function Lua_CollectionBookConfigData.Get:fromHeroSystem()
	local bagId = self.hero_id;
	local cfg = getConfig("collection_bag", bagId);
	if cfg == nil or cfg.common ~= self.id then
		return false;
	end

	local type = cfg.sub_type;
	if type == Lua_CollectionBookUtil.MODEL_CARD or 
		type == Lua_CollectionBookUtil.FRAME_CARD or
		type == Lua_CollectionBookUtil.CONTACT_CARD then
			return true;
	end

	return false;
end

-- 普卡&&是否为仅有卡
function Lua_CollectionBookConfigData.Get:checkOnlyCard()
	local bagId = self.hero_id;
	local cfg = getConfig("collection_bag", bagId);
	if cfg == nil or cfg.common ~= self.id then
		return false;
	end

	local type = cfg.sub_type;
	return type == Lua_CollectionBookUtil.ONLY_CARD;
end

-- 是否为英雄闪卡
function Lua_CollectionBookConfigData.Get:checkHeroCard()
	return DataCenter.collectionBookUtil:checkCardTypeById(self.id, Lua_CollectionBookUtil.FLASH_CARD) == true;
end

-- 是否为皮肤闪卡
function Lua_CollectionBookConfigData.Get:checkClothCard()
	return DataCenter.collectionBookUtil:checkCardTypeById(self.id, Lua_CollectionBookUtil.CLOTH_CARD) == true;
end









-------------------------------------------------------------
-- 子类型
function Lua_CollectionBookConfigData.Get:sub_type()
	return self.config.sub_type;
end

-- 英雄id
function Lua_CollectionBookConfigData.Get:hero_id()
	return self.config.hero_id;
end

-- 兑换道具
function Lua_CollectionBookConfigData.Get:change_item()
	return self.config.change_item;
end

-- 是否制作完成
function Lua_CollectionBookConfigData.Get:completion_card()
	return self.config.completion_card;
end

-- 卡牌名称
function Lua_CollectionBookConfigData.Get:card_Name()
	return self.config.card_Name;
end

-- 闪卡id
function Lua_CollectionBookConfigData.Get:flash_id()
	return tonumber(self.config.flash_id);
end

-- 皮肤加成类型
function Lua_CollectionBookConfigData.Get:prop_type()
	return self.config.prop_type;
end

-- 加成属性
function Lua_CollectionBookConfigData.Get:card_prop()
	return self.config.card_prop;
end

-- 英雄皮肤id
function Lua_CollectionBookConfigData.Get:cloth_id()
	return self.config.cloth_id;
end

-- 卡册封面
function Lua_CollectionBookConfigData.Get:page_img()
	return self.config.page_img;
end