checkRequire("Lua_CollectionBookVo");
checkRequire("Lua_FlashCardConfigData")
Lua_CollectionBookData = class("Lua_CollectionBookData");
function Lua_CollectionBookData:ctor()
end

function Lua_CollectionBookData:dispose()
	if self.collectionBookVoDic then
		for k, v in pairs(self.collectionBookVoDic) do
			v:dispose();
			v = nil;
		end
		self.collectionBookVoDic = nil;
	end

	self.ownerPageIdDic = nil;
	self.ownerPageIds = nil;
	self._curFlaCount = nil;
	self._curComCount = nil;
	self.residueAdmireCount = nil;
	self.bUpdateRankInfo = nil;

	self.otherPageIds = nil;
	self.bShowRewardRed = nil;
	self.flashCardPropDic = nil;
	self._bShowOldVersion = nil;
	self:clearOtherPlayerInfo();
	self:clearActiveCardData();
	self:clearPageEditData();
	self:clearListenActiveItemData();

	self:newClearActiveCardData();
	self._selectEditPageCardId = nil;
	if self._sortPageEditArr then
		self._sortPageEditArr:dispose();
		self._sortPageEditArr:clear();
		self._sortPageEditArr = nil;
	end


	--羁绊
    if self._fetterDic ~= nil then
    	for k, v in pairs(self._fetterDic) do
    		v = nil;
    	end
		self._fetterDic = nil;
	end
	self._fetterHeroDic = nil;
	self._bUpdateDataFromServer = nil;
	self._fetterHasRewardIndex = nil;
	self._collectionTotalAttrib = nil;
end

-- 自身卡册封面信息
function Lua_CollectionBookData:fromServer50203001(msg)
	if msg == nil then
		return;
	end

	if self.ownerPageIds == nil then
		self.ownerPageIdDic = {};
		self.ownerPageIds = {0, 0, 0};
	end

	local id;
	local obj = msg.cover_list;
	local count = #obj;
	for i = 1, count do
		id = tonumber(obj[i]);
		self.ownerPageIdDic[id] = i;
		self.ownerPageIds[i] = id;
	end

	self._curFlaCount = msg.flash_amount;
	self._curComCount = msg.common_amount;
end

-- 请求卡册普卡信息(返回)
function Lua_CollectionBookData:fromServer50203003(msg)
	if msg == nil then
		return;
	end

	if self.itemDir == nil then
		self:initNeedActiveItem();
	end
	local bagId;
	local obj;
	local vo;
	for i = 1, #msg.card_list do
		obj = msg.card_list[i];
		self:checkActiveCardInfo(obj);

		bagId = tonumber(obj.bag_id);
		vo = self:getCollectionBookVoById(bagId);
		if vo then
			vo:fromServer(obj);
		end
	end

	self:clearActiveCardData();
	self:newClearActiveCardData();

	self:updateRewardRedPointState();
	self:updateRedPointWhenActiveCard();
end

-- 请求激活卡牌(返回)
function Lua_CollectionBookData:fromServer50203005(msg)
	if msg == nil then
		return;
	end

	local obj = msg.card_info;
	self:checkActiveCardInfo(obj);

	local bagId = tonumber(obj.bag_id);
	local vo = self:getCollectionBookVoById(bagId);
	if vo then
		vo:fromServer(obj);
		self:clearActiveCardData();
		self:newClearActiveCardData();
	end

	self:updateRewardRedPointState();
	self:updateRedPointWhenActiveCard();
end

-- 请求卡牌放入卡册(返回)
function Lua_CollectionBookData:fromServer50203006(msg)
	if msg == nil then
		return;
	end

	local obj = msg.card_info;
	local bagId = tonumber(obj.bag_id);
	local vo = self:getCollectionBookVoById(bagId);
	if vo then
		vo:fromServer(obj);
		self:clearActiveCardData();
		self:newClearActiveCardData();
	end
end

-- 请求给其他玩家点赞(返回)
function Lua_CollectionBookData:fromServer50203007(msg)
	if msg == nil then
		return;
	end
	 -- 登录时发0申请剩余次数，其余刷新排行榜
    if self.bUpdateRankInfo then
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBRankInfo(); -- 刷新排行榜信息
    end
    self.bUpdateRankInfo = true;
	self.residueAdmireCount = tonumber(msg.times);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_Rank, self.residueAdmireCount > 0);
end

-- 通知收藏册排行榜刷新(返回)跨天
function Lua_CollectionBookData:fromServer80203008(msg)
    if msg == nil then
        return;
    end

	local bShow = msg.flag == 1;
	if bShow then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_Rank, true);
	end
end

-- 请求领取奖励(返回)
function Lua_CollectionBookData:fromServer50203009(msg)
	if msg == nil then
		return;
	end

	local obj = msg.card_info;
	local bagId = tonumber(obj.bag_id);
	local vo = self:getCollectionBookVoById(bagId);
	if vo then
		vo:fromServer(obj);
	end
	self:updateRewardRedPointState();
end

-- 请求请求玩家卡册信息(返回)
function Lua_CollectionBookData:fromServer50203010(msg)
	-- self:clearOtherPlayerInfo();
	if msg == nil then
		return;
	end

	self.otherPCardInfo = msg.card_show;
	self.otherCanAdmire = msg.is_like == 0;
	if self.otherPageIds == nil then
		self.otherPageIds = {0, 0, 0};
	end

	local cardId;
	local activeTime;
	local bCompleteCard;
	local obj = msg.card_show.cover_list; --封面展示卡牌列表 key 卡牌id value 激活时间戳
	local cardCfg;
	-- 封面
	for i = 1, #obj do
		cardId = tonumber(obj[i].key);
		activeTime = tonumber(obj[i].value);

		cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
		if cardCfg then
			local bagId = cardCfg.hero_id;
			local vo = self:getCollectionBookVoById(bagId);
			if vo then
				vo:updateOtherCard(cardId, activeTime);
				self.otherPageIds[i] = cardId;
			end
		end
	end

	-- 分享卡包信息
	local bagId;
	obj = msg.card_show.share_bag;
	for i = 1, #obj do
		bagId = tonumber(obj[i].bag_id);
		local vo = self:getCollectionBookVoById(bagId);
		if vo then
			vo:fromServerOtherPlayer(obj[i]);
		end
	end

	local vo;
	local bagId;
	obj = msg.card_show.card_list; --收藏卡牌列表
	for i = 1, #obj do
		cardId = tonumber(obj[i].key);
		activeTime = tonumber(obj[i].value);

		bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		vo = self:getCollectionBookVoById(bagId); 
		if vo then
			vo:updateOtherCard(cardId, activeTime);
		end
	end
end

-- 请求收藏册闪卡详情(返回)
function Lua_CollectionBookData:fromServer50203011(msg)
	if msg == nil then
		return;
	end

	self.flashCardPropDic = {};

	local bagId;
	local cardId;
	local bCheck = false;
	local obj = msg.card_list;
	for i = 1, #obj do
		cardId = tonumber(obj[i]);
		bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		if getConfig("collection_bag", bagId) and DataCenter.collectionBookUtil:bShieldCardBag(bagId) ~= true and 
			getConfig("collection_book", cardId, "completion_card") == 1 then
			bCheck = true;
			self.flashCardPropDic[cardId] = true;
		end
	end
	
	Lua_MsgUtil.callFunc("UPDATE_COLLECTIONBOOK_VIEWFLASHPROP");
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_FlashCardProp, bCheck);
end

function Lua_CollectionBookData:getCollectionBookVoById(id)
	id = tonumber(id);
	if self.collectionBookVoDic == nil then
		self.collectionBookVoDic = {};
	end

	local vo = self.collectionBookVoDic[id];
	if vo == nil then
		local cfg = getConfig("collection_bag", id);
		if cfg == nil then
			return;
		end

		vo = Lua_CollectionBookVo.new(id, cfg);
		self.collectionBookVoDic[id] = vo;
	end

	return vo;
end

function Lua_CollectionBookData.Get:curFlaCount()
	return self._curFlaCount or 0;
end

function Lua_CollectionBookData.Get:curComCount()
	return self._curComCount or 0;
end

function Lua_CollectionBookData:checkFlashCardProp(cardId)
	if self.flashCardPropDic == nil then
		return false;
	end

	return self.flashCardPropDic[cardId] == true;
end

















-- 封面编辑
function Lua_CollectionBookData:setPageEditId(index, cardId)
	if self.editPageIds == nil then
		self:getPageEditIds();
	end
	cardId = tonumber(cardId);
	cardId = cardId <= 0 and 0 or cardId;
	if self.editPageIds[index] ~= nil then
		local id = self.editPageIds[index];
		self.editPageIds[index] = cardId;
		self.editSelectedIdDir[id] = nil;
		self.editSelectedIdDir[cardId] = index;
	end
end

-- 封面编辑
function Lua_CollectionBookData:getPageEditIds()
	if self.editPageIds == nil then
		local id;
		self.editPageIds = {};
		self.editSelectedIdDir = {};
		for i = 1, #self.ownerPageIds do
			id = self.ownerPageIds[i];
			self.editPageIds[i] = id;
			self.editSelectedIdDir[id] = i;
		end
	end
	return self.editPageIds;
end

-- 封面编辑时是否被选中
function Lua_CollectionBookData:getEditBSelectedById(cardId)
	cardId = tonumber(cardId);
	if self.editSelectedIdDir == nil then
		self:getPageEditIds();
	end

	return self.editSelectedIdDir[cardId];
end

function Lua_CollectionBookData:getEditCardIdByIndex(index)
	if self.editPageIds == nil then
		self:getPageEditIds();
	end
	return self.editPageIds[index];
end

-- 封面编辑
function Lua_CollectionBookData:clearPageEditData()
	self.editPageIds = nil;
	self.editSelectedIdDir = nil;
end

function Lua_CollectionBookData:setOtherPlayerInfo(otherPlayerInfo)
	self.otherPlayerInfo = otherPlayerInfo;
end

function Lua_CollectionBookData:getOtherPlayerInfo()
	return self.otherPlayerInfo;
end

function Lua_CollectionBookData:updateOtherPlayerSingleCard(cardId, time)
	local cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
	if cardCfg == nil then
		return;
	end

	local bagId = cardCfg.hero_id;
	local cBookVo = self:getCollectionBookVoById(bagId);
	if cBookVo == nil then
		return;
	end
	cBookVo:updateOtherCard(cardId, time);
end

function Lua_CollectionBookData:clearOtherSingleCard(cardId)
	local cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
	if cardCfg == nil then
		return;
	end

	local bagId = cardCfg.hero_id;
	local cBookVo = self:getCollectionBookVoById(bagId);
	if cBookVo == nil then
		return;
	end

	cBookVo:clearOtherPlayerInfo();
end

function Lua_CollectionBookData:clearOtherPlayerInfo()
	self.otherPageIds = nil;
	self.otherCanAdmire = nil;
	self.otherPCardInfo = nil;
	self.otherPlayerInfo = nil;
	if self.collectionBookVoDic then
		for k, v in pairs(self.collectionBookVoDic) do
			v:clearOtherPlayerInfo();
		end
	end

	self:clearOtherActiveCardData();
	self:newClearOtherActiveCardData();
end

















----------------------------- 收藏册旧排版------------------------
function Lua_CollectionBookData:analysisActiveCardData()
	self._activePushIdBagIds = {}; --激活卡包
	self._activeWeaponBagIds = {}; -- 神兵列传卡包id
	self._activeClassicBagIds = {}; -- 经典卡卡包id
	self._activeFrameBagIds = {}; -- 名人堂卡包id
	self._activeContactBagIds = {}; -- 联动卡卡包id
	self._activeFlashCardIds = {}; -- 闪卡卡包id

	self._activeComCardWeaponCount = 0; -- 神兵列传激活普卡数量
	self._activeFlaCardWeaponCount = 0; -- 神兵列传激活闪卡数量
	self._activeFlaCardWeaponTCount = 0; -- 神兵列传激活的卡包中全部的闪卡数量

	self._activeClassicCardCount = 0; -- 经典卡激活普卡数量

	self._activeComCardFrameCount = 0; -- 名人堂激活普卡数量
	self._activeFlaCardFrameCount = 0; -- 名人堂激活闪卡数量
	self._activeFlaCardFrameTCount = 0; -- 名人堂激活的卡包中全部的闪卡数量

	self._activeComCardContactCount = 0; -- 联动卡激活普卡数量
	self._activeFlaCardContactCount = 0; -- 联动卡激活闪卡数量
	self._activeFlaCardContactTCount = 0; -- 联动卡激活的卡包中全部的闪卡数量

	local vo;
	local time;
	local bagId;
	local cardId;
	local allBagIds = DataCenter.collectionBookUtil.allBagIds;
	for i = 1, #allBagIds do
		bagId = allBagIds[i];
		vo = self:getCollectionBookVoById(bagId);
		if vo then
			local active_com_num = vo.hasCommonCount;
			local active_fla_num = vo.hasFlashCount;

			local active_cla_num = vo.hasClassicCount;
			local fla_TCount = vo.flashCount;
			self._activeClassicCardCount = self._activeClassicCardCount + active_cla_num;

			cardId = vo.pushId;
			if vo:checkActiveByCardId(cardId) then
				if vo.card_type == 1 then 
					self._activeComCardWeaponCount = self._activeComCardWeaponCount + active_com_num;
					self._activeFlaCardWeaponCount = self._activeFlaCardWeaponCount + active_fla_num;
					self._activeFlaCardWeaponTCount = self._activeFlaCardWeaponTCount + fla_TCount;
					self._activeWeaponBagIds[#self._activeWeaponBagIds + 1] = bagId;
				elseif vo.card_type == 2 then
					self._activeComCardFrameCount = self._activeComCardFrameCount + active_com_num;
					self._activeFlaCardFrameCount = self._activeFlaCardFrameCount + active_fla_num;
					self._activeFlaCardFrameTCount = self._activeFlaCardFrameTCount + fla_TCount;
					self._activeFrameBagIds[#self._activeFrameBagIds + 1] = bagId;
				elseif vo.card_type == 3 then
					self._activeComCardContactCount = self._activeComCardContactCount + active_com_num;
					self._activeFlaCardContactCount = self._activeFlaCardContactCount + active_fla_num;
					self._activeFlaCardContactTCount = self._activeFlaCardContactTCount + fla_TCount;
					self._activeContactBagIds[#self._activeContactBagIds + 1] = bagId;
				end
				self._activePushIdBagIds[#self._activePushIdBagIds + 1] = bagId;
			end

			if vo:checkActiveByCardId(vo.classic) then
				self._activeClassicBagIds[#self._activeClassicBagIds + 1] = bagId;
			end

			if vo:checkActiveByCardId(vo.flash) then
				self._activeFlashCardIds[#self._activeFlashCardIds + 1] = vo.flash;
			end

			local cloth_cards = vo.cloth_card;
			if cloth_cards and #cloth_cards > 0 then
				for i = 1, #cloth_cards do
					cardId = cloth_cards[i];
					if vo:checkActiveByCardId(cardId) then
						self._activeFlashCardIds[#self._activeFlashCardIds + 1] = cardId;
					end
				end
			end
		end
	end

	self._activePushIdBagIds = self:sortActiveBagId(self._activePushIdBagIds);
	self._activeWeaponBagIds = self:sortActiveBagId(self._activeWeaponBagIds);
	self._activeClassicBagIds = self:sortActiveBagId(self._activeClassicBagIds);
	self._activeFrameBagIds = self:sortActiveBagId(self._activeFrameBagIds);
	self._activeContactBagIds = self:sortActiveBagId(self._activeContactBagIds);

	if #self._activeFlashCardIds > 1 then
		table.sort( self._activeFlashCardIds, function(a, b) 
				local aCfg = Lua_CollectionBookConfigData.getConfig(a);
				local bCfg = Lua_CollectionBookConfigData.getConfig(b);
				local aBagId = aCfg.hero_id;
				local bBagId = bCfg.hero_id;
				local aVo = self:getCollectionBookVoById(aBagId);
				local bVo = self:getCollectionBookVoById(bBagId);
				local aSort = aVo:getFlashSortWeightByCard(a);
				local bSort = bVo:getFlashSortWeightByCard(b);
				return aSort > bSort;
			end);
	end
end

function Lua_CollectionBookData:sortActiveBagId(ids)
	if ids == nil or #ids <= 1 then 
		return ids;
	end

	table.sort(ids, function(a, b) 
			local aVo = self:getCollectionBookVoById(a);
			local bVo = self:getCollectionBookVoById(b);
			local aSort = aVo.sort or 0;
			local bSort = bVo.sort or 0;
			return aSort < bSort;
		end);

	return ids;
end

function Lua_CollectionBookData:clearActiveCardData()
	self._activePushIdBagIds = nil; -- 激活的卡包
	self._activeWeaponBagIds = nil; -- 神兵列传
	self._activeClassicBagIds = nil; -- 经典卡
	self._activeFrameBagIds = nil; -- 名人堂
	self._activeContactBagIds = nil; -- 联动卡
	self._activeFlashCardIds = nil; -- 闪卡

	self._activeComCardWeaponCount = nil; -- 神兵列传激活普卡数量
	self._activeFlaCardWeaponCount = nil; -- 神兵列传激活闪卡数量
	self._activeFlaCardWeaponTCount = nil; -- 神兵列传激活的卡包中全部的闪卡数量

	self._activeClassicCardCount = nil; -- 经典卡激活数量

	self._activeComCardFrameCount = nil; -- 名人堂激活普卡数量
	self._activeFlaCardFrameCount = nil; -- 名人堂激活闪卡数量
	self._activeFlaCardFrameTCount = nil; -- 名人堂激活的卡包中全部的闪卡数量

	self._activeComCardContactCount = nil; -- 联动卡激活普卡数量
	self._activeFlaCardContactCount = nil; -- 联动卡激活闪卡数量
	self._activeFlaCardContactTCount = nil; -- 联动卡激活的卡包中全部的闪卡数量
end

function Lua_CollectionBookData.Get:activePushIdBagIds()
	if self._activePushIdBagIds == nil then
		self:analysisActiveCardData();
	end

	return self._activePushIdBagIds;
end

function Lua_CollectionBookData.Get:activeWeaponBagIds()
	if self._activeWeaponBagIds == nil then
		self:analysisActiveCardData();
	end

	return self._activeWeaponBagIds;
end

function Lua_CollectionBookData.Get:activeClassicBagIds()
	if self._activeClassicBagIds == nil then
		self:analysisActiveCardData();
	end

	return self._activeClassicBagIds;
end

function Lua_CollectionBookData.Get:activeFrameBagIds()
	if self._activeFrameBagIds == nil then
		self:analysisActiveCardData();
	end

	return self._activeFrameBagIds;
end

function Lua_CollectionBookData.Get:activeContactBagIds()
	if self._activeContactBagIds == nil then
		self:analysisActiveCardData();
	end

	return self._activeContactBagIds;
end

function Lua_CollectionBookData.Get:activeFlashCardIds()
	if self._activeFlashCardIds == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlashCardIds;
end

function Lua_CollectionBookData.Get:activeComCardWeaponCount()
	if self._activeComCardWeaponCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeComCardWeaponCount;
end

function Lua_CollectionBookData.Get:activeFlaCardWeaponCount()
	if self._activeFlaCardWeaponCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlaCardWeaponCount;
end

-- 神兵列传激活的卡包中全部的闪卡数量
function Lua_CollectionBookData.Get:activeFlaCardWeaponTCount()
	if self._activeFlaCardWeaponTCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlaCardWeaponTCount;
end

function Lua_CollectionBookData.Get:activeClassicCardCount()
	if self._activeClassicCardCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeClassicCardCount;
end

function Lua_CollectionBookData.Get:activeComCardFrameCount()
	if self._activeComCardFrameCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeComCardFrameCount;
end

function Lua_CollectionBookData.Get:activeFlaCardFrameCount()
	if self._activeFlaCardFrameCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlaCardFrameCount;
end

-- 名人堂激活的卡包中全部的闪卡数量
function Lua_CollectionBookData.Get:activeFlaCardFrameTCount()
	if self._activeFlaCardFrameTCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlaCardFrameTCount;
end

function Lua_CollectionBookData.Get:activeComCardContactCount()
	if self._activeComCardContactCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeComCardContactCount;
end

function Lua_CollectionBookData.Get:activeFlaCardContactCount()
	if self._activeFlaCardContactCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlaCardContactCount;
end

-- 联动卡激活的卡包中全部的闪卡数量
function Lua_CollectionBookData.Get:activeFlaCardContactTCount()
	if self._activeFlaCardContactTCount == nil then
		self:analysisActiveCardData();
	end

	return self._activeFlaCardContactTCount;
end





------------------其他玩家---------------
function Lua_CollectionBookData:analysisOtherActiveCardData()
	self._otherActiveWeaponBagIds = {}; -- 神兵列传
	self._otherActiveClassicBagIds = {}; -- 经典卡
	self._otherActiveFrameBagIds = {}; -- 名人堂
	self._otherActiveContactBagIds = {}; -- 联动卡

	self._otherActiveComCardWeaponCount = 0; -- 神兵列传激活普卡数量
	self._otherActiveFlaCardWeaponCount = 0; -- 神兵列传激活闪卡数量
	self._otherActiveFlaCardWeaponTCount = 0; -- 神兵列传激活的卡包中全部的闪卡数量

	self._otherActiveClassicCardCount = 0; -- 经典卡激活数量

	self._otherActiveComCardFrameCount = 0; -- 名人堂激活普卡数量
	self._otherActiveFlaCardFrameCount = 0; -- 名人堂激活闪卡数量
	self._otherActiveFlaCardFrameTCount = 0; -- 名人堂激活的卡包中全部的闪卡数量

	self._otherActiveComCardContactCount = 0; -- 联动卡激活普卡数量
	self._otherActiveFlaCardContactCount = 0; -- 联动卡激活闪卡数量
	self._otherActiveFlaCardContactTCount = 0; -- 联动卡激活的卡包中全部的闪卡数量

	local vo;
	local time;
	local bagId;
	local cardId;
	local allBagIds = DataCenter.collectionBookUtil.allBagIds;
	for i = 1, #allBagIds do
		bagId = allBagIds[i];
		vo = self:getCollectionBookVoById(bagId);
		if vo then
			local active_com_num = vo.hasOtherCommonCount;
			local active_fla_num = vo.hasOtherFlashCount;
			local active_cla_num = vo.hasOtherClassicCount;
			local flash_TCount = vo.flashCount;
			self._otherActiveClassicCardCount = self._otherActiveClassicCardCount + active_cla_num;

			cardId = vo.otherPushId;
			if vo:checkOtherActiveByCardId(cardId) then
				if vo.card_type == 1 then 
					self._otherActiveComCardWeaponCount = self._otherActiveComCardWeaponCount + active_com_num;
					self._otherActiveFlaCardWeaponCount = self._otherActiveFlaCardWeaponCount + active_fla_num;
					self._otherActiveFlaCardWeaponTCount = self._otherActiveFlaCardWeaponTCount + flash_TCount;
					self._otherActiveWeaponBagIds[#self._otherActiveWeaponBagIds + 1] = bagId;
				elseif vo.card_type == 2 then
					self._otherActiveComCardFrameCount = self._otherActiveComCardFrameCount + active_com_num;
					self._otherActiveFlaCardFrameCount = self._otherActiveFlaCardFrameCount + active_fla_num;
					self._otherActiveFlaCardFrameTCount = self._otherActiveFlaCardFrameTCount + flash_TCount;
					self._otherActiveFrameBagIds[#self._otherActiveFrameBagIds + 1] = bagId;
				elseif vo.card_type == 3 then
					self._otherActiveComCardContactCount = self._otherActiveComCardContactCount + active_com_num;
					self._otherActiveFlaCardContactCount = self._otherActiveFlaCardContactCount + active_fla_num;
					self._otherActiveFlaCardContactTCount = self._otherActiveFlaCardContactTCount + flash_TCount;
					self._otherActiveContactBagIds[#self._otherActiveContactBagIds + 1] = bagId;
				end
			end

			if vo:checkOtherActiveByCardId(vo.classic) then
				self._otherActiveClassicBagIds[#self._otherActiveClassicBagIds + 1] = bagId;
			end
		end
	end

	self._otherActiveWeaponBagIds = self:sortActiveBagId(self._otherActiveWeaponBagIds);
	self._otherActiveClassicBagIds = self:sortActiveBagId(self._otherActiveClassicBagIds);
	self._otherActiveFrameBagIds = self:sortActiveBagId(self._otherActiveFrameBagIds);
	self._otherActiveContactBagIds = self:sortActiveBagId(self._otherActiveContactBagIds);
end

function Lua_CollectionBookData:clearOtherActiveCardData()
	self._otherActiveWeaponBagIds = nil; -- 神兵列传
	self._otherActiveClassicBagIds = nil; -- 经典卡
	self._otherActiveFrameBagIds = nil; -- 名人堂
	self._otherActiveContactBagIds = nil; -- 联动卡

	self._otherActiveComCardWeaponCount = nil; -- 神兵列传激活普卡数量
	self._otherActiveFlaCardWeaponCount = nil; -- 神兵列传激活闪卡数量
	self._otherActiveFlaCardWeaponTCount = nil; -- 神兵列传激活的卡包中全部的闪卡数量

	self._otherActiveClassicCardCount = nil; -- 经典卡激活数量

	self._otherActiveComCardFrameCount = nil; -- 名人堂激活普卡数量
	self._otherActiveFlaCardFrameCount = nil; -- 名人堂激活闪卡数量
	self._otherActiveFlaCardFrameTCount = nil; -- 名人堂激活的卡包中全部的闪卡数量

	self._otherActiveComCardContactCount = nil; -- 联动卡激活普卡数量
	self._otherActiveFlaCardContactCount = nil; -- 联动卡激活闪卡数量
	self._otherActiveFlaCardContactTCount = nil; -- 联动卡激活的卡包中全部的闪卡数量
end

function Lua_CollectionBookData.Get:otherActiveWeaponBagIds()
	if self._otherActiveWeaponBagIds == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveWeaponBagIds;
end

function Lua_CollectionBookData.Get:otherActiveClassicBagIds()
	if self._otherActiveClassicBagIds == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveClassicBagIds;
end

function Lua_CollectionBookData.Get:otherActiveFrameBagIds()
	if self._otherActiveFrameBagIds == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFrameBagIds;
end

function Lua_CollectionBookData.Get:otherActiveContactBagIds()
	if self._otherActiveContactBagIds == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveContactBagIds;
end

function Lua_CollectionBookData.Get:otherActiveComCardWeaponCount()
	if self._otherActiveComCardWeaponCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveComCardWeaponCount;
end

function Lua_CollectionBookData.Get:otherActiveFlaCardWeaponCount()
	if self._otherActiveFlaCardWeaponCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFlaCardWeaponCount;
end

-- 神兵列传激活的卡包中全部的闪卡数量
function Lua_CollectionBookData.Get:otherActiveFlaCardWeaponTCount()
	if self._otherActiveFlaCardWeaponTCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFlaCardWeaponTCount;
end


function Lua_CollectionBookData.Get:otherActiveClassicCardCount()
	if self._otherActiveClassicCardCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveClassicCardCount;
end

function Lua_CollectionBookData.Get:otherActiveComCardFrameCount()
	if self._otherActiveComCardFrameCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveComCardFrameCount;
end

function Lua_CollectionBookData.Get:otherActiveFlaCardFrameCount()
	if self._otherActiveFlaCardFrameCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFlaCardFrameCount;
end

-- 名人堂激活的卡包中全部的闪卡数量
function Lua_CollectionBookData.Get:otherActiveFlaCardFrameTCount()
	if self._otherActiveFlaCardFrameTCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFlaCardFrameTCount;
end

function Lua_CollectionBookData.Get:otherActiveComCardContactCount()
	if self._otherActiveComCardContactCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveComCardContactCount;
end

function Lua_CollectionBookData.Get:otherActiveFlaCardContactCount()
	if self._otherActiveFlaCardContactCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFlaCardContactCount;
end

-- 联动卡激活的卡包中全部的闪卡数量
function Lua_CollectionBookData.Get:otherActiveFlaCardContactTCount()
	if self._otherActiveFlaCardContactTCount == nil then
		self:analysisOtherActiveCardData();
	end

	return self._otherActiveFlaCardContactTCount;
end















----------------------------- 收藏册新排版------------------------
function Lua_CollectionBookData:newAnalysisActiveCardData()
	self._activeWeaponCardIds = {};     -- 神兵列传激活卡牌id
	self._activeClassicCardIds = {};    -- 经典卡激活卡牌id
	self._activeFrameCardIds = {};      -- 名人堂激活卡牌id
	self._activeContactCardIds = {};    -- 联动卡激活卡牌id
	self._totalActiveFlashCardIds = {}; -- 全部激活闪卡卡牌id
	self._totalActiveCommonCardIds = {};      -- 全部激活的普卡卡牌id

	local vo;
	local time;
	local bagId;
	local cardId;
	local allBagIds = DataCenter.collectionBookUtil.allBagIds;
	for i = 1, #allBagIds do
		bagId = allBagIds[i];
		vo = self:getCollectionBookVoById(bagId);
		if vo then
			cardId = vo.common;
			if vo:checkActiveByCardId(cardId) then
				if vo.card_type == 1 then 
					self._activeWeaponCardIds[#self._activeWeaponCardIds + 1] = cardId;
				elseif vo.card_type == 2 then
					self._activeFrameCardIds[#self._activeFrameCardIds + 1] = cardId;
				elseif vo.card_type == 3 then
					self._activeContactCardIds[#self._activeContactCardIds + 1] = cardId;
				end

				self._totalActiveCommonCardIds[#self._totalActiveCommonCardIds + 1] = cardId;
			end

			if vo:checkActiveByCardId(vo.classic) then
				self._activeClassicCardIds[#self._activeClassicCardIds + 1] = vo.classic;
			end

			if vo:checkActiveByCardId(vo.flash) then
				self._totalActiveFlashCardIds[#self._totalActiveFlashCardIds + 1] = vo.flash;
			end

			local cloth_cards = vo.cloth_card;
			if cloth_cards and #cloth_cards > 0 then
				for i = 1, #cloth_cards do
					cardId = cloth_cards[i];
					if vo:checkActiveByCardId(cardId) then
						self._totalActiveFlashCardIds[#self._totalActiveFlashCardIds + 1] = cardId;
					end
				end
			end
		end
	end

	self._activeWeaponCardIds = DataCenter.collectionBookUtil:sortCardIds(self._activeWeaponCardIds);
	self._activeClassicCardIds = DataCenter.collectionBookUtil:sortCardIds(self._activeClassicCardIds);
	self._activeFrameCardIds = DataCenter.collectionBookUtil:sortCardIds(self._activeFrameCardIds);
	self._activeContactCardIds = DataCenter.collectionBookUtil:sortCardIds(self._activeContactCardIds);
	self._totalActiveFlashCardIds = DataCenter.collectionBookUtil:sortCardIds(self._totalActiveFlashCardIds);
	self._totalActiveCommonCardIds = DataCenter.collectionBookUtil:sortCardIds(self._totalActiveCommonCardIds);
end

function Lua_CollectionBookData:newClearActiveCardData()
	self._activeWeaponCardIds = nil;  -- 神兵列传激活卡牌id
	self._activeClassicCardIds = nil; -- 经典卡激活卡牌id
	self._activeFrameCardIds = nil;   -- 名人堂激活卡牌id
	self._activeContactCardIds = nil; -- 联动卡激活卡牌id
	self._totalActiveFlashCardIds = nil;   -- 全部激活闪卡卡牌id
	self._totalActiveCommonCardIds = nil; -- 全部激活卡牌id
end

-- 神兵列传激活卡牌id
function Lua_CollectionBookData.Get:activeWeaponCardIds()
	if self._activeWeaponCardIds == nil then
		self:newAnalysisActiveCardData();
	end

	return self._activeWeaponCardIds;
end

-- 经典卡激活卡牌id
function Lua_CollectionBookData.Get:activeClassicCardIds()
	if self._activeClassicCardIds == nil then
		self:newAnalysisActiveCardData();
	end

	return self._activeClassicCardIds;
end

-- 名人堂激活卡牌id
function Lua_CollectionBookData.Get:activeFrameCardIds()
	if self._activeFrameCardIds == nil then
		self:newAnalysisActiveCardData();
	end

	return self._activeFrameCardIds;
end

-- 联动卡激活卡牌id
function Lua_CollectionBookData.Get:activeContactCardIds()
	if self._activeContactCardIds == nil then
		self:newAnalysisActiveCardData();
	end

	return self._activeContactCardIds;
end

-- 全部激活闪卡卡牌id
function Lua_CollectionBookData.Get:totalActiveFlashCardIds()
	if self._totalActiveFlashCardIds == nil then
		self:newAnalysisActiveCardData();
	end

	return self._totalActiveFlashCardIds;
end

-- 全部激活卡牌id
function Lua_CollectionBookData.Get:totalActiveCommonCardIds()
	if self._totalActiveCommonCardIds == nil then
		self:newAnalysisActiveCardData();
	end

	return self._totalActiveCommonCardIds;
end

function Lua_CollectionBookData:getSortPageEditArr()
	if self._sortPageEditArr == nil then
		self._sortPageEditArr = Array();
	else
		self._sortPageEditArr:dispose();
		self._sortPageEditArr:clear();
	end

	local cardId;
	local pageId = self.ownerPageIds and self.ownerPageIds[1] or 0;
	for i = 1, #self.totalActiveCommonCardIds do
		cardId = self.totalActiveCommonCardIds[i];
		if cardId == pageId then
			self._sortPageEditArr:add(cardId, 1);
		else
			self._sortPageEditArr:add(cardId);
		end
	end

	return self._sortPageEditArr;
end

function Lua_CollectionBookData.Get:selectEditPageCardId()
	return self._selectEditPageCardId;
end

function Lua_CollectionBookData.Set:selectEditPageCardId(value)
	self._selectEditPageCardId = value;
end



--------其他玩家--------
function Lua_CollectionBookData:newAnalysisOtherActiveCardData()
	self._otherActiveWeaponCardIds = {};     -- 其他玩家神兵列传激活卡牌id
	self._otherActiveClassicCardIds = {};    -- 其他玩家经典卡激活卡牌id
	self._otherActiveFrameCardIds = {};      -- 其他玩家名人堂激活卡牌id
	self._otherActiveContactCardIds = {};    -- 其他玩家联动卡激活卡牌id
	self._otherTotalActiveFlashCardIds = {}; -- 其他玩家全部激活闪卡卡牌id

	local vo;
	local time;
	local bagId;
	local cardId;
	local allBagIds = DataCenter.collectionBookUtil.allBagIds;
	for i = 1, #allBagIds do
		bagId = allBagIds[i];
		vo = self:getCollectionBookVoById(bagId);
		if vo then
			cardId = vo.common;
			if vo:checkOtherActiveByCardId(cardId) then
				if vo.card_type == 1 then 
					self._otherActiveWeaponCardIds[#self._otherActiveWeaponCardIds + 1] = cardId;
				elseif vo.card_type == 2 then
					self._otherActiveFrameCardIds[#self._otherActiveFrameCardIds + 1] = cardId;
				elseif vo.card_type == 3 then
					self._otherActiveContactCardIds[#self._otherActiveContactCardIds + 1] = cardId;
				end
			end

			if vo:checkOtherActiveByCardId(vo.classic) then
				self._otherActiveClassicCardIds[#self._otherActiveClassicCardIds + 1] = vo.classic;
			end

			if vo:checkOtherActiveByCardId(vo.flash) then
				self._otherTotalActiveFlashCardIds[#self._otherTotalActiveFlashCardIds + 1] = vo.flash;
			end

			local cloth_cards = vo.cloth_card;
			if cloth_cards and #cloth_cards > 0 then
				for i = 1, #cloth_cards do
					cardId = cloth_cards[i];
					if vo:checkOtherActiveByCardId(cardId) then
						self._otherTotalActiveFlashCardIds[#self._otherTotalActiveFlashCardIds + 1] = cardId;
					end
				end
			end
		end
	end

	self._otherActiveWeaponCardIds = DataCenter.collectionBookUtil:sortCardIds(self._otherActiveWeaponCardIds);
	self._otherActiveClassicCardIds = DataCenter.collectionBookUtil:sortCardIds(self._otherActiveClassicCardIds);
	self._otherActiveFrameCardIds = DataCenter.collectionBookUtil:sortCardIds(self._otherActiveFrameCardIds);
	self._otherActiveContactCardIds = DataCenter.collectionBookUtil:sortCardIds(self._otherActiveContactCardIds);
	self._otherTotalActiveFlashCardIds = DataCenter.collectionBookUtil:sortCardIds(self._otherTotalActiveFlashCardIds);
end


function Lua_CollectionBookData:newClearOtherActiveCardData()
	self._otherActiveWeaponCardIds = nil;     -- 其他玩家神兵列传激活卡牌id
	self._otherActiveClassicCardIds = nil;    -- 其他玩家经典卡激活卡牌id
	self._otherActiveFrameCardIds = nil;      -- 其他玩家名人堂激活卡牌id
	self._otherActiveContactCardIds = nil;    -- 其他玩家联动卡激活卡牌id
	self._otherTotalActiveFlashCardIds = nil; -- 其他玩家全部激活闪卡卡牌id
end

-- 其他玩家神兵列传激活卡牌id
function Lua_CollectionBookData.Get:otherActiveWeaponCardIds()
	if self._otherActiveWeaponCardIds == nil then
		self:newAnalysisOtherActiveCardData();
	end

	return self._otherActiveWeaponCardIds;
end

-- 其他玩家经典卡激活卡牌id
function Lua_CollectionBookData.Get:otherActiveClassicCardIds()
	if self._otherActiveClassicCardIds == nil then
		self:newAnalysisOtherActiveCardData();
	end

	return self._otherActiveClassicCardIds;
end

-- 其他玩家名人堂激活卡牌id
function Lua_CollectionBookData.Get:otherActiveFrameCardIds()
	if self._otherActiveFrameCardIds == nil then
		self:newAnalysisOtherActiveCardData();
	end

	return self._otherActiveFrameCardIds;
end

-- 其他玩家联动卡激活卡牌id
function Lua_CollectionBookData.Get:otherActiveContactCardIds()
	if self._otherActiveContactCardIds == nil then
		self:newAnalysisOtherActiveCardData();
	end

	return self._otherActiveContactCardIds;
end

-- 其他玩家全部激活闪卡卡牌id
function Lua_CollectionBookData.Get:otherTotalActiveFlashCardIds()
	if self._otherTotalActiveFlashCardIds == nil then
		self:newAnalysisOtherActiveCardData();
	end

	return self._otherTotalActiveFlashCardIds;
end


















-------------------------------------红点----------------------------
-- 卡包封面上是否显示红点
function Lua_CollectionBookData:checkBagRedPointByCardId(cardId)
	local cfg = Lua_CollectionBookConfigData.getConfig(cardId);
	if cfg == nil then
		return false;
	end

	local bagId = cfg.hero_id;
	local vo = self:getCollectionBookVoById(bagId);
	if vo == nil then
		return false;
	end

	return vo:show_card_redpoint(cardId);
end

-- 奖励红点
function Lua_CollectionBookData:updateRewardRedPointState()
	if self.collectionBookVoDic == nil then
		return;
	end

	local allBags = DataCenter.collectionBookUtil.allBagIds;
	local cBookVo;
	local bagId;
	local bShow;
	for i = 1, #allBags do
		bagId = allBags[i];
		cBookVo = self:getCollectionBookVoById(bagId);
		bShow = cBookVo and cBookVo.receive_reward_redpoint or false;
		if bShow then
			break;
		end
	end

	if self.bShowRewardRed ~= bShow then
		self.bShowRewardRed = bShow;
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_HasReward, bShow);
		DataCenter.heroAtlasData:checkAtlasCarRedDotState();--英雄图鉴闪卡红点
	end

	DataCenter.heroData:checkHeroCarRedDotState();--英雄背包闪卡红点
	DataCenter.strategyData:updateStrategyLineupRedDot(3); -- 攻略-阵容红点
end

function Lua_CollectionBookData:onPackUpdate(dic)
	if not DataCenter.funcOpenData:isOpened(10239) then -- 功能未开启
		return;
	end
	-- if self.bShowRewardRed then -- 已有奖励红点不往下操作
	-- 	return;
	-- end

	if self.collectionBookVoDic == nil then
		return;
	end

	if self.itemDir == nil then
		self:initNeedActiveItem();
	end

	if self.itemIdDic == nil or self.needActiveCards == nil or self.needActiveCardIdArr == nil then
		return;
	end

	local cardId;
	for k, v in pairs(dic) do
		if self.itemIdDic[k] then
			local canActive = false;
			local arr = self.itemDir[k];
			if arr ~= nil and arr:getSize() > 0 then
				for i = 1, arr:getSize() do
					cardId = arr[i];
					canActive = self:checkCanActiveCard(cardId);
					if canActive then
						break;
					end
				end
			end

			if canActive then
				Lua_MsgUtil.callFunc("UPDATE_CBOOKCARD_CanActive");
				DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_CanActive, canActive);
				break;
			end
		end
	end
end

function Lua_CollectionBookData:initNeedActiveItem()
	if self.itemDir == nil then
		self.itemDir = {};
		self.itemIdDic = {};
		self.needActiveCards = {};
		self.needActiveCardIdArr = Array();
		local cardId;
		local cardCfg;
		local exchangeItems;
		local bShowRedPoint;
		local cardIds = DataCenter.collectionBookUtil:getAllNeedActiveCards();
		if cardIds == nil or #cardIds <= 0 then
			return;
		end
		for i = 1, #cardIds do
			cardId = cardIds[i];
			cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
			exchangeItems = cardCfg.change_item;
			if exchangeItems ~= nil and #exchangeItems > 0 then
				self.needActiveCards[cardId] = true;
				if self.needActiveCardIdArr:indexOf(cardId) == -1 then
					self.needActiveCardIdArr:add(cardId);
				end

				local itemId;
				for j = 1, #exchangeItems do
					itemId = exchangeItems[j][1];
					if self.itemDir[itemId] == nil then
						self.itemDir[itemId] = Array();
						self.itemIdDic[itemId] = true;
					end
					if self.itemDir[itemId]:indexOf(cardId) == -1 then
						self.itemDir[itemId]:add(cardId);
					end
				end
			end

			-- 初始化时判断
			if not bShowRedPoint then
				bShowRedPoint = self:checkCanActiveCard(cardId);
				if bShowRedPoint then
					DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_CanActive, bShowRedPoint);
				end
			end
		end

		-- print("初始化监听数据")
		-- self:testItemData();
	end
end

function Lua_CollectionBookData:clearListenActiveItemData()
	if self.itemDir then
		local arr;
		for k, v in pairs(self.itemDir) do
			arr = v;
			if arr then
				arr:dispose();
				arr:clear();
				arr = nil;
			end
		end
		self.itemDir = nil;
	end

	if self.needActiveCardIdArr then
		self.needActiveCardIdArr:dispose();
		self.needActiveCardIdArr:clear();
		self.needActiveCardIdArr = nil;
	end
	self.itemIdDic = nil;
	self.needActiveCards = nil;
end

function Lua_CollectionBookData:removeListenByCardId(cardId)
	if self.needActiveCards == nil or self.needActiveCardIdArr == nil or self.needActiveCardIdArr:getSize() <= 0 then
		return;
	end

	cardId = tonumber(cardId);
	if self.needActiveCards[cardId] then
		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		local cBookVo = self:getCollectionBookVoById(bagId); 
		if cBookVo then
			self:removeListenActiveItem(cardId);
			-- print("移除卡牌：", cardId);
			-- self:testItemData();
		end
	end
end

-- 移除监控激活道具的卡牌
function Lua_CollectionBookData:removeListenActiveItem(cardId)
	if self.itemDir == nil or self.itemIdDic == nil or self.needActiveCards == nil or self.needActiveCardIdArr == nil then
		return;
	end

	if self.needActiveCards[cardId] == nil then
		return;
	end

	local cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
	if cardCfg == nil or cardCfg.bCompletion ~= true then
		return;
	end

	local exchangeItems = cardCfg.change_item;
	if exchangeItems == nil or #exchangeItems <= 0 then
		return;
	end

	local itemId;
	local bCleared;
	for i = 1, #exchangeItems do
		itemId = exchangeItems[i][1];
		bCleared = self.itemDir[itemId] == nil;
		if bCleared then
			-- print("重复卡牌",cardId)
		else
			local index = self.itemDir[itemId]:indexOf(cardId);
			if index ~= -1 then
				self.itemDir[itemId]:remove(index);

				local len = self.itemDir[itemId]:getSize();
				if len <= 0 then
					self.itemDir[itemId]:dispose();
					self.itemDir[itemId]:clear();
					self.itemDir[itemId] = nil;

					self.itemIdDic[itemId] = nil;
				end
			end
		end
	end
	self.needActiveCards[cardId] = nil;
	local index = self.needActiveCardIdArr:indexOf(cardId);
	if index ~= -1 then
		self.needActiveCardIdArr:remove(index);

		local len = self.needActiveCardIdArr:getSize();
		if len <= 0 then
			self.needActiveCardIdArr:dispose();
			self.needActiveCardIdArr:clear();
			self.needActiveCardIdArr = nil;

			self.itemIdDic = nil;
			self.needActiveCards = nil;
		end
	end

	-- self:updateRedPointWhenActiveCard();
end

function Lua_CollectionBookData:updateRedPointWhenActiveCard()
	local bCheck = false;
	if self.needActiveCardIdArr ~= nil and self.needActiveCardIdArr:getSize() > 0 then
		local cardId;
		local len = self.needActiveCardIdArr:getSize();
		for i = 1, len do
			cardId = self.needActiveCardIdArr[i];
			if self:checkCanActiveCard(cardId) then
				bCheck = true;
				break;
			end
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_CanActive, bCheck);
end

function Lua_CollectionBookData:checkCanActiveCard(cardId)
	cardId = tonumber(cardId);
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
	local cBookVo = self:getCollectionBookVoById(bagId);
	local canActive = cBookVo and cBookVo:canActiveByCardId(cardId) or false;
	return canActive;
end

function Lua_CollectionBookData:checkActiveCardInfo(cardInfo)
	local cardId;
	local cBookVo;
	local bActive;
	local bagId = tonumber(cardInfo.bag_id);
	local card_state = cardInfo.card_state;
	for j = 1, #card_state do
		cardId = tonumber(card_state[j].key);
		cBookVo = self:getCollectionBookVoById(bagId);
		bActive = cBookVo and cBookVo:checkActiveByCardId(cardId) or false;
		local curActiveState = tonumber(card_state[j].value) > 1;
		if bActive == false and curActiveState then
			self:removeListenByCardId(cardId);
		end
	end
end

-- ---------------------测试收藏册数据---------------------------
-- function Lua_CollectionBookData:testItemData()
-- 	-- 测试数据
-- 	-- print("测试数据")
-- 	local str = ""
-- 	for k, arr in pairs(self.itemDir) do
-- 		str = ""
-- 		for i = 1, arr:getSize() do
-- 			local cardCfg = Lua_CollectionBookConfigData.getConfig(arr[i]);
-- 			str = str.."    "..arr[i]..cardCfg;
-- 		end
-- 		print(k, str)
-- 	end
-- end




























-----------------------------------------------羁绊-----------------------------
-- 英雄羁绊
function Lua_CollectionBookData:fromServer50114019(msg)
    if msg == nil then
        return;
    end
    self.bUpdateDataFromServer = true;

    local obj;
    for i = 1, #msg.fetter_info do
    	obj = msg.fetter_info[i];
    	self:updateSingleFetterInfo(obj);
    end

    self._collectionTotalAttrib = nil;
    self:updateFetterRedPoint();
end

-- 英雄羁绊奖励返回
function Lua_CollectionBookData:fromServer50114037(msg)
    if msg == nil then
        return;
    end

    local fetter_id = tonumber(msg.fetter_id);
    local data = self:getHeroFetterDataById(fetter_id);
    if data ~= nil then 
    	data.rewardState = tonumber(msg.reward_state);
    end

    self:updateFetterRedPoint();
end

-- 通知羁绊状态变更(返回)
function Lua_CollectionBookData:fromServer80114019(msg)
    if msg == nil then
        return;
    end
	
    local obj;
    for i = 1, #msg.fetter_info do
    	obj = msg.fetter_info[i];
    	self:updateSingleFetterInfo(obj);
    end

    self._collectionTotalAttrib = nil;
    self:updateFetterRedPoint();
end

function Lua_CollectionBookData:getHeroFetterDataById(id)
	if self._fetterDic == nil then
		self._fetterDic = {};
	end

	if id == nil then
		return;
	end

	id = tonumber(id);
	local data = self._fetterDic[id];
	if data == nil then
		if getConfig("hero_fetter", id) then
			data = {rewardState = 0, activeNum = 0}; -- rewardState:1可领取 2已领取
			self._fetterDic[id] = data;
		end
	end
	
	return data;
end

function Lua_CollectionBookData:getFetterHeroStateByHeroId(heroId)
	heroId = tonumber(heroId);
	if self._fetterHeroDic == nil or heroId == nil or self._fetterHeroDic[heroId] == nil then
		return;
	end

	return self._fetterHeroDic[heroId];
end

function Lua_CollectionBookData:updateFetterHeroState(heroId, state)
	if self._fetterHeroDic == nil then
		self._fetterHeroDic = {};
	end

	self._fetterHeroDic[heroId] = state;
end

function Lua_CollectionBookData:updateSingleFetterInfo(serverData)
	if serverData == nil then
		return;
	end

	local value;
	local heroId;
	local bActive;
	local count = 0;
	local data = self:getHeroFetterDataById(tonumber(serverData.fetter_id));
	if data ~= nil then
		local obj;
		data.rewardState = serverData.reward_state; -- 1可领取 2已领取
		for i = 1, #serverData.fetter_list do
			obj = serverData.fetter_list[i];
			heroId = tonumber(obj.hero_id);
			value = tonumber(obj.state); --state 是否激活：0未激活，1：已激活
			bActive = value == 1;
			count = bActive and count + 1 or count;
			self:updateFetterHeroState(heroId, bActive);
		end
		data.activeNum = count;
	end
end

function Lua_CollectionBookData:updateFetterRedPoint()
	local id;
	local data;
	local isShow = false;
	self._fetterHasRewardIndex = nil;
	local fetterIds = DataCenter.collectionBookUtil.allFetterId;
	for i = 1, #fetterIds do
		id = fetterIds[i];
		data = self:getHeroFetterDataById(id);
		if data.rewardState == 1 then
			self._fetterHasRewardIndex = i;
			isShow = true;
			break;
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_Fetter, isShow);
end

function Lua_CollectionBookData.Get:bUpdateDataFromServer()
	return self._bUpdateDataFromServer;
end

function Lua_CollectionBookData.Set:bUpdateDataFromServer(value)
	self._bUpdateDataFromServer = value;
end

function Lua_CollectionBookData.Get:fetterHasRewardIndex()
	return self._fetterHasRewardIndex or 1;
end

function Lua_CollectionBookData.Get:collectionTotalAttrib()
	if self._collectionTotalAttrib == nil then
		local cfg;
		local data;
		local fetterId;
		local health, attack, defence = 0, 0, 0;
		local fetterIds = DataCenter.collectionBookUtil.allFetterId;
		for i = 1, #fetterIds do
			fetterId = fetterIds[i];
			data = self:getHeroFetterDataById(fetterId);
			if data ~= nil and data.rewardState ~= 0 then
				cfg = getConfig("hero_fetter", fetterId);
				health = health + cfg.health;
				attack = attack + cfg.attack;
				defence = defence + cfg.defence;
			end
		end

		self._collectionTotalAttrib = {health = health, attack = attack, defence = defence};
	end

	return self._collectionTotalAttrib;
end











----------------------------------外部接口------------------------------------
-- 根据闪卡id《hero_des》获取卡包的奖励状态是否可领取，奖励
function Lua_CollectionBookData:getRewardStateByFlashId(flashId)
	local canRecReward;
	local rewardItem;
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByFlashId(flashId);
	local cBookVo = self:getCollectionBookVoById(bagId);
	if cBookVo then
		canRecReward = cBookVo.receive_reward_redpoint;
		rewardItem = cBookVo.reward;
	end

	return canRecReward, rewardItem;
end

-- 是否展示旧版本
function Lua_CollectionBookData.Get:bShowOldVersion()
	if self._bShowOldVersion == nil then
		self._bShowOldVersion = false;
	end

	return self._bShowOldVersion;
end

function Lua_CollectionBookData.Set:bShowOldVersion(value)
	self._bShowOldVersion = value;
end