-- 闪卡配置表数据(客户端专用)
Lua_FlashCardConfigData = class("Lua_FlashCardConfigData");
function Lua_FlashCardConfigData.getConfig(id)
	if id == nil then
		return nil;
	end
	
	id = tonumber(id);
	if Lua_FlashCardConfigData.configDic == nil then
		Lua_FlashCardConfigData.configDic = {};
	end

	if Lua_FlashCardConfigData.configDic[id] == nil then
		local cfg = getConfig("hero_des", id);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_FlashCardConfigData.configDic[id] = Lua_FlashCardConfigData.new(id, cfg);
	end
	return Lua_FlashCardConfigData.configDic[id];
end





function Lua_FlashCardConfigData:ctor(id, config)
    self.id = tonumber(id);
    self.config = config;
    if self.config == nil then
		self.config = getConfig("hero_des", id);
	end
end

function Lua_FlashCardConfigData:dispose()
end

-- 新卡、经典卡宽高之间的差值
function Lua_FlashCardConfigData:getDistance()
	return self.newcard_widget - self.classic_widget, self.newcard_height - self.classic_height;
end

function Lua_FlashCardConfigData.Get:showFrontPagePath()
	-- local path;
	-- if not self.isCompletionCard then
	-- 	path = self.showNewCard and self.no_complete_path or self.classic_no_complete_path;
	-- else
	-- 	path = self.showNewCard and self.path or self.old_path;
	-- end

	-- return path;


	return self.showNewCard and self.path or self.old_path;
end

function Lua_FlashCardConfigData.Get:isCompletionCard()-- 是否为制作完成卡牌

	return self.config.is_complete == 1;
end

-- function Lua_FlashCardConfigData.Set:isCompletionCard(value)-- 是否为制作完成卡牌
-- 	self._isCompletionCard = value;
-- 	return self._isCompletionCard;
-- end

function Lua_FlashCardConfigData.Get:showBackPagePath()
	return self.showNewCard and self.back_path or self.old_path2;
end

-- 是否展示新卡
function Lua_FlashCardConfigData.Get:showNewCard()
	return self.config.is_classic ~= 1;
end

function Lua_FlashCardConfigData.Get:backAtlas()
	return "common_altas_2";
end

function Lua_FlashCardConfigData.Get:backSprite()
	if self.camp == nil then
		return "ui_common_metal_19";
	end
	return "xui_common_attribute_"..(6 + self.camp);
end

function Lua_FlashCardConfigData.Get:frontAtlas()
	return "common_altas_3";
end

function Lua_FlashCardConfigData.Get:frontSprite()
	if self.camp == nil then
		return "ui_common_metal_19";
	end
	return "xui_common_attribute_"..(29 + self.camp);
end

function Lua_FlashCardConfigData.Get:back_path()--反面背景图片（新）
	return "/images/hero_card/new_card_bg.png";
end

function Lua_FlashCardConfigData.Get:ownerContent()
	if self._ownerContent == nil then
		self._ownerContent = "";
		self._ownerContent = self:getContent(self._ownerContent, self.host_des);
		self._ownerContent = self:getContent(self._ownerContent, self.master_des);
		self._ownerContent = self:getContent(self._ownerContent, self.dynasty_des);
		self._ownerContent = self:getContent(self._ownerContent, self.feature_des);
	end
	return self._ownerContent;
end

function Lua_FlashCardConfigData:getContent(curStr, addStr)
	if addStr == nil then
		return curStr;
	end
	return curStr..addStr.."\n";
end

-----------------------配置表数据------------------------------

-- 序号
function Lua_FlashCardConfigData.Get:number()
	return self.config.number;
end

function Lua_FlashCardConfigData.Get:old_path()--正面图片（旧）
	if self.config.old_path == nil then
		return nil;
	end
	return "/images/hero_card/"..self.config.old_path..".png";
end

function Lua_FlashCardConfigData.Get:old_path2()--反面图片（旧）
	if self.config.old_path2 == nil then
		return nil;
	end
	return "/images/hero_card/"..self.config.old_path2..".png";
end

function Lua_FlashCardConfigData.Get:camp()--阵营
	return self.config.camp;
end

function Lua_FlashCardConfigData.Get:new_name()--正面名字（新）
	return self.config.new_name;
end

function Lua_FlashCardConfigData.Get:path()--正面图片（新）
	if self.config.path == nil then
		return nil;
	end
	return "/images/hero_card/"..self.config.path..".png";
end

function Lua_FlashCardConfigData.Get:equip_path()--反面武器图片（新）
	if self.config.equip_path == nil then
		return nil;
	end
	return "/images/hero_card/"..self.config.equip_path..".png";
end

function Lua_FlashCardConfigData.Get:title_name()--反面列传名（新）
	return self.config.title_name;
end

function Lua_FlashCardConfigData.Get:equip_name()--反面神兵名（新）
	return self.config.equip_name;
end

function Lua_FlashCardConfigData.Get:page_name()--反面序号名（新）
	return self.config.page_name;
end

function Lua_FlashCardConfigData.Get:host_des()--反面神兵主人（新）
	return self.config.host_des;
end

function Lua_FlashCardConfigData.Get:master_des()--反面铸造大师(新)
	return self.config.master_des;
end

function Lua_FlashCardConfigData.Get:dynasty_des()--反面铸造朝代（新）
	return self.config.dynasty_des;
end
function Lua_FlashCardConfigData.Get:feature_des()--反面神兵特征（新）
	return self.config.feature_des;
end

function Lua_FlashCardConfigData.Get:title()--反面故事名（新）
	return self.config.title;
end

function Lua_FlashCardConfigData.Get:des()--反面传记描述（新）
	return self.config.des;
end

function Lua_FlashCardConfigData.Get:sort()--排序
	return self.config.sort;
end

function Lua_FlashCardConfigData.Get:no_complete_path()--新卡制作未完成
	if self.config.equip_path == nil then
		return nil;
	end
	return "/images/hero_card/"..self.config.no_complete_path..".png";
end

function Lua_FlashCardConfigData.Get:classic_no_complete_path()--经典卡制作未完成
	if self.config.equip_path == nil then
		return nil;
	end
	return "/images/hero_card/"..self.config.classic_no_complete_path..".png";
end

function Lua_FlashCardConfigData.Get:flash_path_2() -- 收藏册详情卡片显示图片
	if self.config.flash_path_2 == nil then
		return nil;
	end
	return "/images/flash_card_2/"..self.config.flash_path_2..".png";
end

function Lua_FlashCardConfigData.Get:flash_card_name() -- 闪卡名字
	return self.config.flash_card_name;
end

function Lua_FlashCardConfigData.Get:classic_widget()-- 经典卡宽度
	return self.config.classic_widget;
end

function Lua_FlashCardConfigData.Get:classic_height()-- 经典卡高度
	return self.config.classic_height;
end

function Lua_FlashCardConfigData.Get:newcard_widget()-- 新卡宽度
	return self.config.newcard_widget;
end

function Lua_FlashCardConfigData.Get:newcard_height()-- 新卡高度
	return self.config.newcard_height;
end