-- 每日首充
checkRequire("Lua_DailyRechargeVo");
Lua_DailyRechargeData = class("Lua_DailyRechargeData")
function Lua_DailyRechargeData:ctor()
end

function Lua_DailyRechargeData:dispose()
	if self._dailyRechargeArr ~= nil then
		self._dailyRechargeArr:dispose();
		self._dailyRechargeArr:clear();
		self._dailyRechargeArr = nil;
	end
	if self.dailyRechargeDic ~= nil then
		for k,v in pairs(self.dailyRechargeDic) do
			v:dispose();
			v = nil;
		end
		self.dailyRechargeDic = nil;
	end
end

function Lua_DailyRechargeData:fromServer50197007(msg)
	if msg == nil then
		return;
	end
	if self.dailyRechargeDic == nil then
		self.dailyRechargeDic = {};
	end

	self.totalRecharge = Mathf.Floor(msg.total_recharge); -- 累计充值

	local obj;
	local vo;
	local redDotState = false;
	for i = 1, #msg.grade_state do -- 各档位领取状态，key：id，value：0未达成 1可领取 2已领取
		obj = msg.grade_state[i];
		vo = self:getDailyRechargeVoById(obj.key);
		if vo == nil then
			vo = Lua_DailyRechargeVo.new(obj.key);
			self.dailyRechargeDic[obj.key] = vo;
		end
		if vo ~= nil then
			vo:updateRechargeInfo(obj.value, msg.world_level);
			if not redDotState and vo.drawState == 1 then
				redDotState = true;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.DailyRecharge, redDotState);
end

function Lua_DailyRechargeData:getDailyRechargeVoById(id)
	if self.dailyRechargeDic and id and self.dailyRechargeDic[id] ~= nil then
		return self.dailyRechargeDic[id];
	end
	return nil;
end

function Lua_DailyRechargeData.Get:dailyRechargeArr()
	if self._dailyRechargeArr == nil then
		self._dailyRechargeArr = Array();

		local config = getConfig("daily_recharge");
		local vo;
		for k,v in pairs(config) do
			vo = self:getDailyRechargeVoById(k);
			if type(k) == type_str_number and vo ~= nil and vo.open then
				self._dailyRechargeArr:add(vo);
			end
		end
		self._dailyRechargeArr:sort("id", false);
	end
	return self._dailyRechargeArr;
end