-- 特效
Lua_EffectVo = class("Lua_EffectVo");
function Lua_EffectVo:ctor(p)
	self:superCall("ctor");

    self:clean();
    self._parent = p;
end

function Lua_EffectVo:dispose()
	self._owner = nil;
    self._target = nil;
    self._configData = nil;
    self._parent = nil;
    self._effAvatarParent = nil;
    self._selfCampPosId = nil;
    if self.targetsList ~= nil then
        self.targetsList:clear();
        self.targetsList = nil;
    end
end

function Lua_EffectVo:clean()
	self.sceneId = 0;
    self.fightId = 0;
    self._selfRoleId = 0;
    self._targetRoleId = 0;
    self._owner = nil;
    self._target = nil;
    self._effectId = nil;
    self._configData = nil;
    self._selfCampPosId = nil;

    self.posx = 0;
    self.posy = 0;
    self.posz = 0;
    self._dir = 0;
    self.spd = -1;
    self.time = 0;
    self.effTime = -1;
    self.startFormationPos = 0;
    self.endFormationPos = 0;
    if self.targetsList ~= nil then
    	self.targetsList:clear();
        self.targetsList = nil;
    end

    self._parent = nil;
    self._effAvatarParent = nil;
    self._formationType = nil;
    self._speed = nil;
    self._speedRate = nil;
    self._selfCampCenterPos = nil;
    self._targetCampCenterPos = nil;
    self._orginPosX = nil;
    self._orginPosY = nil;
    self._orginPosZ = nil;
    self._targetPosX = nil;
    self._targetPosY = nil;
    self._targetPosZ = nil;
    self._controllPosX = nil;
    self._controllPosY = nil;
    self._controllPosZ = nil;
    self._effRotX = nil;
    self._effRotY = nil;
    self._effRotZ = nil;
    self._effSca = nil;
end

function Lua_EffectVo.Get:dir()
    return self._dir;
end

function Lua_EffectVo.Set:dir(val)
    if val == nil then
        self._dir = 0;
    else
        self._dir = val;
    end
end

function Lua_EffectVo:onEnterFrame(dt)
	if self.time > 0 then
	    self.time = self.time - dt * self.speedRate;
	end
end

function Lua_EffectVo.Get:bShow()
	return self.time <= 0; 
end

function Lua_EffectVo.Get:effectId()
	return self._effectId;
end

function Lua_EffectVo.Set:effectId(val)
	if self._effectId ~= val then
		self._effectId = val;
		self._configData = nil;
	end
end

function Lua_EffectVo.Get:configData()
	if self._configData == nil then
		self._configData = Lua_EffectConfigData.getConfigData(self.effectId);
	end
	return self._configData;
end

function Lua_EffectVo.Get:selfRoleId()
	return self._selfRoleId;
end

function Lua_EffectVo.Set:selfRoleId(val)
	if self._selfRoleId ~= val then
		self._selfRoleId = val;
		self._owner = nil;
	end
end

function Lua_EffectVo.Get:owner()
	if self._owner == nil then
		self._owner = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self.selfRoleId);
	end
	return self._owner;
end

function Lua_EffectVo.Get:targetRoleId()
	return self._targetRoleId;
end

function Lua_EffectVo.Set:targetRoleId(val)
	if self._targetRoleId ~= val then
		self._targetRoleId = val;
		self._target = nil;
	end
end

function Lua_EffectVo.Get:target()
	if self._target == nil then
		self._target = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self.targetRoleId);
	end
	return self._target;
end

function Lua_EffectVo.Get:parent()
	if self._parent == nil then
		self._parent = Scene3DManager.instance:getThingRoot(self.sceneId, self.fightId);
        if self._parent == nil then 
        	self._parent = ContainerUtil.getContainer("Thing", true); 
        end
	end
	return self._parent;
end

function Lua_EffectVo.Set:parent(val)
	self._parent = val;
end

function Lua_EffectVo:getParent()
    return self._parent;
end

function Lua_EffectVo.Set:effAvatarParent(val)
    self._effAvatarParent = val;
end

function Lua_EffectVo.Get:effAvatarParent()
    if self._effAvatarParent == nil then
        if self.configData.moveType > 0 then -- 飞行特效挂世界
            local obj = Scene3DManager.instance:getThingRoot(self.sceneId, self.fightId);
            if obj == nil then 
	        	obj = ContainerUtil.getContainer("Thing", true); 
	        end
            self._effAvatarParent = obj.transform;
        else
            if self.configData.hang == 1 then -- 挂avatar
                if self.owner ~= nil and self.owner.player ~= nil then
                    if self.owner.player.avatar ~= nil then
                        if not strIsNullOrEmpty(self.configData.hangPath) then
                            self._effAvatarParent = ContainerUtil.findBoneTransform(self.owner.player.avatar.transform, self.configData.hangPath);
                        end

                        if self._effAvatarParent == nil then
                            self._effAvatarParent = self.owner.player.avatar.transform;
                        end
                    else
                        self._effAvatarParent = self.owner.player.root.transform;
                    end
                end
            elseif self.configData.hang == 2 then
                if self.owner ~= nil and self.owner.player ~= nil then
                    self._effAvatarParent = self.owner.player.root.transform;
                end
            end

            if self._effAvatarParent == nil then
                self._effAvatarParent = self.parent.transform;
            end
        end
    end
    return self._effAvatarParent;
end

function Lua_EffectVo.Get:isHangAvatar()
	if self.configData == nil then
		return false;
	end

    if self.configData.moveType > 0 then -- 飞行特效挂世界
        return false;
    end
    if self.configData.hang == 1 or self.configData.hang == 2 then
        if self.owner ~= nil then
            return true;
        end
    end
    return false;
end

function Lua_EffectVo.Get:speed()
	if self._speed == nil then
		if self.owner ~= nil and self.owner.data ~= nil then
			self._speed = self.owner.data.aniSpeed;
		elseif self.target ~= nil and self.target.data ~= nil then
			self._speed = self.target.data.aniSpeed;
		else
			self._speed = 1;
		end
	end
	return self._speed;
end

function Lua_EffectVo.Set:speed(val)
	self._speed = val;
end

function Lua_EffectVo.Get:speedRate()
	if self._speedRate == nil then
		if self.owner ~= nil and self.owner.data ~= nil then
			self._speedRate = self.owner.data.aniSpdRate;
		elseif self.target ~= nil and self.target.data ~= nil then
			self._speedRate = self.target.data.aniSpdRate;
		else
			self._speedRate = 1;
		end
	end
	return self._speedRate;
end

function Lua_EffectVo.Set:speedRate(val)
	self._speedRate = val;
end

function Lua_EffectVo.Set:formationType(val)
    self._formationType = val;
end

function Lua_EffectVo.Get:formationType()
	if self._formationType == nil then
		if self.owner ~= nil then
			self._formationType = self.owner.formationType;
		end
	end
	return self._formationType ~= nil and self._formationType or 0;
end

function Lua_EffectVo.Set:selfCampPosId(val)
    self._selfCampPosId = val;
end

function Lua_EffectVo.Get:selfCampPosId()
    if self._selfCampPosId == nil then
        if self.owner ~= nil and self.owner.data ~= nil then
            self._selfCampPosId = self.owner.data.campPosId;
        end
    end
    return self._selfCampPosId ~= nil and self._selfCampPosId or 0;
end


function Lua_EffectVo.Get:selfCampPosCenter()
    if self._selfCampCenterPos == nil then
        local cfg = Lua_FightCampPosConfig.getConfigData(self.selfCampPosId);
        if self.formationType == Lua_FightDefine.FIGHT_DEFENDER then
            self._selfCampCenterPos = cfg.defendCenter;
        else
            self._selfCampCenterPos = cfg.attackCenter;
        end
    end
    return self._selfCampCenterPos;
end

function Lua_EffectVo.Get:targetCampCenter()
    if self._targetCampCenterPos == nil then
        if self.target ~= nil and self.target.data ~= nil then
        	local cfg = Lua_FightCampPosConfig.getConfigData(self.target.data.campPosId);
            if self.target.formationType == Lua_FightDefine.FIGHT_DEFENDER then
                self._targetCampCenterPos = cfg.defendCenter;
            else
                self._targetCampCenterPos = cfg.attackCenter;
            end
        else
            local cfg = Lua_FightCampPosConfig.getConfigData(self.selfCampPosId);
            if self.formationType == Lua_FightDefine.FIGHT_ATTACKER then
                self._targetCampCenterPos = cfg.defendCenter;
            else
                self._targetCampCenterPos = cfg.attackCenter;
            end
        end
    end
    return self._targetCampCenterPos;
end

function Lua_EffectVo:getControllPos(startPosx, startPosy, startPosz, endPosx, endPosy, endPosz)
    if self.configData.isThroughAllEff or self.configData.isContactTwoEff or self.configData.isContactAllEff then
    	local vx, vy, vz = self.configData:getControllRange(startPosx, startPosy, startPosz, endPosx, endPosy, endPosz, self.formationType);
    	vx = vx + (startPosx + endPosx) / 2;
    	vy = vy + (startPosy + endPosy) / 2;
    	vz = vz + (startPosz + endPosz) / 2;
        return vx, vy, vz;
    end
    return self.controllPosX, self.controllPosY, self.controllPosZ;
end

function Lua_EffectVo:getStartPos(idx)
    if self.configData.isThroughAllEff or self.configData.isContactTwoEff or self.configData.isContactAllEff then
        local px = 0;
        local py = 0;
        local pz = 0;
        if self.configData.isThroughAllEff then
            if idx == 0 then
                if self.owner ~= nil and self.owner.data ~= nil then
                	px = self.owner.data.px;
                	py = self.owner.data.py;
                	pz = self.owner.data.pz;
                else
                    px = self.currentPointX;
                	py = self.currentPointY;
                	pz = self.currentPointZ;
                end
            elseif self.targetsList == nil or self.targetsList:getSize() < idx then
                px = self.posx;
            	py = self.posy;
            	pz = self.posz;
            else
                local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self.targetsList[idx]);
                if thing == nil then
                    px = self.posx;
	            	py = self.posy;
	            	pz = self.posz;
                else
                    px = thing.data.px;
                	py = thing.data.py;
                	pz = thing.data.pz;
                end
            end
        else
            if self.owner == nil or self.owner.data == nil then
                px = self.posx;
            	py = self.posy;
            	pz = self.posz;
            else
                px = self.owner.data.px;
            	py = self.owner.data.py;
            	pz = self.owner.data.pz;
            end
        end

        local flip = (not self.isHangAvatar and self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        px = (px + self.configData.startOffset.x * flip) * 0.01;
        py = (py + self.configData.startOffset.y) * 0.01;
        pz = (pz + self.configData.startOffset.z * flip) * 0.01;
        return px, py, pz;
    end
    return self.orginPosX, self.orginPosY, self.orginPosZ;
end

function Lua_EffectVo:getEndPos(idx)
    if self.configData.isThroughAllEff or self.configData.isContactTwoEff or self.configData.isContactAllEff then
        local px, py, pz;
        if self.configData.isThroughAllEff then
            if self.targetsList == nil or self.targetsList:getSize() < idx then
                px = self.posx;
                py = self.posy;
                pz = self.posz;
            else
                local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self.targetsList[idx]);
                if thing ~= nil then
                    px = thing.data.orginPosX;
                    py = thing.data.orginPosY;
                    pz = thing.data.orginPosZ;
                else
                    px = self.posx;
                    py = self.posy;
                    pz = self.posz;
                end
            end
        else
            if self.target ~= nil then
                px = self.target.data.px;
                py = self.target.data.py;
                pz = self.target.data.pz;
            else
                px = self.posx;
                py = self.posy;
                pz = self.posz;
            end
        end

        local flip = (not self.isHangAvatar and self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        px = (px + self.configData.endOffset.x * flip) * 0.01;
        py = (py + self.configData.endOffset.y) * 0.01;
        pz = (pz + self.configData.endOffset.z * flip) * 0.01;
        return px, py, pz;
    end
    return self.targetPosX, self.targetPosY, self.targetPosZ;
end

function Lua_EffectVo.Get:orginPosX()
    if self._orginPosX == nil then
        local px, py, pz = self:getShowEffectPos(self.configData.startType, self.formationType);
        local flip = (not self.isHangAvatar or self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        self._orginPosX = (px + self.configData.startOffset.x * flip) * 0.01;
        self._orginPosY = (py + self.configData.startOffset.y) * 0.01;
        self._orginPosZ = (pz + self.configData.startOffset.z * flip) * 0.01;
    end
    return self._orginPosX;
end

function Lua_EffectVo.Get:orginPosY()
    if self._orginPosY == nil then
        local px, py, pz = self:getShowEffectPos(self.configData.startType, self.formationType);
        local flip = (not self.isHangAvatar or self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        self._orginPosX = (px + self.configData.startOffset.x * flip) * 0.01;
        self._orginPosY = (py + self.configData.startOffset.y) * 0.01;
        self._orginPosZ = (pz + self.configData.startOffset.z * flip) * 0.01;
    end
    return self._orginPosY;
end

function Lua_EffectVo.Get:orginPosZ()
    if self._orginPosZ == nil then
        local px, py, pz = self:getShowEffectPos(self.configData.startType, self.formationType);
        local flip = (not self.isHangAvatar or self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        self._orginPosX = (px + self.configData.startOffset.x * flip) * 0.01;
        self._orginPosY = (py + self.configData.startOffset.y) * 0.01;
        self._orginPosZ = (pz + self.configData.startOffset.z * flip) * 0.01;
    end
    return self._orginPosZ;
end

function Lua_EffectVo.Get:targetPosX()
    if self._targetPosX == nil then
        local px, py, pz = self:getShowEffectPos(self.configData.endType, self.formationType);
        local flip = (not self.isHangAvatar or self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        self._targetPosX = (px + self.configData.endOffset.x * flip) * 0.01;
        self._targetPosY = (py + self.configData.endOffset.y) * 0.01;
        self._targetPosZ = (pz + self.configData.endOffset.z * flip) * 0.01;
    end
    return self._targetPosX;
end

function Lua_EffectVo.Get:targetPosY()
    if self._targetPosY == nil then
        local px, py, pz = self:getShowEffectPos(self.configData.endType, self.formationType, true);
        local flip = (not self.isHangAvatar or self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        self._targetPosX = (px + self.configData.endOffset.x * flip) * 0.01;
        self._targetPosY = (py + self.configData.endOffset.y) * 0.01;
        self._targetPosZ = (pz + self.configData.endOffset.z * flip) * 0.01;
    end
    return self._targetPosY;
end

function Lua_EffectVo.Get:targetPosZ()
    if self._targetPosZ == nil then
        local px, py, pz = self:getShowEffectPos(self.configData.endType, self.formationType, true);
        local flip = (not self.isHangAvatar or self.formationType == Lua_FightDefine.FIGHT_ATTACKER) and -1 or 1;
        self._targetPosX = (px + self.configData.endOffset.x * flip) * 0.01;
        self._targetPosY = (py + self.configData.endOffset.y) * 0.01;
        self._targetPosZ = (pz + self.configData.endOffset.z * flip) * 0.01;
    end
    return self._targetPosZ;
end

function Lua_EffectVo.Get:controllPosX()
    if self._controllPosX == nil then
        local vx, vy, vz = self.configData:getControllRange(self.orginPosX, self.orginPosY, self.orginPosZ, self.targetPosX, self.targetPosY, self.targetPosZ, self.formationType);
        self._controllPosX = (self.targetPosX + self.orginPosX) / 2 + vx;
        self._controllPosY = (self.targetPosY + self.orginPosY) / 2 + vy;
        self._controllPosZ = (self.targetPosZ + self.orginPosZ) / 2 + vz;
    end
    return self._controllPosX;
end

function Lua_EffectVo.Get:controllPosY()
    if self._controllPosY == nil then
        local vx, vy, vz = self.configData:getControllRange(self.orginPosX, self.orginPosY, self.orginPosZ, self.targetPosX, self.targetPosY, self.targetPosZ, self.formationType);
        self._controllPosX = (self.targetPosX + self.orginPosX) / 2 + vx;
        self._controllPosY = (self.targetPosY + self.orginPosY) / 2 + vy;
        self._controllPosZ = (self.targetPosZ + self.orginPosZ) / 2 + vz;
    end
    return self._controllPosY;
end

function Lua_EffectVo.Get:controllPosZ()
    if self._controllPosZ == nil then
        local vx, vy, vz = self.configData:getControllRange(self.orginPosX, self.orginPosY, self.orginPosZ, self.targetPosX, self.targetPosY, self.targetPosZ, self.formationType);
        self._controllPosX = (self.targetPosX + self.orginPosX) / 2 + vx;
        self._controllPosY = (self.targetPosY + self.orginPosY) / 2 + vy;
        self._controllPosZ = (self.targetPosZ + self.orginPosZ) / 2 + vz;
    end
    return self._controllPosZ;
end

-- 获取技能初始位置
-- posType: 0默认，1己方，2目标，3目标与己方中心，4己方阵营，5敌对阵营，6战斗中心(特效制作显示位置)，7目标列前面，
function Lua_EffectVo:getShowEffectPos(posType, formationType, isEndType)
-- 8目标排中间列（<=2排），9目标排中间列（<=3排）
    -- print("getShowEffectPos", posType, formationType, isEndType);
    if posType == 1 then --己方位置
        return self:calSelfPos();
    elseif posType == 2 then --目标位置
        return self:calTargetPos();
    elseif posType == 3 then --目标位置
        if self.target ~= nil and self.target.data ~= nil and self.owner ~= nil and self.owner.data ~= nil then
            local vx = (self.target.data.orginPosX + self.owner.data.orginPosX) / 2;
            local vy = (self.target.data.orginPosY + self.owner.data.orginPosY) / 2;
            local vz = (self.target.data.orginPosZ + self.owner.data.orginPosZ) / 2;
            if self.configData.moveType > 0 then
                -- print("目标位置1 ", px, py, pz)
                return vx, vy, vz;
            else
                if self.configData.hang > 0 then
                    LuaUtil.calInverseTransformPoint(self.effAvatarParent, vx * 0.01, vy * 0.01, vz * 0.01);
                    vx = LuaUtil.temporaryVectorX * 100;
                    vy = LuaUtil.temporaryVectorY * 100;
                    vz = LuaUtil.temporaryVectorZ * 100;
                    -- print("目标位置2 ", px, py, pz)
                    return vx, vy, vz;
                else
                    -- print("目标位置3 ", px, py, pz)
                    return vx, vy, vz;
                end
            end
        end
    elseif posType == 4 then --目标与己方中心
        local list = self.selfCampPosCenter;
        local px = (list ~= nil and #list > 0) and list[1] or 0;
        local py = (list ~= nil and #list > 1) and list[2] or 0;
        local pz = (list ~= nil and #list > 2) and list[3] or 0;
        if self.configData.moveType > 0 then
            -- print("目标与己方中心1 ", px, py, pz)
            return px, py, pz;
        else
            if self.configData.hang > 0 then
                LuaUtil.calInverseTransformPoint(self.effAvatarParent, vx * 0.01, vy * 0.01, vz * 0.01);
                vx = LuaUtil.temporaryVectorX * 100;
                vy = LuaUtil.temporaryVectorY * 100;
                vz = LuaUtil.temporaryVectorZ * 100;
                -- print("目标与己方中心2 ", px, py, pz, vx, vy, vz)
                return vx, vy, vz;
            else
                -- print("目标与己方中心3 ", px, py, pz)
                return px, py, pz;
            end
        end
    elseif posType == 5 then --敌对阵营
        local list = self.targetCampCenter;
        local px = (list ~= nil and #list > 0) and list[1] or 0;
        local py = (list ~= nil and #list > 1) and list[2] or 0;
        local pz = (list ~= nil and #list > 2) and list[3] or 0;
        if self.configData.moveType > 0 then
            -- print("敌对阵营1 ", px, py, pz)
            return px, py, pz;
        else
            if self.configData.hang > 0 then
                LuaUtil.calInverseTransformPoint(self.effAvatarParent, px * 0.01, py * 0.01, pz * 0.01);
                vx = LuaUtil.temporaryVectorX * 100;
                vy = LuaUtil.temporaryVectorY * 100;
                vz = LuaUtil.temporaryVectorZ * 100;
                -- print("敌对阵营2 ", px, py, pz, vx, vy, vz)
                return vx, vy, vz;
            else
                -- print("敌对阵营3 ", px, py, pz)
                return px, py, pz;
            end
        end
    elseif posType == 6 then --舞台中心点
        if self.configData.moveType > 0 then
            -- print("舞台中心点1 ", 0, 0, 0)
            return 0, 0, 0;
        else
            if self.configData.hang > 0 then
                LuaUtil.calInverseTransformPoint(self.effAvatarParent, 0, 0, 0);
                local vx = LuaUtil.temporaryVectorX * 100;
                local vy = LuaUtil.temporaryVectorY * 100;
                local vz = LuaUtil.temporaryVectorZ * 100;
                -- print("舞台中心点2 ", vx, vy, vz)
                return vx, vy, vz;
            else
                -- print("舞台中心点3 ", 0, 0, 0)
                return 0, 0, 0;
            end
        end
    elseif posType == 7 then --目标列前面
        if self.target ~= nil then
            local cfg = Lua_FightCampPosConfig.getConfigData(self.target.data.campPosId);
            if cfg ~= nil then
                local pos = self.target.formationPos;
                local vLineIdx = DataCenter.fightData:getVLineByPos(pos);
                -- print("目标列前面1", pos, vLineIdx);
                if vLineIdx ~= -1 then
                    local prePosByVLine = DataCenter.fightData:getPrePosByVLine(vLineIdx);
                    -- print("目标列前面2", pos, vLineIdx, prePosByVLine);
                    if prePosByVLine ~= -1 then
                        local pt = self.target.formationType;
                        local px = cfg:getPosxByIdx(pt, prePosByVLine);
                        local py = cfg:getPosyByIdx(pt, prePosByVLine);
                        local pz = pt == (Lua_FightDefine.FIGHT_ATTACKER) and cfg.frontAttackerPosZ or cfg.frontDefenderPosZ;
                        if self.configData.moveType > 0 then
                            -- print("目标列前面3 ", px, py, pz)
                            return px, py, pz;
                        else
                            if self.configData.hang > 0 then
                                LuaUtil.calInverseTransformPoint(self.effAvatarParent, px*0.01, py*0.01, pz*0.01);
                                px = LuaUtil.temporaryVectorX * 100;
                                py = LuaUtil.temporaryVectorY * 100;
                                pz = LuaUtil.temporaryVectorZ * 100;
                                -- print("目标列前面4 ", px, py, pz)
                                return px, py, pz;
                            else
                                -- print("目标列前面5 ", px, py, pz);
                                return px, py, pz;
                            end
                        end
                    end
                end
            end
        end
    elseif posType == 8 then --
        local fpos = isEndType and self.endFormationPos or self.startFormationPos;
        local hLineIdx = DataCenter.fightData:getHLineByPos(fpos);
        if hLineIdx > 2 then hLineIdx = 2; end
        -- print("posType == 8 ", isEndType, fpos, hLineIdx);
        return self:calLineMidPos(hLineIdx);
    elseif posType == 9 then --
        local fpos = isEndType and self.endFormationPos or self.startFormationPos;
        local hLineIdx = DataCenter.fightData:getHLineByPos(fpos);
        -- print("posType == 9 ", isEndType, fpos, hLineIdx);
        return self:calLineMidPos(hLineIdx);
    end
    return self.posx, self.posy, self.posz;
end

function Lua_EffectVo:calLineMidPos(hLineIdx)
    if self.target ~= nil then
        local cfg = Lua_FightCampPosConfig.getConfigData(self.target.data.campPosId);
        if cfg ~= nil then 
            local vec = cfg:getHMidPosByLine(self.target.formationType, hLineIdx);
            if vec ~= nil then
                return vec.x, vec.y, vec.z;
            end 
        end
    end
    return self.posx, self.posy, self.posz;
end

function Lua_EffectVo:calSelfPos()
    if self.owner ~= nil then
        if self.configData.moveType > 0 then -- 飞行特效，身上挂的话，需要转到世界坐标
            if self.configData.hang > 0 then
                if self.owner.player:calInverseTransformPoint(self.effAvatarParent, self.configData.hangPath, self.configData.hang == 1) then
                    local px = LuaUtil.temporaryVectorX * 100;
                    local py = LuaUtil.temporaryVectorY * 100;
                    local pz = LuaUtil.temporaryVectorZ * 100;
                    -- print("calSelfPos", px, py, pz);
                    return px, py, pz;
                else
                    return self.owner.data.px, self.owner.data.py, self.owner.data.pz;
                end
            else -- 不挂身上
                return self.owner.data.px, self.owner.data.py, self.owner.data.pz;
            end
        else
            if self.configData.hang > 0 then -- 挂自身
                return 0, 0, 0;
            else
                return self.owner.data.px, self.owner.data.py, self.owner.data.pz;
            end
        end
    end
    return self.posx, self.posy, self.posz;
end

function Lua_EffectVo:calTargetPos()
    if self.target ~= nil then
        local px = self.target.data.px;
        local py = self.target.data.py;
        local pz = self.target.data.pz;
        if self.configData.moveType > 0 then -- 飞行特效，身上挂的话，需要转到世界坐标
            return px, py, pz;
        else
            if self.configData.hang > 0 then -- 挂自身
                if self.selfRoleId == self.targetRoleId then
                    return 0, 0, 0;
                else
                    if self.owner ~= nil then
                        local tf = self.effAvatarParent;
                        if tf ~= nil then
                            LuaUtil.calInverseTransformPoint(self.effAvatarParent, px * 0.01, py * 0.01, pz * 0.01);
                            px = LuaUtil.temporaryVectorX * 100;
                            py = LuaUtil.temporaryVectorY * 100;
                            pz = LuaUtil.temporaryVectorZ * 100;
                            return px, py, pz;
                        else
                            return px, py, pz;
                        end
                    else
                        return px, py, pz;
                    end
                end
            else
                return px, py, pz;
            end
        end
    end
    return self.posx, self.posy, self.posz;
end

function Lua_EffectVo.Get:distance()
    return Vector3.DistanceTwoPoint(self.orginPosX, self.orginPosY, self.orginPosZ, self.targetPosX, self.targetPosY, self.targetPosZ);
end

function Lua_EffectVo:getDirByToPos(startPosx, startPosy, startPosz, endPosx, endPosy, endPosz, eulerAnglesX, eulerAnglesY, eulerAnglesZ)
    if self.configData.isThroughAllEff or self.configData.isContactTwoEff or self.configData.isContactAllEff then
        if not Vector3.EqualsPoint(startPosx, startPosy, startPosz, endPosx, endPosy, endPosz) then
            LuaUtil.quaternionLookRot(endPosx - startPosx, endPosy - startPosy, endPosz - startPosz);
            local rx = LuaUtil.temporaryVectorX;
            local ry = LuaUtil.temporaryVectorY;
            local rz = LuaUtil.temporaryVectorZ;
            return rx, ry, rz;
        end
        return eulerAnglesX, eulerAnglesY, eulerAnglesZ;
    end
    return self.effRotX, self.effRotY, self.effRotZ;
end

function Lua_EffectVo.Get:effRotX()
    if self._effRotX == nil then
        self:calEffRot();
    end 
    return self._effRotX;
end

function Lua_EffectVo.Get:effRotY()
    if self._effRotY == nil then
        self:calEffRot();
    end 
    return self._effRotY;
end

function Lua_EffectVo.Get:effRotZ()
    if self._effRotZ == nil then
        self:calEffRot();
    end 
    return self._effRotZ;
end

function Lua_EffectVo:calEffRot()
    self._effRotX = 0;
    self._effRotY = 0;
    self._effRotZ = 0;
    if self.configData.moveType > 0 then -- 位移
        if not Vector3.EqualsPoint(self.orginPosX, self.orginPosY, self.orginPosZ, self.targetPosX, self.targetPosY, self.targetPosZ) then
            LuaUtil.quaternionLookRot(self.targetPosX - self.orginPosX, self.targetPosY - self.orginPosY, self.targetPosZ - self.orginPosZ);
            self._effRotX = LuaUtil.temporaryVectorX;
            self._effRotY = LuaUtil.temporaryVectorY;
            self._effRotZ = LuaUtil.temporaryVectorZ;
        end
    elseif self.configData.mirrorType == 3 then -- 需要旋转
        if not Vector3.EqualsPoint(self.orginPosX, self.orginPosY, self.orginPosZ, self.targetPosX, self.targetPosY, self.targetPosZ) then
            LuaUtil.quaternionLookRot(self.targetPosX - self.orginPosX, self.targetPosY - self.orginPosY, self.targetPosZ - self.orginPosZ);
            self._effRotX = LuaUtil.temporaryVectorX;
            self._effRotY = LuaUtil.temporaryVectorY;
            self._effRotZ = LuaUtil.temporaryVectorZ;
        elseif self.dir ~= 0 then
            self._effRotY = -self.dir + 90; -- 特效默认出的朝向是z的正向
        end
    elseif self.configData.mirrorType == 4 then -- 旋转180
        if self.formationType == Lua_FightDefine.FIGHT_DEFENDER then
            self._effRotY = 180; 
        end
    end

    self._effRotX = self._effRotX + self.configData.effRot.x;
    self._effRotY = self._effRotY + self.configData.effRot.y;
    self._effRotZ = self._effRotZ + self.configData.effRot.z;
end

function Lua_EffectVo:getScaVecByTwoPoint(startPosx, startPosy, startPosz, endPosx, endPosy, endPosz)
    local sz = 1;
    if self.configData.moveType == 0 
        and self.configData.baseLen > 0 
        and (startPosx ~= endPosx or startPosy ~= endPosy or startPosz ~= endPosz) then
        sz = Vector3.DistanceTwoPoint(startPosx, startPosy, startPosz, endPosx, endPosy, endPosz) / self.configData.baseLen;
    end
    if self.configData.mirrorType == 2 then -- 镜面翻转
        sz = self.formationType == Lua_FightDefine.FIGHT_DEFENDER and -sz or sz;
    end
    return sz;
end

function Lua_EffectVo.Get:effSca()
    if self._effSca == nil then
        self._effSca = 1;
        if self.configData.moveType == 0 
            and self.configData.baseLen > 0 
            and (self.orginPosX ~= self.targetPosX or self.orginPosY ~= self.targetPosY or self.orginPosZ ~= self.targetPosZ) then
            self._effSca = self.distance / self.configData.baseLen;
        end
        if self.configData.mirrorType == 2 then -- 镜面翻转
            self._effSca = self.formationType == Lua_FightDefine.FIGHT_DEFENDER and -self._effSca or self._effSca;
        end
    end
    return self._effSca;
end

function Lua_EffectVo:checkIsEnd(idx)
    if self.configData == nil then 
        return true; 
    end
    if self.configData.isThroughAllEff then
        return self.targetsList == nil or self.targetsList:getSize() < idx;
    end
    return true;
end