-- 无尽关卡
Lua_EndlessLevelData = class("Lua_EndlessLevelData");
Lua_EndlessLevelData.reusltRankTime = 60 * 30; -- 最后一天30分用于计算排名数据
function Lua_EndlessLevelData:ctor()
end

function Lua_EndlessLevelData:dispose()
	self._totalMaxWave = nil;
	self._curMaxWave = nil;
	self._curMaxScore = nil;
	self._historyMaxWave = nil;
	self._historyMaxScore = nil;
	self._hasAssistTimes = nil;
	self._maxAssistTimes = nil;
	self._buff = nil;
	self._dayReward = nil;
	self._waveReward = nil;
	self._challengeCond = nil;
	self._starCondArr = nil;
	self._isShowAssistBuff = nil;
	self._buffIdList = nil;
	self._wave = nil;
	self._integral = nil;
	self.bCheckKeepFighting = false;
	self._iskeepFighting = nil;
end

function Lua_EndlessLevelData:fromServer50108096(msg)
	if msg == nil then
		return;
	end

	self._totalMaxWave = msg.pass_count; -- 累计波数
	self._curMaxWave = msg.pass_count_max; -- 今日最高波数
	self._curMaxScore = msg.integral; -- 今日最高积分
	self._historyMaxWave = msg.historic_high_pass; -- 历史最高波数
	self._historyMaxScore = msg.historic_high_integral; -- 历史最高积分
	self._hasAssistTimes = msg.help_out_max - msg.help_out; -- 已经助阵次数
	self._maxAssistTimes = msg.help_out_max; -- 最大助阵次数
	self._buff = msg.buff; -- 挑战buff
	self._dayReward = msg.day_award; -- 每日挑战奖励
	self._waveReward = msg.wave_award; -- 波数奖励

	local obj;
	local list = {};
	self._challengeCond = {};
	for i = 1, #msg.suv_term do
		obj = msg.suv_term[i];
		for j = 1, 4 do
			if obj["value"..j] ~= -1 then -- -1表示不是条件
				list[j] = obj["value"..j];
			end
		end
		self._challengeCond[i] = {obj.type, list};
	end

	local obj;
	local redState = false;
	for i = 1, #msg.wave_award do
		obj = msg.wave_award[i];
		if not redState and obj.term_param2 == 1 then
			redState = true;
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EndlessLevel_WaveReward, redState);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EndlessLevel_DailyReward, msg.day_award.term_param2 == 1);
end

function Lua_EndlessLevelData.Get:totalMaxWave()
	return self._totalMaxWave or 0;
end

function Lua_EndlessLevelData.Get:curMaxWave()
	return self._curMaxWave or 0;
end

function Lua_EndlessLevelData.Get:curMaxScore()
	return self._curMaxScore or 0;
end

function Lua_EndlessLevelData.Get:historyMaxWave()
	return self._historyMaxWave or 0;
end

function Lua_EndlessLevelData.Get:historyMaxScore()
	return self._historyMaxScore or 0;
end

function Lua_EndlessLevelData.Get:hasAssistTimes()
	return self._hasAssistTimes or 0;
end

function Lua_EndlessLevelData.Get:maxAssistTimes()
	return self._maxAssistTimes or 3;
end

function Lua_EndlessLevelData.Get:buff()
	return self._buff or {};
end

function Lua_EndlessLevelData.Get:dayReward()
	return self._dayReward or {};
end

function Lua_EndlessLevelData.Get:waveReward()
	return self._waveReward or {};
end

function Lua_EndlessLevelData.Get:challengeCond()
	return self._challengeCond or {};
end

-- 跨天后条件会变化
function Lua_EndlessLevelData.Get:starCondArr()
	if self._starCondArr == nil then
		self._starCondArr = Array();
	end

	local vo;
	for i = 1, #self.challengeCond do
		vo = self._starCondArr[i];
		if vo == nil then
			vo = Lua_StarCondVo.new(Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL);
			self._starCondArr:add(vo);
		end
		vo:parseCond(self.challengeCond[i]);
	end
	return self._starCondArr;
end

function Lua_EndlessLevelData:fromServer50108099(msg)
	if msg == nil then
		return;
	end

	self._isShowAssistBuff = #msg.helper_list >= msg.helped_max;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EndlessLevel_AssistReward, msg.state == 1);
end

function Lua_EndlessLevelData.Get:isShowAssistBuff()
	return self._isShowAssistBuff or false;
end

function Lua_EndlessLevelData.Get:buffIdList()
	if self._buffIdList == nil then
		self._buffIdList = {};
		for i = 1, #self.buff.skill_id do
			self._buffIdList[i] = self.buff.skill_id[i];
		end
	end
	return self._buffIdList;
end

function Lua_EndlessLevelData:fromServer80108103(msg)
	if msg == nil then
		return;
	end
	self._wave = msg.pass;
	self._integral = msg.integral;
end

function Lua_EndlessLevelData.Get:wave()
	return self._wave or 0;
end

function Lua_EndlessLevelData.Get:integral()
	return self._integral or 0;
end

function Lua_EndlessLevelData:checkKeepFighting()
	if self.bCheckKeepFighting or not DataCenter.loginData.isInGameWorld or not DataCenter.backstageActData.bInitServer then
		return;
	end
	self.bCheckKeepFighting = true;
	
	-- local arr = DataCenter.backstageActData.openIdxArr;
	-- if arr then
	-- 	local vo;
	-- 	for i = 1, arr:getSize() do
	-- 		vo = DataCenter.backstageActData:getActVoByIdx(arr[i]);
	-- 		if vo and vo.actType == 10015 then
	-- 			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelKeepFighting(arr[i]);
	-- 		end
	-- 	end
	-- end
end

function Lua_EndlessLevelData:fromServer50108104(msg)
	if msg == nil then
		return;
	end

	self._iskeepFighting = msg.combat_condition == 1;
	if msg.combat_condition == 1 then
		self._wave = msg.pass_count;
		self._integral = msg.integral;
	end
end

function Lua_EndlessLevelData.Get:iskeepFighting()
	return self._iskeepFighting or false;
end

function Lua_EndlessLevelData:initInfo()
	self._wave = nil;
	self._integral = nil;
end