--寂灭岛装备副本
checkRequire("Lua_TeamSaloonVo"); -- 组队大厅
checkRequire("Lua_TeamMemberVo"); -- 队伍成员
Lua_EquipCopyData = class("Lua_EquipCopyData")
Lua_EquipCopyData.ExtremeRound = 1; -- 极限回合
Lua_EquipCopyData.ExtremePower = 2; -- 极限战力

function Lua_EquipCopyData:ctor()
	self:dispose();
end

function Lua_EquipCopyData:dispose()
	self.free_times = 0;
	self.times_limit = 0;
	self.reward_times = 0;
	self.extra_reward_times = 0;
	self.help_times = 0;
	self.max_difficulty = 0; -- 难度

	self.boss_list = nil;
	self.more_reward = nil;
	self.single_reward = nil;

	-- 组队大厅
	self.is_auto_join = 0;
	self.teamSaloonInfo = nil;--大厅队伍列表

	-- 组队成员
	self.team_id = 0; -- 队伍id
	self.teamMemberDic = nil; -- 队伍成员列表

	-- 今日收获
	self.harvestInfo = nil;

	-- 奖励翻牌
	self.openCardRewardInfo = nil;

	self.bInitEquipCopy = false; -- 初始化标记
	self.copyOpenStateDic = nil; -- 副本开启状态
	self.copyDifficultyDic = nil; -- 副本难度
	self.copySkipFightDic = nil;
	-- 首通排行榜
	self.firstPassSelectedCamp = nil; 
	self.firstCampRedStateDic = {};

	-- 队伍邀请信息
	self.invitationJournalList = nil;

	-- 组队模式：邀请界面（好友、工会）
	self.teamInvitationDic = nil; 
	if self.teamInvitationArr ~= nil then
		self.teamInvitationArr:dispose();
		self.teamInvitationArr:clear();
		self.teamInvitationArr = nil;
	end

	self.team_num = 0;--队伍数量
	self.bTeamInviteRedDot = nil;
	self.fight_start_tick = 0;--战斗准备时间
	self.openTeamState = false;
end

function Lua_EquipCopyData:fromServer50201001(msg)
	if msg == nil then
		return
	end

	self.free_times = msg.left_free_times; -- 单人剩余免费次数
	self.times_limit = msg.fight_times_limit; -- 单人挑战次数上限

	self.reward_times = msg.left_team_reward_times; -- 组队剩余的挑战奖励次数
	self.extra_reward_times = msg.left_team_help_reward_times; -- 组队剩余的协助奖励次数
	self.help_times = msg.left_team_help_times; -- 组队剩余的协助次数

	self.max_difficulty = msg.max_difficulty; -- 当前通关阵营的最大难度
	self.team_id = tonumber(msg.silent_island_team_id); -- 加入的队伍id 未加入id为0

	self.camp_list = msg.camp_list; -- boss阵营信息

	-- 副本难度
	self.copySkipFightDic = {};
	self.copyDifficultyDic = {};

	local list = msg.camp_difficulty;
	local camp;
	local map_list;
	local max_diff;
	for i = 1, #list do
		camp = list[i].type;
		map_list = list[i].map_list;

		if self.copySkipFightDic[camp] == nil then
			self.copySkipFightDic[camp] = {};
		end

		--key:boss阵营难度 value: 是否可以跳过战斗 1：可以跳过 0：不可以跳过
		max_diff = 0;--阵营解锁的最大难度
		for j = 1, #map_list do
			if max_diff < map_list[j].key then
				max_diff = map_list[j].key;
			end
			self.copySkipFightDic[camp][map_list[j].key] = map_list[j].value;
		end
		self.copyDifficultyDic[camp] = max_diff; -- 各阵营解锁的最大难度
	end
	self.bInitEquipCopy = true;

	-- 单人副本红点
	self:checkSingleRedDotState();

	-- 组队副本红点
	self:checkTeamRedDotState();

	-- 是否能打开组队页签
	Lua_MsgUtil.callFunc("EQUIP_COPY_OPEN_TEAM");
end

-- 通过副本id获取难度
function Lua_EquipCopyData:getCopyDifficultyByID(camp)
	if self.copyDifficultyDic == nil or self.copyDifficultyDic[camp] == nil then
		return 1;
	end
	return self.copyDifficultyDic[camp];
end

--获取副本难度是否可以跳过
function Lua_EquipCopyData:bSkipFightByDifficulty(camp, difficulty)
	if self.copySkipFightDic == nil or self.copySkipFightDic[camp] == nil or self.copySkipFightDic[camp][difficulty] == nil then
		return false;
	end
	return self.copySkipFightDic[camp][difficulty] == 1;
end

-- 副本功能开启数据
function Lua_EquipCopyData:fromServer80201028(msg)
	if msg == nil then
		return;
	end

	local list = msg.boss_open_info;
	self.copyOpenStateDic = {};
	for i = 1, #list do
		self.copyOpenStateDic[tonumber(list[i].key)] = tonumber(list[i].value) == 1;
	end
end

-- 副本开启索引
function Lua_EquipCopyData.Get:copyOpenId()
	if self.copyOpenStateDic == nil then
		return 1;
	end

	for id, state in pairs(self.copyOpenStateDic) do
		if state == true then
			return id;
		end
	end
	return 1;
end

-- 副本是否开启
function Lua_EquipCopyData:copyOpenStateById(id)
	if self.copyOpenStateDic == nil or self.copyOpenStateDic[id] == nil then
		return false;
	end
	return self.copyOpenStateDic[id];
end

-- 每日收获信息
function Lua_EquipCopyData:fromServer50201002(msg)
	if msg == nil then
		return;
	end

	local sort = 0;
	local list = msg.daily_harvest_info;
	self.harvestInfo = Array();
	for i=1,#list do
		sort = list[i].fight_grade
		if list[i].is_overreturn == 0 then
			sort = sort + 100000;
		end
		self.harvestInfo:add({data = list[i], is_overreturn = list[i].is_overreturn, sort = sort });
	end
	self.harvestInfo:sort("sort", true);
end

--是否有卡片可以翻牌
function Lua_EquipCopyData.Get:isHavoHarvest()
	if self.harvestInfo == nil then
		return false;
	end

	for i = 1, self.harvestInfo:getSize() do
		if self.harvestInfo[i].is_overreturn == 0 then
			return true;
		end
	end
	return false;
end

















-- 组队大厅
function Lua_EquipCopyData:fromServer50201003(msg)
	if msg == nil then
		return;
	end
	self.is_auto_join = msg.is_auto_join; -- 是否自动加入队伍 0未自动加入 1已自动加入

	self.teamSaloonInfo = Array();--大厅队伍列表

	local svo;
	local list = msg.team_list;
	for i = 1, #list do
		svo = Lua_TeamSaloonVo.new(tonumber(list[i].team_id));
		svo:fromServer(list[i]);
		self.teamSaloonInfo:add(svo);
	end
end

-- 队伍成员信息
function Lua_EquipCopyData:fromServer50201006(msg)
	if msg == nil then
		return;
	end
	self:updateTeamMemberMsg(msg.team_info)
end

--更新队伍成员信息
function Lua_EquipCopyData:fromServer80201005(msg) 
	if msg == nil then
		return;
	end
	-- print("更新队伍成员信息", msg.type)

	-- 备注：
	-- type
	-- 1.加入
	-- 2.退出
	-- 3.位置更换
	-- 4.队伍成员变更
	-- 5.队伍上次分享时间
	-- 6.创建
	-- 7.战斗开始变化（更新战前准备状态）
	-- 8.队伍设置变化
	local typev = msg.type;
	if typev == 2 then
		self.team_id = 0;
		self.leader_id = 0;
		self.teamMemberDic = nil;
	elseif typev == 5 then
		self.last_share_tick = tonumber(tostring(msg.team_info.last_share_tick)); -- 上次分享时间+分享间隔
	elseif typev == 7 then
		self:getTeamState(msg.team_info);
	elseif typev == 8 then
		self:updateTeamSetInfo(msg.team_info.team_set_info);
	else
		self:updateTeamMemberMsg(msg.team_info);
	end
end

-- 更新队伍信息
function Lua_EquipCopyData:updateTeamMemberMsg(msg)
	if msg == nil then
		return;
	end
	self.team_id = tonumber(msg.team_id); -- 队伍id
	self.leader_id = tonumber(msg.leader_id); -- 队长id
	self.last_share_tick = tonumber(msg.last_share_tick); -- 上次分享时间+分享间隔

	self.teamMemberDic = {}; -- 组队列表
	
	local list = msg.member_list; -- 队伍成员列表
	if list == nil then
		return;
	end
	local mvo;
	self.team_num = #list;--队伍数量
	for i = 1, self.team_num do
		mvo = Lua_TeamMemberVo.new(list[i].pos);
		mvo:fromServer(list[i]);
		self.teamMemberDic[list[i].pos] = mvo;
	end
	self:getTeamState(msg);
	self:updateTeamSetInfo(msg.team_set_info);
end

-- 更新队伍设置信息
function Lua_EquipCopyData:updateTeamSetInfo(teamSetInfo)
	self.team_diff = teamSetInfo.difficulty; -- 队伍难度
	self.team_force = teamSetInfo.force_cond; -- 战力要求 0无战力要求
	self.fight_set = teamSetInfo.fight_set; -- 战斗设置 1失败再次挑战 0失败不自动挑战
	self.team_join_limit = teamSetInfo.team_join_limit; -- 队伍加入限制 0任何可以加入 1邀请加入
end

-- 更新队伍准备状态信息
function Lua_EquipCopyData:getTeamState(msg)
	self.fight_start_tick = tonumber(msg.fight_start_tick); -- 战斗开始时间
	self.fight_before_state = msg.fight_before_state; -- 战前 准备状态 1准备 0未准备
end

-- 获取成员vo
function Lua_EquipCopyData:getTeamMemberVoByPos(pos)
	if self.teamMemberDic == nil or self.teamMemberDic[pos] == nil then
		return nil;
	end
	return self.teamMemberDic[pos];
end

-- 更新队伍成员准备状态
function Lua_EquipCopyData:fromServer80201024(msg)
	if msg == nil then
		return;
	end
	self.fight_start_tick = tonumber(msg.fight_start_tick);

	local mvo;
	local list = msg.member_state;
	for i = 1, #list do
		mvo = self:getTeamMemberVoByPos(list[i].key);
		if mvo ~= nil then
			mvo.status = list[i].value;
		end
	end
end

-- 是否是队长
function Lua_EquipCopyData.Get:isLeader()
    return DataCenter.roleData.roleId == self.leader_id;
end

-- 是否可以挑战
function Lua_EquipCopyData.Get:isStarFight()
	local num = 0;
	for k,v in pairs(self.teamMemberDic) do -- 是否都准备
		num = num +1;
		if v.status == 0 then
			return false;
		end
	end

	-- 满员
	if num >= DataCenter.equipCopyUtil.team_num then
		return true;
	end
	return false;
end

-- 挑战的 BossId
function Lua_EquipCopyData.Get:bossId()
	local pos;
	for k,v in pairs(self.teamMemberDic) do
		if v.isSelf == true then
			pos = v.id;
			break;
		end
	end
	return self.camp_list[pos];
end

-- 挑战的boss阵容
function Lua_EquipCopyData.Get:monster_player_id()
	local monster_player_id;
	for k,v in pairs(self.teamMemberDic) do
		if v.isSelf == true then
			monster_player_id = v.boss_id;
			break;
		end
	end
	return monster_player_id;
end

-- 单人奖励翻牌
function Lua_EquipCopyData:fromServer50201030(msg)
	if msg == nil then
		return;
	end
	self.open_index = msg.pos; -- 位置索引

	self.openCardRewardInfo = {};
	local list = msg.reward_info;
	for i = 1, #list do
		self.openCardRewardInfo[list[i].pos] = list[i].reward;
	end
end


-- 多人奖励翻牌
function Lua_EquipCopyData:fromServer80201031(msg)
	if msg == nil then
		return;
	end
	self.openCardRewardInfo = msg.reward_info;
end


-- 队伍开启状态
function Lua_EquipCopyData:fromServer80201039(msg)
	if msg == nil then
		return;
	end
	self.openTeamState = msg.flag == 1; -- 1：开启 0：未开启
end






























-- 寂灭岛排行
-- 首通
function Lua_EquipCopyData:fromServer50201020(msg)
	if msg == nil then
		return;
	end

	DataCenter.equipCopyUtil:initRankConfigInfo();

	local camp;
	local role_list;
	local list = msg.rank_list;
	local id;
	local vo;
	local bRewardCamp;
	local redStateDic = {};
	self.firstPassSelectedCamp = nil;
	for i = 1, #list do
		camp = list[i].camp
		role_list = list[i].role_list;
		
		bRewardCamp = false;
		for j = 1, #role_list do
			id = camp * 1000 + role_list[j].difficulty;
			vo = DataCenter.equipCopyUtil:getConfigVoById(id);
			vo:updateServerInfo(role_list[j]);

			if bRewardCamp == false and vo.hasReward == 0 then
				bRewardCamp = true;
			end
		end

		if bRewardCamp and self.firstPassSelectedCamp == nil then
			self.firstPassSelectedCamp = camp;
		end

		redStateDic[camp] = bRewardCamp;
	end

	self:checkSingleFirstRedDotState(redStateDic)-- 首通红点
end

-- 根据阵营id获取该阵营的排行榜
function Lua_EquipCopyData:getFirstPassRankByCamp(campId)
	local vo;
	local arr = Array();
	local camp_list = DataCenter.equipCopyUtil:getRankByCamp(campId); -- 从EquipCopyUtil中获取该阵营的所有难度
	for i = 1, camp_list:getSize() do
		vo = DataCenter.equipCopyUtil:getConfigVoById(camp_list[i]);
		arr:add(vo);
	end
	arr:sort("sort",true);
	return arr;
end

-- 请求领取寂灭岛首通奖励（返回）
function Lua_EquipCopyData:fromServer50201022(msg)
	if msg == nil then
		return;
	end

	local id = msg.camp * 1000 + msg.difficulty;
	local firstPassVo = DataCenter.equipCopyUtil:getConfigVoById(id);
	firstPassVo:updateFistPassReceive(msg.is_draw_reward);

	-- 领取后更新首通排行榜红点
	local list = DataCenter.equipCopyUtil.rankConfigDic;
	local stateDic = {};
	self.firstPassSelectedCamp = nil;
	for k, v in pairs(list) do
		if v.hasReward == 0 then
			if self.firstPassSelectedCamp == nil then
				self.firstPassSelectedCamp = v.camp;
			end
			stateDic[v.camp] = true;
		end
	end

	--检测首通红点
	self:checkSingleFirstRedDotState(stateDic);
end

-- 极限战力、极限回合
function Lua_EquipCopyData:fromServer50201021(msg)
	if msg == nil then
		return;
	end

	-- 初始化、读取配置表相关数据
	DataCenter.equipCopyUtil:initRankConfigInfo();
	
	local roleList = msg.role_list;
	if roleList ~= nil then
		local id;
		local vo;
		for i = 1, #roleList do
			id = msg.camp * 1000 + roleList[i].difficulty;
			vo = DataCenter.equipCopyUtil:getConfigVoById(id);
			vo:updateServerInfo(roleList[i]);
		end
	end
end




























-- 队伍日志
function Lua_EquipCopyData:fromServer50201013(msg)
	if msg == nil then
		return;
	end

	self.joinTeamTick = tonumber(msg.join_team_tick);

	local logList = msg.log_list;
	local lastTime = tonumber(logList[1].log_tick); -- 上一次日志的时间戳，此时为最新日志log_list[1].log_tick
	local compareTime = self:getLogZeroTime(lastTime); -- 获取加入最新日志当天凌晨0点0分的时间戳
	local curTime;
	local isHistory;
	local isYesterday;
	self.journalArr = Array();
	for i = 1, #logList do
		curTime = tonumber(logList[i].log_tick);

		-- 历史记录
		if curTime < self.joinTeamTick and lastTime >= self.joinTeamTick then 
			self.journalArr:add(LanUtil.getValue(420097));
			isHistory = true;
		end
		lastTime = curTime;

		-- "昨天记录"
		if compareTime > curTime and isHistory == nil and isYesterday == nil then   
			self.journalArr:add(LanUtil.getValue(420098));
			isYesterday = true;
		end

		self.journalArr:add(logList[i]);
	end
end

-- 根据时间戳计算当天凌晨0点0分时的时间戳
function Lua_EquipCopyData:getLogZeroTime(logTime)
	local year, month, day = os.date("%Y", logTime), os.date("%m", logTime), os.date("%d", logTime);
	return os.time({year = tonumber(year), month = tonumber(month), day = tonumber(day), hour = 00, min = 00, sec = 00});
end

-- 队伍邀请信息
function Lua_EquipCopyData:fromServer50201016(msg)
	if msg == nil then
		return;
	end

	self.invitationJournalArr = Array();
	if #msg.invite_list <= 0 then return end

	local obj;
	local isYesterday;
	local zeroTime = self:getLogZeroTime(tonumber(msg.invite_list[1].invite_tick)); -- 最新日志当天凌晨零点零分的时间戳;
	for i = 1, #msg.invite_list do
		obj = msg.invite_list[i];

		-- 判断是否为昨天记录
		if tonumber(obj.invite_tick) < zeroTime and not isYesterday then
			self.invitationJournalArr:add(LanUtil.getValue(420100));
			isYesterday = true;
		end
		self.invitationJournalArr:add(obj);
	end
end

-- 请求处理寂灭岛队伍邀请信息返回
function Lua_EquipCopyData:fromServer50201018(msg)
	if msg == nil then
		return;
	end
	self:fromServer50201016(msg);
	Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INVITATION_JOURNAL", true);
end

-- 请求加入寂灭岛队伍弹窗
function Lua_EquipCopyData:fromServer80201035(msg)
	if msg == nil then
		return;
	end

	if not Lua_WindowUtil.isWindowShowing("Lua_TeamInvitePopUpWindow") then
		Lua_WindowUtil.openWin("Lua_TeamInvitePopUpWindow", Lua_WinParam.ACTION_OPEN, msg.invite_info)
	end

	self:updateTeamInviteRedDot(true);
end

-- 组队模式：邀请界面（好友、工会）
function Lua_EquipCopyData:fromServer50201027(msg)
	if msg == nil then
		return;
	end

	local id;
	local roleInfo;
	self.teamInvitationDic = {}; 
	self.teamInvitationArr = Array();
	for i = 1, #msg.role_list do
		roleInfo = msg.role_list[i];
		id = roleInfo.show_role.id;
		self.teamInvitationDic[id] = roleInfo;
		self.teamInvitationArr:add(id);
	end
	self.teamInvitationArr:sortf(self, self.sortTeamInvitation);
end

-- 排序
function Lua_EquipCopyData:sortTeamInvitation(a, b)
    local aInfo = self:getTeamInvitationVoById(a).show_role;
    local bInfo = self:getTeamInvitationVoById(b).show_role;
    return tonumber(aInfo.force) > tonumber(bInfo.force);
end

-- 根据id获取邀请信息
function Lua_EquipCopyData:getTeamInvitationVoById(id)
	if self.teamInvitationDic == nil or self.teamInvitationDic[id] == nil then
		return;
	end
	return self.teamInvitationDic[id];
end

-- 还有好友可邀请
function Lua_EquipCopyData:canInvite()
	local invite;
	for k, v in pairs(self.teamInvitationDic) do
		if v.is_invited == 0 and v.is_online == 1 then
			invite = true;
			break;
		end
	end
	return invite == true;
end

-- 请求邀请加入寂灭岛队伍
function Lua_EquipCopyData:fromServer50201015(msg)
	if msg == nil then
		return;
	end

	local roleId = msg.role_id;
	local vo = self:getTeamInvitationVoById(roleId);
	vo.is_invited = msg.is_invite;
end



































-----------------------------------------   红点   -------------------------------------------------------

--首通红点
function Lua_EquipCopyData:checkSingleFirstRedDotState(campRedStateDic)
	local bossNameArr = DataCenter.equipCopyUtil.bossNameArr;
	for i = 1, bossNameArr:getSize() do
		if i == 1 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_FirstPassRank_CampOne, campRedStateDic[i]);
		elseif i == 2 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_FirstPassRank_CampTwo, campRedStateDic[i]);
		elseif i == 3 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_FirstPassRank_CampThree, campRedStateDic[i]);
		elseif i == 4 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_FirstPassRank_CampFour, campRedStateDic[i]);
		end
	end

	Lua_MsgUtil.callFunc("EQUIPCOPY_UPDATE_SINGLE_FIRST");--首通红点
end

--  单人红点
function Lua_EquipCopyData:checkSingleRedDotState()
	--战令/单人奖励次数/单人今日收获
	local bool = self.equipCopyWarMarkRedDot or self.equipCopySingleRewardRedDot or self.equipCopySingleHarvestRedDot;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_Single_ActiveNode, bool);

	Lua_MsgUtil.callFunc("EQUIPCOPY_UPDATE_SINGLE_BTNREDPOINT");--单人
end

--组队红点
function Lua_EquipCopyData:checkTeamRedDotState()
	local teamRedState = false;
	if self.openTeamState then
		teamRedState = self.equipCopyWarMarkRedDot or self.equipCopyTeamRewardRedDot or self.equipCopyTeamHarvestRedDot;
	else
		self:updateTeamInviteRedDot(false);
	end
	-- 组队模式红点末梢为button
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_Team_ActiveNode, teamRedState);

	Lua_MsgUtil.callFunc("EQUIPCOPY_UPDATE_TEAM_BTNREDPOINT");--组队
end


--组队邀请红点
function Lua_EquipCopyData:updateTeamInviteRedDot(state)
	if self.bTeamInviteRedDot == state then
		return
	end
	self.bTeamInviteRedDot = state;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EquipCopy_Team_Invite, state);
end

-- 是否有首通红点
function Lua_EquipCopyData.Get:firstPassRankRedDot()
	return self.firstPassSelectedCamp ~= nil;
end

-- 是否有战令红点
function Lua_EquipCopyData.Get:equipCopyWarMarkRedDot()
	return DataCenter.warOrderData:getEquipCopyWarMarkRedPoint();
end

-- 是否有单人奖励次数
function Lua_EquipCopyData.Get:equipCopySingleRewardRedDot()
	return self.free_times > 0; -- 单人奖励剩余次数是否大于0
end

-- 是否有组队奖励次数
function Lua_EquipCopyData.Get:equipCopyTeamRewardRedDot()
	return self.openTeamState and self.reward_times > 0; -- 组队开启and剩余的奖励次数
end

-- 是否拥有组队奖励次数
function Lua_EquipCopyData.Get:isHasTeamRewardNum()
	return self.reward_times > 0 or self.extra_reward_times > 0;
end

-- 今日收获红点是否显示
function Lua_EquipCopyData:fromServer80201033(msg)
	if msg == nil then
		return;
	end

	self.harvestRedPoint = msg.type; -- type: 0无奖励领取 1有单人奖励领取 2有队伍奖励领取 3单人队伍奖励都可领取

	-- 单人副本红点
	self:checkSingleRedDotState();

	-- 组队副本红点
	self:checkTeamRedDotState();
end

-- 单人今日收获红点
function Lua_EquipCopyData.Get:equipCopySingleHarvestRedDot()
	return self.harvestRedPoint == 1 or self.harvestRedPoint == 3; -- 单人今日收获:0无奖励领取 1有单人奖励领取 2有队伍奖励领取 3单人队伍奖励都可领取
end

-- 组队今日收获红点
function Lua_EquipCopyData.Get:equipCopyTeamHarvestRedDot()
	return self.harvestRedPoint == 2 or self.harvestRedPoint == 3; -- 组队今日收获:0无奖励领取 1有单人奖励领取 2有队伍奖励领取 3单人队伍奖励都可领取
end