-- 积天豪礼
checkRequire("Lua_CumulateGiftVo");
Lua_CumulateGiftData = class("Lua_CumulateGiftData");
function Lua_CumulateGiftData:ctor()
end

function Lua_CumulateGiftData:dispose()
	if self.cumulateGiftDic ~= nil then
		for k,v in pairs(self.cumulateGiftDic) do
			v:dispose();
			v = nil;
		end
		self.cumulateGiftDic = nil;
	end
	if self._cumulateGiftArr ~= nil then
		self._cumulateGiftArr:dispose();
		self._cumulateGiftArr:clear();
		self._cumulateGiftArr = nil;
	end
end

function Lua_CumulateGiftData:fromServer50197018(msg)
	if msg == nil then
		return;
	end

	if self._cumulateGiftArr == nil then
		self._cumulateGiftArr = Array();
		self.cumulateGiftDic = {};
	else
		if self.curRound ~= Mathf.Floor(msg.index / 1000) then
			local arr = self._cumulateGiftArr;
			for i = 1, arr:getSize() do
				self.cumulateGiftDic[arr[i]] = nil;
			end
			self._cumulateGiftArr:clear();
			self.cumulateGiftDic = {};
		end
	end
	self.index = msg.index; -- 索引id
	self._rechargeDays = msg.index % 1000; -- 当前档次/已累充天数
	self._curRound = Mathf.Floor(msg.index / 1000); -- 当前轮次
	self._rewardKey = self:getRewardKey(self.curRound, msg.world_lvl); -- 活动刷新时世界等级
	self.isNeedSort = true;
	self:InitConfigInfo();

	local obj
	local vo;
	local redDotState = false;
	for i = 1, #msg.cumulate_list do
		obj = msg.cumulate_list[i];
		vo = self:getCumulateGiftVo(obj.key);
		if vo ~= nil then
			vo:updateCumulateGiftVoInfo(obj, msg.money);
			if not redDotState and obj.value == 1 then
				redDotState = true;
			end
		end
	end
	
	if self.constConfig.is_stop == 1 then
		local actVo = DataCenter.internalActData:getActivityVo(Lua_ActivityList.ID_CumulateGift);
		actVo:fromServerInfo(0, 0);
	end
	local bShow = (redDotState or msg.is_first_open == 0) and self.constConfig.is_stop ~= 1;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_CumulateGift, bShow);
end

function Lua_CumulateGiftData.Get:rechargeDays()
	return self._rechargeDays or 0;
end

function Lua_CumulateGiftData.Get:curRound()
	return self._curRound or 1;
end

function Lua_CumulateGiftData.Get:rewardKey()
	if self._rewardKey == nil then
		self._rewardKey = self:getRewardKey(self.curRound, 1);
	end
	return self._rewardKey;
end

function Lua_CumulateGiftData:getRewardKey(curRound, worldLevel)
	local worldLvDic = self.constConfig.world_lvl_reward;
	if worldLvDic == nil then
		return nil;
	end

	local gradeInfo = #worldLvDic < curRound and worldLvDic[#worldLvDic] or worldLvDic[curRound];
	for i = 1, #gradeInfo do
		if worldLevel <= gradeInfo[i][2] then
			return gradeInfo[i][3];
		end
	end
	return worldLvDic[#gradeInfo][3];
end

function Lua_CumulateGiftData.Get:constConfig()
	return getConfig("cumulate_days_recharge", "config");
end

function Lua_CumulateGiftData.Get:showGiftId()
	local list = self.constConfig.show_id_list;
	if #list >= self.curRound then
		return list[self.curRound];
	else
		return list[1];
	end
end

function Lua_CumulateGiftData:InitConfigInfo()
	if self._cumulateGiftArr:getSize() <= 0 then
		local config = getConfig("cumulate_days_recharge");
		for k,v in pairs(config) do
			if v.round ~= nil and v.round == self.curRound then
				self._cumulateGiftArr:add(k);
				self.cumulateGiftDic[k] = Lua_CumulateGiftVo.new(k, v);
			end
		end
	end
end

function Lua_CumulateGiftData.Get:cumulateGiftArr()
	if self.isNeedSort then
		self.isNeedSort = false;
		self._cumulateGiftArr:sortf(self, self.sortFun);
	end
	return self._cumulateGiftArr;
end

function Lua_CumulateGiftData:sortFun(a, b)
	local voA = self:getCumulateGiftVo(a);
	local voB = self:getCumulateGiftVo(b);
	local _a = voA.sortWeight;
	local _b = voB.sortWeight;
	if _a ~= _b then
		if _b > _a then
			return false;
		end
	else
		if a > b then
			return false;
		end
	end
	return true;
end

function Lua_CumulateGiftData:getCumulateGiftVo(id)
	if id and self.cumulateGiftDic and self.cumulateGiftDic[id] then
		return self.cumulateGiftDic[id];
	end
	return nil;
end