-- 每日特惠
checkRequire("Lua_DailyDiscountVo");
Lua_DailyDiscountData = class("Lua_DailyDiscountData");
function Lua_DailyDiscountData:ctor()
end

function Lua_DailyDiscountData:dispose()
	if self.giftDic ~= nil then
		for k,v in pairs(self.giftDic) do
			self.giftDic[k]:dispose();
			self.giftDic[k] = nil;
		end
		self.giftDic = nil;
	end
	self._giftTypeArr = nil;
	self.giftIdArrDic = nil;
	self.redState = nil;
end

function Lua_DailyDiscountData:fromServer50197001(msg)
	if msg == nil then
		return;
	end
	if self._giftTypeArr == nil then
		self._giftTypeArr = Array();
	else
		self._giftTypeArr:clear();
	end
	if self.giftIdArrDic == nil then
		self.giftIdArrDic = {};
	end
	if self.redState == nil then
		self.redState = {};
	end
	self.isNeedSort = true;

	local obj, idArr, vo;
	local state = false;
	for i = 1, #msg.daily_gift_info do
		obj = msg.daily_gift_info[i];
		self._giftTypeArr:add(obj.gift_id);
		self.redState[obj.gift_id] = false;

		idArr = Array();
		for j = 1, #obj.times_map do
			vo = self:getDiscountGiftVo(obj.times_map[j].key, true);
			if vo then
				vo:updateBuyTimes(obj.times_map[j].value, obj.can_buy);
				if not self.redState[obj.gift_id] and vo.isFree then
					state = true;
					self.redState[obj.gift_id] = true;
				end
				idArr:add(obj.times_map[j].key);
			end
		end
		idArr:sort(nil, false);
		self.giftIdArrDic[obj.gift_id] = idArr;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_DailyDiscount, state);
end

-- 每个类型对应红点状态
function Lua_DailyDiscountData:getRedShowState(id)
	return self.redState[id];
end

-- 礼包类型
function Lua_DailyDiscountData.Get:giftTypeArr()
	if self.isNeedSort then
		self.isNeedSort = false;
		self._giftTypeArr:sort(nil, false);
	end
	return self._giftTypeArr;
end

-- 子礼包IdArr
function Lua_DailyDiscountData:getGiftInfoById(mainId)
	return self.giftIdArrDic[mainId];
end

-- 子礼包，isUpdate：是否是本功能数据更新，外部调用不需要填
function Lua_DailyDiscountData:getDiscountGiftVo(id, isUpdate)
	if self.giftDic == nil then
		self.giftDic = {};
	end
	local vo = self.giftDic[id];
	if vo == nil and isUpdate then
		local config = getConfig("daily_gift", id);
		if config then
			vo = Lua_DailyDiscountVo.new(id, config);
			self.giftDic[id] = vo;
		end
	end
	return vo;
end