-- 英雄集结
Lua_HeroGatherData = class("Lua_HeroGatherData")
function Lua_HeroGatherData:ctor()
end

function Lua_HeroGatherData:dispose()
	self._curTaskId = nil;
	self._endTick = nil;
	self.heroGatherList = nil;
end

function Lua_HeroGatherData:fromServer50197016(msg)
	if msg == nil then
		return;
	end
	self:updateHeroGatherServerInfo(msg)
end

function Lua_HeroGatherData:fromServer80197016(msg)
	if msg == nil then
		return;
	end
	self:updateHeroGatherServerInfo(msg)
end

function Lua_HeroGatherData:updateHeroGatherServerInfo(msg)
	if msg == nil then
		return;
	end

	self._curTaskId = msg.cur_task; -- 当前阶段id
	self._endTick = msg.close_tick or self.endTick; -- 结束时间戳

	local obj;
	local redDotState = false;
	for i = 1, #msg.hero_gather_list do
		obj = msg.hero_gather_list[i];
		self:getHeroGatherStageInfo(obj.task_id, obj);
		if not redDotState and obj.state == 1 then
			redDotState = true;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_HeroGather, redDotState);

	local actVo = DataCenter.internalActData:getActivityVo(Lua_ActivityList.ID_HeroGather);
	actVo:fromServerInfo(1, self.endTick);
end

function Lua_HeroGatherData.Get:curTaskId()
	return self._curTaskId or 1;
end

function Lua_HeroGatherData.Get:endTick()
	return self._endTick or 0;
end

function Lua_HeroGatherData.Get:leftTime()
	return self.endTick - DataCenter.roleData.serverTime;
end

function Lua_HeroGatherData:getHeroGatherStageInfo(id, msg)
	if self.heroGatherList == nil then
		self.heroGatherList = {};
	end
	if msg ~= nil then
		self.heroGatherList[id] = msg;
	end
	if id == nil or self.heroGatherList[id] == nil then
		return {state = 0, progress = 0};
	end
	return self.heroGatherList[id];
end

function Lua_HeroGatherData.Get:heroGatherConstConfig()
	return getConfig("hero_gather", "config");
end

function Lua_HeroGatherData.Get:heroGatherInfoArr()
	if self._heroGatherInfoArr == nil then
		self._heroGatherInfoArr = Array();

		local config = getConfig("hero_gather");
		for k,v in pairs(config) do
			if v.target_num ~= nil then
				self._heroGatherInfoArr:add(v);
			end
		end
		self._heroGatherInfoArr:sort("id", false);
	end
	return self._heroGatherInfoArr;
end