-- 成长投资
checkRequire("Lua_investmentVo");
Lua_InvestmentData = class("Lua_InvestmentData")
function Lua_InvestmentData:ctor()
end

function Lua_InvestmentData:dispose()
	self._defaultStep = nil;
	self.showInfoDic = nil;
	self.extraMoneyDic = nil;
	self.investmentVoDic = nil;
end

function Lua_InvestmentData:fromServer50110006(msg)
	if msg == nil then
		return;
	end

	local stepInfo, obj, vo, redState, step;
	for i = 1, #msg.step_list do
		stepInfo = msg.step_list[i];
		for j = 1, #stepInfo.reward_state do
			obj = stepInfo.reward_state[j];
			vo = self:getInvestmentVo(obj.key);
			if vo == nil then
				vo = Lua_investmentVo.new(obj.key);
				self.investmentVoDic[obj.key] = vo;
			end
			vo:updateInvestmentVoInfo(stepInfo.step, stepInfo.lock_state, obj);

			if obj.value == 1 or obj.ex_value == 1 then
				redState = true;
				if step == nil or step > stepInfo.step then
					step = stepInfo.step;
				end
			end
		end
	end
	self._defaultStep = step;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_Investment, redState);
end

function Lua_InvestmentData.Get:defaultStep()
	if self._defaultStep == nil or self._defaultStep > self.showMaxStep then
		self._defaultStep = self.showMaxStep;
	end
	return self._defaultStep;
end

function Lua_InvestmentData.Get:showMaxStep()
	local config = getConfig("grow_up_invest_const");
	local level = DataCenter.roleData.level;
	local condId = DataCenter.mainLineData.checkpointId;
	local step = 1;
	for k,v in pairs(config) do
		if step <= k and level >= v.level_limit[1] and condId > v.mainline_limit then
			step = k;
		end
	end
	return step;
end

function Lua_InvestmentData:getInvestmentVo(id)
	if self.investmentVoDic == nil then
		self.investmentVoDic = {};
	end
	if id == nil or self.investmentVoDic[id] == nil then
		return nil;
	end
	return self.investmentVoDic[id];
end

function Lua_InvestmentData:getShowInfoByStep(showStep)
	if self.showInfoDic == nil then
		self.showInfoDic = {};
	end
	if self.showInfoDic[showStep] == nil then
		self.showInfoDic[showStep] = self:initShowInfoByStep(showStep);
	end
	return self.showInfoDic[showStep];
end

function Lua_InvestmentData:initShowInfoByStep(showStep)
	local list = getConfig("grow_up_invest");
	local stepList = getConfig("grow_up_invest_const", showStep);
	local arr = Array();
	for k,v in pairs(list) do
		if v.reward_level >= stepList.level_limit[1] and
			(v.reward_level <= stepList.level_limit[2] or stepList.level_limit[2] == 0) then
				arr:add(k);
		end
	end
	arr:sort(nil, false);
	return arr;
end

function Lua_InvestmentData:getExtraMoneyByStep(showStep)
	if self.extraMoneyDic == nil then
		self.extraMoneyDic = {};
	end
	if self.extraMoneyDic[showStep] == nil then
		self.extraMoneyDic[showStep] = 0;

		local arr = self:getShowInfoByStep(showStep);
		for i = 1, arr:getSize() do
			vo = self:getInvestmentVo(arr[i]);
			if vo ~= nil then
				self.extraMoneyDic[showStep] = self.extraMoneyDic[showStep] + vo.extraMoney;
			end
		end
	end
	return self.extraMoneyDic[showStep];
end

function Lua_InvestmentData:getRechargeId(step)
	return getConfig("grow_up_invest_const", step, "recharge_id");
end