Lua_DailyDiscountVo = class("Lua_DailyDiscountVo")
function Lua_DailyDiscountVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_DailyDiscountVo:dispose()
	self._config = nil;
	self._limitTimes = nil;
	self.isCanBuyAll = false;
end

function Lua_DailyDiscountVo:updateBuyTimes(hasBuyTimes, buyState)
	self.limitTimes = self.totalTimes - hasBuyTimes;
	self.isCanBuyAll = buyState == 1; -- 是否可以一键购买： 0否 1是
end

-- 限制购买次数
function Lua_DailyDiscountVo.Get:limitTimes()
	if self._limitTimes == nil then
		self._limitTimes = self.totalTimes;
	end
	return self._limitTimes;
end

function Lua_DailyDiscountVo.Set:limitTimes(val)
	self._limitTimes = val;
end

-- 是否免费
function Lua_DailyDiscountVo.Get:isFree()
	return self.recharge == 0 and self.limitTimes > 0;
end

function Lua_DailyDiscountVo.Get:config()
	if self._config == nil then
		self._config = getConfig("daily_gift", self.id);
	end
	return self._config;
end

-- 购买金额
function Lua_DailyDiscountVo.Get:recharge()
	local recharge;
	if self.config.recharge_type == 1 then
		recharge = 0;
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.id);
		recharge = tonumber(rechargeInfo.money);
	end
	return recharge;
end

-- 限制购买总次数
function Lua_DailyDiscountVo.Get:totalTimes()
	return self.config.limit_times;
end

-- 世界等级
function Lua_DailyDiscountVo.Get:worldLevel()
	return self.config.world_level;
end

-- 世界等级奖励列表
function Lua_DailyDiscountVo.Get:reward()
	local rewardInfo = Lua_RewardConfigData.getConfigDataById(self.config.reward_id);
	return rewardInfo.client_show;
end