Lua_RecoverResourcesVo = class("Lua_RecoverResourcesVo")
function Lua_RecoverResourcesVo:ctor(id)
	self.id = id;
end

function Lua_RecoverResourcesVo:dispose()
	self._recoverDays = nil;
	self._recoverReward = nil;
end

function Lua_RecoverResourcesVo:updateRecoverResourcesVoInfo(msg)
	self._recoverDays = msg.recover_times; -- 可找回天数
	self._recoverReward = msg.recover_reward; -- 可找回奖励
end

function Lua_RecoverResourcesVo.Get:recoverDays()
	return self._recoverDays or 0;
end

function Lua_RecoverResourcesVo.Get:recoverReward()
	if self._recoverReward == nil then
		self._recoverReward = self.rewardItem;
	end
	return self._recoverReward or {};
end

function Lua_RecoverResourcesVo.Get:config()
	if self._config == nil then
		self._config = getConfig("recover_resources", self.id);
	end
	return self._config;
end

-- 名字
function Lua_RecoverResourcesVo.Get:name()
	return self.config.name;
end

-- 开启id
function Lua_RecoverResourcesVo.Get:openId()
	return self.config.open_id;
end

-- 显示排序
function Lua_RecoverResourcesVo.Get:sort()
	return self.config.sort;
end

-- 找回资源类型：1道具资源 2次数资源
function Lua_RecoverResourcesVo.Get:resourceType()
	return self.config.resource_type;
end

-- 找回奖励
function Lua_RecoverResourcesVo.Get:rewardItem()
	return self.config.reward_item;
end

-- 找回次数
function Lua_RecoverResourcesVo.Get:times()
	return self.config.times;
end

-- 描述
function Lua_RecoverResourcesVo.Get:des()
	return self.config.des;
end