Lua_SpecialFundsVo = class("Lua_SpecialFundsVo");
function Lua_SpecialFundsVo:ctor()
	self:superCall("ctor");
end

function Lua_SpecialFundsVo:dispose()
	self._gradeType = nil;
	self._lockState = nil;
	self._rechargeState = nil;
	self._fundsRedState = nil;
	self._hasDrawDay = nil;
	self:superCall("dispose");
end

function Lua_SpecialFundsVo:updateFundsVoInfo(msg)
	if msg == nil then
		return;
	end
	table.sort( msg.reward_list, function(a, b) return a.key < b.key end );

	self._gradeType = msg.type; -- 档次类型
	self._lockState = msg.lock_state == 1; -- 是否解锁 0否 1是
	self._rechargeState = msg.recharge_type == 1; -- 是否可充值 0否 1是
	self._rewardList = msg.reward_list; -- key奖励id，value奖励状态：0不可领取 1可领取 2已领取

	local obj, day;
	self._fundsRedState = false;
	self._hasDrawDay = nil;
	for i = 1, #msg.reward_list do
		obj = msg.reward_list[i];
		day = obj.key % 1000;
		if not self._fundsRedState and obj.value == 1 then
			self._fundsRedState = true;
		end
		if obj.value == 2 and (self._hasDrawDay == nil or day > self._hasDrawDay) then
			self._hasDrawDay = day; -- 已经领取的最大天数
		end
	end
end

function Lua_SpecialFundsVo.Get:gradeType()
	return self._gradeType or 1;
end

function Lua_SpecialFundsVo.Get:lockState()
	return self._lockState;
end

function Lua_SpecialFundsVo.Get:rechargeState()
	return self._rechargeState;
end

function Lua_SpecialFundsVo.Get:fundsRedState()
	return self._fundsRedState;
end

function Lua_SpecialFundsVo.Get:hasDrawDay()
	return self._hasDrawDay or 0;
end

function Lua_SpecialFundsVo.Get:rewardList()
	return self._rewardList or {};
end