-- 角色隐藏信息
Lua_AttackHideRoleHeadInfo = class("Lua_AttackHideRoleHeadInfo");
function Lua_AttackHideRoleHeadInfo:ctor()
	self:superCall("ctor");

    self.roleId = 0; -- 角色id
    self.hideTimeCount = 0; -- 隐藏时长
    self.startTime = 0; -- 开始时间点
    self.fightId = 0;
    self.sceneId = 0;
end

function Lua_AttackHideRoleHeadInfo:clean()
    self.roleId = 0;
    self.hideTimeCount = 0;
    self.startTime = 0;
    self.fightId = 0;
    self.sceneId = 0;
end

function Lua_AttackHideRoleHeadInfo:setInfo(sid, fid, rid, startT, hideCountT)
    self.sceneId = sid;
	self.fightId = fid;
	self.roleId = rid;
	self.startTime = startT;
	self.hideTimeCount = hideCountT;
	if startT <= 0 and hideCountT > 0 then -- 隐藏
		self:hideRole();
	end
end

function Lua_AttackHideRoleHeadInfo:frameScript(dt)
	if self.startTime > 0 then
	    self.startTime = self.startTime - dt;
	    if self.startTime <= 0 then -- 隐藏
	    	self.startTime = 0;
	    	self:hideRole();
	    end
	    return;
	end

	if self.hideTimeCount > 0 then
		self.hideTimeCount = self.hideTimeCount - dt;
		if self.hideTimeCount <= 0 then
			self.hideTimeCount = 0;
			self:showRole();
		end
	end

    return self.hideTimeCount <= 0;
end

function Lua_AttackHideRoleHeadInfo:hideRole()
	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self.roleId);
    if thing ~= nil then
        thing:setHeadContainerState(false);
    end
end

function Lua_AttackHideRoleHeadInfo:showRole()
	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self.roleId);
    if thing ~= nil then
        thing:setHeadContainerState(true);
    end
end