-- 战斗站位数据
Lua_FightCampPosConfig = class("Lua_FightCampPosConfig");
function Lua_FightCampPosConfig.getConfigData(id)
    if Lua_FightCampPosConfig.configsDic == nil then
        Lua_FightCampPosConfig.configsDic = { };
    end
    if Lua_FightCampPosConfig.configsDic[id] == nil then
    	local cfg = getConfig("tb_fight_camppos", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_FightCampPosConfig.configsDic[id] = Lua_FightCampPosConfig.new(id, cfg);
    end
    return Lua_FightCampPosConfig.configsDic[id];
end

function Lua_FightCampPosConfig:ctor(id, cfg)
    self:superCall("ctor");

    self.id = id;
    self.config = cfg;
    if self.config == nil then
	    self.config = getConfig("tb_fight_camppos", id);
	end
end

function Lua_FightCampPosConfig.Get:attackDir()
	return self.config.attackDir;
end

function Lua_FightCampPosConfig.Get:defendDir()
	return self.config.defendDir;
end

function Lua_FightCampPosConfig.Get:attackCenter()
	return self.config.attackCenter;
end

function Lua_FightCampPosConfig.Get:defendCenter()
	return self.config.defendCenter;
end

function Lua_FightCampPosConfig.Get:attackPosxArr()
	if self.config.attackPosxArr == nil then
		self.config.attackPosxArr = {-200,0,200,-200,0,200,-200,0,200,0};
	end
	return self.config.attackPosxArr;
end

function Lua_FightCampPosConfig.Get:attackPoszArr()
	if self.config.attackPoszArr == nil then
		self.config.attackPoszArr = {200,200,200,400,400,400,600,600,600,800};
	end
	return self.config.attackPoszArr;
end

function Lua_FightCampPosConfig.Get:defendPosxArr()
	if self.config.defendPosxArr == nil then
		self.config.defendPosxArr = {-200,0,200,-200,0,200,-200,0,200,0};
	end
	return self.config.defendPosxArr;
end

function Lua_FightCampPosConfig.Get:defendPoszArr()
	if self.config.defendPoszArr == nil then
		self.config.defendPoszArr = {-200,-200,-200,-400,-400,-400,-600,-600,-600,-800};
	end
	return self.config.defendPoszArr;
end

function Lua_FightCampPosConfig:getPosxByIdx(formationType, idx)
	if idx == nil or idx == 0 then
		idx = 11;
	end

	local list;
	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
		list = self.attackPosxArr;
	else
		list = self.defendPosxArr;
	end

	if list ~= nil and #list >= idx then
		return list[idx];
	end
	return 0;
end

function Lua_FightCampPosConfig:getPosyByIdx(formationType, idx)
	return 0;
end

function Lua_FightCampPosConfig:getPoszByIdx(formationType, idx)
	if idx == nil or idx == 0 then
		idx = 11;
	end
	
	local list;
	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
		list = self.attackPoszArr;
	else
		list = self.defendPoszArr;
	end

	if list ~= nil and #list >= idx then
		return list[idx];
	end
	return 0;
end

function Lua_FightCampPosConfig:getDirByType(formationType)
	local dir;
	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
		dir = self.attackDir;
	else
		dir = self.defendDir;
	end

	if dir == nil then
		dir = formationType == Lua_FightDefine.FIGHT_ATTACKER and 90 or 270;
	end
	return dir;
end

function Lua_FightCampPosConfig.Get:stageCenterVec()
	return self.config.stageCenterVec;
end

function Lua_FightCampPosConfig.Get:stageCenterVecX()
	return (self.config.stageCenterVec ~= nil and #self.config.stageCenterVec > 0) and self.config.stageCenterVec[1] or 0;
end

function Lua_FightCampPosConfig.Get:stageCenterVecY()
	return (self.config.stageCenterVec ~= nil and #self.config.stageCenterVec > 1) and self.config.stageCenterVec[2] or 0;
end

function Lua_FightCampPosConfig.Get:stageCenterVecZ()
	return (self.config.stageCenterVec ~= nil and #self.config.stageCenterVec > 2) and self.config.stageCenterVec[3] or 0;
end

function Lua_FightCampPosConfig.Get:frontAttackerPosZ()
	if self._frontAttackerPosZ == nil then
		for i = 1, #self.attackPoszArr do
			if self._frontAttackerPosZ == nil or self._frontAttackerPosZ < self.attackPoszArr[i] then
				self._frontAttackerPosZ = self.attackPoszArr[i];
			end
		end
	end
	return self._frontAttackerPosZ;
end

function Lua_FightCampPosConfig.Get:frontDefenderPosZ()
	if self._frontDefenderPosZ == nil then
		for i = 1, #self.defendPoszArr do
			if self._frontDefenderPosZ == nil or self._frontDefenderPosZ > self.defendPoszArr[i] then
				self._frontDefenderPosZ = self.defendPoszArr[i];
			end
		end
	end
	return self._frontDefenderPosZ;
end

function Lua_FightCampPosConfig:getPosXByIdx(formationType, idx)
    return formationType == Lua_FightDefine.FIGHT_ATTACKER and self:getatta(idx) : getDefendPosByIdx(idx);
end

function Lua_FightCampPosConfig:getHMidPosByIdx(formationType, idx)
    local hLineIdx = DataCenter.fightData:getHLineByPos(idx);
    return self:getHMidPosByLine(formationType, hLineIdx);
end

function Lua_FightCampPosConfig:getHMidPosByLine(formationType, hLineIdx)
    local vec = Vector3.zero;
    if formationType == Lua_FightDefine.FIGHT_ATTACKER then
        if self._attackHLineMidPosDic == nil or self._attackHLineMidPosDic[hLineIdx] == nil then
            if self._attackHLineMidPosDic == nil then self._attackHLineMidPosDic = {}; end
            local list = DataCenter.fightData:getPosByHLine(hLineIdx);
            if list ~= nil and list:getSize() > 0 then
                for i = 1, list:getSize() do
                	vec.x = vec.x + self:getPosxByIdx(formationType, list[i]);
                	vec.z = vec.z + self:getPoszByIdx(formationType, list[i]);
                end
                vec.x = vec.x / list:getSize();
                vec.z = vec.z / list:getSize();
            end
            self._attackHLineMidPosDic[hLineIdx] = vec;
        else
        	vec = self._attackHLineMidPosDic[hLineIdx];
        end
    else
    	if self._defendHLineMidPosDic == nil or self._defendHLineMidPosDic[hLineIdx] == nil then
            if self._defendHLineMidPosDic == nil then self._defendHLineMidPosDic = {}; end
            local list = DataCenter.fightData:getPosByHLine(hLineIdx);
            if list ~= nil and list:getSize() > 0 then
                for i = 1, list:getSize() do
                	vec.x = vec.x + self:getPosxByIdx(formationType, list[i]);
                	vec.z = vec.z + self:getPoszByIdx(formationType, list[i]);
                end
                vec.x = vec.x / list:getSize();
                vec.z = vec.z / list:getSize();
            end
            self._defendHLineMidPosDic[hLineIdx] = vec;
        else
        	vec = self._defendHLineMidPosDic[hLineIdx];
        end
    end
    return vec;
end