-- 首充
checkRequire("Lua_FirstRechargeConfigVo");
Lua_FirstRechargeData = class("Lua_FirstRechargeData");
function Lua_FirstRechargeData:ctor()
	self:dispose();
end

function Lua_FirstRechargeData:dispose()
	self.gradeInfoDic = nil;
	self:init();
end

function Lua_FirstRechargeData:init()
	self._showIdx = nil;
	self._totalRecharge = nil;
	self._uiVersion = nil;
	self.curGradeArr = nil;
end

function Lua_FirstRechargeData:fromServer50110002(msg)
	if msg == nil then
		return;
	end

	if self.uiVersion ~= msg.selectPanelType then
		self:init();
	end
	self._totalRecharge = msg.total_recharge; -- 累计充值金额
	self._uiVersion = msg.selectPanelType; -- 首充版本类型
	self:initShowInfo();

	local obj;
	local isShowBtn = false;
	local redState = false;
	self._showIdx = nil;
	self.drawedRewardDic = {};
	for i = 1, #msg.draw_state do
		obj = msg.draw_state[i];
		for j = 1, #obj.draw_list do
			self.drawedRewardDic[obj.draw_list[j]] = 1;
		end

		vo = self:getGradeInfo(obj.grade);
		if vo ~= nil then
			vo:updateGradeInfo(obj);
			if not vo.isDrawedAllReward then
				isShowBtn = true;
			end
			if vo.redPointState then
				redState = true;
				if self._showIdx == nil or self._showIdx > obj.grade then
					self._showIdx = obj.grade;
				end
			end
		end
	end
	if DataCenter.funcOpenData:isOpened(10182) then
		DataCenter.mainMenuData:setIconShowInfo(30005, isShowBtn);
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.FirstRecharge, redState);
end

function Lua_FirstRechargeData.Get:showIdx()
	return self._showIdx or 1;
end

function Lua_FirstRechargeData:initShowInfo()
	if self.curGradeArr == nil then
		self.curGradeArr = Array();
		self.gradeInfoDic = {};

		local config = getConfig("recharge_first_config");
		for k,v in pairs(config) do
			if self.uiVersion == v.version then
				self.curGradeArr:add(v.grade);
				self.gradeInfoDic[v.grade] = Lua_FirstRechargeConfigVo.new(k);
			end
		end
		self.curGradeArr:sort(nil, false);
	end
end

function Lua_FirstRechargeData:getGradeInfo(grade)
	if self.gradeInfoDic == nil and self.gradeInfoDic[grade] == nil then
		return nil;
	end
	return self.gradeInfoDic[grade];
end

function Lua_FirstRechargeData:getRewardDrawState(id)
	if self.drawedRewardDic == nil or self.drawedRewardDic[id] == nil then
		return false;
	end
	return self.drawedRewardDic[id] == 1;
end

function Lua_FirstRechargeData.Get:totalRecharge()
	return self._totalRecharge or 0;
end

function Lua_FirstRechargeData.Get:uiVersion()
	if self._uiVersion == nil or self._uiVersion == 0 then
		self._uiVersion = 1;
	end
	return self._uiVersion;
end

function Lua_FirstRechargeData:getRewardConfigInfo(id)
	return getConfig("recharge_first", id);
end