checkRequire("Lua_FriendData")
checkRequire("Lua_FriendUtil")
Lua_FriendProxy = class("Lua_FriendProxy")
function Lua_FriendProxy:ctor()
    DataCenter.friendData = Lua_FriendData.new();
    DataCenter.friendUtil = Lua_FriendUtil.new();

    -- 80107008是多余的，50107009和50107010的返回使用50107001

    Lua_MsgUtil.addLuaMsg(50107001, self, self.rGetFriendListInfo);
    Lua_MsgUtil.addLuaMsg(50107002, self, self.rApplyFriend);
    Lua_MsgUtil.addLuaMsg(50107003, self, self.rApplyFriendResult); -- 返回好友申请结果，是否存在对方好友栏已满或在对方黑名单上
    Lua_MsgUtil.addLuaMsg(50107007, self, self.rFindFriendInfo);
    Lua_MsgUtil.addLuaMsg(80107014, self, self.updateFriendRedPoint); -- 好友赠送礼物、好友申请页签红点

    Lua_MsgUtil.addLuaMsg(50107010, self, self.rGiveGiftToFriend);
    Lua_MsgUtil.addLuaMsg(50107012, self, self.rReceiveGiftOfFriend);
    Lua_MsgUtil.addLuaMsg(50107013, self, self.rReceiveGiftsOfFriend);
    Lua_MsgUtil.addLuaMsg(80107015, self, self.aRemoveFriend);

    -- 战力对比
    Lua_MsgUtil.addLuaMsg(50212001, self, self.rViewOtherForceRatio); --请求查看角色的战力对比信息返回
    Lua_MsgUtil.addLuaMsg(50212002, self, self.rViewOtherAttributeRatio); --请求查看玩家属性对比信息返回
    Lua_MsgUtil.addLuaMsg(50212003, self, self.rViewOtherArtifactRatio); --请求查看玩家神器对比信息返回
    Lua_MsgUtil.addLuaMsg(50212004, self, self.rViewOtherHomologatorRatio); --请求查看同调器对比信息返回
    Lua_MsgUtil.addLuaMsg(50212005, self, self.rGetHeroForceRank); --请求英雄战力排名对比返回
    Lua_MsgUtil.addLuaMsg(50212006, self, self.rGetLeagueSkillInfo); --请求公会技巧属性对比信息返回
    Lua_MsgUtil.addLuaMsg(50212007, self, self.rGetBeastPropInfo); --请求异兽属性对比信息（返回）
    Lua_MsgUtil.addLuaMsg(50212008, self, self.rGetBeastRatioInfo); --请求异兽对比信息（返回）
    Lua_MsgUtil.addLuaMsg(50212009, self, self.rGetPotentialRatioInfo); -- 请求潜能属性对比信息（返回）
end

-------------------- 返回 --------------------

-- 获取好友列表(返回)
function Lua_FriendProxy:rGetFriendListInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107001();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107001(msg);
        Lua_MsgUtil.callFunc("SET_FRIENDPANEL_INFO", msg.type);

        if msg.type == Lua_FriendData.FRIEND_TYPE then
            local friendIds = {};
            local obj = msg.friend_list;
            for i = 1, #obj do
                friendIds[#friendIds + 1] = tonumber(obj[i].show.id);
            end
            Lua_MsgUtil.callFunc("GET_FRIENDID_LIST", friendIds);
        end
    end
end

-- 请求好友申请(返回)
function Lua_FriendProxy:rApplyFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107002();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107002(msg);
        Lua_MsgUtil.callFunc("SET_FRIENDPANEL_INFO");
    end
end

-- 请求返回好友申请结果，是否存在对方好友栏已满或在对方黑名单上
function Lua_FriendProxy:rApplyFriendResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107003();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107003(msg);
    end
end

-- 请求搜索好友(返回)
function Lua_FriendProxy:rFindFriendInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107007();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107007(msg);
        Lua_MsgUtil.callFunc("UPDATA_ADDFRIEND_INFO");
    end
end

function Lua_FriendProxy:updateFriendRedPoint(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80107014();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer80107014(msg);
        Lua_MsgUtil.callFunc("UPDATA_FRIEND_SENDRECBTN");
    end
end

-- 请求赠送好友礼物（返回）
function Lua_FriendProxy:rGiveGiftToFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107010();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107010(msg);
    end
end

-- 请求领取好友礼物（返回）
function Lua_FriendProxy:rReceiveGiftOfFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107012();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107012(msg);
    end
end

-- 一键领取所有礼物（返回）
function Lua_FriendProxy:rReceiveGiftsOfFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107013();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107013(msg);
    end
end

-- 通知好友删除
function Lua_FriendProxy:aRemoveFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80107015();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer80107015(msg);
    end
end

-- 请求查看角色的战力对比信息返回
function Lua_FriendProxy:rViewOtherForceRatio(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212001();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50212001(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioMainWindow", Lua_WinParam.ACTION_OPEN);
    end
end

-- 请求查看玩家属性对比信息返回
function Lua_FriendProxy:rViewOtherAttributeRatio(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212002();
        msg:ParseFromString(mp.data);
        -- DataCenter.friendData:fromServer50212002(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeAttributeWindow", Lua_WinParam.ACTION_OPEN, msg);
    end
end

-- 请求查看玩家神器对比信息返回
function Lua_FriendProxy:rViewOtherArtifactRatio(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212003();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50212003(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeWindow", Lua_WinParam.ACTION_OPEN, Lua_FriendUtil.ARTFACTRATIO);
    end
end


-- 请求查看同调器对比信息返回
function Lua_FriendProxy:rViewOtherHomologatorRatio(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212004();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50212004(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeWindow", Lua_WinParam.ACTION_OPEN, Lua_FriendUtil.HOMOLOGATORRATIO);
    end
end

-- 请求英雄战力排名对比返回
function Lua_FriendProxy:rGetHeroForceRank(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212005();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50212005(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeWindow", Lua_WinParam.ACTION_OPEN, Lua_FriendUtil.HERORATIO);
    end
end

-- 请求公会技巧属性对比信息返回
function Lua_FriendProxy:rGetLeagueSkillInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212006();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50212006(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeAttributeWindow", Lua_WinParam.ACTION_OPEN, {type = Lua_FriendUtil.LEAGUESKILL});
    end
end

-- 请求异兽属性对比信息（返回）
function Lua_FriendProxy:rGetBeastPropInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212007();
        msg:ParseFromString(mp.data);
        -- DataCenter.friendData:fromServer50212007(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeAttributeWindow", Lua_WinParam.ACTION_OPEN, {type = Lua_FriendUtil.BEASTRATIO, msg = msg});
    end
end

-- 请求异兽对比信息（返回）
function Lua_FriendProxy:rGetBeastRatioInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212008();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50212008(msg);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeWindow", Lua_WinParam.ACTION_OPEN, Lua_FriendUtil.BEASTRATIO);
    end
end

-- 请求潜能属性对比信息（返回）
function Lua_FriendProxy:rGetPotentialRatioInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50212009();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_ForceRatioTypeAttributeWindow", Lua_WinParam.ACTION_OPEN, {type = Lua_FriendUtil.POTENTIALRATIO, msg = msg});
    end
end








-------------------- 请求 --------------------

-- 获取好友相关列表 type 1 好友，2 黑名单，3 好友申请列表，4 已删除好友，5 推荐好友
function Lua_FriendProxy:sGetFriendListInfo(type)
    local msg = ProtoPublic_pb.Proto10107001();
    msg.type = type;
    sendMsg(10107001, msg);
end

-- 请求好友申请 friend_id 好友id
function Lua_FriendProxy:sApplyFriend(friend_id, server_flag)
    local msg = ProtoPublic_pb.Proto10107002();
    msg.friend_id = friend_id;
    msg.server_flag = server_flag;
    sendMsg(10107002, msg);
end 

-- 请求好友申请审核 type 1.同意所有 2.拒绝所有 3.同意单个好友申请 4.拒绝单个好友申请 apply_id 申请的玩家id
function Lua_FriendProxy:sCheckApplyFriend(type, playerInfo)
    local msg = ProtoPublic_pb.Proto10107003();
    msg.type = type;

    if playerInfo ~= nil then
        msg.apply_id = playerInfo;
    end
    sendMsg(10107003, msg);
end

-- 请求删除好友 friend_id 要删除的好友id
function Lua_FriendProxy:sRemoveFriend(friend_id)
    local msg = ProtoPublic_pb.Proto10107004();
    msg.friend_id = friend_id;
    sendMsg(10107004, msg);
end 

-- 请求加入黑名单 id 玩家id
function Lua_FriendProxy:sAddBackList(id, server_flag)
    local msg = ProtoPublic_pb.Proto10107005();
    msg.id = id;
    msg.server_flag = server_flag;
    sendMsg(10107005, msg);
end

-- 请求删除黑名单 id 玩家id
function Lua_FriendProxy:sRemoveBackList(id)
    local msg = ProtoPublic_pb.Proto10107006();
    msg.id = id;
    sendMsg(10107006, msg);
end

-- 请求搜索好友 name 玩家名
function Lua_FriendProxy:sFindFriendInfo(name)
    local msg = ProtoPublic_pb.Proto10107007();
    msg.name = name;
    sendMsg(10107007, msg);
end

-- 请求赠送好友礼物 friend_id 好友id
function Lua_FriendProxy:sGiveGiftToFriend(friend_id)
    local msg = ProtoPublic_pb.Proto10107010();
    msg.friend_id = friend_id;
    sendMsg(10107010, msg);
end

-- 请求领取好友赠送礼物 friend_id 好友id
function Lua_FriendProxy:sReceiveGiftOfFriend(friend_id)
    local msg = ProtoPublic_pb.Proto10107012();
    msg.friend_id = friend_id;
    sendMsg(10107012, msg);
end

-- 一键领取、赠送所有好友礼物
function Lua_FriendProxy:sReceiveGiftsOfFriend()
    sendMsg(10107013);
end

-- 请求查看角色的战力对比信息
function Lua_FriendProxy:sViewOtherForceRatio(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212001();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212001, cmd);
end

-- 请求查看玩家属性对比信息
function Lua_FriendProxy:sViewOtherAttributeRatio(role_id, server_flag, type)
    local cmd = ProtoPublic_pb.Proto10212002();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    cmd.type = type;
    sendMsg(10212002, cmd);
end

-- 请求查看玩家神器对比信息
function Lua_FriendProxy:sViewOtherArtifactRatio(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212003();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212003, cmd);
end

-- 请求查看玩家同调器对比信息
function Lua_FriendProxy:sViewOtherHomologatorRatio(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212004();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212004, cmd);
end

-- 请求英雄战力排名对比
function Lua_FriendProxy:sGetHeroForceRank(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212005();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212005, cmd);
end

-- 请求公会技巧属性对比信息
function Lua_FriendProxy:sGetLeagueSkillInfo(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212006();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212006, cmd);
end

-- 请求异兽属性对比信息
function Lua_FriendProxy:sGetBeastPropInfo(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212007();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212007, cmd);
end

-- 请求异兽对比信息
function Lua_FriendProxy:sGetBeastRatioInfo(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212008();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212008, cmd);
end

-- 请求潜能属性对比信息
function Lua_FriendProxy:sGetPotentialRatioInfo(role_id, server_flag)
    local cmd = ProtoPublic_pb.Proto10212009();
    cmd.role_id = tonumber(role_id);
    cmd.server_flag = server_flag;
    sendMsg(10212009, cmd);
end