Lua_FriendUtil = class("Lua_FriendUtil");
Lua_FriendUtil.HERORATIO = 1;  --英雄对比
Lua_FriendUtil.RUNERATIO = 2; --符石对比
Lua_FriendUtil.EQUIPRATIO = 3; --装备对比
Lua_FriendUtil.WEAPONRATIO = 4;-- 神兵对比
Lua_FriendUtil.TOTEMRATIO = 5;-- 图腾对比
Lua_FriendUtil.ARTFACTRATIO = 6; --神器对比
Lua_FriendUtil.PERSONTITLE = 7; -- 称号
Lua_FriendUtil.HOMOLOGATORRATIO = 8;-- 同调器
Lua_FriendUtil.LEAGUELEVEL = 9; -- 公会等级
Lua_FriendUtil.LEAGUESKILL = 10; -- 公会技巧
Lua_FriendUtil.COLLECTIONITEM = 11; -- 藏品柜
Lua_FriendUtil.POTENTIALRATIO = 12; -- 潜能
Lua_FriendUtil.NEW_COLLECTIONITEM = 13; -- 新藏品柜
Lua_FriendUtil.TACTICRATIO = 14; -- 战法
Lua_FriendUtil.BEASTRATIO = 16; -- 异兽
function Lua_FriendUtil:ctor()
    self:dispose();
end

function Lua_FriendUtil:dispose()
    self.curOpenUIType = 0;
    self.friendList = {};
    self.rewardState = {};
end

function Lua_FriendUtil:getAllRatioIds()
	if self._allRatioIds == nil then
		self._allRatioIds = {};

		local count;
		local cfg = getConfig("forceradio_type");
		for k, v in pairs(cfg) do
			if v.shield ~= 1 then
				count = #self._allRatioIds;
				self._allRatioIds[count + 1] = k;
			end
		end

		table.sort( self._allRatioIds, function(a, b)
			local aSort = self:getRatioCfgAtt(a, 3);
			local bSort = self:getRatioCfgAtt(b, 3);
			return aSort < bSort;
		 end);
	end

	return self._allRatioIds;
end

function Lua_FriendUtil:getRatioCfgAtt(id, type)
	local cfg = getConfig("forceradio_type", id);
	if cfg == nil then
		return;
	end

	if type == 0 then
		return cfg;
	elseif type == 1 then -- id
		return cfg.id;
	elseif type == 2 then 
		return cfg.desc;
	elseif type == 3 then 
		return cfg.sort;
	elseif type == 4 then --点击搜索按钮类型
		return cfg.type;
	-- elseif type == 5 then 
	-- 	return cfg.max_value;
	elseif type == 6 then --是否显示《总属性对比》按钮
		return cfg.show_btn;
	elseif type == 7 then -- 底部跳转id
		return cfg.func_id;
	elseif type == 8 then 
		return cfg.atlas, cfg.sprite;
	elseif type == 9 then -- 属性对比窗口跳转id
		return cfg.tip_func_id;
	end
end

function Lua_FriendUtil:getArtifactIds()
	if self._artifactIds == nil then
		self._artifactIds = {};
		local config = getConfig("artifact");
		for k, v in pairs(config) do
			if v.is_shield ~= 1 then
				self._artifactIds[#self._artifactIds + 1] = k;
			end
		end
	end
	return self._artifactIds;
end

function Lua_FriendUtil.Get:beastRatioIds()
	if self._beastRatioIds == nil then
		self._beastRatioIds = {-1};
		local list = DataCenter.strangeBeastUtil:getStrangeBeastAtlasIds();
		for i = 1, #list do
			self._beastRatioIds[#self._beastRatioIds + 1] = list[i];
		end

		table.sort( self._beastRatioIds, function(a, b) return a < b;end)
	end

	return self._beastRatioIds;
end
