Lua_GashaponUtil = class("Lua_GashaponUtil");
function Lua_GashaponUtil:ctor()
	self:dispose();
end

function Lua_GashaponUtil:dispose()
	self.openDay = nil;
	self.showUpHeroInfoArr = nil;
	self._showRewardArr = nil;
	self._upHeroInfoArr = nil;
end

function Lua_GashaponUtil:getGashaponConstConfig(id, param)
	if param == 1 then
		return getConfig("gashapon_const", id, "value");
	elseif param == 2 then
		return getConfig("gashapon_const", id, "value2");
	elseif param == 3 then
		return getConfig("gashapon_const", id, "value_float");
	else
		return getConfig("gashapon_const", id, "json_value");
	end
end

-- 展示奖励
function Lua_GashaponUtil.Get:showRewardArr()
	if self._showRewardArr == nil then
		self._showRewardArr = Array();

		local config = getConfig("gashapon_item");
		for k,v in pairs(config) do
			if v.is_show == 1 then
				self._showRewardArr:add(k);
			end
		end
		self._showRewardArr:sort(nil, false);
	end
	return self._showRewardArr;
end

-- UP保底次数
function Lua_GashaponUtil.Get:guaranteeList()
	return self:getGashaponConstConfig("guarantee", 4);
end

-- 货币列表
function Lua_GashaponUtil.Get:moneyList()
	return self:getGashaponConstConfig("money_list", 4);
end

-- 广播id
function Lua_GashaponUtil.Get:broadcastId()
	return self:getGashaponConstConfig("broadcast_id", 1);
end

-- 连抽次数
function Lua_GashaponUtil.Get:drawMoreTimes()
	return self:getGashaponConstConfig("continuous", 1);
end

-- 钻石可抽的最大次数
function Lua_GashaponUtil.Get:diamondMaxTimes()
	return self:getGashaponConstConfig("diamond_time", 1);
end

-- 有返回时显示动画的最大时间
function Lua_GashaponUtil.Get:showRewardTime()
	return self:getGashaponConstConfig("show_reward_time", 1);
end

-- 没有返回时显示动画的最大时间
function Lua_GashaponUtil.Get:showRewardMaxTime()
	return self:getGashaponConstConfig("show_reward_max_time", 1);
end

-- 规则描述信息
function Lua_GashaponUtil.Get:gashponRuleInfoDic()
	return getConfig("gashapon_rule_reward");
end

-- 没有选择英雄时的展示位置
function Lua_GashaponUtil.Get:noSelectPosList()
	return self:getGashaponConstConfig("no_select_pos_list", 4);
end

-- 选择英雄时的展示位置
function Lua_GashaponUtil.Get:selectPosList()
	return self:getGashaponConstConfig("select_pos_list", 4);
end

-- 选择英雄后英雄的展示位置
function Lua_GashaponUtil.Get:posIdx()
	return self:getGashaponConstConfig("pos_index", 1);
end

-- 钻石单抽数量
function Lua_GashaponUtil.Get:diamondOneInfo()
	return self:getGashaponConstConfig("diamond_one_item", 4);
end

-- 钻石多抽数量
function Lua_GashaponUtil.Get:diamondMoreInfo()
	return self:getGashaponConstConfig("diamond_more_item", 4);
end

-- 道具单抽数量
function Lua_GashaponUtil.Get:itemOneInfo()
	return self:getGashaponConstConfig("act_one_item", 4);
end

-- 道具多抽数量
function Lua_GashaponUtil.Get:itemMoreInfo()
	return self:getGashaponConstConfig("act_more_item", 4);
end

-- UP英雄信息
function Lua_GashaponUtil.Get:upHeroInfoArr()
	if self._upHeroInfoArr == nil then
		self._upHeroInfoArr = Array();

		local config = getConfig("gashapon_up_item");
		for k,v in pairs(config) do
			self._upHeroInfoArr:add(k);
		end
		self._upHeroInfoArr:sort(nil, false);
	end
	return self._upHeroInfoArr;
end

-- 限制开服天数后的UP英雄
function Lua_GashaponUtil:getAllUpHeroInfo()
	if self.openDay and self.openDay ~= DataCenter.roleData.open_days then
		self.showUpHeroInfoArr = nil;
	end
	self.openDay = DataCenter.roleData.open_days;

	if self.showUpHeroInfoArr == nil then
		self.showUpHeroInfoArr = Array();
		
		local info, openState, openDay;
		for i = 1, self.upHeroInfoArr:getSize() do
			info = self:getSingleUpHeroInfo(self.upHeroInfoArr[i]);
	        openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(info.hero_id, Lua_NewHeroFuncOpen.gashapon);
			if openState then
				self.showUpHeroInfoArr:add(self.upHeroInfoArr[i]);
			end
		end
	end
	return self.showUpHeroInfoArr;
end

function Lua_GashaponUtil:getSingleUpHeroInfo(id)
	return getConfig("gashapon_up_item", id);
end

function Lua_GashaponUtil:getSingleHeroInfo(id)
	return getConfig("gashapon_item", id);
end