checkRequire("Lua_GoFishingData");
checkRequire("Lua_GoFishingUtil");
checkRequire("Lua_GoFishingController");
Lua_GoFishingProxy = class("Lua_GoFishingProxy");
function Lua_GoFishingProxy:ctor()
	DataCenter.goFishingData = Lua_GoFishingData.new();
	DataCenter.goFishingUtil = Lua_GoFishingUtil.new();
	DataCenter.goFishingController = Lua_GoFishingController.new();

	Lua_MsgUtil.addLuaMsg(50242001, self, self.rGoFishingInfo);
	Lua_MsgUtil.addLuaMsg(50242002, self, self.rGoFishingGearAndLureInfo);
	Lua_MsgUtil.addLuaMsg(50242003, self, self.rUpFishingGearLv);
	Lua_MsgUtil.addLuaMsg(50242005, self, self.rGoFishingIndentInfo);
	Lua_MsgUtil.addLuaMsg(50242007, self, self.rStartGoFishing);
	Lua_MsgUtil.addLuaMsg(50242014, self, self.rGoFishingDailyGiftInfo);
	Lua_MsgUtil.addLuaMsg(50242016, self, self.rGoFishingAquariumInfo);
	Lua_MsgUtil.addLuaMsg(50242018, self, self.rGoFishingFisheryInfo);
	Lua_MsgUtil.addLuaMsg(50242019, self, self.rChangeGoFishingFishery);
	Lua_MsgUtil.addLuaMsg(50242020, self, self.rGoFishingAtlasInfo);
	Lua_MsgUtil.addLuaMsg(50242022, self, self.rUpGoFishingAtlasLv);
	Lua_MsgUtil.addLuaMsg(50242026, self, self.rGoFishingAtlasAttrInfo);

	Lua_MsgUtil.addLuaMsg(80242001, self, self.nGoFishingInfo); -- 通知钓鱼功能开启弹窗（通知）

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateGoFishingRedDot); -- 道具数量改变时更新红点
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateGoFishingRedDot); -- 货币改变时更新红点
end

-- 请求垂钓之境主界面（返回）
function Lua_GoFishingProxy:rGoFishingInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242001();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242001(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_INFO");
	end
end

-- 请求渔具鱼饵信息（返回）
function Lua_GoFishingProxy:rGoFishingGearAndLureInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242002();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242002(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_GEARANDLURE_INFO");
	end
end

-- 请求升级渔具（返回）
function Lua_GoFishingProxy:rUpFishingGearLv(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242003();
		msg:ParseFromString(mp.data);
		if msg.gear_id ~= 0 then -- 进阶成功
			OperateAlert.showLangValue(794094);
			Lua_WindowUtil.openWin("Lua_GoFishingGearAdvancedSucceedWindow", Lua_WinParam.ACTION_OPEN, msg.gear_id);
		else
			OperateAlert.showLangValue(794093);
		end
	end
end

-- 请求每日订单界面（返回）
function Lua_GoFishingProxy:rGoFishingIndentInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242005();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242005(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_INDENT_INFO");
	end
end

-- 请求开始钓鱼（返回）
function Lua_GoFishingProxy:rStartGoFishing(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242007();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242007(msg);
		DataCenter.goFishingController:fromServer50242007();
	end
end

-- 请求每日礼包界面（返回）
function Lua_GoFishingProxy:rGoFishingDailyGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242014();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_DAILYGIFT_INFO", msg);
	end
end

-- 请求水族馆界面信息（返回）
function Lua_GoFishingProxy:rGoFishingAquariumInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242016();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242016(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_AQUARIUM_INFO");
	end
end

-- 请求渔场信息（返回）
function Lua_GoFishingProxy:rGoFishingFisheryInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242018();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242018(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_FISHERY_INFO", msg);
	end
end

-- 请求切换渔场（返回）
function Lua_GoFishingProxy:rChangeGoFishingFishery(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242019();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242019(msg);
		DataCenter.funcPathUtil:gotoFunction(1190, true);
	end
end

-- 请求图鉴列表（返回）
function Lua_GoFishingProxy:rGoFishingAtlasInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242020();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer50242020(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_ATLAS_INFO", msg);
	end
end

-- 请求升级图鉴（返回）
function Lua_GoFishingProxy:rUpGoFishingAtlasLv(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242022();
		msg:ParseFromString(mp.data);
		if msg.book_type == 0 then
			Lua_WindowUtil.openWin("Lua_GoFishingCollectionUpLvSucceedWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

-- 请求图鉴总属性（返回）
function Lua_GoFishingProxy:rGoFishingAtlasAttrInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50242026();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_GOFISHING_ATLASATTR_INFO", msg);
	end
end

-- 通知钓鱼功能开启弹窗（通知）
function Lua_GoFishingProxy:nGoFishingInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80242001();
		msg:ParseFromString(mp.data);
		DataCenter.goFishingData:fromServer80242001(msg);
	end
end

function Lua_GoFishingProxy:updateGoFishingRedDot(dic)
	DataCenter.goFishingData:updateStaminaRedPointState(dic);
	DataCenter.goFishingData:updateAquariumRedPointState(dic);
	DataCenter.goFishingData:updateCollectionUpLvRedPointState(dic);
end










-- 请求垂钓之境主界面
function Lua_GoFishingProxy:sGoFishingInfo(open_flag)
	local cmd = ProtoPublic_pb.Proto10242001();
	cmd.open_flag = open_flag; -- 手动点开界面 0否 1是，用于弹出获得的体力，1不返回界面信息
	sendMsg(10242001, cmd);
end

-- 请求渔具鱼饵信息
function Lua_GoFishingProxy:sGoFishingGearAndLureInfo()
	sendMsg(10242002);
end

-- 请求升级渔具
function Lua_GoFishingProxy:sUpFishingGearLv(gear_id)
	local cmd = ProtoPublic_pb.Proto10242003();
	cmd.gear_id = gear_id; -- 钓具id
	sendMsg(10242003, cmd);
end

-- 请求更换鱼饵
function Lua_GoFishingProxy:sChangeFishingLureId(lure)
	local cmd = ProtoPublic_pb.Proto10242004();
	cmd.lure = lure; -- 鱼饵id
	sendMsg(10242004, cmd);
end

-- 请求每日订单界面
function Lua_GoFishingProxy:sGoFishingIndentInfo()
	sendMsg(10242005);
end

-- 请求提交任务订单
function Lua_GoFishingProxy:sCompleteIndent(sort_id)
	local cmd = ProtoPublic_pb.Proto10242006();
	cmd.sort_id = sort_id; -- 提交订单索引
	sendMsg(10242006, cmd);
end

-- 请求开始钓鱼
function Lua_GoFishingProxy:sStartGoFishing()
	sendMsg(10242007);
end

-- 请求渔获处理
function Lua_GoFishingProxy:sDealWithFish(fishing_uid, dispose, replace)
	local cmd = ProtoPublic_pb.Proto10242008();
	cmd.fishing_uid = tonumber(fishing_uid); -- 渔获唯一id
	cmd.dispose = dispose; -- 处理方式 0售卖 1放入鱼护 2提交订单 3放入水族馆/收藏
	cmd.replace = replace; -- 替换水族馆索引
	sendMsg(10242008, cmd);
end

-- 请求洗练渔具
function Lua_GoFishingProxy:sClearFishingGear(gear_id, cost_type)
	local cmd = ProtoPublic_pb.Proto10242009();
	cmd.gear_id = gear_id; -- 渔具id
	cmd.cost_type = cost_type; -- 1道具消费 2钻石消费
	sendMsg(10242009, cmd);
end

-- 请求保存渔具洗练属性
function Lua_GoFishingProxy:sSaveClearFishingGearInfo(gear_id, is_save)
	local cmd = ProtoPublic_pb.Proto10242010();
	cmd.gear_id = gear_id; -- 渔具id
	cmd.is_save = is_save; -- 是否保存属性 0否1是
	sendMsg(10242010, cmd);
end

-- 请求刷新每日订单任务
function Lua_GoFishingProxy:sRefreshGoFishingIndentInfo(index)
	local cmd = ProtoPublic_pb.Proto10242011();
	cmd.index = index; -- 订单索引
	sendMsg(10242011, cmd);
end

-- 请求重置每日订单任务
function Lua_GoFishingProxy:sResetGoFishingIndentInfo()
	sendMsg(10242012);
end

-- 请求鱼护一键提交提交出售
function Lua_GoFishingProxy:sFishingProtectionAllComprate()
	sendMsg(10242013);
end

-- 请求每日礼包界面
function Lua_GoFishingProxy:sGoFishingDailyGiftInfo()
	sendMsg(10242014);
end

-- 请求购买每日礼包
function Lua_GoFishingProxy:sBuyGoFishingDailyGift(reward_id)
	local cmd = ProtoPublic_pb.Proto10242015();
	cmd.reward_id = reward_id; -- 礼包id
	sendMsg(10242015, cmd);
end

-- 请求水族馆界面信息
function Lua_GoFishingProxy:sGoFishingAquariumInfo()
	sendMsg(10242016);
end

-- 请求水族馆升级
function Lua_GoFishingProxy:sUpGoFishingAquariumLv()
	sendMsg(10242017);
end

function Lua_GoFishingProxy:sGoFishingAllFisheryInfo()
	local fisheryArr = DataCenter.goFishingUtil.fisheryArr;
	for i = 1, fisheryArr:getSize() do
		self:sGoFishingFisheryInfo(fisheryArr[i]);
	end
end

-- 请求渔场信息
function Lua_GoFishingProxy:sGoFishingFisheryInfo(fishery)
	local cmd = ProtoPublic_pb.Proto10242018();
	cmd.fishery = fishery; -- 渔场id
	sendMsg(10242018, cmd);
end

-- 请求切换渔场
function Lua_GoFishingProxy:sChangeGoFishingFishery(fishery)
	local cmd = ProtoPublic_pb.Proto10242019();
	cmd.fishery = fishery; -- 渔场id
	sendMsg(10242019, cmd);
end

function Lua_GoFishingProxy:sGoFishingAllAtlasInfo()
	local fishAtlasArr = DataCenter.goFishingUtil.fishAtlasArr;
	for i = 1, fishAtlasArr:getSize() do
		self:sGoFishingAtlasInfo(fishAtlasArr[i]);
	end
end

-- 请求图鉴列表
function Lua_GoFishingProxy:sGoFishingAtlasInfo(book_type)
	local cmd = ProtoPublic_pb.Proto10242020();
	cmd.book_type = book_type; -- 渔获图鉴类型 0收藏品/渔场id
	sendMsg(10242020, cmd);
end

-- 请求点开图鉴（用于新纪录）
function Lua_GoFishingProxy:sGoFishingAtlasClick(reward_id, book_type)
	local cmd = ProtoPublic_pb.Proto10242021();
	cmd.reward_id = reward_id; -- 藏品id/渔获id
	cmd.book_type = book_type; -- 渔获图鉴类型 0收藏品/渔场id
	sendMsg(10242021, cmd);
end

-- 请求升级图鉴
function Lua_GoFishingProxy:sUpGoFishingAtlasLv(dic, book_id, book_type)
	local cmd = ProtoPublic_pb.Proto10242022();
	cmd.book_id = book_id; -- 藏品id/渔获id
	cmd.book_type = book_type; -- 渔获图鉴类型 0收藏品/渔场id
	local struct;
	for itemId, count in pairs(dic) do
		struct = getProtoMsg("ProtoPair");
		if string.len(itemId) >= 20 then
			itemId = string.sub(itemId, 1, 9);
		end
		struct.key = tonumber(itemId);
		struct.value = count;
		cmd.use_list:addToList(struct);
	end
	sendMsg(10242022, cmd);
end

-- 请求解锁渔场
function Lua_GoFishingProxy:sUnLockFishery()
	sendMsg(10242025);
end

-- 请求图鉴总属性
function Lua_GoFishingProxy:sGoFishingAtlasAttrInfo()
	sendMsg(10242026);
end

-- 请求钓鱼结束校验
function Lua_GoFishingProxy:sGoFishingCheckout()
	sendMsg(10242027);
end