Lua_GoFishingUtil = class("Lua_GoFishingUtil");
function Lua_GoFishingUtil:ctor()
end

function Lua_GoFishingUtil:dispose()
end

function Lua_GoFishingUtil:getGoFishingConstConfig(id, param)
	if param == 1 then
		return getConfig("fishing_const", id, "value");
	-- elseif param == 2 then
	-- 	return getConfig("fishing_const", id, "string_value");
	-- elseif param == 3 then
	-- 	return getConfig("fishing_const", id, "float_value");
	else
		return getConfig("fishing_const", id, "json_value");
	end
end

function Lua_GoFishingUtil:getGoFishingPrivilegeConfig(id, param)
	if param == 1 then
		return getConfig("fishing_privilege", id, "value") or 0;
	-- elseif param == 2 then
	-- 	return getConfig("fishing_privilege", id, "string_value");
	-- elseif param == 3 then
	-- 	return getConfig("fishing_privilege", id, "float_value");
	else
		return getConfig("fishing_privilege", id, "json_value");
	end
end

-- 钓鱼基础时间
function Lua_GoFishingUtil.Get:fishingTime()
	return self:getGoFishingConstConfig("fishing_time", 1);
end

-- 保存鱼数目
function Lua_GoFishingUtil.Get:fishSaveNum()
	return self:getGoFishingConstConfig("fish_save", 1);
end

-- 特权保存鱼数目
function Lua_GoFishingUtil.Get:vipFishSaveNum()
	return self:getGoFishingPrivilegeConfig("ex_save", 1);
end

-- 自动钓鱼按钮显示次数
function Lua_GoFishingUtil.Get:showAutoBtnTimes()
	return self:getGoFishingConstConfig("auto_btn_show", 1);
end

-- 自动钓鱼按钮开启次数
function Lua_GoFishingUtil.Get:openAutoBtnTimes()
	return self:getGoFishingConstConfig("auto_open", 1);
end

-- 水族馆最大等级
function Lua_GoFishingUtil.Get:aquariumMaxLevel()
	return self:getGoFishingConstConfig("aquarium_max_level", 1);
end

-- 水族馆每级有n个阶段
function Lua_GoFishingUtil.Get:aquariumStage()
	return self:getGoFishingConstConfig("aquarium_stage", 1);
end

-- 任务刷新卷
function Lua_GoFishingUtil.Get:refreshItem()
	return self:getGoFishingConstConfig("refresh_item", 4);
end

-- 任务重置卷
function Lua_GoFishingUtil.Get:resetItem()
	return self:getGoFishingConstConfig("reset_item", 4);
end

-- 主界面货币
function Lua_GoFishingUtil.Get:mainMoneyItem()
	return self:getGoFishingConstConfig("main_money_item", 4);
end

-- 渔具升级界面货币
function Lua_GoFishingUtil.Get:gearLevelMoneyItem()
	return self:getGoFishingConstConfig("gear_level_money_item", 4);
end

-- 渔具洗练界面货币
function Lua_GoFishingUtil.Get:gearClearMoneyItem()
	return self:getGoFishingConstConfig("gear_clear_money_item", 4);
end

-- 订单界面货币
function Lua_GoFishingUtil.Get:indentMoneyItem()
	return self:getGoFishingConstConfig("indent_money_item", 4);
end

-- 水族馆界面货币
function Lua_GoFishingUtil.Get:aquariumMoneyItem()
	return self:getGoFishingConstConfig("aquarium_money_item", 4);
end

-- 商店界面货币
function Lua_GoFishingUtil.Get:shopMoneyItem()
	return self:getGoFishingConstConfig("shop_money_item", 4);
end

-- 藏品数量叠加上限
function Lua_GoFishingUtil.Get:showMaxNum()
	return self:getGoFishingConstConfig("show_max_num", 1);
end

-- 商店不限购时限制购买的最大数量
function Lua_GoFishingUtil.Get:shopLimitBuyMaxNum()
	return self:getGoFishingConstConfig("shop_limit_buy_max_num", 1);
end

-- 钓鱼指引
function Lua_GoFishingUtil.Get:fishGuideList()
	return getConfig("fishing_guide");
end

-- 钓鱼渔具
function Lua_GoFishingUtil:getTheFishingGearInfo(gearId)
	return getConfig("fishing_gear", gearId);
end

-- 钓鱼渔具品质
function Lua_GoFishingUtil:getTheFishingGearColorInfo(id)
	return getConfig("fishing_gear_color", id);
end

-- 钓鱼渔场
function Lua_GoFishingUtil:getTheFisheryInfo(fisherId)
	return getConfig("fishing_fishery", fisherId);
end

function Lua_GoFishingUtil.Get:fisheryArr()
	if self._fisheryArr == nil then
		self._fisheryArr = Array();

		local config = getConfig("fishing_fishery");
		for k,_ in pairs(config) do
			self._fisheryArr:add(k);
		end
		self._fisheryArr:sort(nil, false);
	end
	return self._fisheryArr;
end

-- 钓鱼水族馆
function Lua_GoFishingUtil:getTheAquariumInfo(aquariumId)
	return getConfig("fishing_room", aquariumId);
end

-- 钓鱼图鉴
function Lua_GoFishingUtil:getFishAtlasInfo(atlasId)
	return getConfig("fishing_book", atlasId);
end

-- 钓鱼图鉴等级
function Lua_GoFishingUtil:getFishAtlasUpLvInfo(atlasUpLvId)
	return getConfig("fishing_book_level", atlasUpLvId);
end

-- 钓鱼图鉴等级id
function Lua_GoFishingUtil:getFishAtlasUpLvId(atlasId, level)
	return atlasId * 1000 + level;
end

function Lua_GoFishingUtil:initFishAtlasInfo()
	if self._fishAtlasArr == nil then
		self._fishAtlasArr = Array();
		self._fishAtlasDic = {};

		local config = getConfig("fishing_book");
		for k,v in pairs(config) do
			if self._fishAtlasArr:indexOf(v.book_type) == -1 then
				self._fishAtlasArr:add(v.book_type);
			end
			if self._fishAtlasDic[v.book_type] == nil then
				self._fishAtlasDic[v.book_type] = Array();
			end
			self._fishAtlasDic[v.book_type]:add(k);
		end
		self._fishAtlasArr:sort(nil, false);

		for i = 1, self._fishAtlasArr:getSize() do
			self._fishAtlasDic[self._fishAtlasArr[i]]:sort(nil, false);
		end
	end
end

function Lua_GoFishingUtil.Get:fishAtlasArr()
	if self._fishAtlasArr == nil then
		self:initFishAtlasInfo();
	end
	return self._fishAtlasArr;
end

function Lua_GoFishingUtil.Get:fishAtlasDic()
	if self._fishAtlasDic == nil then
		self:initFishAtlasInfo();
	end
	return self._fishAtlasDic;
end

-- 钓鱼任务
function Lua_GoFishingUtil:getFishTaskInfo(taskId)
	return getConfig("fishing_task", taskId);
end

-- 钓鱼礼包
function Lua_GoFishingUtil:getFishDailyGiftInfo(giftId)
	return getConfig("fishing_recharge", giftId);
end

function Lua_GoFishingUtil.Get:privilegeDesList()
	if self._privilegeDesList == nil then
		self._privilegeDesList = Array();
		local list = getConfig("fishing_privilege", "content_list", "json_value");
		local config;
		for i = 1, #list do
			config = getConfig("fishing_privilege", list[i][1]);
			if config ~= nil then
				local str;
				if list[i][3] == 1 then
					str = LanUtil.formateStr(list[i][2], tostring(config.value));
				elseif list[i][3] == 2 then
					for _, v in ipairs(config.json_value) do
						if str == nil then
							str = spliceIconStrById(v[1]) .. v[2];
						else
							str = str .. Lua_ColorDefine.getColorStr("543A2F", "、") .. spliceIconStrById(v[1]) .. v[2];
						end
					end
					str = LanUtil.formateStr(list[i][2], str);
				elseif list[i][3] == 3 then
					for k, v in pairs(config.json_value) do
						vo = DataCenter.attributesUtil:createAttrVo(k);
						vo.value = v;
						if str == nil then
							str = vo.show_name..Lua_ColorDefine.getColorStr("EC893A", "+"..vo.showValue);
						else
							str = str.."、"..vo.show_name..Lua_ColorDefine.getColorStr("EC893A", "+"..vo.showValue);
						end
					end
				end
				str = LanUtil.formateStr(490003, i, str);
				self._privilegeDesList:add(str);
			end
		end
	end
	return self._privilegeDesList;
end

function Lua_GoFishingUtil:getRankRewardList(type)
	if self.rankRewardDic == nil then
		self.rankRewardDic = {};
		local config = getConfig("fishing_rank_reward");
		for k, v in pairs(config) do
			if self.rankRewardDic[v.type] == nil then
				self.rankRewardDic[v.type] = Array();
			end
			self.rankRewardDic[v.type]:add(k);
		end
		for _, v in pairs(self.rankRewardDic) do
			v:sort(nil, false);
		end
	end
	return self.rankRewardDic[type];
end

function Lua_GoFishingUtil:getTheTypeName(typeTag)
	local desStr = "";
	if typeTag == Lua_PackDefine.GOFISHING_LURE then -- 鱼饵
		desStr = "鱼饵"
	elseif typeTag == Lua_PackDefine.GOFISHING_SMALlFISH then -- 小型鱼
		desStr = "小型鱼"
	elseif typeTag == Lua_PackDefine.GOFISHING_MIDDLEFISH then -- 中型鱼
		desStr = "中型鱼"
	elseif typeTag == Lua_PackDefine.GOFISHING_BIGFISH then -- 大型鱼
		desStr = "大型鱼"
	elseif typeTag == Lua_PackDefine.GOFISHING_AQUATIC then -- 水中生物
		desStr = "水中生物"
	elseif typeTag == Lua_PackDefine.GOFISHING_RUBBISH then -- 杂物
		desStr = "杂物"
	elseif typeTag == Lua_PackDefine.GOFISHING_COLLECTION then -- 藏品
		desStr = "藏品"
	end
	return desStr;
end

function Lua_GoFishingUtil:getTheQualityName(quality)
	local nameStr = "";
	if quality == 2 then
		nameStr = "绿色";
	elseif quality == 3 then
		nameStr = "蓝色";
	elseif quality == 4 then
		nameStr = "紫色";
	elseif quality == 5 then
		nameStr = "橙色";
	elseif quality == 6 then
		nameStr = "红色";
	end
	return nameStr;
end