checkRequire("Lua_GodSeaPeakUtil");
checkRequire("Lua_GodSeaPeakData");
Lua_GodSeaPeakProxy = class("Lua_GodSeaPeakProxy")
function Lua_GodSeaPeakProxy:ctor()
	DataCenter.godSeaPeakUtil = Lua_GodSeaPeakUtil.new();
	DataCenter.godSeaPeakData = Lua_GodSeaPeakData.new();

	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onItemUpdate);

	Lua_MsgUtil.addLuaMsg(50240001, self, self.rWinInfo); -- 返回海神之巅的界面
	Lua_MsgUtil.addLuaMsg(50240002, self, self.rDanReward); -- 返回段位奖励
	Lua_MsgUtil.addLuaMsg(50240003, self, self.rTaskInfo); -- 返回任务进度
	Lua_MsgUtil.addLuaMsg(50240005, self, self.rHonourInfo); -- 返回荣耀殿堂界面
	Lua_MsgUtil.addLuaMsg(50240006, self, self.rRankInfo); -- 返回神海之巅的排行榜
	Lua_MsgUtil.addLuaMsg(50240007, self, self.rLike); -- 请求神海之巅点赞返回
	Lua_MsgUtil.addLuaMsg(50240008, self, self.rMatchInfo); -- 返回神海之巅的匹配数据
	Lua_MsgUtil.addLuaMsg(50240009, self, self.rBuyFightTimes); -- 返回神海之巅购买挑战次数
	Lua_MsgUtil.addLuaMsg(50240011, self, self.rRoleInfo); -- 返回神海之巅段位角色信息
	Lua_MsgUtil.addLuaMsg(50240012, self, self.rRecordInfo); -- 返回神海之巅战报
	Lua_MsgUtil.addLuaMsg(50240013, self, self.rHideLineup); -- 神海之巅队伍隐藏返回
	Lua_MsgUtil.addLuaMsg(50240014, self, self.rRecordDetails); -- 返回神海之巅战报详细

	Lua_MsgUtil.addLuaMsg(50240015, self, self.rSeasonInfo); -- 请求神海之巅指定赛季前三(返回)
	Lua_MsgUtil.addLuaMsg(50240016, self, self.rTreasureInfo); -- 请求抽奖界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50240017, self, self.rTreasureDraw); -- 请求神域宝藏抽奖(返回)
	Lua_MsgUtil.addLuaMsg(50240018, self, self.rTreasureRecord); -- 请求神域宝藏抽奖记录(返回)
	Lua_MsgUtil.addLuaMsg(50240020, self, self.rCheckLineup); -- 请求阵容数据(返回)
	Lua_MsgUtil.addLuaMsg(50240022, self, self.rSkipFight); -- 请求战斗跳过(返回)
	Lua_MsgUtil.addLuaMsg(50240023, self, self.rCheckScore); -- 请求神海之巅段位积分变化(返回)

	Lua_MsgUtil.addLuaMsg(80240021, self, self.updateRedPoint); -- 通知神海之巅红点
end

function Lua_GodSeaPeakProxy:onItemUpdate(tab)
	local costItem = getConfig("god_sea_const", "once_item_gift", "json_value1", 1, 1);
	local costCoin = getConfig("god_sea_const", "once_gift", "json_value1", 1, 1);
	if tab and (tab[costItem] or tab[costCoin]) then
		DataCenter.godSeaPeakData:checkTreasureDrawRed();
	end
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
-- 上行消息号

-- 请求巅峰对决界面信息
function Lua_GodSeaPeakProxy:sWinInfo(type)
	local cmd = ProtoPublic_pb.Proto10240001();
	cmd.type = type;
	sendMsg(10240001, cmd);
end

-- 请求段位奖励
function Lua_GodSeaPeakProxy:sDanReward()
	sendMsg(10240002);
end

-- 请求任务进度
function Lua_GodSeaPeakProxy:sTaskInfo()
	sendMsg(10240003);
end

-- 请求荣耀殿堂界面
function Lua_GodSeaPeakProxy:sHonourInfo()
	sendMsg(10240005);
end

-- 请求神海之巅的排行榜
function Lua_GodSeaPeakProxy:sRankInfo(page)
	local cmd = ProtoPublic_pb.Proto10240006();
	cmd.page = page;
	sendMsg(10240006, cmd);
end

-- 请求神海之巅点赞
function Lua_GodSeaPeakProxy:sLike(player_id, type)
	local cmd = ProtoPublic_pb.Proto10240007();
	cmd.player_id = tonumber(player_id);
	cmd.type = type;
	sendMsg(10240007, cmd);
end

-- 请求神海之巅匹配
function Lua_GodSeaPeakProxy:sMatchInfo(type)
	local cmd = ProtoPublic_pb.Proto10240008();
	cmd.type = type;
	sendMsg(10240008, cmd);
end

-- 请求神海之巅购买挑战次数
function Lua_GodSeaPeakProxy:sBuyFightTimes(buy_num)
	local cmd = ProtoPublic_pb.Proto10240009();
	cmd.buy_num = buy_num;
	sendMsg(10240009, cmd);
end

-- 请求神海之巅奖励领取
function Lua_GodSeaPeakProxy:sRewardReceive(type, award_id)
	local cmd = ProtoPublic_pb.Proto10240010();
	cmd.type = type;
	cmd.award_id = award_id;
	sendMsg(10240010, cmd);
end

-- 请求神海之巅段位角色信息
function Lua_GodSeaPeakProxy:sRoleInfo(dan_id)
	local cmd = ProtoPublic_pb.Proto10240011();
	cmd.dan_id = dan_id;
	sendMsg(10240011, cmd);
end

-- 请求神海之巅战报
function Lua_GodSeaPeakProxy:sRecordInfo()
	sendMsg(10240012);
end

-- 请求神海之巅队伍隐藏
function Lua_GodSeaPeakProxy:sHideLineup(tab)
	local cmd = ProtoPublic_pb.Proto10240013();
	for k,v in pairs(tab) do
		if v == 1 then
			cmd.indexes:append(k);
		end
	end
	sendMsg(10240013, cmd);
end

-- 请求神海之巅战报详细
function Lua_GodSeaPeakProxy:sRecordDetails(record_id)
	local cmd = ProtoPublic_pb.Proto10240014();
	cmd.record_id = tonumber(record_id);
	sendMsg(10240014, cmd);
end

-- 请求神海之巅指定赛季前三
function Lua_GodSeaPeakProxy:sSeasonInfo(season)
	local cmd = ProtoPublic_pb.Proto10240015();
	cmd.season = season;
	sendMsg(10240015, cmd);
end

-- 请求抽奖界面信息
function Lua_GodSeaPeakProxy:sTreasureInfo()
	sendMsg(10240016);
end

-- 请求神域宝藏抽奖
function Lua_GodSeaPeakProxy:sTreasureDraw(extract_time)
	local cmd = ProtoPublic_pb.Proto10240017();
	cmd.extract_time = tonumber(extract_time);
	sendMsg(10240017, cmd);
end

-- 请求神域宝藏抽奖记录
function Lua_GodSeaPeakProxy:sTreasureRecord()
	sendMsg(10240018);
end

-- 请求神域宝藏抽奖记录
function Lua_GodSeaPeakProxy:sCheckLineup(id)
	local cmd = ProtoPublic_pb.Proto10240020();
	cmd.id = tonumber(id);
	sendMsg(10240020, cmd);
end

-- 请求战斗跳过
function Lua_GodSeaPeakProxy:sSkipFight(type)
	local cmd = ProtoPublic_pb.Proto10240022();
	cmd.type = type;
	sendMsg(10240022, cmd);
end

function Lua_GodSeaPeakProxy:sCheckScore()
	sendMsg(10240023);
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
-- 下行消息号

-- 返回海神之巅的界面
function Lua_GodSeaPeakProxy:rWinInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240001();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240001(msg);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_INFO");
	end
end

-- 返回段位奖励
function Lua_GodSeaPeakProxy:rDanReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240002();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240002(msg);
		Lua_MsgUtil.callFunc("GOD_SEA_DAN_REWARD");
	end
end

-- 返回荣耀殿堂界面
function Lua_GodSeaPeakProxy:rHonourInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240005();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_HONOUR_INFO", msg);
	end
end

-- 返回任务进度
function Lua_GodSeaPeakProxy:rTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240003();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240003(msg);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_TASK", msg);
	end
end

-- 返回神海之巅的排行榜
function Lua_GodSeaPeakProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_RANK_INFO", msg);
	end
end

-- 请求神海之巅点赞返回
function Lua_GodSeaPeakProxy:rLike(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_LIKE", msg);
	end
end

-- 返回神海之巅的匹配数据
function Lua_GodSeaPeakProxy:rMatchInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240008();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_MATCH_INFO", msg);
	end
end

-- 返回神海之巅购买挑战次数
function Lua_GodSeaPeakProxy:rBuyFightTimes(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240009();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_GodSeaPeakBuyTimesWindow", Lua_WinParam.ACTION_CLOSE);
		DataCenter.godSeaPeakData:fromServer50240009(msg);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_FIGHT_TIMES");
		OperateAlert.showLangValue(790032);
	end
end

-- 返回神海之巅段位角色信息
function Lua_GodSeaPeakProxy:rRoleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240011();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_ROLE_INFO", msg);
	end
end

-- 返回神海之巅战报
function Lua_GodSeaPeakProxy:rRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240012();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_RECORD", msg);
	end
end

-- 神海之巅队伍隐藏返回
function Lua_GodSeaPeakProxy:rHideLineup(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240013();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240013(msg);
		OperateAlert.showLangValue(790040);
	end
end

-- 返回神海之巅战报详细
function Lua_GodSeaPeakProxy:rRecordDetails(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240014();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_RECORD_DETAILS", msg);
	end
end

-- 请求神海之巅指定赛季前三(返回)
function Lua_GodSeaPeakProxy:rSeasonInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240015();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_SEASON_INFO", msg);
	end
end

-- 请求抽奖界面信息(返回)
function Lua_GodSeaPeakProxy:rTreasureInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240016();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240016(msg);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_TREASURE", msg);
	end
end

-- 请求神域宝藏抽奖(返回)
function Lua_GodSeaPeakProxy:rTreasureDraw(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240017();
		msg:ParseFromString(mp.data);
		local arr = Array();
		local vo;
		for i = 1, #msg.item_list do
			vo = DataCenter.packData:getRewardVo(msg.item_list[i]);
			arr:add(vo);
		end
		Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
	end
end

-- 请求神域宝藏抽奖记录(返回)
function Lua_GodSeaPeakProxy:rTreasureRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240018();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_TREASURE_RECORD", msg);
	end
end

-- 请求阵容数据(返回)
function Lua_GodSeaPeakProxy:rCheckLineup(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240020();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_CHECK_LINEUP", msg);
	end
end

-- 请求战斗跳过(返回)
function Lua_GodSeaPeakProxy:rSkipFight(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto10240022();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240022(msg);
	end
end

-- 请求神海之巅段位积分变化(返回)
function Lua_GodSeaPeakProxy:rCheckScore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50240023();
		msg:ParseFromString(mp.data);
		DataCenter.godSeaPeakData:fromServer50240023(msg);
		Lua_MsgUtil.callFunc("GOD_SEA_PEAK_CHECK_SCORE");
	end
end

-- 通知神海之巅红点
function Lua_GodSeaPeakProxy:updateRedPoint(mp)
	if not DataCenter.funcOpenData:isOpened(10316) then
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80240021();
		msg:ParseFromString(mp.data);
		local key = msg.red_point_info.key;
		local value = msg.red_point_info.value;
		if key == 1 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.GodSeaPeak_Record, value == 1);
		elseif key == 2 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.GodSeaPeak_Honour_Like, value == 1);
		end
	end
end