Lua_GodSeaPeakUtil = class("Lua_GodSeaPeakUtil")
function Lua_GodSeaPeakUtil:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_GodSeaPeakUtil:dispose()

end

function Lua_GodSeaPeakUtil.Get:tabList()
	if self._tabList == nil then
		self._tabList = Array();
		self._tabList:add({ textAtlas = "god_sea_peak_atlas_1", textNormalSprite = "xui_shzd_zgnbutton_1_n", textSelectedSprite = "xui_shzd_zgnbutton_1_p",
			panel = "Lua_GodSeaPeakPanel", redPointId = Lua_RedPointList.GodSeaPeak_Main });
		self._tabList:add({ textAtlas = "god_sea_peak_atlas_1", textNormalSprite = "xui_shzd_zgnbutton_2_n", textSelectedSprite = "xui_shzd_zgnbutton_2_p",
			panel = "Lua_GodSeaPeakTreasurePanel", redPointId = Lua_RedPointList.GodSeaPeak_Treasure });
		self._tabList:add({ textAtlas = "god_sea_peak_atlas_1", textNormalSprite = "xui_shzd_zgnbutton_3_n", textSelectedSprite = "xui_shzd_zgnbutton_3_p",
			panel = "Lua_GodSeaPeakHonourPanel", redPointId = Lua_RedPointList.GodSeaPeak_Honour });
		self._tabList:add({ textAtlas = "god_sea_peak_atlas_1", textNormalSprite = "ui_djc_button_002_n", textSelectedSprite = "ui_djc_button_002_p",
			path_id = 1188 });
	end
	return self._tabList;
end

function Lua_GodSeaPeakUtil.Get:freeTimes()
	return getConfig("god_sea_const", "free_times", "value") or 0;
end

function Lua_GodSeaPeakUtil.Get:buyLimitTimes()
	return getConfig("god_sea_const", "buying_challenge", "value") or 0;
end

function Lua_GodSeaPeakUtil.Get:buyTimesCost()
	return getConfig("god_sea_const", "buying_challenge", "json_value1", 1);
end

function Lua_GodSeaPeakUtil:getHideLineupNum(rank)
	if rank > 0 then
		local list = getConfig("god_sea_const", "hide_lineup_rank", "json_value1");
		for i,v in ipairs(list) do
			if rank <= v[1] then
				return v[2];
			end
		end
	end
	return 0;
end

function Lua_GodSeaPeakUtil.Get:matchTick()
	return getConfig("god_sea_const", "match_tick", "value") or 1;
end

function Lua_GodSeaPeakUtil.Get:oneDrawCost()
	local cost = getConfig("god_sea_const", "once_item_gift", "json_value1", 1);
	if cost and DataCenter.packData:getItemCountById(cost[1]) >= cost[2] then
		return cost;
	end
	return getConfig("god_sea_const", "once_gift", "json_value1", 1);
end

function Lua_GodSeaPeakUtil.Get:tenDrawCost()
	local cost = getConfig("god_sea_const", "repeatedly_item_gift", "json_value1", 1);
	if cost and DataCenter.packData:getItemCountById(cost[1]) >= cost[2] then
		return cost;
	end
	return getConfig("god_sea_const", "repeatedly_gift", "json_value1", 1);
end

function Lua_GodSeaPeakUtil.Get:skipFightTimes()
	return getConfig("god_sea_const", "skip_win_times", "value") or 0;
end

function Lua_GodSeaPeakUtil.Get:forceRate()
	return getConfig("god_sea_const", "force_rate", "value") or 1;
end

function Lua_GodSeaPeakUtil.Get:rankLikeTimes()
	return getConfig("god_sea_const", "leaderboard_likes", "value") or 0;
end

function Lua_GodSeaPeakUtil:initDanInfo()
	if self._danList == nil then
		self._danList = Array();
		self._binDanList = Array();
		self._reachRewardList = Array();
		local config = getConfig("god_sea_dan");
		for k, v in pairs(config) do
			self._danList:add(k);
			if self._binDanList:indexOf(v.big_dan) == -1 then
				self._binDanList:add(v.big_dan);
			end
			self._reachRewardList:add(k);
		end
		self._danList:sort(nil, true);
		self._binDanList:sort(nil, false);
	end
end

-- 段位列表
function Lua_GodSeaPeakUtil.Get:danList()
	self:initDanInfo();
	return self._danList;
end

-- 大段列表
function Lua_GodSeaPeakUtil.Get:binDanList()
	self:initDanInfo();
	return self._binDanList;
end

-- 段位达标奖励
function Lua_GodSeaPeakUtil.Get:reachRewardList()
	self:initDanInfo();
	self._reachRewardList:sortf(self, self.onReachRewardSort);
	return self._reachRewardList;
end

function Lua_GodSeaPeakUtil:onReachRewardSort(a, b)
	a = DataCenter.godSeaPeakData:getDanVoById(a);
	b = DataCenter.godSeaPeakData:getDanVoById(b);
	if a.rewardState == b.rewardState then
		if a.id > b.id then
			return false;
		end
	elseif a.rewardState == 2 and b.rewardState ~= 2 then
		return false;
	elseif a.rewardState ~= 1 and b.rewardState == 1 then
		return false;
	end
	return true;
end

function Lua_GodSeaPeakUtil:getDanConfig(id)
	return getConfig("god_sea_dan", id);
end

function Lua_GodSeaPeakUtil:initRewardInfo()
	if self._weekRewardList == nil then
		self._weekRewardList = Array();
		self._drawMaxLevel = 0;
		self._drawRewardDic = {};
		self._rankRewardList = Array();
		local config = getConfig("god_sea_award");
		for k, v in pairs(config) do
			if v.type == 1 then
				self._weekRewardList:add(k);
			elseif v.type == 2 then
				if v.luck_level > self._drawMaxLevel then
					self._drawMaxLevel = v.luck_level;
				end
				if self._drawRewardDic[v.luck_level] == nil then
					self._drawRewardDic[v.luck_level] = Array();
				end
				self._drawRewardDic[v.luck_level]:add(k);
			elseif v.type == 3 then
				self._rankRewardList:add(k);
			end
		end
		self._weekRewardList:sort(nil, false);
		for k,v in pairs(self._drawRewardDic) do
			v:sort(nil, false);
		end
		self._rankRewardList:sort(nil, false);
	end
end

-- 每周奖励
function Lua_GodSeaPeakUtil.Get:weekRewardList()
	self:initRewardInfo();
	return self._weekRewardList;
end

-- 抽奖奖励
function Lua_GodSeaPeakUtil:getDrawRewardByLv(level)
	self:initRewardInfo();
	return self._drawRewardDic[level];
end

-- 抽奖奖励最大等级
function Lua_GodSeaPeakUtil.Get:drawMaxLevel()
	self:initRewardInfo();
	return self._drawMaxLevel or 1;
end

-- 排名奖励
function Lua_GodSeaPeakUtil.Get:rankRewardList()
	self:initRewardInfo();
	return self._rankRewardList;
end

function Lua_GodSeaPeakUtil:getRewardConfig(id)
	return getConfig("god_sea_award", id);
end

function Lua_GodSeaPeakUtil:getTaskConfig(id)
	return getConfig("god_sea_task", id);
end

function Lua_GodSeaPeakUtil:initTreasureInfo()
	if self._treasureList == nil then
		self._treasureList = Array();
		self._treasureRuleList = Array();
		local config = getConfig("god_sea_pool");
		for k,v in pairs(config) do
			if v.show_reward ~= nil then
				self._treasureList:add(k);
			end
			if v.probability ~= nil then
				self._treasureRuleList:add(k);
			end
		end
		self._treasureList:sort(nil, false);
		self._treasureRuleList:sort(nil, false);
	end
end

function Lua_GodSeaPeakUtil.Get:treasureList()
	self:initTreasureInfo();
	return self._treasureList;
end

function Lua_GodSeaPeakUtil.Get:treasureRuleList()
	self:initTreasureInfo();
	return self._treasureRuleList;
end

function Lua_GodSeaPeakUtil:getTreasureConfig(id)
	return getConfig("god_sea_pool", id);
end