-- 登录福利
Lua_HalfMonthGiftData = class("Lua_HalfMonthGiftData");
Lua_HalfMonthGiftData.fixType = 1; -- 固定奖励
Lua_HalfMonthGiftData.optionalType = 2; -- 自选奖励
function Lua_HalfMonthGiftData:ctor()
	self:superCall("ctor");
end

function Lua_HalfMonthGiftData:dispose()
	if self._giftTypeArr ~= nil then
		local len = self._giftTypeArr:getSize();
		while(len > 0) do
			local key = self._giftTypeArr:remove(len);
			self.halfMonthGiftDic[key] = nil;
			len = len - 1;
		end
		self._giftTypeArr = nil;
		self.halfMonthGiftDic = nil;
	end
	self.previewGiftInfoDic = nil;
	self._curDay = nil;
	self.isNeedRefresh = nil;
	self:superCall("dispose");
end

function Lua_HalfMonthGiftData:fromServer50108119(msg)
	if msg == nil then
		return;
	end
	if self._giftTypeArr == nil then
		self._giftTypeArr = Array();
		self.halfMonthGiftDic = {};
	else
		self._giftTypeArr:clear();
	end

	self._curDay = msg.day;

	local obj, subObj, redState;
	for i = 1, #msg.gift_list do
		obj = msg.gift_list[i];
		self._giftTypeArr:add(obj.gift_type);
		self.halfMonthGiftDic[obj.gift_type] = obj;

		redState = false;
		for j = 1, #obj.reward_list do
			subObj = obj.reward_list[j];
			if obj.recharge_state == 1 and not redState and subObj.state == 1 then
				redState = true;
				break;
			end
		end
		DataCenter.redPointData:updateRedPointState("HalfMonthGift_"..obj.gift_type, redState);
	end
	self.isNeedRefresh = true;
	self._giftTypeArr:sort(nil, false);
end

function Lua_HalfMonthGiftData.Get:curDay()
	return self._curDay or 1;
end

function Lua_HalfMonthGiftData.Get:giftTypeArr()
	return self._giftTypeArr;
end

function Lua_HalfMonthGiftData:getHalfMonthGiftByGifType(giftType)
	if giftType == nil or self.halfMonthGiftDic == nil or self.halfMonthGiftDic[giftType] == nil then
		return nil;
	end
	return self.halfMonthGiftDic[giftType];
end

function Lua_HalfMonthGiftData:getPreviewInfoByGifType(giftType)
	if self.isNeedRefresh or self.previewGiftInfoDic == nil then
		self.previewGiftInfoDic = {};
	end

	if self.previewGiftInfoDic[giftType] == nil then
		local info = self:getHalfMonthGiftByGifType(giftType);
		local obj, lineTag;
		local index = 1;
		local showList = {};
		for i = 1, #info.reward_list do
			obj = info.reward_list[i];
			if (lineTag and lineTag ~= obj.line_index) or (showList[index] ~= nil and showList[index][1].reward_type ~= obj.reward_type) then
				index = index + 1;
			end
			lineTag = obj.line_index;

			if showList[index] == nil then
				showList[index] = Array();
			end
			showList[index]:add(obj);
		end
		self.previewGiftInfoDic[giftType] = showList;
	end
	return self.previewGiftInfoDic[giftType];
end