checkRequire("Lua_HeroFashionConfigData");
checkRequire("Lua_HeroFashionVo");
Lua_HeroFashionData = class("Lua_HeroFashionData")
function Lua_HeroFashionData:ctor()
	self:superCall("ctor");
	self.defaultDic = {};
	self.skinDic = {};
	self.activateIds = Array();
end

function Lua_HeroFashionData:dispose()
	if self.skinDic then
		for _, vo in pairs(self.skinDic) do
			vo:reset();
		end
	end
	self.activateIds:clear();
end

function Lua_HeroFashionData:fromServer50114022(msg)
	if msg == nil or msg.clothes_list == nil then
		return;
	end

	local list;
	local vo;
	for i = 1, #msg.clothes_list do
		list = msg.clothes_list[i].clothes_list;
		for j = 1, #list do
			vo = self:getHeroFashionVo(list[j].clothes_id);
			vo:fromServer(list[j]);
			if vo.isActivate then
				self.activateIds:add(vo.id);
			end
		end
	end
end

function Lua_HeroFashionData:fromServer80114022(msg)
	if msg == nil or msg.clothes_info == nil then
		return;
	end

	local list = msg.clothes_info.clothes_list;
	for i = 1, #list do
		vo = self:getHeroFashionVo(list[i].clothes_id);
		vo:fromServer(list[i]);
		if vo.isActivate then
			if self.activateIds:indexOf(vo.id) == -1 then
				self.activateIds:add(vo.id);
			end
		else
			self.activateIds:removeItem(vo.id);
		end
	end
end

function Lua_HeroFashionData:getHeroFashionList(heroId)
	self:initHeroFashion();
	local data = self.heroSkinDic[heroId];
	local arr = Array();
	if data then
		local value = false;
		local config;
		for i = 1, data:getSize() do
			config = Lua_HeroFashionConfigData.getConfig(data[i]);
			if DataCenter.roleData.open_days >= config.openDay then
				value = true;
				arr:add(data[i]);
			end
		end
		if value then
			arr:insert(heroId, 1);
		end
	end
	return arr;
end

function Lua_HeroFashionData:initHeroFashion()
	if self.heroSkinDic == nil then
		self.heroSkinDic = {};
		self._fashionNum = 0;
		local config = getConfig("hero_clothes");
		for k, v in pairs(config) do
			if v.is_shield ~= 1 then
				if self.heroSkinDic[v.hero_id] == nil then
					self.heroSkinDic[v.hero_id] = Array();
				end
				self.heroSkinDic[v.hero_id]:add(k);
				self._fashionNum = self._fashionNum + 1;
			end
		end
	end
end

function Lua_HeroFashionData:checkExistFashion(heroId)
	self:initHeroFashion();
	local data = self.heroSkinDic[heroId];
	if data == nil then
		return false;
	end
	local arr = self:getHeroFashionList(heroId);
	return arr:getSize() > 0;
end

function Lua_HeroFashionData.Get:totalFashionNum()
	self:initHeroFashion();
	return self._fashionNum or 0
end

function Lua_HeroFashionData:getHeroFashionVo(skinId)
	skinId = tonumber(skinId);
	if self.skinDic[skinId] == nil then
		local config = Lua_HeroFashionConfigData.getConfig(skinId);
		if config == nil then
			return nil;
		end
		self.skinDic[skinId] = Lua_HeroFashionVo.new(skinId, config);
	end
	return self.skinDic[skinId];
end

function Lua_HeroFashionData:getDefaultFashionVo(heroId)
	heroId = tonumber(heroId);
	if self.defaultDic[heroId] == nil then
		local config = Lua_HeroConfigData.getConfig(heroId);
		if config == nil then
			return nil;
		end
		self.defaultDic[heroId] = Lua_HeroFashionVo.new(heroId, config, true);
	end
	return self.defaultDic[heroId];
end


function Lua_HeroFashionData:getFashionAttrStr()
	local str;
	local len = self.activateIds:getSize();
	if len > 0 then
		local vo;
		local tab = {};
		for i = 1, len do
			vo = self:getHeroFashionVo(self.activateIds[i]);
			tab = DataCenter.attributesUtil:getAttrDic(vo.allProp, tab);
		end

		local arr = DataCenter.attributesUtil:getAttrArrByDic(tab);
		len = arr:getSize();
		for i = 1, len do
			if i == 1 then
				str = LanUtil.formateStr(126505, arr[i].show_name, arr[i].showValue);
			else
				str = str.."\n"..LanUtil.formateStr(126505, arr[i].show_name, arr[i].showValue);
			end
		end
	end
	return str;
end

function Lua_HeroFashionData:getFashionItemArr(list)
	local arr = Array();
	if list then
		for i = 1, #list do
			local data = DataCenter.packData:getItemListById(list[i]);
			if data then
				for j = 1, data:getSize() do
					arr:add(data[j]);
				end
			end
		end
	end
	return arr;
end

function Lua_HeroFashionData:checkRedPoint(heroVo)
	self:initHeroFashion();
	local arr = self.heroSkinDic[heroVo.id];
	if arr then
		local vo;
		for i = 1, arr:getSize() do
			vo = self:getHeroFashionVo(arr[i]);
			if vo and vo.redPointState then
				return true;
			end
		end
	end
	return false;
end