Lua_HeroFashionVo = class("Lua_HeroFashionVo")
function Lua_HeroFashionVo:ctor(id, config, isDefault)
	self.id = tonumber(id);
	self._config = config;
	self.isDefault = isDefault;
	self.weaponIsActivate = false;
end

function Lua_HeroFashionVo:reset()
	self._is_activate = 0;
	self._tick = 0;
	self._is_click = 0;
end

function Lua_HeroFashionVo:fromServer(msg)
	self._is_activate = msg.is_activate;
	self._tick = tonumber(msg.tick);
	self._is_click = msg.is_click;
end

function Lua_HeroFashionVo.Get:config()
	if self._config then
		return self._config;
	end
	if self.isDefault then
		return Lua_HeroConfigData.getConfig(self.id);
	end
	return Lua_HeroFashionConfigData.getConfig(self.id);
end

-- 时装过期时间戳，0表示无限期
function Lua_HeroFashionVo.Get:tick()
	return self._tick or 0;
end

-- 是否访问过皮肤红点 0未访问 1已访问
function Lua_HeroFashionVo.Get:isClick()
	return self._is_click == 1;
end

-- 激活状态，0未激活，1已激活
function Lua_HeroFashionVo.Get:isActivate()
	if self.isDefault then
		return true;
	end
	return self._is_activate == 1;
end

function Lua_HeroFashionVo.Get:residueTime()
	return self.tick - DataCenter.roleData.serverTime;
end

function Lua_HeroFashionVo.Get:redPointState()
	if not self.isActivate and self.activateItem > 0 then
		local arr = DataCenter.packData:getItemListById(self.activateItem);
		if arr then
			local vo;
			for i = 1, arr:getSize() do
				vo = DataCenter.packData:getItemVoByUnId(arr[i]);
				if vo.agingType == 0 then
					return true;
				end
			end
		end
	end
	return false;
end

function Lua_HeroFashionVo.Get:curPropStr()
	if self._curPropStr == nil and self.curProp then
		self._curPropStr = DataCenter.attributesUtil:getAttrStr(self.curProp, "\n");
	end
	return self._curPropStr;
end

function Lua_HeroFashionVo.Get:allPropStr()
	if self._allPropStr == nil and self.allProp then
		self._allPropStr = DataCenter.attributesUtil:getAttrStr(self.allProp, "\n");
	end
	return self._allPropStr;
end










function Lua_HeroFashionVo.Get:name()
	return self.config.name;
end

function Lua_HeroFashionVo.Get:heroId()
	return self.config.heroId;
end

function Lua_HeroFashionVo.Get:activateItem()
	return self.config.activateItem;
end

function Lua_HeroFashionVo.Get:siftItem()
	return self.config.siftItem;
end

function Lua_HeroFashionVo.Get:activatePath()
	return self.config.activatePath;
end

function Lua_HeroFashionVo.Get:color()
	return self.config.color;
end

function Lua_HeroFashionVo.Get:colorAtlas()
	return self.config.colorAtlas;
end

function Lua_HeroFashionVo.Get:colorSprite()
	return self.config.colorSprite;
end

function Lua_HeroFashionVo.Get:curProp()
	return self.config.curProp;
end

function Lua_HeroFashionVo.Get:allProp()
	return self.config.allProp;
end

function Lua_HeroFashionVo.Get:skinPicUrl()
	return self.config.skinPicUrl;
end

function Lua_HeroFashionVo.Get:skinPic()
	return self.config.skin_pic;
end

function Lua_HeroFashionVo.Get:avatar_atlas_1()
    return self.config.avatar_atlas_1;
end

function Lua_HeroFashionVo.Get:avatar_sprite_1()
    return self.config.avatar_sprite_1;
end

function Lua_HeroFashionVo.Get:avatar_atlas_2()
    return self.config.avatar_atlas_2;
end

function Lua_HeroFashionVo.Get:avatar_sprite_2()
    return self.config.avatar_sprite_2;
end

function Lua_HeroFashionVo.Get:atlas()
    return self.config.atlas;
end

function Lua_HeroFashionVo.Get:sprite()
    return self.config.sprite;
end

function Lua_HeroFashionVo.Get:path()
	return self.config.path;
end

function Lua_HeroFashionVo.Get:heroRolePath()
	return self.config.heroRolePath;
end

function Lua_HeroFashionVo.Get:floder()
	return self.config.floder;
end

function Lua_HeroFashionVo.Get:jid()
	return self.config.jid;
end

function Lua_HeroFashionVo.Get:modelUrl()
	return self.config.modelUrl;
end

function Lua_HeroFashionVo.Get:modelSrc()
	return self.config.modelSrc;
end

function Lua_HeroFashionVo.Get:uiSceneId()
	return self.config.uiSceneId;
end

function Lua_HeroFashionVo.Get:uiModelUrl()
	return self.config.uiModelUrl;
end

function Lua_HeroFashionVo.Get:uiModelSrc()
	return self.config.uiModelSrc;
end

function Lua_HeroFashionVo.Get:uiModelAvatarName()
	return self.config.uiModelAvatarName;
end

function Lua_HeroFashionVo.Get:uiModelCamController()
	return self.config.uiModelCamController;
end

function Lua_HeroFashionVo.Get:uiModelScale()
	return self.config.uiModelScale;
end

function Lua_HeroFashionVo.Get:poseActEffs()
    local list = self.config.poseActEffs;
    if self.weaponIsActivate then
        local arr = Array();
        if list then
            for i = 1, #list do
                arr:add(list[i]);
            end
        end
        list = self.config.activatePoseActEffs;
        if list then
            for i = 1, #list do
                arr:add(list[i]);
            end
        end
        return arr;
    end
    return list;
end

function Lua_HeroFashionVo.Get:showActEffs()
    return self.config.showActEffs;
end

function Lua_HeroFashionVo.Get:uiShowAct()
    return self.config.uiShowAct;
end

function Lua_HeroFashionVo.Get:lineSound()
	return self.config.lineSound;
end

function Lua_HeroFashionVo.Get:bShowFur()
	return self.config.bShowFur;
end

function Lua_HeroFashionVo.Get:getLabel()
	return self.config.getLabel;
end