-- 成圣之路 Data
checkRequire("Lua_HeroHolyTaskVo");
checkRequire("Lua_HeroHolySoulVo");
Lua_HeroHolyData = class("Lua_HeroHolyData");

-- 页签类型
Lua_HeroHolyData.BEYOND = 1;
Lua_HeroHolyData.HALF_HOLY = 2;
Lua_HeroHolyData.HOLY_SOUL = 3;

-- 圣魂类型数
Lua_HeroHolyData.SOUL_TYPE_NUM = 3;

function Lua_HeroHolyData:ctor()
    self:dispose();
end

function Lua_HeroHolyData:dispose()
    self.isInit = false;
end

function Lua_HeroHolyData:fromServer50114045(msg)
    self.isInit = true;
    local vo;
    for i = 1, #msg.task_info do
        vo = self:getTaskVoByCondId(msg.task_info[i].key);
        if vo ~= nil then
            vo:fromServer(msg.task_info[i]);
        end
    end
    Lua_MsgUtil.callFunc("HEROHOLY_TASKINFO_UPDATE");
end

function Lua_HeroHolyData:fromServer80114046(msg)
    local vo = self:getTaskVoByCondId(msg.task_id);
    if vo ~= nil then
        vo.state = msg.state;
        vo.progress = msg.progress;
    end
    Lua_MsgUtil.callFunc("HEROHOLY_TASKINFO_UPDATE");
end




















--------------------------------- 任务 ---------------------------------

function Lua_HeroHolyData:getTaskVoDic()
    if self.holyTaskVoDic == nil then
        self.holyTaskVoDic = {};
        self.holyTaskCondIdDic = {};

        local config = getConfig("hero_holy_task");
        for k, v in pairs(config) do
            self.holyTaskVoDic[k] = Lua_HeroHolyTaskVo.new(k, v);

            if v.cond_id ~= nil then
                self.holyTaskCondIdDic[v.cond_id] = k;
            end
        end
    end
    return self.holyTaskVoDic;
end

function Lua_HeroHolyData:getTaskVoArr()
    local arr = Array();
    local dic = self:getTaskVoDic();
    for k, v in pairs(dic) do
        if v ~= nil then
            arr:add(v);
        end
    end
    arr:sort("sort", false);
    return arr;
end

function Lua_HeroHolyData:getTaskVoById(id)
    local dic = self:getTaskVoDic();
    return dic[id];
end

function Lua_HeroHolyData:getTaskVoByCondId(cond_id)
    local dic = self:getTaskVoDic();
    local id = self.holyTaskCondIdDic[cond_id];
    if id ~= nil then
        return dic[id];
    end
    return nil;
end

function Lua_HeroHolyData:getTaskFinishInfo(uid)
    local arr = self:getTaskVoArr();
    local vo;
    local num = 0;
    for i = 1, arr:getSize() do
        vo = arr[i];
        if vo.cond_id ~= nil then
            if vo.state == 1 then
                num = num + 1;
            end
        else
            if vo:curStateByUid(uid) then
                num = num + 1;
            end
        end
    end
    return num, arr:getSize();
end
















--------------------------------- 圣魂 ---------------------------------

function Lua_HeroHolyData:getSoulVo(heroId, soulType)
    if self.holySoulVoDic == nil then
        self.holySoulVoDic = {};
    end
    local id = heroId * 100 + soulType;
    local vo = self.holySoulVoDic[id];
    if vo == nil then
        vo = Lua_HeroHolySoulVo.new(id);
        self.holySoulVoDic[id] = vo;
    end
    return vo;
end

function Lua_HeroHolyData:getSoulVoArr(heroId)
    local arr = Array();
    local vo;
    for i = 1, Lua_HeroHolyData.SOUL_TYPE_NUM do
        vo = self:getSoulVo(heroId, i);
        arr:add(vo);
    end
    return arr;
end

function Lua_HeroHolyData:initStuffData(uid)
    self.curHeroUid = uid;
    if self.stuffUidTempDic == nil then
        self.stuffUidTempDic = {};
    else
        table.clear(self.stuffUidTempDic)
    end
    if self.stuffUidPosDic == nil then
        self.stuffUidPosDic = {};
    else
        table.clear(self.stuffUidPosDic)
    end
    if self.removeLineupUidDic == nil then
        self.removeLineupUidDic = {};
    else
        table.clear(self.removeLineupUidDic)
    end
end

function Lua_HeroHolyData:setStuffUidTempDic(uid, val)
    self.stuffUidTempDic[uid] = val;
end

function Lua_HeroHolyData:addStuffUidPosDic(soulType, index, uid)
    self:setStuffUidTempDic(uid, true);

    if self.stuffUidPosDic[soulType] == nil then
        self.stuffUidPosDic[soulType] = {};
    end
    if self.stuffUidPosDic[soulType][index] == nil then
        self.stuffUidPosDic[soulType][index] = Array();
    end
    self.stuffUidPosDic[soulType][index]:add(uid);
end

function Lua_HeroHolyData:delStuffUidPosDic(soulType, index, uid)
    self:setStuffUidTempDic(uid, false);

    if self.stuffUidPosDic[soulType] == nil or self.stuffUidPosDic[soulType][index] == nil then
        return;
    end
    self.stuffUidPosDic[soulType][index]:removeItem(uid);
end

function Lua_HeroHolyData:clearStuffUidPosDic(soulType, index, uidList)
    for k, v in pairs(uidList) do
        if v == 0 then
            self:addStuffUidPosDic(soulType, index, k);
        elseif v == 1 then
            self:delStuffUidPosDic(soulType, index, k);
        end
    end
end

function Lua_HeroHolyData:isSelectSuff(uid)
    return self.stuffUidTempDic[uid] == true;
end

function Lua_HeroHolyData:isSelectSuffByIdx(soulType, index, uid)
    if self.stuffUidPosDic[soulType] ~= nil and self.stuffUidPosDic[soulType][index] ~= nil then
        local arr = self.stuffUidPosDic[soulType][index];
        for i = 1, arr:getSize() do
            if arr[i] == uid then
                return true;
            end
        end
    end
    return false;
end

function Lua_HeroHolyData:getSelectStuffNum(soulType, index)
    if self.stuffUidPosDic[soulType] == nil or self.stuffUidPosDic[soulType][index] == nil then
        return 0;
    end
    return self.stuffUidPosDic[soulType][index]:getSize();
end

function Lua_HeroHolyData:getCostHeroArr(stuffInfo)
    local star = DataCenter.heroUtil:getHeroAwakenStarByQuality(stuffInfo.quality, stuffInfo.quality_star);
    local vo;
    local unique_id;
    local arr = Array();
    if stuffInfo.id == 0 then -- 不指定英雄，才能用万能道具
        local pack_info = DataCenter.packData:getUnIdList(Lua_PackDefine.ALMIGHTY_HERO);
        for i = 1, pack_info:getSize() do
            unique_id = pack_info[i];
            vo = DataCenter.packData:getItemVoByUnId(unique_id);
            if stuffInfo.campType ~= 0 then -- 指定类型
                if vo.campType == stuffInfo.campType and vo.star == star then
                    for j = 1, vo.count do
                        local uid = vo.id .. "00000000000" .. j;
                        arr:add(uid);         
                    end
                end
            elseif star ~= 0 then -- 指定星级
                if vo.star == star then
                    for j = 1, vo.count do
                        local uid = vo.id .. "00000000000" .. j;
                        arr:add(uid);         
                    end
                end
            end
        end
    end

    local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
    self:sortHeroInfo(heroUidArr);
    for i = 1, heroUidArr:getSize() do
        unique_id = heroUidArr[i];
        if unique_id ~= self.curHeroUid then--筛选掉当前英雄，和已经选择的英雄
            if self:isSelectSuff(unique_id) then -- 筛选掉已经选择的英雄
                if self:isSelectSuffByIdx(stuffInfo.soulType, stuffInfo.index, unique_id) then --当前材料索引下已选的英雄需要显示出来
                    arr:add(unique_id);
                end
            else
                vo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if vo.is_league_transaction == false and not vo.trial_state then
                    if stuffInfo.id ~= 0 then --指定英雄
                        if vo.id == stuffInfo.id and vo.campType == stuffInfo.campType and vo.star == star then
                            arr:add(unique_id);
                        end
                    elseif stuffInfo.campType ~= 0 then --指定类型
                        if vo.campType == stuffInfo.campType and vo.star == star then
                            arr:add(unique_id);
                        end
                    elseif star ~= 0 then --指定星级
                        if vo.star == star then
                            arr:add(unique_id);
                        end
                    end
                end
            end
        end
    end
    return arr;
end

function Lua_HeroHolyData:sortHeroInfo(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = DataCenter.heroData:getItemByUniqueId(arr[i]).upStarSort;
            local b = DataCenter.heroData:getItemByUniqueId(arr[j]).upStarSort;
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

function Lua_HeroHolyData:checkLineupNumState(select_uid)
    if self.stuffUidTempDic == nil or select_uid == nil then
        return true;
    end
    
    local hvo;
    local config;
    local lineupList = {};
    local lineupType, lineupIdx, standIdx;
    for uid, v in pairs(self.stuffUidTempDic) do
        if v == true then
            hvo = DataCenter.heroData:getItemByUniqueId(uid);
            if hvo ~= nil and hvo.lineup_state_list ~= nil then
                for i = 1, #hvo.lineup_state_list do
                    lineupType = hvo.lineup_state_list[i].key;
                    config = getConfig("hero_camp_lineup", lineupType);
                    if config ~= nil and config.can_nil ~= 1 then
                        lineupIdx, standIdx = DataCenter.heroLineupData:getLineupHeroInfo(lineupType, hvo.id);
                        if lineupIdx ~= nil then
                            if lineupList[lineupType] == nil then
                                lineupList[lineupType] = {};
                            end
                            if lineupList[lineupType][lineupIdx] == nil then
                                lineupList[lineupType][lineupIdx] = 1;
                            else
                                lineupList[lineupType][lineupIdx] = lineupList[lineupType][lineupIdx] + 1;
                            end
                        end
                    end
                end
            end
        end
    end

    hvo = DataCenter.heroData:getItemByUniqueId(select_uid);
    if hvo ~= nil and hvo.lineup_state_list ~= nil then
        for i = 1, #hvo.lineup_state_list do
            lineupType = hvo.lineup_state_list[i].key;
            config = getConfig("hero_camp_lineup", lineupType);
            if config ~= nil and config.can_nil ~= 1 then
                lineupIdx, standIdx = DataCenter.heroLineupData:getLineupHeroInfo(lineupType, hvo.id);
                if lineupIdx ~= nil then
                    if lineupList[lineupType] == nil then
                        lineupList[lineupType] = {};
                    end
                    if lineupList[lineupType][lineupIdx] == nil then
                        lineupList[lineupType][lineupIdx] = 1;
                    else
                        lineupList[lineupType][lineupIdx] = lineupList[lineupType][lineupIdx] + 1;
                    end

                    if lineupList[lineupType][lineupIdx] >= DataCenter.heroLineupData:getLineupHeroNum(lineupType, lineupIdx) then
                        return false, config.name;
                    end
                end
            end
        end
    end
    return true;
end


















--------------------------------- 红点 ---------------------------------

function Lua_HeroHolyData:checkRedPoint(uid)
    if DataCenter.heroData:isOpenHeroHoly(uid) == false then
        return false;
    end
    local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
    if heroVo.trial_state == true then
        return false;
    end

    if self:checkTaskRedPoint(uid) then
        return true;
    end
    if self:checkHalfRedPoint(uid) then
        return true;
    end
    if self:checkActiveRedPoint(uid) then
        return true;
    end
    return false;
end

function Lua_HeroHolyData:checkTaskRedPoint(uid)
    if not self.isInit then
        return false;
    end
    local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
    if heroVo.holy_soul_skill == 0 then
        local curNum, num = self:getTaskFinishInfo(uid);
        return curNum >= num;
    end
    return false;
end

function Lua_HeroHolyData:checkHalfRedPoint(uid)
    local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
    if heroVo ~= nil and heroVo.star == 14 then
        return DataCenter.heroUpStarData:checkUpStarRedDot(heroVo, false);
    end
    return false;
end

function Lua_HeroHolyData:checkActiveRedPoint(uid)
    local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
    if heroVo.star < 15 or heroVo.holy_soul_skill ~= 0 then
        return false;
    end
    if self:isSoulActiveAll(uid) then
        return false;
    end

    local arr = self:getSoulVoArr(heroVo.id);
    local tempDic;
    local data;
    local star;
    local heroUidArr;
    local selectNum;
    local unique_id;
    local hvo;
    local state;
    for i = 1, arr:getSize() do
        if self:holySoulState(uid, i) == false then
            tempDic = {};
            data = arr[i].item_material;
            state = true;
            for j = 1, arr[i].heroStuffArr:getSize() do
                data = arr[i].heroStuffArr[j];
                star = DataCenter.heroUtil:getHeroAwakenStarByQuality(data.quality, data.quality_star);
                heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
                selectNum = 0;
                for k = 1, heroUidArr:getSize() do
                    unique_id = heroUidArr[k];
                    if unique_id ~= uid and tempDic[unique_id] == nil then
                        hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
                        if hvo.isSpecialState ~= true and hvo.is_league_transaction == false and not hvo.trial_state then
                            if data.id ~= 0 then
                                if hvo.id == data.id and hvo.campType == data.campType and hvo.star == star then
                                    selectNum = selectNum + 1;
                                    tempDic[unique_id] = 1;
                                end
                            else
                                if hvo.campType == data.campType and hvo.star == star then
                                    selectNum = selectNum + 1;
                                    tempDic[unique_id] = 1;
                                end
                            end
                        end
                        if selectNum >= data.needNum then
                            break;
                        end
                    end
                end
                if selectNum < data.needNum then
                    state = false;
                end
            end

            data = arr[i].item_material;
            for j = 1, #data do
                selectNum = DataCenter.packData:getItemCountById(data[j][1]);
                if selectNum < data[j][2] then
                    state = false;
                    break;
                end
            end

            if state then
                return true;
            end
        end
    end
    return false;
end

















--------------------------------- 外部接口 ---------------------------------

function Lua_HeroHolyData:getSoulActiveNum(uid)
    local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
    local soulInfo = heroVo.holy_soul_info;
    local activeNum = 0;
    for i = 1, #soulInfo do
        if soulInfo[i].value == 1 then
            activeNum = activeNum + 1;
        end
    end
    return activeNum;
end

function Lua_HeroHolyData:isSoulActiveAll(uid)
    local activeNum = self:getSoulActiveNum(uid);
    return activeNum >= Lua_HeroHolyData.SOUL_TYPE_NUM;
end

function Lua_HeroHolyData:holySoulState(uid, soulType)
    local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
    local soulInfo = heroVo.holy_soul_info;
    for i = 1, #soulInfo do
        if soulInfo[i].key == soulType then
            return soulInfo[i].value == 1;
        end
    end
    return false;
end