-- 成圣之路 圣魂Vo
Lua_HeroHolySoulVo = class("Lua_HeroHolySoulVo");

function Lua_HeroHolySoulVo:ctor(id)
    self.id = id;
    self.config = getConfig("hero_holy_soul", id);

    if self.config == nil then
        LogManager.LogError("hero_holy_soul" .. "未配置对应id " .. id, false);
    end
end

function Lua_HeroHolySoulVo:dispose()
end

function Lua_HeroHolySoulVo:initStuffInfo()
    if DataCenter.heroHolyData:holySoulState(DataCenter.heroHolyData.curHeroUid, self.soul_type) then
        return false;
    end

    local data;
    local star;
    local isAutoSelect;
    local heroUidArr;
    local unique_id;
    local hvo;
    local selectNum = 0;
    for i = 1, self.heroStuffArr:getSize() do
        data = self.heroStuffArr[i];
        star = DataCenter.heroUtil:getHeroAwakenStarByQuality(data.quality, data.quality_star);

        -- 判断自动选择
        isAutoSelect = data.id ~= 0 and star <= 5;
        if not isAutoSelect then
            break;
        end

        heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
        for j = 1, heroUidArr:getSize() do
            unique_id = heroUidArr[j];
            if unique_id ~= DataCenter.heroHolyData.curHeroUid and not DataCenter.heroHolyData:isSelectSuff(unique_id) then
                hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if hvo.isSpecialState ~= true and hvo.is_league_transaction == false and not hvo.trial_state then
                    if data.id ~= 0 then
                        if hvo.id == data.id and hvo.campType == data.campType and hvo.star == star then
                            selectNum = selectNum + 1;
                            DataCenter.heroHolyData:addStuffUidPosDic(self.soul_type, i, unique_id);
                        end
                    else
                        if hvo.campType == data.campType and hvo.star == star then
                            selectNum = selectNum + 1;
                            DataCenter.heroHolyData:addStuffUidPosDic(self.soul_type, i, unique_id);
                        end
                    end
                end

                if selectNum >= data.needNum then
                    break;
                end
            end
        end
    end
end

function Lua_HeroHolySoulVo:checkRedPoint()
    if DataCenter.heroHolyData:holySoulState(DataCenter.heroHolyData.curHeroUid, self.soul_type) then
        return false;
    end

    local data;
    local star;
    local selectNum;
    local tempUidDic = {};
    for i = 1, self.heroStuffArr:getSize() do
        data = self.heroStuffArr[i];
        star = DataCenter.heroUtil:getHeroAwakenStarByQuality(data.quality, data.quality_star);
        selectNum = DataCenter.heroHolyData:getSelectStuffNum(self.soul_type, i);
        heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
        for j = 1, heroUidArr:getSize() do
            unique_id = heroUidArr[j];
            if unique_id ~= DataCenter.heroHolyData.curHeroUid and not DataCenter.heroHolyData:isSelectSuff(unique_id)
                and not tempUidDic[unique_id] then
                hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if hvo.isSpecialState ~= true and hvo.is_league_transaction == false and not hvo.trial_state then
                    if data.id ~= 0 then
                        if hvo.id == data.id and hvo.campType == data.campType and hvo.star == star then
                            selectNum = selectNum + 1;
                            tempUidDic[unique_id] = true;
                        end
                    else
                        if hvo.campType == data.campType and hvo.star == star then
                            selectNum = selectNum + 1;
                            tempUidDic[unique_id] = true;
                        end
                    end
                end

                if selectNum >= data.needNum then
                    break;
                end
            end
        end
        if selectNum < data.needNum then
            return false;
        end
    end
    for i = 1, #self.item_material do
        if DataCenter.packData:getItemCountById(self.item_material[i][1]) < self.item_material[i][2] then
            return false;
        end
    end
    return true;
end

function Lua_HeroHolySoulVo.Get:heroStuffArr()
    if self._heroStuffArr == nil then
        self._heroStuffArr = Array();
        local material = self.hero_material;
        for i = 1, #material do
            self._heroStuffArr:add({index = i, soulType = self.soul_type, quality = material[i][1][1], quality_star = material[i][1][2],
            campType = material[i][2], needNum = material[i][3], id = material[i][4]});
        end
    end
    return self._heroStuffArr;
end

function Lua_HeroHolySoulVo.Get:costStuffNum()
    return self.heroStuffArr:getSize() + #self.item_material;
end

function Lua_HeroHolySoulVo.Get:isHeroEnough()
    local data;
    local selectNum;
    for i = 1, self.heroStuffArr:getSize() do
        data = self.heroStuffArr[i];
        selectNum = DataCenter.heroHolyData:getSelectStuffNum(data.soulType, data.index);
        if data.needNum > selectNum then
            return false;
        end
    end
    return true;
end

function Lua_HeroHolySoulVo.Get:isItemEnough()
    local data;
    local packNum;
    for i = 1, #self.item_material do
        data = self.item_material[i];
        packNum = DataCenter.packData:getItemCountById(data[1]);
        if data[2] > packNum then
            return data[1];
        end
    end
    return true;
end

------------------------ 配置数据 ------------------------

-- 英雄id
function Lua_HeroHolySoulVo.Get:hero_id()
    return self.config.hero_id;
end

-- 圣魂类型
function Lua_HeroHolySoulVo.Get:soul_type()
    return self.config.type;
end

-- 英雄材料
function Lua_HeroHolySoulVo.Get:hero_material()
    if self.config == nil or self.config.hero_material == nil then
        return {};
    end
    return self.config.hero_material;
end

-- 道具材料
function Lua_HeroHolySoulVo.Get:item_material()
    if self.config == nil or self.config.item_material == nil then
        return {};
    end
    return self.config.item_material;
end

-- 属性
function Lua_HeroHolySoulVo.Get:prop()
    return self.config.prop;
end

-- 名称
function Lua_HeroHolySoulVo.Get:name()
    return self.config.name;
end