-- 成圣之路 任务Vo
Lua_HeroHolyTaskVo = class("Lua_HeroHolyTaskVo");

function Lua_HeroHolyTaskVo:ctor(id, config)
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig("hero_holy_task", self.id);
    end
end

function Lua_HeroHolyTaskVo:dispose()
    self.state = 0;
    self.progress = 0;
end

function Lua_HeroHolyTaskVo:fromServer(msg)
    self.state = tonumber(msg.value); -- 1：完成 0：未完成
    self.progress = msg.other;
end

function Lua_HeroHolyTaskVo.Get:maxProgress()
    if self.cond_id ~= nil then
        return getConfig("total_task", self.cond_id, "progress");
    elseif self.id == 3 then
        return 1;
    elseif self.id == 4 then
        return Lua_HeroHolyData.SOUL_TYPE_NUM;
    end
    return 0;
end

------------------------ 具体英雄处理 ------------------------

function Lua_HeroHolyTaskVo:curProgressByUid(uid)
    if self.id == 3 then
        local heroVo = DataCenter.heroData:getItemByUniqueId(uid);
        return heroVo.star >= 15 and 1 or 0;
    elseif self.id == 4 then
        return DataCenter.heroHolyData:getSoulActiveNum(uid);
    end
    return 0;
end

function Lua_HeroHolyTaskVo:curStateByUid(uid)
    local progress = self:curProgressByUid(uid);
    return progress >= self.maxProgress;
end

------------------------ 配置数据 ------------------------

-- 条件id
function Lua_HeroHolyTaskVo.Get:cond_id()
    return self.config.cond_id;
end

-- 标题名
function Lua_HeroHolyTaskVo.Get:title()
    return self.config.title;
end

-- 描述
function Lua_HeroHolyTaskVo.Get:desc()
    return self.config.desc;
end

-- 按钮名
function Lua_HeroHolyTaskVo.Get:btn_name()
    return self.config.btn_name;
end

-- 按钮位置
function Lua_HeroHolyTaskVo.Get:btn_pos()
    return self.config.btn_pos;
end

-- 跳转id
function Lua_HeroHolyTaskVo.Get:path_id()
    return self.config.path_id;
end

-- 排序
function Lua_HeroHolyTaskVo.Get:sort()
    return self.config.sort;
end