-- 布阵配置数据
Lua_HeroLineupUtil = class("Lua_HeroLineupUtil");
function Lua_HeroLineupUtil:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_HeroLineupUtil:dispose()
    self.standDic = nil;
    self.standIndexDic = nil;
end

function Lua_HeroLineupUtil:getLineupTabArr()
    if self.lineupTabArr == nil then
        self.lineupTabArr = Array();
        local config = getConfig("hero_camp_lineup");
        local vo;
        for k, v in pairs(config) do
            if v.is_show == 1 then
                vo = DataCenter.heroLineupData:getLineupVo(k, v);
                self.lineupTabArr:add(vo);
            end
        end
        self.lineupTabArr:sort("sort", false);
    end
    return self.lineupTabArr;
end

--获取站位信息
function Lua_HeroLineupUtil.Get:standConfigInfo()
    if self.standcfg == nil then
        self.standcfg = getConfig("hero_camp_position");
    end
    return self.standcfg;
end

function Lua_HeroLineupUtil:getStandInfoByType(standType)
    local info = self.standConfigInfo[standType]
    if info == nil then
        info = self.standConfigInfo[1]
    end
    return info;
end

--获取xx阵法站位的索引
function Lua_HeroLineupUtil:getIndexByStand(standType, standIdx)
    if self.standIndexDic == nil then
        self.standIndexDic = {};
    end
    if self.standIndexDic[standType] == nil then
        self.standIndexDic[standType] = {};
        local stand_list = self:getStandListByType(standType);
        for i = 1, #stand_list do
            self.standIndexDic[standType][stand_list[i]] = i;
        end
    end

    return self.standIndexDic[standType][standIdx];
end

--获取xx阵法索引的站位
function Lua_HeroLineupUtil:getStandByIndex(standType, index)
    if self.standDic == nil then
        self.standDic = {};
    end
    if self.standDic[standType] == nil then
        self.standDic[standType] = {};
        local stand_list = self:getStandListByType(standType);
        for i = 1, #stand_list do
            self.standDic[standType][i] = stand_list[i];
        end
    end
    
    return self.standDic[standType][index];
end

function Lua_HeroLineupUtil:getStandListByType(standType)
    local info = self:getStandInfoByType(standType)
    if info.unlock_list then
        local list = {}
        local standIdx
        local id
        for i = 1, #info.unlock_list do
            standIdx = info.unlock_list[i][1]
            id = info.unlock_list[i][2]
            if id == 0 then
                table.insert(list, standIdx)
            elseif DataCenter.mainLineData:getCheckpointIsCompleted(id) then
                table.insert(list, standIdx)
            end
        end        
        return list
    end
    return info.position_list
end

function Lua_HeroLineupUtil:getPosListByType(standType)
    local info = self:getStandInfoByType(standType)
    if info then
        return info.position_list
    end
    return nil
end










---------------------------------------------- 光环数据 ----------------------------------------------
-- 获取激活光环id
function Lua_HeroLineupUtil:getAureoleId(list)
    if list == nil then
        return 0;
    end

    -- local normalNum = 0;
    -- local specialNum = 0;
    local campDic = {};
    local camp;
    if list.typeof ~= nil and list:typeof() == "Array" then
        for i = 1, list:getSize() do
            camp = list[i];
            -- if camp > 4 then
            --     specialNum = specialNum + 1;
            -- else
            --     normalNum = normalNum + 1;
            -- end
            if campDic[camp] == nil then
                campDic[camp] = 1;
            else
                campDic[camp] = campDic[camp] + 1;
            end
        end
    else
        for k, v in pairs(list) do
            -- if k > 4 then
            --     specialNum = specialNum + 1;
            -- else
            --     normalNum = normalNum + 1;
            -- end
            campDic[k] = v;
        end
    end

    local maxCamp, maxNum = 0, 0;
    for k, v in pairs(campDic) do
        if k < 5 and v > maxNum then -- 只算自然系
            maxCamp = k;
            maxNum = v;
        end
    end
    local num = maxNum + (campDic[5] or 0);
    if num == 6 then
        return num * 1000 + maxCamp;
    end
    return num * 1000;
end

function Lua_HeroLineupUtil:getAureoleInfoByType(aureoleType)
    if self.aureoleDic == nil then
        self.aureoleDic = {};
        local config = getConfig("hero_camp_aureole");
        for k, v in pairs(config) do
            if self.aureoleDic[v.aureole_type] == nil then
                self.aureoleDic[v.aureole_type] = Array();
            end
            self.aureoleDic[v.aureole_type]:add(k);
        end
        for k, v in pairs(self.aureoleDic) do
            v:sort(nil, false);
        end
    end
    return self.aureoleDic[aureoleType];
end

function Lua_HeroLineupUtil:getAureoleConfig(id)
    return getConfig("hero_camp_aureole", id);
end

--获取光环属性
function Lua_HeroLineupUtil:getAureoleAttrInfo(id)
    local cfg = self:getAureoleConfig(id);
    local arr = Array();
    if cfg ~= nil then
        local vo;
        local list = cfg.attr_list;
        for i=1,#list do
            vo = DataCenter.attributesUtil:createAttrVo(list[i]);
            if vo ~= nil then
                vo.value = getConfig("hero_camp_aureole", id, list[i]);
                arr:add(vo);
            end
        end
        arr:sort("sort", true);
    end
    
    return arr;
end