-- 英雄材料
Lua_HeroMaterialVo = class("Lua_HeroMaterialVo")
function Lua_HeroMaterialVo:ctor(index)
	self:superCall("ctor")
	self.index = index
end

-- [星级，阵营，数量，英雄ID]
function Lua_HeroMaterialVo:setData(data)
	self._quality = data[1][1]
	self._quality_star = data[1][2]
	self._camp = data[2]
	self._num = data[3]
	self._id = data[4]
	self:resetSelected()
end

function Lua_HeroMaterialVo.Get:id()
	return self._id == nil and 0 or self._id
end

function Lua_HeroMaterialVo.Get:star()
	return DataCenter.heroUtil:getHeroAwakenStarByQuality(self.quality, self.quality_star)
end

function Lua_HeroMaterialVo.Get:color()
	local id = DataCenter.heroUtil:getHeroAwakenStarId(self.quality, self.quality_star)
	return getConfig("hero_awaken_star", id, "color") or 1;
end

function Lua_HeroMaterialVo.Get:quality()
	return self._quality == nil and 0 or self._quality
end

function Lua_HeroMaterialVo.Get:quality_star()
	return self._quality_star == nil and 0 or self._quality_star
end

function Lua_HeroMaterialVo.Get:camp()
	return self._camp == nil and 0 or self._camp
end

function Lua_HeroMaterialVo.Get:num()
	return self._num == nil and 0 or self._num
end

function Lua_HeroMaterialVo.Get:heroVo()
	if self.id and self.id > 0 then
		if self._heroVo == nil then
			self._heroVo = Lua_HeroVo.new(self.id)
		else
			self._heroVo:setData(self.id)
		end
		self._heroVo.level = 0
		self._heroVo.quality = self.quality
		self._heroVo.quality_star = self.quality_star
		self._heroVo.campType = self.camp
		return self._heroVo
	end
	return nil
end










function Lua_HeroMaterialVo.Get:selectedList()
	return self._selectedList
end

function Lua_HeroMaterialVo.Get:selectedNum()
	if self._selectedList then
		return self._selectedList:getSize()
	end
	return 0
end

function Lua_HeroMaterialVo.Get:bEnough()
	return self.selectedNum >= self.num
end

function Lua_HeroMaterialVo:resetSelected()
	if self._selectedList == nil then
		self._selectedList = Array()
		self._selectedDic = {}
	else
		local len = self._selectedList:getSize()
		local uniqueId
		while len > 0 do
			uniqueId = self._selectedList:remove()
			self._selectedDic[uniqueId] = nil
			len = len - 1
		end
	end
end

function Lua_HeroMaterialVo:addHeroMaterial(heroUnId)
	if self._selectedDic[heroUnId] == nil then
		self._selectedList:add(heroUnId)
		self._selectedDic[heroUnId] = 1
	end
end

function Lua_HeroMaterialVo:removeHeroMaterial(heroUnId)
	self._selectedList:removeItem(heroUnId)
	self._selectedDic[heroUnId] = nil
end

function Lua_HeroMaterialVo:checkHeroIsSelected(heroUnId)
	if self._selectedDic and self._selectedDic[heroUnId] == 1 then
		return true
	end
	return false
end