-- 英雄战法 Data
checkRequire("Lua_HeroTacticVo");
checkRequire("Lua_HeroTacticFetterVo");
Lua_HeroTacticData = class("Lua_HeroTacticData")
function Lua_HeroTacticData:ctor()
    self:dispose();
end

function Lua_HeroTacticData:dispose()
    self._heroTacticMainDic = {}; -- 主战法列表
    self._heroTacticSubDic = {}; -- 副战法列表
    self.heroWearNum = 0; -- 英雄穿戴数量

    if self._fetterArr ~= nil then
        self._fetterArr:dispose();
        self._fetterArr:clear();
    end
    self._fetterDic = nil;
    self.isInitFetter = false;
end

function Lua_HeroTacticData:fromServer50241001(msg)
    local tacticVo = DataCenter.packData:getItemVoByUnId(msg.item_unique_id);
    if tacticVo.tacticHeroUid == 0 then
        local arr = DataCenter.heroTacticUtil:upgradeUpAttrVoArr(tacticVo.tacticLvlId);
        if arr:getSize() > 0 then
            Lua_WindowUtil.openWin("Lua_AttrChangeTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
        end
    end

    Lua_MsgUtil.callFunc("UPDATE_TACTIC_UPGRADE_INFO", msg.item_unique_id);
end

function Lua_HeroTacticData:fromServer50241002(msg)
    self:checkFetterState(msg.item_unique_id);

    Lua_WindowUtil.openWin("Lua_TacticStarUpWindow", Lua_WinParam.ACTION_OPEN, msg.item_unique_id);

    Lua_MsgUtil.callFunc("UPDATE_TACTIC_INFO", msg.item_unique_id);
end

function Lua_HeroTacticData:fromServer50241006(msg)
    local data;
    local vo;
    for i = 1, #msg.fetter_list do
        data = msg.fetter_list[i];
        vo = self:getFetterVo(tonumber(data.key));
        if vo ~= nil then
            vo:fromServer(data);
        end
    end
    self.isInitFetter = true;
    DataCenter.heroData:checkHeroRedDotState();
end

function Lua_HeroTacticData:fromServer50241007(msg)
    local id = tonumber(msg.fetter.key);
    local vo = self:getFetterVo(id);
    if vo ~= nil then
        vo:fromServer(msg.fetter);
    end
    DataCenter.heroData:checkHeroRedDotState();

    Lua_WindowUtil.openWin("Lua_TacticFetterUpWindow", Lua_WinParam.ACTION_OPEN, id);

    Lua_MsgUtil.callFunc("UPDATE_TACTIC_FETTER_INFO");
end


















 ----------------------------------- 英雄处理 -----------------------------------

function Lua_HeroTacticData:updateHeroTactic(heroUid, tacticInfo, trialState)
    if trialState then
        return;
    end

    local changeNum = 0;
    if tacticInfo ~= nil then
        local mainUid = tonumber(tacticInfo.item_unique_id);
        local subUid = tonumber(tacticInfo.inherit_id);

        if self:getMainTacticUid(heroUid) == 0 then
            if mainUid > 0 then
                changeNum = 1;
            end
        else
            if mainUid == 0 then
                changeNum = -1;
            end
        end
        if self:getSubTacticUid(heroUid) == 0 then
            if subUid > 0 then
                changeNum = changeNum + 1;
            end
        else
            if subUid == 0 then
                changeNum = changeNum - 1;
            end
        end

        self._heroTacticMainDic[heroUid] = mainUid;
        self._heroTacticSubDic[heroUid] = subUid;
    else
        if self:getMainTacticUid(heroUid) > 0 then
            changeNum = -1;
        end
        if self:getSubTacticUid(heroUid) > 0 then
            changeNum = changeNum - 1;
        end

        self._heroTacticMainDic[heroUid] = nil;
        self._heroTacticSubDic[heroUid] = nil;
    end
    self.heroWearNum = self.heroWearNum + changeNum;
end

function Lua_HeroTacticData:getMainTacticUid(heroUid)
    return self._heroTacticMainDic[tonumber(heroUid)] or 0;
end

function Lua_HeroTacticData:getSubTacticUid(heroUid)
    return self._heroTacticSubDic[tonumber(heroUid)] or 0;
end

function Lua_HeroTacticData:getMainTacticVo(heroUid)
    local tacticUid = self:getMainTacticUid(heroUid);
    if tacticUid > 0 then
        return DataCenter.packData:getItemVoByUnId(tacticUid);
    end
    return nil;
end

function Lua_HeroTacticData:getSubTacticVo(heroUid)
    local tacticUid = self:getSubTacticUid(heroUid);
    if tacticUid > 0 then
        return DataCenter.packData:getItemVoByUnId(tacticUid);
    end
    return nil;
end





















 ----------------------------------- 图鉴 -----------------------------------

function Lua_HeroTacticData:initFetterInfo()
    if self._fetterDic == nil then
        self._fetterDic = {};
        self._fetterArr = Array();
        local config = getConfig("fight_rule_fetter_suit");
        for k, v in pairs(config) do
            self._fetterDic[k] = Lua_HeroTacticFetterVo.new(k, v);
            self._fetterArr:add(k);
        end
        self._fetterArr:sort(nil, false);
    end
end

function Lua_HeroTacticData.Get:getFetterArr()
    self:initFetterInfo();
    return self._fetterArr;
end

function Lua_HeroTacticData:getFetterVo(id)
    self:initFetterInfo();
    return self._fetterDic[id];
end

function Lua_HeroTacticData:checkFetterState(tacticUid)
    local tacticVo = DataCenter.packData:getItemVoByUnId(tacticUid);
    if tacticVo == nil then
        return;
    end

    local list = tacticVo.fetter;
    if list == nil then
        return;
    end

    local fetterVo;
    for i = 1, #list do
        fetterVo = self:getFetterVo(list[i]);
        if fetterVo ~= nil then
            fetterVo:checkState();
        end
    end
end

function Lua_HeroTacticData.Get:totalFetterPropArr()
    local arr = self.getFetterArr;
    local vo;
    local dic;
    local propList;
    for i = 1, arr:getSize() do
        vo = self:getFetterVo(arr[i]);
        if vo ~= nil and vo.starLv >= 0 and vo.state > 0 then
            propList = DataCenter.heroTacticUtil:fetterProp(vo.starLvId);
            dic = DataCenter.attributesUtil:getAttrDic(propList, dic);
        end
    end

    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic);
    else
        return Array();
    end
end

function Lua_HeroTacticData.Get:getFetterUpIdx()
    local index = 1;
    local arr = self.getFetterArr;
    local vo;
    for i = 1, arr:getSize() do
        vo = self:getFetterVo(arr[i]);
        if vo.state == 2 then
            index = i;
            break;
        end
    end
    return index;
end





















 ----------------------------------- 调用方法 -----------------------------------

 function Lua_HeroTacticData:getTacticAtlasVo(id)
    if self.tacticAtlasVoDic == nil then
        self.tacticAtlasVoDic = {};
    end

    vo = self.tacticAtlasVoDic[id];
    if vo == nil then
        vo = Lua_ToolVo.createToolVo(id);
        self.tacticAtlasVoDic[id] = vo;
    end
    return vo;
end

function Lua_HeroTacticData:getTacticVo(id)
    local vo = DataCenter.packData:getItemVoById(id);
    if vo == nil then
        vo = self:getTacticAtlasVo(id);
    end
    return vo;
end

function Lua_HeroTacticData:getTacticVoArr(tacticUid, isAll)
    tacticUid = tacticUid ~= nil and tacticUid or 0;
    isAll = isAll ~= nil and isAll or false;

    local vo;
    local arr = Array();
    local config = getConfig("fight_rule");
    for k, v in pairs(config) do
        vo = self:getTacticVo(k);
        if (tacticUid == 0 or tacticUid ~= vo.unique_id) and (isAll or vo.isActive) then
            arr:add(vo);
        end
    end
    arr:sort("tacticSort", false);
    return arr;
end

function Lua_HeroTacticData.Get:freeTacticUid()
    local uidArr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_TACTIC);
    local tacticVo;
    for i = 1, uidArr:getSize() do
        tacticVo = DataCenter.packData:getItemVoByUnId(uidArr[i]);
        if tacticVo.tacticHeroUid <= 0 then
            return uidArr[i];
        end
    end
    return nil;
end

























------------------------------- 红点 -------------------------------

function Lua_HeroTacticData:checkTacticRedDot(heroUid)
    local heroVo = DataCenter.heroData:getItemByUniqueId(heroUid);
    if heroVo.trial_state or not heroVo.showTactic then
        return false;
    end

    if not self:isOpenTactic(heroUid) then
        return false;
    end

    local tacticUid = heroVo.fight_rule.item_unique_id;
    if tacticUid == nil or tonumber(tacticUid) == 0 then
        return self.getWearRedState;
    end
    
    local tacticVo = DataCenter.packData:getItemVoByUnId(tonumber(tacticUid));
    if tacticVo ~= nil then
        if tacticVo.isUpgrade or tacticVo.isUpstar then
            return true;
        end
    end
    return self.getFetterRedState;
end

function Lua_HeroTacticData:isOpenTactic(heroUid)    
    if not DataCenter.funcOpenData:isOpened(10317) then
        return false;
    end

    local heroVo = DataCenter.heroData:getItemByUniqueId(heroUid);
    local config = DataCenter.heroTacticUtil.unlock_star;
    local star = DataCenter.heroUtil:getHeroAwakenStarByQuality(config[1], config[2]);
    return heroVo.star >= star;
end

function Lua_HeroTacticData.Get:getFetterRedState()
    if not self.isInitFetter then
        return false;
    end

    local arr = self.getFetterArr;
    local vo;
    for i = 1, arr:getSize() do
        vo = self:getFetterVo(arr[i]);
        if vo.state == 2 then
            return true;
        end
    end
    return false;
end

function Lua_HeroTacticData.Get:getWearRedState()
    local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_TACTIC);
    return self.heroWearNum < arr:getSize();
end