-- 英雄战法 羁绊Vo
Lua_HeroTacticFetterVo = class("Lua_HeroTacticFetterVo");

function Lua_HeroTacticFetterVo:ctor(id, config)
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig("fight_rule_fetter_suit", id);
    end
    self:dispose();
end

function Lua_HeroTacticFetterVo:dispose()
    self.starLv = -1;
    self._lastLv = nil;
    self._state = nil;
end

function Lua_HeroTacticFetterVo:fromServer(msg)
    self.starLv = tonumber(msg.value);

    if self._lastLv ~= self.starLv then
        self._lastLv = self.starLv;
        self._starLvId = self.id * 100 + self.starLv;

        self:checkState();
    end
end

function Lua_HeroTacticFetterVo.Get:starLvId()
    if self.starLv < 0 or self._starLvId == nil then
        self._starLvId = self.id * 100 + 0;
    end
    return self._starLvId;
end

-- 0:未激活 1：已激活 2：可升星
function Lua_HeroTacticFetterVo.Get:state()
    if self._state == nil then
        local list = self.fight_rule_list;
        local len = #list;
        local num = 0;
        local vo;
        for i = 1, len do
            vo = DataCenter.packData:getItemVoById(list[i]);
            if vo == nil then
                break;
            end

            if self.starLv < 0 or vo.tacticStar > self.starLv then
                num = num + 1;
            end
        end

        
        if num >= len and self.starLv < self.max_level then
            self._state = 2;
        else
            if self.starLv < 0 then
                self._state = 0;
            else
                self._state = 1;
            end
        end
    end
    return self._state;
end

function Lua_HeroTacticFetterVo:checkState()
    self._state = nil;
end


------------------------------- 配置数据 -------------------------------

function Lua_HeroTacticFetterVo.Get:name()
    return self.config.name;
end

function Lua_HeroTacticFetterVo.Get:level()
    if self.config == nil or self.config.level == nil then
        return 0;
    end
    return self.config.level;
end

function Lua_HeroTacticFetterVo.Get:max_level()
    if self.config == nil or self.config.max_level == nil then
        return 0;
    end
    return self.config.max_level;
end

function Lua_HeroTacticFetterVo.Get:fight_rule_list()
    if self.config == nil or self.config.fight_rule_list == nil then
        return {};
    end
    return self.config.fight_rule_list;
end