checkRequire("Lua_HeroTacticUtil");
checkRequire("Lua_HeroTacticData");
Lua_HeroTacticProxy = class("Lua_HeroTacticProxy");
function Lua_HeroTacticProxy:ctor()
    DataCenter.heroTacticUtil = Lua_HeroTacticUtil.new();
    DataCenter.heroTacticData = Lua_HeroTacticData.new();

    Lua_MsgUtil.addLuaMsg(50241001, self, self.rTacticUpgrade);  -- 请求升级战法(返回)
    Lua_MsgUtil.addLuaMsg(50241002, self, self.rTacticUpStar);  -- 请求升星战法(返回)
    Lua_MsgUtil.addLuaMsg(50241004, self, self.rTacticAttach);  -- 请求附魂战法(返回)
    Lua_MsgUtil.addLuaMsg(50241005, self, self.rTacticReset);  -- 请求重生战法(返回)
    Lua_MsgUtil.addLuaMsg(50241006, self, self.rTacticFetter);  -- 请求战法羁绊界面(返回)
    Lua_MsgUtil.addLuaMsg(50241007, self, self.rTacticFetterUp);  -- 请求升星战法羁绊(返回)
end



----------------------------------------- 上行 -----------------------------------------

-- 请求升级战法
function Lua_HeroTacticProxy:sTacticUpgrade(item_id)
    local cmd = ProtoPublic_pb.Proto10241001();
    cmd.item_id = item_id;
    sendMsg(10241001, cmd);
end

-- 请求升星战法
function Lua_HeroTacticProxy:sTacticUpStar(item_id)
    local cmd = ProtoPublic_pb.Proto10241002();
    cmd.item_id = item_id;
    sendMsg(10241002, cmd);
end

-- 请求装卸战法
function Lua_HeroTacticProxy:sTacticChange(item_unique_id, hero_unique_id)
    local cmd = ProtoPublic_pb.Proto10241003();
    cmd.item_unique_id = item_unique_id; -- 道具唯一id
    if hero_unique_id ~= nil then
        cmd.hero_unique_id = hero_unique_id; -- 英雄唯一id
    end
    sendMsg(10241003, cmd);
end

-- 请求附魂战法
function Lua_HeroTacticProxy:sTacticAttach(inherit_id, attach_id)
    local cmd = ProtoPublic_pb.Proto10241004();
    cmd.inherit_id = inherit_id; -- 附魂道具id
    if attach_id ~= nil then
        cmd.attach_id = attach_id; -- 附魂给道具id
    end
    sendMsg(10241004, cmd);
end

-- 请求重生战法
function Lua_HeroTacticProxy:sTacticReset(item_unique_id)
    local cmd = ProtoPublic_pb.Proto10241005();
    cmd.item_unique_id = item_unique_id;
    sendMsg(10241005, cmd);
end

-- 请求战法羁绊界面
function Lua_HeroTacticProxy:sTacticFetter()
    sendMsg(10241006);
end

-- 请求升星战法羁绊
function Lua_HeroTacticProxy:sTacticFetterUp(fetter_id)
    local cmd = ProtoPublic_pb.Proto10241007();
    cmd.fetter_id = fetter_id;
    sendMsg(10241007, cmd);
end







----------------------------------------- 下行 -----------------------------------------

-- 请求升级战法(返回)
function Lua_HeroTacticProxy:rTacticUpgrade(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50241001();
        msg:ParseFromString(mp.data);
        DataCenter.heroTacticData:fromServer50241001(msg);
    end
end

-- 请求升星战法(返回)
function Lua_HeroTacticProxy:rTacticUpStar(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50241002();
        msg:ParseFromString(mp.data);
        DataCenter.heroTacticData:fromServer50241002(msg);
    end
end

-- 请求附魂战法(返回)
function Lua_HeroTacticProxy:rTacticAttach(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50241004();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATE_TACTIC_INFO", msg);
    end
end

-- 请求重生战法(返回)
function Lua_HeroTacticProxy:rTacticReset(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50241005();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATE_TACTIC_INFO", msg.item_unique_id);
    end
end

-- 请求战法羁绊界面(返回)
function Lua_HeroTacticProxy:rTacticFetter(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50241006();
        msg:ParseFromString(mp.data);
        DataCenter.heroTacticData:fromServer50241006(msg);
    end
end

-- 请求升星战法羁绊(返回)
function Lua_HeroTacticProxy:rTacticFetterUp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50241007();
        msg:ParseFromString(mp.data);
        DataCenter.heroTacticData:fromServer50241007(msg);
    end
end