-- 英雄战法 Util
Lua_HeroTacticUtil = class("Lua_HeroTacticUtil")
function Lua_HeroTacticUtil:ctor()
    self:dispose();
end

function Lua_HeroTacticUtil:dispose()
end

--------------------------- 常量配置 ---------------------------

-- 解锁星级
function Lua_HeroTacticUtil.Get:unlock_star()
    if self._unlock_star == nil then
        self._unlock_star = getConfig("fight_rule_const", "unlock_star", "json_value");
    end
    return self._unlock_star;
end

-- 重生消耗
function Lua_HeroTacticUtil.Get:rebirth_cost()
    return getConfig("fight_rule_const", "rebirth_cost", "json_value");
end

-- 重生返还比例
function Lua_HeroTacticUtil.Get:rebirth_lose()
    return getConfig("fight_rule_const", "rebirth_lose", "float_value");
end

-- 赋魂继承比例
function Lua_HeroTacticUtil.Get:inherit_rate()
    return getConfig("fight_rule_const", "inherit_rate", "float_value");
end

--------------------------- 升级配置 ---------------------------

function Lua_HeroTacticUtil:upgradeCost(tacticLvlId)
    return getConfig("fight_rule_lvl_prop", tacticLvlId, "lvlup_cost");
end

function Lua_HeroTacticUtil:upgradeProp(tacticLvlId)
    return getConfig("fight_rule_lvl_prop", tacticLvlId, "add_prop");
end

--------------------------- 升星配置 ---------------------------

function Lua_HeroTacticUtil:upstarCost(tacticStarId)
    return getConfig("fight_rule_star_prop", tacticStarId, "lvlup_cost");
end

function Lua_HeroTacticUtil:upstarProp(tacticStarId)
    return getConfig("fight_rule_star_prop", tacticStarId, "add_prop");
end

function Lua_HeroTacticUtil:getSkillId(tacticStarId)
    return getConfig("fight_rule_star_prop", tacticStarId, "skill");
end

--------------------------- 图鉴配置 ---------------------------

function Lua_HeroTacticUtil:fetterProp(starLvId)
    return getConfig("fight_rule_fetter", starLvId, "add_prop");
end












--------------------------- 升级 ---------------------------

function Lua_HeroTacticUtil:isMeetUpgradeCost(tacticLvlId)
    local list = self:upgradeCost(tacticLvlId);
    if list == nil then
        return false;
    end

    local packNum;
    for i = 1, #list do
        packNum = DataCenter.packData:getItemCountById(list[i][1]);
        if packNum < list[i][2] then
            return false;
        end
    end
    return true;
end

function Lua_HeroTacticUtil:totalUpgradeCostDic(tacticVo)
    local dic = {};
    local list;
    local id = tacticVo.lvl_prop * 1000;
    for i = tacticVo.min_level, tacticVo.tacticLevel - 1 do
        list = self:upgradeCost(id + i);
        for j = 1, #list do
            if dic[list[j][1]] == nil then
                dic[list[j][1]] = 0;
            end
            dic[list[j][1]] = dic[list[j][1]] + list[j][2];
        end
    end
    return dic;
end












--------------------------- 升星 ---------------------------

function Lua_HeroTacticUtil:isMeetUpstarCost(tacticStarId)
    local list = self:upstarCost(tacticStarId);
    if list == nil then
        return false;
    end

    local packNum;
    for i = 1, #list do
        packNum = DataCenter.packData:getItemCountById(list[i][1]);
        if packNum < list[i][2] then
            return false;
        end
    end
    return true;
end

function Lua_HeroTacticUtil:getChipLimitNum(tacticId, num)
    local vo = DataCenter.packData:getItemVoById(tacticId);
    if vo ~= nil then
        local list = self:upstarCost(vo.tacticStarId);
        if list ~= nil then
            for i = 1, #list do
                if list[i][1] == vo.chipId then
                    return list[i][2];
                end
            end
        end
    end
    return num;
end















--------------------------- 属性 ---------------------------

function Lua_HeroTacticUtil:getAttrVoArr(tacticLvlId, tacticStarId)
    local propList, dic;
    if tacticLvlId ~= nil then
        propList = self:upgradeProp(tacticLvlId);
        dic = DataCenter.attributesUtil:getAttrDic(propList);
    end
    if tacticStarId ~= nil then
        propList = self:upstarProp(tacticStarId);
        dic = DataCenter.attributesUtil:getAttrDic(propList, dic);
    end
    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic);
    else
        return Array();
    end
end

function Lua_HeroTacticUtil:upgradeAttrVoArr(tacticLvlId)
    local propList = self:upgradeProp(tacticLvlId);
    local dic = DataCenter.attributesUtil:getAttrDic(propList);

    local nextDic;
    propList = self:upgradeProp(tacticLvlId + 1);
    if propList ~= nil then
        nextDic = DataCenter.attributesUtil:getAttrDic(propList);
    end
    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
    else
        return Array();
    end
end

function Lua_HeroTacticUtil:upgradeUpAttrVoArr(tacticLvlId)
    local lastList = self:upgradeProp(tacticLvlId - 1);
    local curList = self:upgradeProp(tacticLvlId);
    local arr = Array();
    local vo;
    if lastList ~= nil and curList ~= nil then
        for k, v in pairs(curList) do
            vo = DataCenter.attributesUtil:createAttrVo(k);
            vo.value = v - lastList[k];
            arr:add(vo);
        end
    end
    return arr;
end









function Lua_HeroTacticUtil:upstarAttrVoArr(tacticStarId)
    local propList = self:upstarProp(tacticStarId);
    local dic = DataCenter.attributesUtil:getAttrDic(propList);

    local nextDic;
    propList = self:upstarProp(tacticStarId + 1);
    if propList ~= nil then
        nextDic = DataCenter.attributesUtil:getAttrDic(propList);
    end
    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
    else
        return Array();
    end
end












function Lua_HeroTacticUtil:fetterPropVoArr(starLvId)
    local propList = self:fetterProp(starLvId);
    local dic = DataCenter.attributesUtil:getAttrDic(propList);
    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic);
    else
        return Array();
    end
end

function Lua_HeroTacticUtil:fetterUpPropVoArr(starLvId)
    local propList = self:fetterProp(starLvId);
    local dic = DataCenter.attributesUtil:getAttrDic(propList);

    local nextDic;
    propList = self:fetterProp(starLvId + 1);
    if propList ~= nil then
        nextDic = DataCenter.attributesUtil:getAttrDic(propList);
    end
    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
    else
        return Array();
    end
end