-- 跳跳乐（后台）
Lua_JumpingHappyData = class("Lua_JumpingHappyData");
function Lua_JumpingHappyData:ctor()
	self:superCall("ctor");
end

function Lua_JumpingHappyData:dispose()
	self.costId = nil;
	self.costNum = nil;

	self.curBDeath = nil;
	self.levelInfo = nil;
	self._bTest = nil;
	self._blockInfo = nil;
	self._curJumpNum = nil;
	self._activity_id = nil;
	self._bPlayJumping = nil;
	self.instanceBlockInfoDic = nil;
	self.bCheckServerData = nil;
	self.model_dir = nil; -- 模型转向角度
	self.control_point = nil; -- 控制点控制系数
	self.origin_height = nil; -- 原地跳高度
	self.model_speed = nil; -- 运动速度
	self.avoid_num = nil; -- 防误触按压时间（帧）
	self.jump_time_ratio = nil; -- 跳跃轨迹运动时长相对按压时长比例
	self.press_time_limit = nil; -- 按压时长限制
	self.animation_time_pre = nil; -- 下蹲时长（秒）
	self.animation_time_up = nil; -- 起跳时长（秒）
	self.animation_time_down = nil; -- 下落时长（秒)
	self.animation_time_success = nil; -- 下落成功时长（秒）
	self.animation_time_fail = nil; -- 下落死亡时长（秒）
	self.animation_time_sky = nil; -- 空中时长（秒）
	self:superCall("dispose");
end

-- 请求浣熊跳跳乐界面(返回)
function Lua_JumpingHappyData:fromServer50108123(msg)
	if msg == nil then
		return;
	end
	
	local info = msg.type_info;
	self.levelInfo = {};
	for i = 1, #info do
		self.levelInfo[info[i].type_id] = info[i];
	end

	self.residueCount = msg.times; -- 可用挑战次数
	self.buy_times = msg.buy_times; -- 单次可购买次数上限

	local cost_item = msg.item_use;
	self.costId = tonumber(cost_item.key);
	self.costNum = tonumber(cost_item.value);

	self.ruleInfo = msg.explain;
	self.pressTime = msg.pressing_time;
	self.maxPressTime = msg.top_pressing_time;
	self.perJumpDistance = msg.jump_distance;
	self.maxLineNum = msg.max_line_num;
	self.model_dir = msg.model_dir; -- 模型转向角度
	self.control_point = msg.control_point; -- 控制点控制系数
	self.origin_height = msg.origin_height; -- 原地跳高度
	self.model_speed = msg.model_speed; -- 运动速度
	self.avoid_num = msg.avoid_num; -- 防误触按压时间（帧）
	self.jump_time_ratio = msg.jump_time_ratio; -- 跳跃轨迹运动时长相对按压时长比例
	self.press_time_limit = msg.press_time_limit; -- 按压时长限制
	self.animation_time_pre = msg.animation_time_pre; -- 下蹲时长（秒）
	self.animation_time_up = msg.animation_time_up; -- 起跳时长（秒）
	self.animation_time_down = msg.animation_time_down; -- 下落时长（秒)
	self.animation_time_success = msg.animation_time_success; -- 下落成功时长（秒）
	self.animation_time_fail = msg.animation_time_fail; -- 下落死亡时长（秒）
	self.animation_time_sky = msg.animation_time_sky; -- 空中时长（秒）

	self:setBlockInfo(msg.block_list);
end

-- 请求计算浣熊跳跳乐分数
function Lua_JumpingHappyData:fromServer50108127(msg)
	if msg == nil then
		return;
	end

	local levelId = msg.type_id;
	local levelInfo = self:getLevelInfoById(levelId);
	if levelInfo == nil then
		return;
	end

	self.curSorce = msg.score;
	self.historyScore = msg.top_score;
	self.curAddSorce = msg.add_score;

	local info = msg.game_info
	for i = 1, #info do
		self:setInstanceBlockInfo(info[i]);
	end
	self.curBDeath = msg.is_die == 1;
	self.curJumpNum = msg.jump_num;
	self.bCheckServerData = true;
end

-- 请求浣熊跳跳乐任务信息（返回）
function Lua_JumpingHappyData:fromServer50108124(msg)
	if msg == nil then
		return;
	end

	local info;
	local bCheck;
	local type = msg.type;
	for i = 1, #msg.task_info do
		info = msg.task_info[i];
		if info.info1 == 1 then
			bCheck = true;
			break;
		end
	end

	local redId = type == 1 and Lua_RedPointList.JumpHappy_Task_Day or Lua_RedPointList.JumpHappy_Task_Total;
	DataCenter.redPointData:updateRedPointState(redId, bCheck);
end

function Lua_JumpingHappyData.Set:activity_id(value)
	self._activity_id = value;
end

function Lua_JumpingHappyData.Get:activity_id()
	return self._activity_id;
end

-- 方块信息列表
function Lua_JumpingHappyData:setBlockInfo(itemInfo)
	if self._blockInfo == nil then
		self._blockInfo = {};
	end

	if itemInfo == nil then
		return;
	end

	local info;
	for i = 1, #itemInfo do
		info = itemInfo[i];
		self._blockInfo[info.block_id] = info;
	end
end

function Lua_JumpingHappyData:getBlockInfoById(id)
	if self._blockInfo == nil or id == nil then
		return;
	end

	return self._blockInfo[id];
end

function Lua_JumpingHappyData:getLevelInfoById(id)
	if self.levelInfo == nil or id == nil then
		return;
	end

	return self.levelInfo[id];
end

function Lua_JumpingHappyData:setInstanceBlockInfo(serverInfo)
	if self.instanceBlockInfoDic == nil then
		self.instanceBlockInfoDic = {};
	end

	local blockIndex = serverInfo.number;
	self.instanceBlockInfoDic[blockIndex] = serverInfo;
end

function Lua_JumpingHappyData:getInstanceBlockInfo(blockIndex)
	if blockIndex == nil or self.instanceBlockInfoDic == nil or self.instanceBlockInfoDic[blockIndex] == nil then
		return;
	end

	return self.instanceBlockInfoDic[blockIndex];
end

function Lua_JumpingHappyData.Get:curJumpNum()
	if self._curJumpNum == nil then
		self._curJumpNum = 0;
	end

	return self._curJumpNum;
end

function Lua_JumpingHappyData.Set:curJumpNum(value)
	self._curJumpNum = value;
end

function Lua_JumpingHappyData.Get:bTest()
	if self._bTest == nil then
		self._bTest = false;
	end

	return self._bTest;
end

function Lua_JumpingHappyData.Set:bTest(value)
	self._bTest = value;
end

function Lua_JumpingHappyData.Get:bPlayJumping()
	if self._bPlayJumping == nil then
		self._bPlayJumping = false;
	end

	return self._bPlayJumping;
end

function Lua_JumpingHappyData.Set:bPlayJumping(value)
	self._bPlayJumping = value;
end


















