-- 限时特惠礼包
checkRequire("Lua_LimitSpecialGiftGiftVo");
Lua_LimitSpecialGiftData = class("Lua_LimitSpecialGiftData");
function Lua_LimitSpecialGiftData:ctor()
	self:dispose();
end

function Lua_LimitSpecialGiftData:dispose()
	self.limitSpecialGiftDic = {}; -- key礼包id value配置表数据+服务端数据
	self._limitStageArr = Array(); -- 礼包类型集合
	self.giftIdsArr = Array(); -- 未结束活动id集合
	self.recordPopupId = nil; -- 记录要弹出的礼包id
	Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
end

function Lua_LimitSpecialGiftData:fromServer50197063(msg)
	if msg == nil then
		return;
	end
	self:updateGiftState(msg.gift_state);
end

function Lua_LimitSpecialGiftData:fromServer80197063(msg)
	if msg == nil then
		return;
	end
	self:updateGiftState(msg.gift_state);
end

function Lua_LimitSpecialGiftData:updateGiftState(list)
	local obj, vo, endTime, minTime;
	local maxTime = 0;
	self._limitStageArr:clear();
	self.giftIdsArr:clear();
	for i = 1, #list do
		obj = list[i];
		vo = self:getLimitSpecialGiftVo(obj.gift_id);
		if vo ~= nil then
			vo:updateServerInfo(obj);

			endTime = vo.endTime;
			maxTime = endTime > maxTime and endTime or maxTime;
			if endTime > 0 then
				if minTime == nil or minTime > endTime then
					minTime = endTime;
				end
				if self._limitStageArr:indexOf(vo.giftStage) == -1 then
					self._limitStageArr:add(vo.giftStage);
				end
				self.giftIdsArr:add(obj.gift_id);
			end
			if obj.is_open == 1 then -- is_open 是否弹出新弹窗 0不弹出 1弹出
				self:judgePopupInfo(obj.gift_id);
			end
		end
	end
	self._limitStageArr:sort(nil, false);
	self:checkPopupInfo();
	self:checkGiftEndInfo(maxTime, minTime);
end

function Lua_LimitSpecialGiftData:getLimitSpecialGiftVo(giftId)
	if giftId == nil then
		return;
	end

	local vo = self.limitSpecialGiftDic[giftId];
	if vo == nil then
		local config = getConfig("time_limit_special_gift", giftId);
		if config then
			vo = Lua_LimitSpecialGiftGiftVo.new(giftId);
			self.limitSpecialGiftDic[giftId] = vo;
		end
	end
	return vo;
end

-- 只弹期数最大的礼包，有多个同期数只弹礼包id最大的
function Lua_LimitSpecialGiftData:judgePopupInfo(newGiftId)
	if self.recordPopupId then
		local recordVo = self:getLimitSpecialGiftVo(self.recordPopupId);
		local newVo = self:getLimitSpecialGiftVo(newGiftId);
		if (recordVo.giftStage == newVo.giftStage and self.recordPopupId < newGiftId) or recordVo.giftStage < newVo.giftStage then
			self.recordPopupId = newGiftId;
		end
	else
		self.recordPopupId = newGiftId;
	end
end

function Lua_LimitSpecialGiftData:checkPopupInfo()
	-- print("checkPopupId", self.recordPopupId);
	if DataCenter.sceneData.curSceneId == Lua_SceneDefine.MAINCITY and self.recordPopupId then
		Lua_WindowUtil.openWin("Lua_LimitSpecialGiftWindow", Lua_WinParam.ACTION_OPEN, self.recordPopupId);
		self.recordPopupId = nil;
	end
end

function Lua_LimitSpecialGiftData:checkGiftEndInfo(maxTime, minTime)
	DataCenter.mainMenuData:setIconShowInfo(Lua_MenuViewDefine.ICON_LIMIT_SPECIAL_GIFT, maxTime > 0, maxTime);
	Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	if minTime and minTime > 0 then
		Lua_CommonUtil.delayCall(minTime, self, self.updateLeftTime);
	end
end

function Lua_LimitSpecialGiftData:updateLeftTime()
	self.isRefreshEndGift = true; -- 把失效礼包移除
	Lua_ProxyManager.getProxy("Lua_LimitSpecialGiftProxy"):sLimitSpecialGiftInfo();
end

function Lua_LimitSpecialGiftData.Get:limitStageArr()
	return self._limitStageArr;
end

function Lua_LimitSpecialGiftData:getGiftShowArr(giftStage)
	local vo;
	local arr = Array();
	for i = 1, self.giftIdsArr:getSize() do
		vo = self:getLimitSpecialGiftVo(self.giftIdsArr[i]);
		if vo.giftStage == giftStage then
			arr:add(self.giftIdsArr[i]);
		end
	end
	arr:sort(nil, false);
	return arr;
end