Lua_LimitSpecialGiftGiftVo = class("Lua_LimitSpecialGiftGiftVo");
function Lua_LimitSpecialGiftGiftVo:ctor(id)
	self.id = id; -- 礼包id/充值id
end

function Lua_LimitSpecialGiftGiftVo:dispose()
	self._closeTick = nil;
	self._leftTimes = nil;
	self._recordId = nil;
	self._config = nil;
	self._money = nil;
end

function Lua_LimitSpecialGiftGiftVo:updateServerInfo(msg)
	self._closeTick = msg.close_tick; -- 礼包关闭时间戳
	self._leftTimes = msg.times; -- 礼包剩余次数
	self._recordId = msg.record_id; -- 战斗记录id
end

function Lua_LimitSpecialGiftGiftVo.Get:closeTick()
	return self._closeTick or 0;
end

function Lua_LimitSpecialGiftGiftVo.Get:leftTimes()
	return self._leftTimes or 0;
end

function Lua_LimitSpecialGiftGiftVo.Get:recordId()
	return self._recordId or 0;
end

function Lua_LimitSpecialGiftGiftVo.Get:endTime()
	return self.closeTick - DataCenter.roleData.serverTime;
end





------------------------- 配置 -------------------------

function Lua_LimitSpecialGiftGiftVo.Get:config()
	if self._config == nil then
		self._config = getConfig("time_limit_special_gift", self.id);
		if self._config == nil then
			LogManager.LogError("no time_limit_special_gift config id：" .. self.id, false);
		end
	end
	return self._config;
end

-- 礼包名字
function Lua_LimitSpecialGiftGiftVo.Get:giftName()
	return self.config.gift_name;
end

-- 礼包期数
function Lua_LimitSpecialGiftGiftVo.Get:giftStage()
	return self.config.gift_stage;
end

-- 金额
function Lua_LimitSpecialGiftGiftVo.Get:money()
	if self._money == nil then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.id);
		self._money = tonumber(rechargeInfo.money);
	end
	return self._money;
end

-- 限购总次数
function Lua_LimitSpecialGiftGiftVo.Get:totalTimes()
	return self.config.limit_times;
end

-- 奖励道具
function Lua_LimitSpecialGiftGiftVo.Get:rewardItem()
	return self.config.reward_item;
end

-- 返利数值
function Lua_LimitSpecialGiftGiftVo.Get:sloganValue()
	return self.config.slogan_value;
end

-- 是否展示道具图片
function Lua_LimitSpecialGiftGiftVo.Get:isShowIcon()
	return self.config.is_show_icon == 1;
end

-- 展示道具图片的缩放
function Lua_LimitSpecialGiftGiftVo.Get:showIconScale()
	return self.config.show_icon_scale;
end

-- 展示道具图片
function Lua_LimitSpecialGiftGiftVo.Get:showIcon()
	return self.config.show_icon;
end

-- 标题1位置
function Lua_LimitSpecialGiftGiftVo.Get:titlePos_1()
	return self.config.title_pos_1;
end

-- 标题2位置
function Lua_LimitSpecialGiftGiftVo.Get:titlePos_2()
	return self.config.title_pos_2;
end

-- 标题1图片
function Lua_LimitSpecialGiftGiftVo.Get:titleIcon_1()
	return self.config.title_icon_1;
end

-- 标题2图片
function Lua_LimitSpecialGiftGiftVo.Get:titleIcon_2()
	return self.config.title_icon_2;
end

-- 立绘路径
function Lua_LimitSpecialGiftGiftVo.Get:portraitUrl()
	return self.config.portrait_url;
end

-- 立绘位置
function Lua_LimitSpecialGiftGiftVo.Get:portraitPos()
	return self.config.portrait_pos;
end

-- 背景
function Lua_LimitSpecialGiftGiftVo.Get:bgUrl()
	return self.config.bg_url;
end

-- 背景位置
function Lua_LimitSpecialGiftGiftVo.Get:bgPos()
	return self.config.bg_pos;
end