-- 幸运礼盒
checkRequire("Lua_LuckyGiftBoxTaxkVo");
Lua_LuckyGiftBoxData = class("Lua_LuckyGiftBoxData");
function Lua_LuckyGiftBoxData:ctor()
	self:dispose();
end

function Lua_LuckyGiftBoxData:dispose()
	self.isShowOpenTween = false; -- 是否播放开启动画（每轮一次，选择终极奖励才开始）
	self.showCount = 0;
	self.drawCount = 0;
	self.curGiftIdx = nil; -- 此次开启的奖励位置索引
	self._isDrawBestGIft = false;
	self.showInfoDic = {};
	self.luckyBoxInfoDic = {};

	self.advance_gift_id = nil;

	self.curSelectIdx = nil;
	self.bestGiftInfoDic = {};

	self.taskInfoDic = {};
	self._taskInfoArr = Array();
end

-- 幸运礼盒界面信息
function Lua_LuckyGiftBoxData:fromServer50108012(msg)
	if msg == nil then
		return;
	end

	if self.advance_gift_id == 0 and msg.advance_gift_id ~= 0 then
		self.isShowOpenTween = true;
	end
	if #msg.reward_state == 0 then -- 开始新的一轮
		self.showInfoDic = {};
		self.luckyBoxInfoDic = {};
		self._isDrawBestGIft = false;
	end

	self.is_last_round = msg.is_last_round; -- 是否最后一轮：0否 1是
	self.advance_gift_id = msg.advance_gift_id; -- 终极礼盒道具id
	self.advance_gift_amount = msg.advance_gift_amount; -- 终极奖励道具数量
	self.cost_item_id = msg.cost_item_id; -- 活动道具id
	self.cost_item_num = msg.cost_item_num; -- 活动道具消耗数量

	self.recharge_item_id = msg.recharge_item_id; -- 钻石id
	self.discount_recharge_item_num = msg.discount_recharge_item_num; -- 折扣钻石消耗数量
	self.discount_residue_times = msg.discount_residue_times; -- 折扣钻石兑换剩余次数
	self.discount_max_times = msg.discount_max_times; -- 折扣钻石使用上限次数
	self.recharge_item_num = msg.recharge_item_num; -- 原价钻石消耗数量
	self.cost_residue_times = msg.cost_residue_times; -- 原价钻石兑换剩余次数
	self.cost_max_times = msg.cost_max_times; -- 原价钻石使用上限次数

	self.diamondLeftTimes = msg.discount_residue_times + msg.cost_residue_times;
	self.diamondTotalTimes = msg.discount_max_times + msg.cost_max_times;
	
	self.icon_config = msg.icon_config; -- 额外配置
	self.posList = msg.award_show; -- 奖励展示排列信息[行，列]
	self.show_box_item = msg.show_box_item; -- 展示奖励道具

	self.showCount = #msg.show_box_item; -- 礼盒展示最大数量
	self.drawCount = #msg.reward_state; -- 已抽的礼盒个数

	local obj;
	for i = 1, #msg.show_box_item do
		obj = msg.show_box_item[i];
		self.showInfoDic[obj.other] = obj;
	end

	local vo;
	for i = 1, #msg.reward_state do
		obj = msg.reward_state[i];
		vo = self.luckyBoxInfoDic[obj.cell_index];
		if vo == nil then
			self.curGiftIdx = obj.cell_index;
			self.luckyBoxInfoDic[obj.cell_index] = obj;
		end
		if obj.gift_item.id == msg.advance_gift_id and obj.gift_item.amount == msg.advance_gift_amount then
			self._isDrawBestGIft = true;
		end
	end
end

function Lua_LuckyGiftBoxData.Get:costType()
	local hasCount = DataCenter.packData:getItemCountById(self.cost_item_id);
	local _costType = 0;
	if hasCount >= self.cost_item_num then
		_costType = 1;
	else
		if self.discount_residue_times > 0 then
			_costType = 2;
		elseif self.cost_residue_times > 0 then
			_costType = 3;
		end
	end
	return _costType;
end

function Lua_LuckyGiftBoxData.Get:curItemId()
	if self.costType == 1 then
		return self.cost_item_id;
	elseif self.costType == 2 then
		return self.recharge_item_id;
	else
		return self.recharge_item_id;
	end
end

function Lua_LuckyGiftBoxData.Get:curItemCount()
	if self.costType == 1 then
		return self.cost_item_num;
	elseif self.costType == 2 then
		return self.discount_recharge_item_num;
	else
		return self.recharge_item_num;
	end
end

function Lua_LuckyGiftBoxData.Get:curDiamondCount()
	if self.discount_residue_times > 0 then
		return self.discount_recharge_item_num;
	else
		return self.recharge_item_num;
	end
end

-- 判断终极奖励是否抽中
function Lua_LuckyGiftBoxData.Get:isDrawBestGIft()
	return self._isDrawBestGIft;
end

-- 终极礼盒界面信息
function Lua_LuckyGiftBoxData:fromServer50108017(msg)
	if msg == nil then
		return;
	end

	self.round = msg.round; -- 当前轮次
	self.advance_gift_id = msg.advance_gift_id; -- 终极奖励道具id
	self.advance_gift_amount = msg.advance_gift_amount; -- 终极奖励道具数量

	local obj;
	for i = 1, #msg.advance_gift_state do
		obj = msg.advance_gift_state[i];
		if self.bestGiftInfoDic[obj.round] == nil then
			self.bestGiftInfoDic[obj.round] = {};
		end
		self.bestGiftInfoDic[obj.round][obj.cell_index] = obj;
	end
	self.curSelectIdx = self:getCurSelectIdx(self.bestGiftInfoDic[msg.round]);
end

-- 当前终极奖励道具索引
function Lua_LuckyGiftBoxData:getCurSelectIdx(data)
	local idx = 1;
	for i = 1, #data do
		if data[i].gift_id == self.advance_gift_id and data[i].gift_amount == self.advance_gift_amount then
			idx = i;
			break;
		end
	end
	return idx;
end

-- 幸运礼盒任务信息
function Lua_LuckyGiftBoxData:fromServer50108052(msg)
	if msg == nil then
		return;
	end


	local obj;
	local vo;
	self._taskInfoArr:clear();
	for i = 1, #msg.task_info do
		obj = msg.task_info[i];
		self._taskInfoArr:add(obj.info3);

		vo = self.taskInfoDic[obj.info3];
		if vo == nil then
			vo = Lua_LuckyGiftBoxTaxkVo.new();
			self.taskInfoDic[obj.info3] = vo;
		end
		vo:updateLuckyGiftBoxTaskVo(obj);
	end
	self:updateGiftBoxTaskRedDot();
end

function Lua_LuckyGiftBoxData:getLuckyGiftBoxTaskVoInfo(id)
	return self.taskInfoDic[id];
end

function Lua_LuckyGiftBoxData.Get:taskInfoArr()
	self._taskInfoArr:sortf(self, self.sortFun);
	return self._taskInfoArr;
end

function Lua_LuckyGiftBoxData:sortFun(a, b)
	local voA = self:getLuckyGiftBoxTaskVoInfo(a);
	local voB = self:getLuckyGiftBoxTaskVoInfo(b);
	if voA.openState == voB.openState then
		if voA.openState then
			if voA.drawState == voB.drawState then
				if voA.drawState == 1 then
					return voA.taskId < voB.taskId;
				else
					if (voA.curProcess >= voA.totalProgress and voB.curProcess >= voB.totalProgress)
						or (voA.curProcess < voA.totalProgress and voB.curProcess < voB.totalProgress) then
							return voA.taskId < voB.taskId;
					else
						if voA.curProcess < voA.totalProgress then
							return false;
						end
					end
				end
			else
				if voA.drawState == 1 then
					return false;
				end
			end
		else
			return voA.taskId < voB.taskId;
		end
	else
		if not voA.openState then
			return false;
		end
	end
	return true;
end

-- 刷新幸运礼盒任务
function Lua_LuckyGiftBoxData:fromServer80108054(msg)
	if msg == nil then
		return;
	end
	self.taskInfoDic[msg.info3]:updateLuckyGiftBoxTaskVo(msg);
	self:updateGiftBoxTaskRedDot();
end

function Lua_LuckyGiftBoxData:updateGiftBoxTaskRedDot()
	local vo;
	local redDotState = false;
	for i = 1, self._taskInfoArr:getSize() do
		vo = self:getLuckyGiftBoxTaskVoInfo(self._taskInfoArr[i]);
		if not redDotState and vo.drawState == 0 and vo.curProcess >= vo.totalProgress then
			redDotState = true;
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LuckyGiftBox_Task, redDotState);
end