-- 豪礼兑换 Data
Lua_LuxuryCashData = class("Lua_LuxuryCashData");
Lua_LuxuryCashData.norType = 1; -- 普通兑换
Lua_LuxuryCashData.advType = 2; -- 高级兑换

function Lua_LuxuryCashData:ctor()
	self:dispose();
end

function Lua_LuxuryCashData:dispose()
end

function Lua_LuxuryCashData:fromServer50108131(msg)
	self.actIdx = msg.act_index; -- 活动索引
	self.closeTime = msg.close_show; -- 结束掉落时间戳
	self.rewardList = msg.show_reward; -- 展示奖励
	self.costList = msg.cost_item; -- 活动兑换道具

	self._costDic = {};
	local vo;
	for i = 1, #self.costList do
		vo = Lua_ToolVo.createToolVo(self.costList[i].value);
		self._costDic[self.costList[i].key] = vo;
	end

	self._shopDic = {};
	for i = 1, #msg.cash_item do
		vo = msg.cash_item[i];
		if self._shopDic[vo.grade] == nil then
			self._shopDic[vo.grade] = Array();
		end
		self._shopDic[vo.grade]:add(vo);
	end
	self:checkShopRedDot();
	Lua_MsgUtil.callFunc("UPDATE_LUXURYCASH_INFO");
end

function Lua_LuxuryCashData:getCostItemVo(_type)
	local vo;
	if self._costDic ~= nil then
		vo = self._costDic[_type];
	end
	return vo or {};
end

function Lua_LuxuryCashData:getShopItemArr(_type)
	local arr;
	if self._shopDic ~= nil then
		arr = self._shopDic[_type];
	end
	return arr or Array();
end

function Lua_LuxuryCashData:checkShopRedDot()
	local showType;
	local itemId;
	local arr;
	local packNum;
	local redState;
	for i = 1, #self.costList do
		showType = self.costList[i].key;
		itemId = self.costList[i].value;
		arr = self:getShopItemArr(showType);
		packNum = DataCenter.packData:getItemCountById(itemId);
		redState = false;
		for j = 1, arr:getSize() do
			if arr[j].recommend == 1 and arr[j].limit_times > arr[j].times and packNum >= arr[j].recharge then
				redState = true;
				break;
			end
		end
		DataCenter.redPointData:updateRedPointState("LuxuryCash_Shop" .. i, redState);
	end
end

function Lua_LuxuryCashData:fromServer50108135(msg)
	if msg == nil then
		return;
	end

	local redState = false;
	for i = 1, #msg.task_info do
		if not redState and msg.task_info[i].info1 == 1 then
			redState = true;
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LuxuryCash_Task, redState);
end