Lua_MainMenuTipsPanel = class("Lua_MainMenuTipsPanel", Lua_DisplayObject)
function Lua_MainMenuTipsPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_MainMenuTipsPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.showList = Array();
    self.hideList = Array();

    self:addLuaEvent("INFINITYHALL_BUFF_CHOOSE", self, self.onInfinityHallTips);
    self:addLuaEvent("FORMTEAMCOMPELTITION_APPLICATION_TIP", self, self.onFormTeamCompetitionTips);
    self:addLuaEvent("WILD_SECRET_LODE_REPORT", self, self.onWildSecretLodeReport);
    self:onWildSecretLodeReport();
end

function Lua_MainMenuTipsPanel:dispose()
    if self.showList then
        self.showList:dispose();
        self.showList:clear();
        self.showList = nil;
    end
    if self.hideList then
        self.hideList:dispose();
        self.hideList:clear();
        self.hideList = nil;
    end
    self.infinityHallItem = nil;
    self.formTeamCompetitionItem = nil;
    self.tipsIcon = nil;
    self.lodeTipsIcon = nil;
    self:superCall("dispose");
end

function Lua_MainMenuTipsPanel:onInfinityHallTips(recordId)
    if recordId == nil then
        if self.infinityHallItem then
            self:returntItem(self.infinityHallItem);
            self.infinityHallItem = nil;
        end
    else
        if self.infinityHallItem == nil then
            self.infinityHallItem = self:createItem();
        end
        self.infinityHallItem:setData(1, recordId);
    end
    self:checkTipsIcon();
end

function Lua_MainMenuTipsPanel:onFormTeamCompetitionTips(state)
    if state == 1 then
        if self.formTeamCompetitionItem == nil then
            self.formTeamCompetitionItem = self:createItem();
            self.formTeamCompetitionItem:setData(2);
        end
    else
        if self.formTeamCompetitionItem then
            self:returntItem(self.formTeamCompetitionItem);
            self.formTeamCompetitionItem = nil;
        end
    end
    self:checkTipsIcon();
end

function Lua_MainMenuTipsPanel:createItem()
    local len = self.hideList:getSize();
    local item;
    if len > 0 then
        item = self.hideList:remove();
        item:setEnable(true);
    else
        item = Lua_MainMenuTipsItem.new(self.content);
        item:setRectSize(281, 243);
    end
    self.showList:add(item);
    return item;
end

function Lua_MainMenuTipsPanel:returntItem(item)
    local len = self.showList:getSize();
    for i = 1, len do
        if self.showList[i] == item then
            item:setEnable(false);
            self.showList:remove(i);
            self.hideList:add(item);
            break;
        end
    end
end

function Lua_MainMenuTipsPanel:checkTipsIcon()
    local len = self.showList:getSize();
    if len > 0 then
        if self.tipsIcon == nil then
            self.tipsIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_zjm_btn_012", 65, 305, 0, 0);
            self.tipsIcon.anchorValue = 6;
        end
        self.tipsIcon:setEnable(true);
    else
        if self.tipsIcon then
            self.tipsIcon:setEnable(false);
        end
    end

    local item;
    for i = 1, len do
        item = self.showList[i];
        item:setEnable(true);
        item:setRectAnchor(6);
        item:setLocation(177.5, 343 + (i - 1) * 70, 0);
    end
end

function Lua_MainMenuTipsPanel:onWildSecretLodeReport()
    if DataCenter.wildSecretData.reportList ~= nil then
        if self.lodeTipsIcon == nil then
            self.lodeTipsIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_zjm_btn_015", 125, 305, 0, 0);
            self.lodeTipsIcon.anchorValue = 6;
            self.lodeTipsIcon:addClickFuntion(self, self.onWildSecretLodeReportClick);
        end
        self.lodeTipsIcon:setEnable(true);
    else
        if self.lodeTipsIcon then
            self.lodeTipsIcon:setEnable(false);
        end
    end
end

function Lua_MainMenuTipsPanel:onWildSecretLodeReportClick(go)
    self.lodeTipsIcon:setEnable(false);
    Lua_WindowUtil.openWin("Lua_WildLodeTipsWindow", Lua_WinParam.ACTION_OPEN, DataCenter.wildSecretData.reportList);
end










Lua_MainMenuTipsItem = class("Lua_MainMenuTipsItem", Lua_DisplayObject)
function Lua_MainMenuTipsItem:ctor(p)
    self:superCall("ctor", p, "MainMenuTipsItem_skin");
end

function Lua_MainMenuTipsItem:buildShowItem()
    self:superCall("buildShowItem");
    self.tipsBg:addClickFuntion(self, self.onTipsClick)
end

function Lua_MainMenuTipsItem:dispose()
    self.key = nil;
    self.data = nil;
    self:superCall("dispose");
end

function Lua_MainMenuTipsItem:setData(key, data)
    self.key = key;
    self.data = data;
    if key == 1 then
        -- 无尽火域
        self.tipsText:setLangValue(304041);
    elseif key == 2 then
        -- 组队赛
        self.tipsText:setLangValue(772113);
    end
end

function Lua_MainMenuTipsItem:onTipsClick(go)
    if self.key == 1 then
        DataCenter.fightData:checkBuffChoose(self.data)
    elseif self.key == 2 then
        local tipsData = { 
            des = LanUtil.getValue(772114), btnType = 1, owner = self, sureLabel = LanUtil.getValue(772115),
            cancelFun = self.removeFormTips, sureFun = self.openFormWin };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
    end
end

function Lua_MainMenuTipsItem:removeFormTips()
    Lua_MsgUtil.callFunc("FORMTEAMCOMPELTITION_APPLICATION_TIP", 0);
end

function Lua_MainMenuTipsItem:openFormWin()
    Lua_WindowUtil.openWin("Lua_FormTeamCompetitionMainWindow", Lua_WinParam.ACTION_OPEN, 2);
    self:removeFormTips();
end