checkRequire("Lua_FuncOpenUtil");
checkRequire("Lua_FuncOpenData");
checkRequire("Lua_MainMenuIconData");
checkRequire("Lua_NeverTipData");
checkRequire("Lua_RewardConfigData");
checkRequire("Lua_FuncPathUtil")
checkRequire("Lua_FuncPlayUtil");
Lua_MainViewProxy = class("Lua_MainViewProxy");
function Lua_MainViewProxy:ctor()
	DataCenter.funcOpenUtil = Lua_FuncOpenUtil.new();
	DataCenter.funcOpenData = Lua_FuncOpenData.new();
	DataCenter.mainMenuData = Lua_MainMenuIconData.new();
	DataCenter.neverTipData = Lua_NeverTipData.new();
	DataCenter.funcPlayUtil = Lua_FuncPlayUtil.new();
	DataCenter.funcPathUtil = Lua_FuncPathUtil.new();

	Lua_MsgUtil.addEventListener("FUNCTION_OPEN", self, self.onFuncOpen);
	Lua_MsgUtil.addEventListener("MENUICON_ALL_UPDATE", self, self.onUpdateTopIcon);
	Lua_MsgUtil.addEventListener("WIN_SHOW_COMPLETE", self, self.onWinShowCompleted);

	Lua_MsgUtil.addLuaMsg(50115001, self, self.rFuncOpenInfo); -- 功能开启信息（返回）
	Lua_MsgUtil.addLuaMsg(50115002, self, self.rFuncOpenReward); -- 请求功能开启奖励(返回)
	Lua_MsgUtil.addLuaMsg(50115003, self, self.rFuncOpenTipsClose); -- 请求关闭功能弹窗(返回)

	Lua_MsgUtil.addLuaMsg(80115001, self, self.updateFuncOpen); -- 通知功能开启信息
	Lua_MsgUtil.addLuaMsg(80115002, self, self.updateNewFuncOpen); -- 通知新功能开启
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听
-- 游戏中功能开启请求服务端数据
-- 1、打开界面不用实时请求服务端数据
-- 2、计算红点
function Lua_MainViewProxy:onFuncOpen(openDic)
	if openDic == nil then
		return;
	end
	if openDic[10002] == 1 then -- 英雄
		DataCenter.heroData:checkHeroRedDotState();--英雄主线阵容红点
		DataCenter.heroData:checkHeroCarRedDotState();--英雄背包闪卡红点
		DataCenter.heroAtlasData:checkAtlasCarRedDotState();--英雄图鉴闪卡红点
	end
	if openDic[10003] == 1 then -- 主线推图
		Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sMainLineInfo();
	end
	if openDic[10016] == 1 then -- 每日签到
		Lua_ProxyManager.getProxy("Lua_WelfareProxy"):sSignInInfo();
	end
	if openDic[10095] == 1 then -- 主线挂机
		Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sHookInfo();
	end
	if openDic[10221] == 1 then -- 主线推图
		Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sTaskInfo();
	end
	if openDic[10182] == 1 then -- 首充请求
		Lua_ProxyManager.getProxy("Lua_FirstRechargeProxy"):sFirstRechargeInfo();
	end
	if openDic[10220] == 1 then -- 主线快速战斗
		DataCenter.hookData:checkFastFightRedPoint();
	end
	if openDic[10028] == 1 then -- 主线任务
		Lua_ProxyManager.getProxy("Lua_TaskProxy"):sExploreTourInfo();
	end
	if openDic[10092] == 1 then -- 边境远征
		Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sExpeditionInfo();
	end
	if openDic[10188] == 1 then -- 通天塔
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerInfo(0);
	end
	if openDic[10194] == 1 then -- 任务
		Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskInfo();
	end
	if openDic[10235] == 0 and Lua_WindowUtil.isWindowShowing("Lua_StarTrialWindow") then -- 星魂试炼
		Lua_MsgUtil.callFunc("CLOSE_TRIALBTN");
	end
	if openDic[10149] == 1 then -- 英雄之力
		Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sStatue();
	end
	if openDic[10195] == 1 then -- 无穷战殿
		Lua_ProxyManager.getProxy("Lua_InfinityHallProxy"):sInfinityHall(0);
	end
	if openDic[10210] == 1 then -- 命格
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sFateInfo();
	end
	if openDic[10209] == 1 then -- 神器
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sArtifactInfo();
	end
	-- if openDic[10211] == 1 then -- 神器幻化
	-- 	Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sClothesInfo();
	-- end
	if openDic[10227] == 1 then -- 星河殿
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sChapterInfo();
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(0);
	end
	if openDic[10235] == 1 then
		Lua_ProxyManager.getProxy("Lua_LimitedTimeActivityProxy"):sStarRiverTrialInfo(0);
	end
	if openDic[10017] == 1 then
		Lua_ProxyManager.getProxy("Lua_VipProxy"):sGetVipPanelInfo();
	end
	if openDic[10019] == 1 then -- 八日登录
		Lua_ProxyManager.getProxy("Lua_SevenDayProxy"):sSevenDaySigInInfo();
	end
	if openDic[10256] == 1 then -- 每日特惠
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sDailyDiscountInfo();
	end
	if openDic[10192] == 1 then -- 新服专享
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sNewServeGiftInfo();
	end
	if openDic[10025] == 1 then -- 每日充值
		Lua_ProxyManager.getProxy("Lua_DailyRechargeProxy"):sDailyRechargeInfo();
	end
	if openDic[10010] == 1 then -- 每日礼包
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sDailyGiftInInfo();
	end
	if openDic[10202] == 1 then -- 每周礼包
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sWeeklyGiftInInfo();
	end
	if openDic[10203] == 1 then -- 每月礼包
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthlyGiftInInfo();
	end
	if openDic[10242] == 1 then -- 开服竞技
		DataCenter.OpenServiceAthleticsData:updateRedPoint(true);
	end
	if openDic[10257] == 1 then -- 成长投资
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sInvestmentLogin();
	end
	if openDic[10241] == 1 then -- 百抽盛典
		Lua_ProxyManager.getProxy("Lua_HundredCeremonyProxy"):sHundredCeremonyInfo();
	end
	if openDic[10247] == 1 then -- 独家企划
		Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sExclusivePlanInfo();
		Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetTaskInfo();
	end
	if openDic[10226] == 1 then -- 特卖店(红点)
		Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(Lua_ShopData.SPIRIT_SHOP);
	end
	if openDic[10204] == 1 then -- 普通幸运转盘
		Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sLuckyTurntableInfo(Lua_LuckyTurntableData.ordinaryTurnTable);
	end
	if openDic[10205] == 1 then -- 高级幸运转盘
		Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sLuckyTurntableInfo(Lua_LuckyTurntableData.seniorTurnTable);
	end
	if openDic[10218] == 1 then -- 藏品柜
		-- Lua_ProxyManager.getProxy("Lua_CollectionProxy"):sCollectionInfo();
		Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetInfo();
		Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetPrizeDrawInfo(1);
		Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetPrizeDrawInfo(2);
	end
	if openDic[10222] == 1 then -- 魔灵岛
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sEquipCopy();
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sFirstPassRankInfo();
	end
	if openDic[10076] == 1 then -- 小卖部
		Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sWishBlessInfo();-- 老客回顾
		Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitMain();
	end
	if openDic[10223] == 1 then -- 活跃战令
		Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarInfo(0);
	end
	if openDic[10245] == 1 then -- 昆墟圣地
		Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sGetKunXuInfo(0); --请求活动界面信息:首次开启标志 0跳过 1开启
		if DataCenter.funcOpenData:isOpened(10246) then
			Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sWarOrderInfo(6);--昆墟战令
		end
	end
	if openDic[10240] == 1 then -- 专属订阅
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sPersonReadInfo();
	end
	if openDic[10249] == 1 then -- 炼金坊
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sAlchemyInfo();
	end
	if openDic[10212] == 1 or openDic[10213] == 1 or openDic[10214] == 1 or openDic[10215] == 1 or openDic[10216] == 1 then -- 日常试炼
		Lua_ProxyManager.getProxy("Lua_TrialProxy"):refreshRedPoint();
	end
	if openDic[10252] == 1 then -- 精英赛
		Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sWinInfo();
	end
	if openDic[10239] == 1 then -- 收藏册
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBPageInfo();
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBOrdinaryCardInfo();
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sAdmireOtherPlayer(0); 
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBRankInfo(); --红点
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sHeroFetter(); -- 更新角色信息
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sFlashCardDetailProp(0); 
	end
	if openDic[10281] == 1 then -- 问卷有礼
		Lua_ProxyManager.getProxy("Lua_QuestionProxy"):sQuestion();
	end
	if openDic[10282] == 1 then -- 英雄赠礼
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sOpenServerHeroGiftInfo();
	end
	if openDic[10283] == 1 then -- 英雄降临
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroComeInfo();
	end
	if openDic[10286] == 1 then -- 英雄挑战
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeInfo();
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeTaskInfo();
	end
	if openDic[10284] == 1 then -- 巅峰对决
		Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDInfo();
	end
	if openDic[10285] == 1 then -- 古城秘藏
		Lua_ProxyManager.getProxy("Lua_TownTreasureProxy"):sActivityInfo();
		Lua_ProxyManager.getProxy("Lua_TownTreasureProxy"):sTaskInfo();
	end
	-- if openDic[10287] == 1 or openDic[10288] == 1 then -- 公会交易行
	-- 	if DataCenter.roleData.league_id ~= 0 then
	-- 		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance();
	-- 	end
	-- end
	-- 联盟-心愿墙
	if openDic[10007] == 1 or openDic[10309] == 1 then
		if DataCenter.roleData.league_id ~= 0 then
			Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueWishWallInfo(0);
			Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueWishWallTaskInfo();
		end
	end
	if openDic[10277] == 1 then -- 公会对抗
		if DataCenter.roleData.league_id ~= 0 then
			Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteInfo();
			Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteReward();
		end
	end
	if openDic[10206] == 1 then -- 英雄集结
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sHeroGatherInfo();
	end
	if openDic[10207] == 1 then -- 积天豪礼
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sCumulateGiftInfo(0);
	end
	if openDic[10290] == 1 then -- 神域试炼
		Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sGetDivineDomainInfo(0);
		Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sGetAcheiveRewardInfo(Lua_DivineDomainTrialUtil.FIGHTING_REWARD);
		Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sGetAcheiveRewardInfo(Lua_DivineDomainTrialUtil.ACHIEVEMENT_REWARD);
		Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sNoticeBossReset() 
	end
	if openDic[10291] == 1 then -- 扭蛋机
		DataCenter.gashaponData:updateMoreDrawRedDot();
		Lua_ProxyManager.getProxy("Lua_GashaponProxy"):sGashaponInfo();
	end
	if openDic[10292] == 1 then -- 图腾
		DataCenter.heroData:checkHeroRedDotState();
	end
	if openDic[10009] == 1 then -- 月卡
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthCardInInfo();
	end
	if openDic[10181] == 1 then -- 等级礼包
		Lua_ProxyManager.getProxy("Lua_WelfareProxy"):sOpenGradeGiftInfo();
	end
	if openDic[10294] == 1 then -- 资源找回
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sRecoverResourcesInfo();
	end
	-- 皮肤商店
	if openDic[10295] == 1 then
		Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(Lua_ShopData.HERO_SKIN_SHOP);
	end
	-- 超值基金
	if openDic[10193] == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsInfo();
	end
	-- 时空争霸
	if openDic[10298] == 1 then
		Lua_ProxyManager.getProxy("Lua_TimeSpaceRaceProxy"):sWinInfo(0);
	end
	if openDic[10301] == 1 then -- 组队赛
		Lua_ProxyManager.getProxy("Lua_FormTeamCompetitionProxy"):sGetFormTeamCompetitionFightPanelInfo();
		Lua_ProxyManager.getProxy("Lua_FormTeamCompetitionProxy"):sGetFormTeamCompetitionRewardInfo();
		Lua_ProxyManager.getProxy("Lua_FormTeamCompetitionProxy"):sGetFormTeamCompetitionInviteInfo(); -- 被邀请红点
		Lua_ProxyManager.getProxy("Lua_FormTeamCompetitionProxy"):sGetFormTeamCompetitionApplyJoinTeam(); -- 成员招募红点
	end
	-- 冠军赛
	if openDic[10304] == 1 then
		Lua_ProxyManager.getProxy("Lua_ChampionMatchProxy"):sWinInfo(0);
		Lua_ProxyManager.getProxy("Lua_ChampionMatchProxy"):sHonourInfo();
	end
	-- 异兽系统
	if openDic[10305] == 1 then
		Lua_ProxyManager.getProxy("Lua_StrangeBeastProxy"):sGetStrangeBeastInfo();
		Lua_ProxyManager.getProxy("Lua_StrangeBeastProxy"):sGetStrangeBeastNestInfo();
		Lua_ProxyManager.getProxy("Lua_StrangeBeastProxy"):sGetStrangeTreeInfo();
		Lua_ProxyManager.getProxy("Lua_StrangeBeastProxy"):sGetStrangeBeastRecruitInfo();
		Lua_ProxyManager.getProxy("Lua_StrangeBeastProxy"):sGetStrangeFetter();
	end
	-- 蛮荒秘境
	if openDic[10308] == 1 then
		Lua_ProxyManager.getProxy("Lua_WildSecretProxy"):sLodeRegionInfo();
		Lua_ProxyManager.getProxy("Lua_WildSecretProxy"):sLodeSelfInfo();
	end
	-- 公会战
	if openDic[10314] == 1 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueFightMainInfo();
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueFightRewardInfo(0);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueFightRewardInfo(1);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueFightBattleInfo(0);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueFightBattleInfo(1);
	end
	-- 藏品战令
	if openDic[10315] == 1 then
		Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sWarOrderInfo(Lua_WarOrderData.CollectionCabinet);
	end
	-- 神海之巅
	if openDic[10316] == 1 then
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sWinInfo(1);
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sTaskInfo();
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sTreasureInfo();
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sHonourInfo();
		DataCenter.godSeaPeakData:checkTreasureDrawRed();
	end
	-- 战法
	if openDic[10317] == 1 then
		Lua_ProxyManager.getProxy("Lua_HeroTacticProxy"):sTacticFetter();
	end
	-- 攻略
	if openDic[10302] == 1 then
		DataCenter.strategyData:updateStrategyLineupRedDot(2); -- 攻略-英雄阵容红点
	end
	-- 神海战令
	if openDic[10319] == 1 then
		Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sWarOrderInfo(Lua_WarOrderData.GodSeaPeak);
	end
	-- 钓鱼
	if openDic[10320] == 1 then
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingInfo(0);
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingGearAndLureInfo();
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingIndentInfo();
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAquariumInfo();
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAllFisheryInfo();
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAllAtlasInfo();
	end
	openDic = nil;
end

function Lua_MainViewProxy:onUpdateTopIcon()
	DataCenter.mainMenuData:updateTopIconData();
end

function Lua_MainViewProxy:onWinShowCompleted(winName)
	DataCenter.mainMenuData:checkCloseWin(winName)
	DataCenter.funcPathUtil:checkCloseWin(winName)
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
function Lua_MainViewProxy:sFuncOpenInfo()
	sendMsg(10115001);
end

function Lua_MainViewProxy:sFuncOpenReward(function_id)
	local cmd = ProtoPublic_pb.Proto10115002();
	cmd.function_id = function_id;
	sendMsg(10115002, cmd);
end

function Lua_MainViewProxy:sFuncOpenTipsClose(function_id)
	LogManager.showLog("功能预告弹框关闭ID " .. function_id);
	local cmd = ProtoPublic_pb.Proto10115003();
	cmd.function_id = function_id;
	sendMsg(10115003, cmd);
end






------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_MainViewProxy:rFuncOpenInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50115001();
		msg:ParseFromString(mp.data);
		DataCenter.funcOpenData:fromServerData(msg.function_open);
	end
end

function Lua_MainViewProxy:rFuncOpenReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50115002();
		msg:ParseFromString(mp.data);
		DataCenter.funcOpenData:updateSingleFunc(msg.function_open)
		Lua_MsgUtil.callFunc("FUNCTION_OPEN_REWARD");
	end
end

function Lua_MainViewProxy:rFuncOpenTipsClose(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50115003();
		msg:ParseFromString(mp.data);
		DataCenter.funcOpenData:updateSingleFunc(msg.function_open)
		Lua_MsgUtil.callFunc("FUNCTION_OPENWIN_CLOSE");-- 功能开启后 功能弹窗关闭时 	引导用
	end
end

function Lua_MainViewProxy:updateFuncOpen(mp)
	if mp.errno == 0 then
		print("通知功能开启信息")
		local msg = ProtoPublic_pb.Proto80115001();
		msg:ParseFromString(mp.data);
		DataCenter.funcOpenData:fromServerData(msg.function_open);
	end
end

function Lua_MainViewProxy:updateNewFuncOpen(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80115002();
		msg:ParseFromString(mp.data);
		DataCenter.funcOpenData:fromServerData(msg.function_open);
	end
end