-- 干脆面碰碰
checkRequire("Lua_MergeBlockDiffVo");
Lua_MergeBlockData = class("Lua_MergeBlockData");
function Lua_MergeBlockData:ctor()
end

function Lua_MergeBlockData:dispose()
	self._challengeTimes = nil;
	self._limitBuyTimes = nil;
	self._itemCostInfo = nil;
	self._isFirst = nil;
	self._maxSlidingAngle = nil;
	self._verticalSquareCos = nil;
	self._horizontalSquareCos = nil;
	self._maxSlidingTime = nil;
	self._minSlidingDistance = nil;
	self._slideTime = nil;
	self._explain = nil;
	self._ruleList = nil;
	self._ruleDic = nil;
	self._saveInfo = nil;
	self._mergeBlockDiffTypeArr = nil;
	self.mergeBlockDiffTypeDic = nil;
	self._isMergeBlockTween = nil;
end

function Lua_MergeBlockData:fromServer50108079(msg)
	if msg == nil then
		return;
	end
	if self._ruleDic == nil then
		self._ruleDic = {};
	end
	if self._mergeBlockDiffTypeArr == nil then
		self._mergeBlockDiffTypeArr = Array();
	end
	self.isNeedSort = true;

	self._challengeTimes = msg.times; -- 可用次数
	self._limitBuyTimes = msg.buy_times; -- 剩余可购买次数，-1无限制
	self._itemCostInfo = msg.item_use; -- 道具购买次数消耗
	self._isFirst = msg.is_first == 1; -- 是否第一次打开 0否 1是
	self._maxSlidingAngle = msg.sliding_angle; -- 滑动最大角度
	self._maxSlidingTime = msg.sliding_times; -- 滑动最大时间
	self._minSlidingDistance = msg.sliding_distance; -- 滑动最小距离
	self._slideTime = msg.sliding_speed; -- 滑动速度
	self._explain = msg.explain; -- 游戏说明
	self._ruleList = msg.rule; -- 合成规则

	local obj;
	for i = 1, #msg.rule do
		obj = msg.rule[i];
		self._ruleDic[obj.int1] = obj;
	end

	local obj, vo;
	self._saveInfo = nil;
	for i = 1, #msg.type_info do
		obj = msg.type_info[i];
		vo = self:getDiffTypeInfoByDiffType(obj.type);
		if vo == nil then
			vo = Lua_MergeBlockDiffVo.new(obj.type);
			self._mergeBlockDiffTypeArr:add(obj.type);
			self.mergeBlockDiffTypeDic[obj.type] = vo;
		end
		vo:updateMergeBlockDiffVoInfo(obj);

		if self._saveInfo == nil or #self._saveInfo.game_info < #vo.game_info then
			self._saveInfo = vo;
		end
	end
end

function Lua_MergeBlockData.Get:challengeTimes()
	return self._challengeTimes or 0;
end

function Lua_MergeBlockData.Get:limitBuyTimes()
	return self._limitBuyTimes or 0;
end

function Lua_MergeBlockData.Get:itemCostInfo()
	return self._itemCostInfo or 0;
end

function Lua_MergeBlockData.Get:isFirst()
	return self._isFirst or false;
end

function Lua_MergeBlockData.Get:maxSlidingAngle()
	return self._maxSlidingAngle or 30;
end

function Lua_MergeBlockData.Get:verticalSquareCos()
	if self._verticalSquareCos == nil then
		local radian = Mathf.Rad(90 - self.maxSlidingAngle);
		self._verticalSquareCos = Mathf.Cos(radian) * Mathf.Cos(radian);
	end
	return self._verticalSquareCos;
end

function Lua_MergeBlockData.Get:horizontalSquareCos()
	if self._horizontalSquareCos == nil then
		local radian = Mathf.Rad(self.maxSlidingAngle);
		self._horizontalSquareCos = Mathf.Cos(radian) * Mathf.Cos(radian);
	end
	return self._horizontalSquareCos;
end

function Lua_MergeBlockData.Get:maxSlidingTime()
	return self._maxSlidingTime or 0.3;
end

function Lua_MergeBlockData.Get:minSlidingDistance()
	return self._minSlidingDistance or 30;
end

function Lua_MergeBlockData.Get:slideTime()
	return self._slideTime or 0.08;
end

function Lua_MergeBlockData.Get:explain()
	return self._explain or {};
end

function Lua_MergeBlockData.Get:ruleList()
	return self._ruleList or {};
end

function Lua_MergeBlockData.Get:ruleDic()
	return self._ruleDic or {};
end

function Lua_MergeBlockData.Get:saveInfo()
	return self._saveInfo or {};
end

function Lua_MergeBlockData:getDiffTypeInfoByDiffType(diffType)
	if self.mergeBlockDiffTypeDic == nil then
		self.mergeBlockDiffTypeDic = {};
	end
	if diffType == nil or self.mergeBlockDiffTypeDic[diffType] == nil then
		return nil;
	end
	return self.mergeBlockDiffTypeDic[diffType];
end

function Lua_MergeBlockData.Get:mergeBlockDiffTypeArr()
	if self.isNeedSort then
		self.isNeedSort = false;
		self._mergeBlockDiffTypeArr:sort(nil, false);
	end
	return self._mergeBlockDiffTypeArr;
end

function Lua_MergeBlockData:fromServer50108080(msg)
	if msg == nil then
		return;
	end

	local obj;
	local redState = false;
	for i = 1, #msg.task_info do
		obj = msg.task_info[i];
		if not redState and obj.info1 == 1 then
			redState = true;
			break;
		end
	end
	if msg.type == 1 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.MergeBlock_Task_Daily, redState);
	else
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.MergeBlock_Task_Cumulate, redState);
	end
end

function Lua_MergeBlockData.Get:isMergeBlockTween()
	return self._isMergeBlockTween or false;
end

function Lua_MergeBlockData.Set:isMergeBlockTween(val)
	if self._isMergeBlockTween ~= val then
		self._isMergeBlockTween = val;
		-- DataCenter.loginData:checkFpsState();
		if not val then
			DataCenter.popupWinManager:checkPopupWin();
		end
	end
end