Lua_MergeBlockDiffVo = class("Lua_MergeBlockDiffVo");
function Lua_MergeBlockDiffVo:ctor(diffType)
	self.diffType = diffType; -- 难度
end

function Lua_MergeBlockDiffVo:dispose()
	self.progressRewardDic = nil;
	self._game_info = nil;
end

function Lua_MergeBlockDiffVo:updateMergeBlockDiffVoInfo(msg)
	self.open_time = msg.open_time; -- 开启时间（剩余XX秒）
	self.top_score = msg.top_score; -- 最高分
	self.top_player = msg.top_player; -- 最高分玩家信息
	self._game_info = msg.game_info; -- 上次保存的对局信息
	self.last_score = msg.last_score; -- 上次保存的对局分数

	if self.progressRewardDic == nil then
		self.progressRewardDic = {};
	end

	table.sort(msg.progress_reward, function(a, b) return tonumber(tostring(a.cond_int)) < tonumber(tostring(b.cond_int)); end);
	local obj;
	for i = 1, #msg.progress_reward do
		obj = msg.progress_reward[i];
		self.progressRewardDic[i] = {
			index = i,
			diffType = self.diffType,
			score = tonumber(tostring(obj.cond_int)),
			drawState = obj.state, -- 0没有奖励 1可领取 2已领取
			itemList = obj.item_list -- 奖励的道具列表
		};
	end
end

function Lua_MergeBlockDiffVo.Get:timeCond()
	return self.open_time > 0;
end

function Lua_MergeBlockDiffVo.Get:game_info()
	return self._game_info or {};
end