-- 藏品柜配置表数据
Lua_CollectionCabinetConfigData = class("Lua_CollectionCabinetConfigData");
function Lua_CollectionCabinetConfigData.getConfig(id)
	if id == nil then
		return nil;
	end
	
	id = tonumber(id);
	if Lua_CollectionCabinetConfigData.configDic == nil then
		Lua_CollectionCabinetConfigData.configDic = {};
	end

	if Lua_CollectionCabinetConfigData.configDic[id] == nil then
		local cfg = getConfig("new_collection_cabinet", id);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_CollectionCabinetConfigData.configDic[id] = Lua_CollectionCabinetConfigData.new(id, cfg);
	end
	return Lua_CollectionCabinetConfigData.configDic[id];
end

function Lua_CollectionCabinetConfigData:ctor(id, config)
	self:superCall("ctor");
    self.id = id;
    self._config = config;
end





---------------------------------------- 配置信息 ----------------------------------------
function Lua_CollectionCabinetConfigData.Get:config()
	if self._config == nil then
		self._config = getConfig("strange_beasts", self.id);
	end
	return self._config;
end

-- 藏品名称
function Lua_CollectionCabinetConfigData.Get:name()
	if self.config == nil or self.config.name == nil then
		return "";
	end
	return self.config.name;
end

-- 显示顺序
function Lua_CollectionCabinetConfigData.Get:sort()
	if self.config == nil or self.config.sort == nil then
		return 0;
	end
	return self.config.sort;
end

-- 本体道具id
function Lua_CollectionCabinetConfigData.Get:item_id()
	if self.config == nil or self.config.item_id == nil then
		return 0;
	end
	return self.config.item_id;
end

-- 初始星级
function Lua_CollectionCabinetConfigData.Get:initial_star()
	if self.config == nil or self.config.initial_star == nil then
		return 1;
	end
	return self.config.initial_star;
end

-- 最大星级
function Lua_CollectionCabinetConfigData.Get:max_star()
	if self.config == nil or self.config.max_star == nil then
		return 0;
	end
	return self.config.max_star;
end

-- 初始等级
function Lua_CollectionCabinetConfigData.Get:initial_level()
	if self.config == nil or self.config.initial_level == nil then
		return 0;
	end
	return self.config.initial_level;
end

-- 最大等级
function Lua_CollectionCabinetConfigData.Get:max_level()
	if self.config == nil or self.config.max_level == nil then
		return 0;
	end
	return self.config.max_level;
end

-- 等级相关配置
function Lua_CollectionCabinetConfigData.Get:level_normal_type()
	if self.config == nil or self.config.level_normal_type == nil then
		return 1;
	end
	return self.config.level_normal_type;
end

-- 颜色
function Lua_CollectionCabinetConfigData.Get:color()
	if self.config == nil or self.config.color == nil then
		return 0;
	end
	return self.config.color;
end

-- 重复获得本体时转换道具
function Lua_CollectionCabinetConfigData.Get:transfer_item()
	if self.config == nil or self.config.transfer_item == nil then
		return {};
	end
	return self.config.transfer_item;
end

-- 基础评分
function Lua_CollectionCabinetConfigData.Get:score()
	if self.config == nil or self.config.score == nil then
		return 0;
	end
	return self.config.score;
end

-- 引用图集
function Lua_CollectionCabinetConfigData.Get:atlas()
	if self.config == nil or self.config.atlas == nil then
		return nil;
	end
	return self.config.atlas;
end

-- 引用图标
function Lua_CollectionCabinetConfigData.Get:sprite()
	if self.config == nil or self.config.sprite == nil then
		return nil;
	end
	return self.config.sprite;
end

-- 图鉴
function Lua_CollectionCabinetConfigData.Get:atlas_img()
	if self.config == nil or self.config.atlas_img == nil then
		return nil;
	end
	return self.config.atlas_img;
end

-- 传记标题
function Lua_CollectionCabinetConfigData.Get:desc_title()
	if self.config == nil or self.config.desc_title == nil then
		return "";
	end
	return self.config.desc_title;
end

-- 传记内容
function Lua_CollectionCabinetConfigData.Get:desc_content()
	if self.config == nil or self.config.desc_content == nil then
		return "";
	end
	return self.config.desc_content;
end