checkRequire("Lua_CollectionCabinetData");
checkRequire("Lua_CollectionCabinetUtil");
Lua_CollectionCabinetProxy = class("Lua_CollectionCabinetProxy");
function Lua_CollectionCabinetProxy:ctor()
	DataCenter.collectionCabinetData = Lua_CollectionCabinetData.new();
	DataCenter.collectionCabinetUtil = Lua_CollectionCabinetUtil.new();

	Lua_MsgUtil.addLuaMsg(50230001, self, self.rCollectionCabinetPrizeDraw);
	Lua_MsgUtil.addLuaMsg(50230002, self, self.rCollectionCabinetInfo);
	Lua_MsgUtil.addLuaMsg(80230002, self, self.nCollectionCabinetInfo);
	Lua_MsgUtil.addLuaMsg(50230006, self, self.rCollectionCabinetPrizeDrawInfo);
	Lua_MsgUtil.addLuaMsg(50230007, self, self.rCollectionCabinetDrawRecordInfo);

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateCollectionCabinetPackRedDot);
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateCollectionCabinetMoneyRedDot);
end

-- 请求藏品柜抽奖（返回）
function Lua_CollectionCabinetProxy:rCollectionCabinetPrizeDraw(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50230001();
		msg:ParseFromString(mp.data);
		DataCenter.collectionCabinetData:fromServer50230001(msg);
		Lua_MsgUtil.callFunc("UPDATE_NEW_COLLECTION_CABINET_PRIZEDRAW", msg);
	end
end

-- 请求藏品柜的信息（返回）
function Lua_CollectionCabinetProxy:rCollectionCabinetInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50230002();
		msg:ParseFromString(mp.data);
		DataCenter.collectionCabinetData:fromServer50230002(msg);
		Lua_MsgUtil.callFunc("UPDATE_NEW_COLLECTION_CABINET_INFO");
	end
end

-- 藏品柜的信息（通知）
function Lua_CollectionCabinetProxy:nCollectionCabinetInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80230002();
		msg:ParseFromString(mp.data);
		DataCenter.collectionCabinetData:fromServer80230002(msg);
		Lua_MsgUtil.callFunc("UPDATE_NEW_COLLECTION_CABINET_INFO");
	end
end

-- 请求藏品柜抽奖页面信息（返回）
function Lua_CollectionCabinetProxy:rCollectionCabinetPrizeDrawInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50230006();
		msg:ParseFromString(mp.data);
		DataCenter.collectionCabinetData:fromServer50230006(msg);
		Lua_MsgUtil.callFunc("UPDATE_NEW_COLLECTION_CABINET_PRIZEDRAW_INFO", msg.card_pool_type);
	end
end

-- 请求藏品柜抽奖页面信息（返回）
function Lua_CollectionCabinetProxy:rCollectionCabinetDrawRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50230007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_NEW_COLLECTION_CABINET_DRAWRECORD_INFO", msg);
	end
end

function Lua_CollectionCabinetProxy:updateCollectionCabinetPackRedDot(dic)
	DataCenter.collectionCabinetData:checkCollectionPackRedPoint(dic);
	DataCenter.collectionCabinetData:checkCollectionDrawRedPoint(dic);
end

function Lua_CollectionCabinetProxy:updateCollectionCabinetMoneyRedDot(dic)
	DataCenter.collectionCabinetData:checkCollectionMoneyRedPoint(dic);
end










-- 请求藏品柜抽奖
function Lua_CollectionCabinetProxy:sCollectionCabinetPrizeDraw(card_pool_type, extract_time)
	local cmd = ProtoPublic_pb.Proto10230001();
	cmd.card_pool_type = card_pool_type; -- 卡池类型：1初级 2高级
	cmd.extract_time = extract_time; -- 抽取次数
	sendMsg(10230001, cmd);
end

-- 请求藏品柜信息
function Lua_CollectionCabinetProxy:sCollectionCabinetInfo()
	sendMsg(10230002);
end

-- 请求藏品升星/升级
function Lua_CollectionCabinetProxy:sCollectionCabinetOpertate(collect_id, opertate_type)
	local cmd = ProtoPublic_pb.Proto10230003();
	cmd.collect_id = collect_id; -- 藏品id
	cmd.type = opertate_type; -- 操作类型：1升星 2升级
	sendMsg(10230003, cmd);
end

-- 请求领取藏品激活奖励
function Lua_CollectionCabinetProxy:sCollectionCabinetDrawActReward(collect_id)
	local cmd = ProtoPublic_pb.Proto10230004();
	cmd.collect_id = collect_id; -- 藏品id
	sendMsg(10230004, cmd);
end

-- 请求藏品柜抽奖页面信息
function Lua_CollectionCabinetProxy:sCollectionCabinetPrizeDrawInfo(card_pool_type)
	local cmd = ProtoPublic_pb.Proto10230006();
	cmd.type = card_pool_type; -- 卡池类型：1初级 2高级
	sendMsg(10230006, cmd);
end

-- 请求藏品柜抽奖记录信息
function Lua_CollectionCabinetProxy:sCollectionCabinetDrawRecordInfo(card_pool_type)
	local cmd = ProtoPublic_pb.Proto10230007();
	cmd.type = card_pool_type; -- 卡池类型：1初级 2高级
	sendMsg(10230007, cmd);
end