Lua_CollectionCabinetUtil = class("Lua_CollectionCabinetUtil");
function Lua_CollectionCabinetUtil:ctor()
	self:superCall("ctor");
end

function Lua_CollectionCabinetUtil:dispose()
	self:superCall("dispose");
end

function Lua_CollectionCabinetUtil:getCollectionCabinetConstConfig(id, param)
	local config = getConfig("new_collection_cabinet_const", id);
	if config then
		if param == 1 then
			return config.value;
		elseif param == 2 then
			return config.floatvalue;
		elseif param == 3 then
			return config.strvalue;
		elseif param == 4 then
			return config.jsonvalue;
		end
	end
	return nil;
end

-- 单个藏品分享每日上限
function Lua_CollectionCabinetUtil.Get:shareMaxTimes()
	local config = self:getCollectionCabinetConstConfig("collection_shared_daily_limit", 1);
	return config or 0;
end

-- 藏品分享冷却时间（单位：秒）
function Lua_CollectionCabinetUtil.Get:shareIntervalTime()
	local config = self:getCollectionCabinetConstConfig("collection_shared_cool_limit", 1);
	return config or 0;
end

-- 藏品页签配置
function Lua_CollectionCabinetUtil.Get:collectionTabList()
	return getConfig("new_collection_tab");
end

-- 藏品配置
function Lua_CollectionCabinetUtil:getCollectionCabinetConfig(collectId)
	return getConfig("new_collection_cabinet", collectId);
end

function Lua_CollectionCabinetUtil:initCollectionInfo()
	if self._allCollectionIdsArr == nil then
		self._allCollectionIdsArr = Array();
		self._allColllectionColorIdsArr = Array();
		self._allColllectionColorIdsDic = {};

		local config = getConfig("new_collection_cabinet");
		for k,v in pairs(config) do
			if v.is_show == 1 then
				self._allCollectionIdsArr:add(k);
				if self._allColllectionColorIdsArr:indexOf(v.color) == -1 then
					self._allColllectionColorIdsArr:add(v.color);
				end
				if self._allColllectionColorIdsDic[v.color] == nil then
					self._allColllectionColorIdsDic[v.color] = Array();
				end
				self._allColllectionColorIdsDic[v.color]:add(k);
			end
		end
		self._allCollectionIdsArr:sortf(self, self.sortFun);
		self._allColllectionColorIdsArr:sort(nil, true);

		for k,v in pairs(self._allColllectionColorIdsDic) do
			v:sortf(self, self.sortColorFun);
		end
	end
end

function Lua_CollectionCabinetUtil:sortFun(a, b)
	local collectVo_a = self:getCollectionCabinetConfig(a);
	local collectVo_b = self:getCollectionCabinetConfig(b);
	if collectVo_a.color == collectVo_b.color then
		return collectVo_a.sort < collectVo_b.sort;
	else
		return collectVo_a.color > collectVo_b.color;
	end
end

function Lua_CollectionCabinetUtil:sortColorFun(a, b)
	local collectVo_a = self:getCollectionCabinetConfig(a);
	local collectVo_b = self:getCollectionCabinetConfig(b);
	return collectVo_a.sort < collectVo_b.sort;
end

function Lua_CollectionCabinetUtil.Get:allCollectionIdsArr()
	if self._allCollectionIdsArr == nil then
		self:initCollectionInfo();
	end
	return self._allCollectionIdsArr;
end

function Lua_CollectionCabinetUtil.Get:allColllectionColorIdsArr()
	if self._allColllectionColorIdsArr == nil then
		self:initCollectionInfo();
	end
	return self._allColllectionColorIdsArr;
end

function Lua_CollectionCabinetUtil.Get:allColllectionColorIdsDic()
	if self._allColllectionColorIdsDic == nil then
		self:initCollectionInfo();
	end
	return self._allColllectionColorIdsDic;
end

-- 藏品上限
function Lua_CollectionCabinetUtil.Get:totalCollectionCount()
	return self.allCollectionIdsArr:getSize();
end

function Lua_CollectionCabinetUtil:getAllColllectColorIdsByColor(color)
	if color == nil then
		return 0;
	end
	return self.allColllectionColorIdsDic[color];
end

-- 藏品升星配置
function Lua_CollectionCabinetUtil:getCollectionCabinetStarConfig(starId)
	return getConfig("new_collection_cabinet_star", starId);
end

function Lua_CollectionCabinetUtil:getCollectionCabinetStarId(id, starLv)
	return id * 1000 + starLv;
end

function Lua_CollectionCabinetUtil:getCollectionCabinetEntryConfig(entryId)
	return getConfig("new_collection_cabinet_entry", entryId);
end

-- 藏品升级配置
function Lua_CollectionCabinetUtil:getCollectionCabinetLvConfig(levelId)
	return getConfig("new_collection_cabinet_level", levelId);
end

function Lua_CollectionCabinetUtil:getCollectionCabinetLvId(levelType, lv)
	return levelType * 100 + lv;
end

function Lua_CollectionCabinetUtil:getStarEntryGrowUpDesByCamp(camp)
	return LanUtil.getValue(787500 + camp);
end

function Lua_CollectionCabinetUtil:getCollectionActiveTitleNameByColor(color)
	return LanUtil.getValue(787510 + color);
end

function Lua_CollectionCabinetUtil:getCollectionAtlasTitleNameByColor(color)
	return LanUtil.getValue(787520 + color);
end




















---------------------------------------- 抽奖 ----------------------------------------

-- 低级抽奖单抽次数
function Lua_CollectionCabinetUtil.Get:oneLowDrawTimes()
	return self:getCollectionCabinetConstConfig("one_low_draw_item_cost", 1);
end

-- 低级抽奖多抽次数
function Lua_CollectionCabinetUtil.Get:moreLowDrawTimes()
	return self:getCollectionCabinetConstConfig("more_low_draw_item_cost", 1);
end

-- 高级抽奖单抽次数
function Lua_CollectionCabinetUtil.Get:oneDrawTimes()
	return self:getCollectionCabinetConstConfig("one_draw_item_cost", 1);
end

-- 高级抽奖多抽次数
function Lua_CollectionCabinetUtil.Get:moreDrawTimes()
	return self:getCollectionCabinetConstConfig("more_draw_item_cost", 1);
end

-- 低级道具抽奖单抽消耗
function Lua_CollectionCabinetUtil.Get:oneLowDrawCostList()
	return self:getCollectionCabinetConstConfig("one_low_draw_item_cost", 4);
end

-- 低级道具抽奖多抽消耗
function Lua_CollectionCabinetUtil.Get:moreLowDrawCostList()
	return self:getCollectionCabinetConstConfig("more_low_draw_item_cost", 4);
end

-- 高级道具抽奖单抽消耗
function Lua_CollectionCabinetUtil.Get:oneDrawCostList()
	return self:getCollectionCabinetConstConfig("one_draw_item_cost", 4);
end

-- 高级道具抽奖多抽消耗
function Lua_CollectionCabinetUtil.Get:moreDrawCostList()
	return self:getCollectionCabinetConstConfig("more_draw_item_cost", 4);
end

-- 货币抽奖单抽消耗
function Lua_CollectionCabinetUtil.Get:oneMoneyCostList()
	return self:getCollectionCabinetConstConfig("one_draw_money_cost", 4);
end

-- 货币抽奖多抽消耗
function Lua_CollectionCabinetUtil.Get:moreMoneyCostList()
	return self:getCollectionCabinetConstConfig("ten_draw_money_cost", 4);
end

-- 奖励预览-低级概率
function Lua_CollectionCabinetUtil.Get:lowProbabilityList()
	return self:getCollectionCabinetConstConfig("low_probability", 4);
end

-- 奖励预览-高级概率
function Lua_CollectionCabinetUtil.Get:probabilityList()
	return self:getCollectionCabinetConstConfig("probability", 4);
end

-- 低级抽奖广播id列表
function Lua_CollectionCabinetUtil.Get:lowDrawBroadcastList()
	return self:getCollectionCabinetConstConfig("low_draw_broadcast", 4);
end

-- 高级抽奖广播id列表
function Lua_CollectionCabinetUtil.Get:drawBroadcastList()
	return self:getCollectionCabinetConstConfig("draw_broadcast", 4);
end

function Lua_CollectionCabinetUtil:getCollectionCabinetPeriodConfig(periodId)
	return getConfig("new_collection_lottery_round", periodId);
end

function Lua_CollectionCabinetUtil:getCollectionCabinetMainPoolConfig(poolId)
	return getConfig("new_collection_cabinet_pool", poolId);
end

function Lua_CollectionCabinetUtil:getCollectionCabinetSubPoolConfig(poolId)
	local config = self:getCollectionCabinetMainPoolConfig(poolId);
	return config.weight_list;
end

function Lua_CollectionCabinetUtil:initCollectionDrawRuleInfo()
	if self.drawRuleDic == nil then
		self.drawRuleDic = {};

		local config = getConfig("new_collection_cabinet_draw_rule");
		for k,v in pairs(config) do
			if self.drawRuleDic[v.pool_type] == nil then
				self.drawRuleDic[v.pool_type] = Array();
			end
			self.drawRuleDic[v.pool_type]:add(k);
		end
		for k,v in pairs(self.drawRuleDic) do
			v:sort(nil, false);
		end
	end
end

function Lua_CollectionCabinetUtil:getCollectionCabinetDrawRuleInfoByType(poolType)
	if self.drawRuleDic == nil then
		self:initCollectionDrawRuleInfo();
	end
	return self.drawRuleDic[poolType];
end

function Lua_CollectionCabinetUtil:getCollectionCabinetRuleConfig(ruleId)
	return getConfig("new_collection_cabinet_draw_rule", ruleId);
end