-- 开服试炼-英雄降临
checkRequire("Lua_OpenServerHeroComeTaskVo");
Lua_OpenServerHeroComeData = class("Lua_HeroComeData")
function Lua_OpenServerHeroComeData:ctor()
end

function Lua_OpenServerHeroComeData:dispose()
	if self.taskVoList ~= nil then
		local len = self.taskVoArr:getSize();
		while len > 0 do
			local key = self.taskVoArr:remove(len);
			if key then
				self.taskVoList[key]:dispose();
				self.taskVoList[key] = nil;
			end
			len = len - 1;
		end
		self.taskVoList = nil;
		self.taskVoArr = nil;
	end
end

function Lua_OpenServerHeroComeData:fromServer50197048(msg)
	if msg == nil then
		return;
	end

	self.heroDrawState = msg.hero_state; -- 英雄领取状态：0不可领取 1可领取 2已领取
	self.activeTime = msg.end_time; -- 活动时间
	self.isFirst = msg.red_state == 1; -- 首登红点，1首次登录

	local obj;
	local vo;
	local taskState = false;
	local completeCount = 0;
	for i = 1, #msg.task_progress do
		obj = msg.task_progress[i];
		vo = self:getTaskVoById(obj.key);
		if vo ~= nil then
			vo:updataHeroComeTaskVoInfo(obj.value, obj.ex_value);
		end
		if not taskState and obj.value == 1 then
			taskState = true;
		end
		if obj.value == 2 then
			completeCount = completeCount + 1;
		end
	end
	local firstRedPoint = self.isFirst and (completeCount ~= #msg.task_progress or self.heroDrawState ~= 2);
	local redState = taskState or self.heroDrawState == 1 or firstRedPoint;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroCome, redState);
end

function Lua_OpenServerHeroComeData:getTaskVoById(id)
	if self.taskVoList == nil then
		self:initTaskInfo();
	end
	return self.taskVoList[id];
end

function Lua_OpenServerHeroComeData:initTaskInfo()
	local config = getConfig("hero_fall");
	local vo;
	self.taskVoList = {};
	self.taskVoArr = Array();
	for k,v in pairs(config) do
		if type(k) == "number" then
			vo = Lua_OpenServerHeroComeTaskVo.new(k);
			self.taskVoList[k] = vo;
			self.taskVoArr:add(k);
		end
	end
	self.taskVoArr:sort(nil, false);
end

-- 任务完成通知红点
function Lua_OpenServerHeroComeData:fromServer80197051(msg)
	if msg == nil or msg.function_id ~= 10283 or Lua_WindowUtil.isWindowShowing("Lua_OpenServerHeroComeWindow") then
		return;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroCome, msg.red_state == 1);
end

-- 英雄id
function Lua_OpenServerHeroComeData.Get:heroId()
	return getConfig("hero_fall", "const", "hero_reward");
end

-- 英雄立绘位置
function Lua_OpenServerHeroComeData.Get:heroUrlPos()
	return getConfig("hero_fall", "const", "hero_url_pos");
end

-- 英雄名字位置
function Lua_OpenServerHeroComeData.Get:heroNamePos()
	return getConfig("hero_fall", "const", "hero_name_pos");
end