checkRequire("Lua_OperationalActivitiesUtil")
checkRequire("Lua_BackstageActivitiesData");
checkRequire("Lua_InternalActivitiesData");
checkRequire("Lua_UpStarOfCycleData");
checkRequire("Lua_CustomGiftData");
checkRequire("Lua_LuckyGiftBoxData");
checkRequire("Lua_SpecialDiscountGiftData");
checkRequire("Lua_NewSpecialFundsData");
checkRequire("Lua_BossChallengeData");
checkRequire("Lua_MoreDoubleData");
checkRequire("Lua_CrackShotData");
checkRequire("Lua_EuropeanRecruitData");
checkRequire("Lua_MergeBlockData");
checkRequire("Lua_ThrowKnifeData");
checkRequire("Lua_EndlessLevelData");
checkRequire("Lua_LoginRewardData");
checkRequire("Lua_TotemRecruitData");
checkRequire("Lua_SkinPurchaseData");
checkRequire("Lua_HalfMonthGiftData");
checkRequire("Lua_JumpingHappyData");
checkRequire("Lua_LuxuryCashData");

Lua_OperationalActivitiesProxy = class("Lua_OperationalActivitiesProxy");
function Lua_OperationalActivitiesProxy:ctor()
	DataCenter.operationalActUtil = Lua_OperationalActivitiesUtil.new();
	DataCenter.backstageActData = Lua_BackstageActivitiesData.new();
	DataCenter.internalActData = Lua_InternalActivitiesData.new();
	DataCenter.upStarOfCycleData = Lua_UpStarOfCycleData.new();
	DataCenter.customGiftData = Lua_CustomGiftData.new();
	DataCenter.luckyGiftBoxData = Lua_LuckyGiftBoxData.new();
	DataCenter.specialDiscountGiftData = Lua_SpecialDiscountGiftData.new();
	DataCenter.newSpecialFundsData = Lua_NewSpecialFundsData.new();
	DataCenter.bossChallengeData = Lua_BossChallengeData.new();
	DataCenter.moreDoubleData = Lua_MoreDoubleData.new();
	DataCenter.crackShotData = Lua_CrackShotData.new();
	DataCenter.europeanRecruitData = Lua_EuropeanRecruitData.new();
	DataCenter.mergeBlockData = Lua_MergeBlockData.new();
	DataCenter.throwKnifeData = Lua_ThrowKnifeData.new();
	DataCenter.endlessLevelData = Lua_EndlessLevelData.new();
	DataCenter.loginRewardData = Lua_LoginRewardData.new();
	DataCenter.totemRecruitData = Lua_TotemRecruitData.new();
	DataCenter.skinPurchaseData = Lua_SkinPurchaseData.new();
	DataCenter.halfMonthGiftData = Lua_HalfMonthGiftData.new();
	DataCenter.jumpingHappyData = Lua_JumpingHappyData.new();
	DataCenter.luxuryCashData = Lua_LuxuryCashData.new();

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateItemInfo);
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateItemInfo);

	Lua_MsgUtil.addLuaMsg(80108001, self, self.updateActivitiesInfo);  -- 通知运营活动列表
	Lua_MsgUtil.addLuaMsg(80108002, self, self.updateActivitiesRedDot);-- 通知运营活动红点
	Lua_MsgUtil.addLuaMsg(80108044, self, self.updateMoreDoubleInfo);  -- 通知多倍活动
	Lua_MsgUtil.addLuaMsg(80108071, self, self.noticeEuropeanRecruitOpen);  -- 通知欧皇招募首次弹窗

	Lua_MsgUtil.addLuaMsg(50108003, self, self.rCumulateRechargeInfo); -- 请求累积充值界面（返回）
	Lua_MsgUtil.addLuaMsg(50108005, self, self.rUpStarOfCycleInfo); -- 请求升星专属界面（返回）
	Lua_MsgUtil.addLuaMsg(50108007, self, self.rCustomGiftInfo); -- 请求定制礼包界面（返回）
	Lua_MsgUtil.addLuaMsg(50108012, self, self.rLuckyGiftBoxInfo); -- 请求幸运礼盒界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108017, self, self.rBestGiftBoxInfo); -- 请求终极礼盒界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108018, self, self.rLuckyGiftBoxDetailInfo); -- 请求幸运礼盒界面详情信息（返回）
	Lua_MsgUtil.addLuaMsg(50108010, self, self.rSpecialDiscountGiftInfo); --请求特惠礼包界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50197005, self, self.rSpecialFundsInfo); -- 请求超值基金界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108038, self, self.rQuarterHotSellInfo); -- 请求当季热卖界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108040, self, self.rBossChallengeInfo); -- 请求boss挑战界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108041, self, self.rBossChallengeRankRewardInfo); -- 请求boss挑战排行奖励信息（返回）
	Lua_MsgUtil.addLuaMsg(50108043, self, self.rBossChallengeRankInfo); -- 请求boss挑战排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(50108044, self, self.rMoreDoubleInfo); -- 请求多倍活动界面（返回）
	Lua_MsgUtil.addLuaMsg(50108045, self, self.rWeekCardInfo); -- 周卡界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108052, self, self.rLuckyGiftBoxTaskInfo); -- 请求幸运礼盒任务信息（返回）
	Lua_MsgUtil.addLuaMsg(80108054, self, self.nLuckyGiftBoxTaskInfo); -- 请求幸运礼盒任务信息（返回）
	Lua_MsgUtil.addLuaMsg(50108060, self, self.rCrackShotInfo); -- 请求百发百中界面（返回）
	Lua_MsgUtil.addLuaMsg(50108061, self, self.rCrackShotTaskInfo); -- 请求百发百中任务信息（返回）
	Lua_MsgUtil.addLuaMsg(50108062, self, self.rCrackShotRankInfo); -- 请求百发百中排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(50108063, self, self.rCrackShotRankReward); -- 请求百发百中排行榜奖励（返回）
	Lua_MsgUtil.addLuaMsg(50108064, self, self.rComputeCrackShotScore); -- 请求计算百发百中分数（返回）
	Lua_MsgUtil.addLuaMsg(50108068, self, self.rCrackShotLevelInfo); -- 请求百发百中关卡信息（返回）
	Lua_MsgUtil.addLuaMsg(50108070, self, self.rDiamondShopInfo); -- 请求钻石商城信息信息（返回）
	Lua_MsgUtil.addLuaMsg(50108071, self, self.rEuropeanRecruitInfo); -- 请求欧皇召唤界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108072, self, self.rEuropeanRecruitInvitationInfo); -- 请求欧皇召唤助力界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108073, self, self.rEuropeanRecruitOtherInvitationInfo); -- 请求他人欧皇召唤助力界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108074, self, self.rEuropeanRecruitRecordInfo); -- 请求欧皇招募暂存记录界面（返回）
	Lua_MsgUtil.addLuaMsg(50108075, self, self.rSaveEuropeanRecruitRecord); -- 请求欧皇招募保存上一条招募记录（返回）
	Lua_MsgUtil.addLuaMsg(50108078, self, self.rEuropeanRecruitShareTime); -- 请求欧皇招募分享结束冷却时间（返回）
	Lua_MsgUtil.addLuaMsg(80108072, self, self.rEuropeanRecruitHide); -- 通知欧皇招募隐藏
	Lua_MsgUtil.addLuaMsg(50108079, self, self.rMergeBlockInfo); -- 请求干脆面碰碰界面（返回）
	Lua_MsgUtil.addLuaMsg(50108080, self, self.rMergeBlockTaskInfo); -- 请求干脆面碰碰任务信息（返回）
	Lua_MsgUtil.addLuaMsg(50108081, self, self.rMergeBlockRankInfo); -- 请求干脆面碰碰排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(50108082, self, self.rMergeBlockRankReward); -- 请求干脆面碰碰排行榜奖励（返回）
	Lua_MsgUtil.addLuaMsg(50108083, self, self.rComputeMergeBlockScore); -- 请求计算干脆面碰碰分数（返回）
	Lua_MsgUtil.addLuaMsg(50108087, self, self.rAlwaysRechargeGiftInfo); -- 连充献礼（返回）
	Lua_MsgUtil.addLuaMsg(50108088, self, self.rThrowKnifeInfo); -- 请求见缝插刀界面（返回）
	Lua_MsgUtil.addLuaMsg(50108089, self, self.rThrowKnifeTaskInfo); -- 请求见缝插刀任务信息（返回）
	Lua_MsgUtil.addLuaMsg(50108090, self, self.rThrowKnifeRankInfo); -- 请求见缝插刀排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(50108091, self, self.rThrowKnifeRankReward); -- 请求见缝插刀排行榜奖励（返回）
	Lua_MsgUtil.addLuaMsg(50108092, self, self.rComputeThrowKnifeScore); -- 请求计算见缝插刀分数（返回）
	Lua_MsgUtil.addLuaMsg(50108095, self, self.rThrowKnifeLevelInfo); -- 请求见缝插刀关卡信息（返回）
	Lua_MsgUtil.addLuaMsg(50108096, self, self.rEndlessLevelInfo); -- 请求无尽关卡界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108098, self, self.rEndlessLevelRankRewardInfo); -- 请求无尽关卡排行榜奖励信息（返回）
	Lua_MsgUtil.addLuaMsg(50108099, self, self.rEndlessLevelAssistMyInfo); -- 请求无尽关卡助力界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108100, self, self.rEndlessLevelAssistOtherInfo); -- 请求他人无尽关卡助力界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108101, self, self.rEndlessLevelAssistShare); -- 请求无尽关卡分享信息（返回）
	Lua_MsgUtil.addLuaMsg(50108102, self, self.rEndlessLevelRankInfo); -- 请求无尽关卡排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(80108103, self, self.nEndlessLevelSkipInfo); -- 无尽关卡跳过关卡信息（通知）
	Lua_MsgUtil.addLuaMsg(50108104, self, self.rEndlessLevelKeepFighting); -- 请求无尽关卡是否继续战斗（返回）
	Lua_MsgUtil.addLuaMsg(50108105, self, self.rLoginRewardInfo); -- 请求登录福利界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108106, self, self.rTotemRecruitInfo); -- 请求图腾招募界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108107, self, self.rTotemRecruitPreviewInfo); -- 请求图腾招募奖励一览界面（返回）
	Lua_MsgUtil.addLuaMsg(50108108, self, self.rTotemRecruitRecordInfo); -- 请求图腾招募抽奖记录界面（返回）
	Lua_MsgUtil.addLuaMsg(80108108, self, self.nTotemRecruitRecordInfo); -- 通知图腾招募抽奖记录界面（通知）
	Lua_MsgUtil.addLuaMsg(50108109, self, self.rTotemRecruitDrawRecruitReward); -- 请求抽取图腾招募奖励（返回）
	Lua_MsgUtil.addLuaMsg(50108110, self, self.rTotemRecruitTaskInfo); -- 请求图腾招募任务界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108112, self, self.rStrangeBeastMatchInfo); -- 请求异兽争胜界面（返回）
	Lua_MsgUtil.addLuaMsg(50108113, self, self.rStrangeBeastMatchRankInfo); -- 请求异兽争胜排行界面（返回）
	Lua_MsgUtil.addLuaMsg(50108114, self, self.rStrangeBeastMatchRankRewardInfo); -- 请求异兽争胜排行奖励界面（返回）
	Lua_MsgUtil.addLuaMsg(50108115, self, self.rStrangeBeastMatchTaskInfo); -- 请求异兽争胜日常任务界面（返回）
	Lua_MsgUtil.addLuaMsg(50108118, self, self.rSkinPurchaseInfo); -- 请求皮肤直购活动界面（返回）
	Lua_MsgUtil.addLuaMsg(50108119, self, self.rHalfMonthGiftInfo); -- 请求半月礼包界面（返回）
	Lua_MsgUtil.addLuaMsg(50108123, self, self.rJumpingHappyInfo); -- 请求浣熊跳跳乐界面（返回）
	Lua_MsgUtil.addLuaMsg(50108124, self, self.rJumpingHappyTaskInfo); -- 请求浣熊跳跳乐任务信息（返回）
	Lua_MsgUtil.addLuaMsg(50108125, self, self.rJumpingHappyRankInfo); -- 请求浣熊跳跳乐排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(50108126, self, self.rJumpingHappyRankRewardInfo); -- 请求浣熊跳跳乐排行榜奖励（返回）
	Lua_MsgUtil.addLuaMsg(50108127, self, self.rJumpingHappyScore); -- 请求计算浣熊跳跳乐分数（返回）
	Lua_MsgUtil.addLuaMsg(50108131, self, self.rLuxuryCashInfo); -- 请求豪礼兑换奖励界面（返回）
	Lua_MsgUtil.addLuaMsg(50108133, self, self.rLuxuryCashGiftInfo); -- 请求豪礼兑换礼包界面（返回）
	Lua_MsgUtil.addLuaMsg(50108135, self, self.rGetLuxuryCashTaskInfo); -- 请求豪礼兑换任务界面（返回）
end



------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求运营活动的界面信息
-- index:
-- 1、图腾秘藏分页类型 界面索引 0默认全发
function Lua_OperationalActivitiesProxy:sActivityInfo(act_index, index)
	local cmd = ProtoPublic_pb.Proto10108002();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.index = index or -1; -- 活动唯一索引
	sendMsg(10108002, cmd);
end

-- 请求领取累积充值奖励
function Lua_OperationalActivitiesProxy:sReceiveReward(act_index, id)
	local cmd = ProtoPublic_pb.Proto10108004();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.id = id; -- 累充档次id
	sendMsg(10108004, cmd);
end

-- 请求解锁升星专属（周期）奖励
function Lua_OperationalActivitiesProxy:sReceiveUpStarReward(act_index, gift_id)
	local cmd = ProtoPublic_pb.Proto10108006();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id
	sendMsg(10108006, cmd);
end

-- 请求定制礼包自定义
function Lua_OperationalActivitiesProxy:sDefineCustomGift(act_index, gift_id, reward_list)
	local cmd = ProtoPublic_pb.Proto10108008();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id

	local struct;
	for i = 1, reward_list:getSize() do
		if reward_list[i].tvo ~= nil then
			struct = getProtoMsg("ProtoThree");
			struct.key = reward_list[i].tvo.id;
			struct.value = reward_list[i].tvo.count;
			struct.ex_value = reward_list[i].index;
			cmd.reward_list:addToList(struct); -- 自定义奖励道具
		end
	end
	
	sendMsg(10108008, cmd);
end

-- 请求购买0元定制礼包
function Lua_OperationalActivitiesProxy:sBuyCustomGift(act_index, gift_id)
	local cmd = ProtoPublic_pb.Proto10108009();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id
	sendMsg(10108009, cmd);
end

-- 请求更换终极礼盒
function Lua_OperationalActivitiesProxy:sChangeBestGiftBox(act_index, advance_gift_index)
	local cmd = ProtoPublic_pb.Proto10108013();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.advance_gift_index = advance_gift_index; -- 当前轮次终极礼盒索引
	sendMsg(10108013, cmd);
end

-- 请求开启下一轮幸运礼盒
function Lua_OperationalActivitiesProxy:sStartNextRounds(act_index)
	local cmd = ProtoPublic_pb.Proto10108014();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108014, cmd);
end

-- 请求抽取幸运礼盒道具
function Lua_OperationalActivitiesProxy:sDrawLuckyGiftBox(act_index, cell_index)
	local cmd = ProtoPublic_pb.Proto10108015();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.cell_index = cell_index; -- 礼盒位置索引
	sendMsg(10108015, cmd);
end

-- 请求终极礼盒界面信息
function Lua_OperationalActivitiesProxy:sBestGiftBoxInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108017();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108017, cmd);
end

-- 请求幸运礼盒界面详情信息
function Lua_OperationalActivitiesProxy:sLuckyGiftBoxDetailInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108018();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108018, cmd);
end

-- 请求幸运礼盒任务信息
function Lua_OperationalActivitiesProxy:sLuckyGiftBoxTaskInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108052();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108052, cmd);
end

-- 请求领取幸运礼盒任务奖励
function Lua_OperationalActivitiesProxy:sLuckyGiftBoxTaskReward(act_index, task_id)
	local cmd = ProtoPublic_pb.Proto10108053();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108053, cmd);
end

-- 请求领取免费特惠礼包
function Lua_OperationalActivitiesProxy:sBuySpecialDiscountGift(act_index,gift_id)
	local cmd = ProtoPublic_pb.Proto10108011();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id;
	sendMsg(10108011, cmd);
end

-- 请求领取超值基金奖励
function Lua_OperationalActivitiesProxy:sSpecialFundsReward(act_index)
	local cmd = ProtoPublic_pb.Proto10197006();
	-- cmd.type = 1;
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10197006, cmd);
end

-- 请求购买当季热卖礼包
function Lua_OperationalActivitiesProxy:sBuyQuarterGift(act_index, id)
	local cmd = ProtoPublic_pb.Proto10108039();
	cmd.act_index = act_index;
	cmd.id = id;
	sendMsg(10108039, cmd);
end

-- 请求boss挑战排行奖励信息
function Lua_OperationalActivitiesProxy:sBossChallengeRankRewardInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108041();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108041, cmd);
end

-- 请求领取boss挑战每日奖励
function Lua_OperationalActivitiesProxy:sBossChallengeDailyReward(act_index)
	local cmd = ProtoPublic_pb.Proto10108042();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108042, cmd);
end

-- 请求boss挑战排行榜信息
function Lua_OperationalActivitiesProxy:sBossChallengeRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108043();
	-- cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0:清空刷新 1:下一页
	sendMsg(10108043, cmd);
end

-- 请求百发百中任务信息
function Lua_OperationalActivitiesProxy:sCrackShotTaskInfo(act_index, task_type)
	local cmd = ProtoPublic_pb.Proto10108061();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = task_type; -- 任务类型：1每日 2累计
	sendMsg(10108061, cmd);
end

-- 请求百发百中排行榜信息
function Lua_OperationalActivitiesProxy:sCrackShotRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108062();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0:清空刷新 1:下一页
	sendMsg(10108062, cmd);
end

-- 请求百发百中排行榜奖励
function Lua_OperationalActivitiesProxy:sCrackShotRankReward(act_index)
	local cmd = ProtoPublic_pb.Proto10108063();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108063, cmd);
end

-- 请求计算百发百中分数
function Lua_OperationalActivitiesProxy:sComputeCrackShotScore(act_index, difficulty_type, firing_angle, target_angle, is_first)
	local cmd = ProtoPublic_pb.Proto10108064();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = difficulty_type; -- 难度
	cmd.firing_angle = firing_angle; -- 射击角度
	cmd.target_angle = target_angle; -- 目标圆心角度
	cmd.is_first = is_first; -- 第一次点击 0否 1是（用于扣游玩次数）
	sendMsg(10108064, cmd);
end

-- 请求百发百中领取阶段奖励
function Lua_OperationalActivitiesProxy:sDrawCrackShotStageReward(act_index, difficulty_type)
	local cmd = ProtoPublic_pb.Proto10108065();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = difficulty_type; -- 难度
	sendMsg(10108065, cmd);
end

-- 请求百发百中领取任务奖励
function Lua_OperationalActivitiesProxy:sDrawCrackShotTaskReward(act_index, task_type, task_id)
	local cmd = ProtoPublic_pb.Proto10108066();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = task_type; -- 任务类型
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108066, cmd);
end

-- 请求百发百中购买次数
function Lua_OperationalActivitiesProxy:sBuyCrackShotTimes(act_index, times)
	local cmd = ProtoPublic_pb.Proto10108067();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.times = times; -- 购买次数
	sendMsg(10108067, cmd);
end

-- 请求百发百中关卡信息
function Lua_OperationalActivitiesProxy:sCrackShotLevelInfo(act_index, difficulty_type, sub_type)
	local cmd = ProtoPublic_pb.Proto10108068();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = difficulty_type; -- 难度
	cmd.sub_type = sub_type; -- 库
	sendMsg(10108068, cmd);
end

-- 请求百发百中关卡信息
function Lua_OperationalActivitiesProxy:sDiamondShopBuyGift(act_index, gift_id, buys_num)
	local cmd = ProtoPublic_pb.Proto10108070();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id
	cmd.buys_num = buys_num; -- 购买数量
	sendMsg(10108070, cmd);
end

-- 请求欧皇召唤助力界面信息
function Lua_OperationalActivitiesProxy:sEuropeanRecruitInvitationInfo(active_id, type)
	local cmd = ProtoPublic_pb.Proto10108072();
	cmd.active_id = active_id; 
	cmd.type = type;
	sendMsg(10108072, cmd);
end

-- 请求他人欧皇召唤助力界面信息
function Lua_OperationalActivitiesProxy:sEuropeanRecruitOtherInvitationInfo(active_id, player_id, server_flag)
	local cmd = ProtoPublic_pb.Proto10108073();
	cmd.active_id = active_id; 
	cmd.player_id = tonumber(player_id);
	cmd.server_flag = server_flag;
	sendMsg(10108073, cmd);
end

-- 请求欧皇招募暂存记录界面
function Lua_OperationalActivitiesProxy:sEuropeanRecruitRecordInfo(active_id, type)
	local cmd = ProtoPublic_pb.Proto10108074();
	cmd.active_id = active_id;
	cmd.type = type; -- 1 窗口 2数据
	sendMsg(10108074, cmd);
end

-- 请求欧皇招募保存上一条招募记录
function Lua_OperationalActivitiesProxy:sSaveEuropeanRecruitRecord(active_id, index)
	local cmd = ProtoPublic_pb.Proto10108075();
	cmd.active_id = active_id;
	cmd.index = index;
	sendMsg(10108075, cmd);
end

-- 请求领取欧皇招募奖励
function Lua_OperationalActivitiesProxy:sReceiveEuropeanRecruitReward(active_id, index)
	local cmd = ProtoPublic_pb.Proto10108076();
	cmd.active_id = active_id;
	cmd.index = index;
	sendMsg(10108076, cmd);
end

-- 请求助力欧皇召唤
function Lua_OperationalActivitiesProxy:sEuropeanRecruitAcceptInvitation(active_id, help_id, server_flag)
	local cmd = ProtoPublic_pb.Proto10108077();
	cmd.active_id = active_id;
	cmd.help_id = help_id;
	cmd.server_flag = server_flag;
	sendMsg(10108077, cmd);
end

-- 请求欧皇招募分享结束冷却时间
function Lua_OperationalActivitiesProxy:sEuropeanRecruitShareTime(index, server_flag, active_id)
	local cmd = ProtoPublic_pb.Proto10108078();
	cmd.index = index;
	if server_flag ~= nil then
		cmd.server_flag = server_flag;
	end
	if active_id ~= nil then
		cmd.active_id = active_id;
	end

	sendMsg(10108078, cmd);
end

-- 请求干脆面碰碰任务信息
function Lua_OperationalActivitiesProxy:sMergeBlockTaskInfo(act_index, task_type)
	local cmd = ProtoPublic_pb.Proto10108080();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = task_type; -- 任务类型：1每日 2累计
	sendMsg(10108080, cmd);
end

-- 请求干脆面碰碰排行榜信息
function Lua_OperationalActivitiesProxy:sMergeBlockRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108081();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0:清空刷新 1:下一页
	sendMsg(10108081, cmd);
end

-- 请求干脆面碰碰排行榜奖励
function Lua_OperationalActivitiesProxy:sMergeBlockRankReward(act_index)
	local cmd = ProtoPublic_pb.Proto10108082();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108082, cmd);
end

-- 请求计算干脆面碰碰分数
function Lua_OperationalActivitiesProxy:sComputeMergeBlockScore(act_index, difficulty_type, base_grade, blockArr, gameArr, state, direction)
	local cmd = ProtoPublic_pb.Proto10108083();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = difficulty_type; -- 难度
	cmd.base_grade = base_grade; -- 基础分数
	for i = 1, blockArr:getSize() do
		cmd.block_list:append(blockArr[i]); -- 空方块列表
	end
	for i = 1, gameArr:getSize() do
		cmd.game_info:append(gameArr[i]); -- 对局信息
	end
	cmd.state = state; -- 1第一次点击 2正常游玩 3失败
	cmd.direction = direction; -- 滑动方向
	sendMsg(10108083, cmd);
end

-- 请求干脆面碰碰领取阶段奖励
function Lua_OperationalActivitiesProxy:sDrawMergeBlockStageReward(act_index, difficulty_type)
	local cmd = ProtoPublic_pb.Proto10108084();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = difficulty_type; -- 难度
	sendMsg(10108084, cmd);
end

-- 请求干脆面碰碰领取任务奖励
function Lua_OperationalActivitiesProxy:sDrawMergeBlockTaskReward(act_index, task_type, task_id)
	local cmd = ProtoPublic_pb.Proto10108085();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = task_type; -- 任务类型
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108085, cmd);
end

-- 请求干脆面碰碰购买次数
function Lua_OperationalActivitiesProxy:sBuyMergeBlockTimes(act_index, times)
	local cmd = ProtoPublic_pb.Proto10108086();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.times = times; -- 购买次数
	sendMsg(10108086, cmd);
end

-- 连充献礼领取
function Lua_OperationalActivitiesProxy:sGetAlwaysRechargeReward(act_index, that_day)
	local cmd = ProtoPublic_pb.Proto10108087();
	cmd.act_index = act_index;
	cmd.that_day = that_day;
	sendMsg(10108087, cmd);
end

-- 请求见缝插刀任务信息
function Lua_OperationalActivitiesProxy:sThrowKnifeTaskInfo(act_index, task_type)
	local cmd = ProtoPublic_pb.Proto10108089();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = task_type; -- 任务类型：1每日 2累计
	sendMsg(10108089, cmd);
end

-- 请求见缝插刀排行榜信息
function Lua_OperationalActivitiesProxy:sThrowKnifeRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108090();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0:清空刷新 1:下一页
	sendMsg(10108090, cmd);
end

-- 请求见缝插刀排行榜奖励
function Lua_OperationalActivitiesProxy:sThrowKnifeRankReward(act_index)
	local cmd = ProtoPublic_pb.Proto10108091();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108091, cmd);
end

-- 请求计算见缝插刀分数
function Lua_OperationalActivitiesProxy:sComputeThrowKnifeScore(act_index, state, level, grade, extra_grade, knifeAngleArr)
	local cmd = ProtoPublic_pb.Proto10108092();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.state = state; -- 1开始游玩 2正常游玩 3结束
	cmd.level = level; -- 起始关卡/当前关卡
	cmd.grade = grade; -- 起始分数/当前关卡得分
	cmd.extra_grade = extra_grade; -- 额外得分（击中配置道具）
	for i = 1, knifeAngleArr:getSize() do
		cmd.verification:append(knifeAngleArr[i]); -- 验证信息，每把刀的角度
	end
	sendMsg(10108092, cmd);
end

-- 请求见缝插刀领取阶段奖励
function Lua_OperationalActivitiesProxy:sDrawThrowKnifeStageReward(act_index)
	local cmd = ProtoPublic_pb.Proto10108093();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108093, cmd);
end

-- 请求见缝插刀领取任务奖励
function Lua_OperationalActivitiesProxy:sDrawThrowKnifeTaskReward(act_index, task_type, task_id)
	local cmd = ProtoPublic_pb.Proto10108094();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = task_type; -- 任务类型
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108094, cmd);
end

-- 请求见缝插刀关卡信息
function Lua_OperationalActivitiesProxy:sThrowKnifeLevelInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108095();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108095, cmd);
end

-- 请求无尽关卡领取奖励
function Lua_OperationalActivitiesProxy:sEndlessLevelDrawReward(reward_type, act_index)
	local cmd = ProtoPublic_pb.Proto10108097();
	cmd.type = reward_type; -- 奖励类型：1波数领取 2每日挑战领取 3为助战奖励
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108097, cmd);
end

-- 请求无尽关卡排行奖励信息
function Lua_OperationalActivitiesProxy:sEndlessLevelRankRewardInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108098();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108098, cmd);
end

-- 请求无尽关卡助力界面
function Lua_OperationalActivitiesProxy:sEndlessLevelAssistMyInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108099();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108099, cmd);
end

-- 请求他人无尽关卡助力界面
function Lua_OperationalActivitiesProxy:sEndlessLevelAssistOtherInfo(active_id, player_id, server_flag)
	local cmd = ProtoPublic_pb.Proto10108100();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.player_id = player_id; -- 玩家ID
	cmd.server_flag = server_flag; -- 玩家服务器标识
	sendMsg(10108100, cmd);
end

-- 请求无尽关卡助力分享
function Lua_OperationalActivitiesProxy:sEndlessLevelAssistShare(index, server_flag, active_id)
	local cmd = ProtoPublic_pb.Proto10108101();
	cmd.index = index; -- 好友id/频道类型
	cmd.server_flag = server_flag; -- 玩家服务器标识
	cmd.active_id = active_id; -- 活动唯一索引
	sendMsg(10108101, cmd);
end

-- 请求无尽关卡排行榜
function Lua_OperationalActivitiesProxy:sEndlessLevelRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108102();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0:清空刷新 1:下一页
	sendMsg(10108102, cmd);
end

-- 请求助力无尽关卡助力
function Lua_OperationalActivitiesProxy:sEndlessLevelAssistToOther(active_id, help_id, server_flag)
	local cmd = ProtoPublic_pb.Proto10108103();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.help_id = help_id; -- 助力玩家id
	cmd.server_flag = server_flag; -- 助力玩家服务器标识
	sendMsg(10108103, cmd);
end

-- 请求无尽关卡继续战斗
function Lua_OperationalActivitiesProxy:sEndlessLevelKeepFighting(act_index)
	local cmd = ProtoPublic_pb.Proto10108104();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108104, cmd);
end

-- 请求领取登录福利
function Lua_OperationalActivitiesProxy:sDrawLoginReward(drawType, day_id, act_index)
	local cmd = ProtoPublic_pb.Proto10108105();
	cmd.type = drawType; -- 1 为登录福利，2七日累充
	cmd.day_id = day_id; -- 天数id
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108105, cmd);
end

-- 请求图腾招募奖励一览界面
function Lua_OperationalActivitiesProxy:sTotemRecruitPreviewInfo(active_id, index)
	local cmd = ProtoPublic_pb.Proto10108107();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.index = index; -- 界面索引 0默认全发
	sendMsg(10108107, cmd);
end

-- 请求图腾招募抽奖记录界面
function Lua_OperationalActivitiesProxy:sTotemRecruitRecordInfo(active_id, index)
	local cmd = ProtoPublic_pb.Proto10108108();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.index = index; -- 界面索引 0默认全发
	sendMsg(10108108, cmd);
end

-- 请求抽取图腾招募奖励
function Lua_OperationalActivitiesProxy:sTotemRecruitDrawRecruitReward(active_id, index, draw_times)
	local cmd = ProtoPublic_pb.Proto10108109();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.index = index; -- 界面索引 0默认全发
	cmd.draw_times = draw_times; -- 抽取次数
	sendMsg(10108109, cmd);
end

-- 请求图腾招募任务界面信息
function Lua_OperationalActivitiesProxy:sTotemRecruitTaskInfo(active_id, task_type)
	local cmd = ProtoPublic_pb.Proto10108110();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.task_type = task_type; -- 任务类型 1日常任务 2累积任务
	sendMsg(10108110, cmd);
end

-- 请求领取图腾招募任务奖励信息
function Lua_OperationalActivitiesProxy:sTotemRecruitDrawTaskReward(active_id, reward_id)
	local cmd = ProtoPublic_pb.Proto10108111();
	cmd.active_id = active_id; -- 活动唯一索引
	cmd.reward_id = reward_id; -- 任务id
	sendMsg(10108111, cmd);
end

-- 请求异兽争胜排行界面
function Lua_OperationalActivitiesProxy:sStrangeBeastMatchRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108113();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0刷新 1下一页
	sendMsg(10108113, cmd);
end

-- 请求异兽争胜排行奖励界面
function Lua_OperationalActivitiesProxy:sStrangeBeastMatchRankRewardInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108114();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108114, cmd);
end

-- 请求异兽争胜日常任务界面
function Lua_OperationalActivitiesProxy:sStrangeBeastMatchTaskInfo(act_index, _type)
	local cmd = ProtoPublic_pb.Proto10108115();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = _type; -- 任务类型 1 每日 2 累计
	sendMsg(10108115, cmd);
end


-- 请求领取异兽争胜积分奖励
function Lua_OperationalActivitiesProxy:sGetStrangeBeastMatchScoreReward(act_index, id)
	local cmd = ProtoPublic_pb.Proto10108116();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.id = id; -- 积分档次id
	sendMsg(10108116, cmd);
end

-- 请求领取异兽争胜日常任务奖励
function Lua_OperationalActivitiesProxy:sGetStrangeBeastMatchTaskReward(act_index, _type, task_id)
	local cmd = ProtoPublic_pb.Proto10108117();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = _type; -- 任务类型
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108117, cmd);
end

-- 请求皮肤直购预览
function Lua_OperationalActivitiesProxy:sSkinPurchase(active_id)
	local cmd = ProtoPublic_pb.Proto10108122();
	cmd.active_id = active_id; -- 活动唯一索引
	sendMsg(10108122, cmd);
end

-- 请求领取半月礼包奖励
function Lua_OperationalActivitiesProxy:sDrawHalfMonthGift(act_index, reward_id, itemIdArr)
	local cmd = ProtoPublic_pb.Proto10108121();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.reward_id = reward_id; -- 奖励id
	if itemIdArr then
		local item_list;
		for i = 1, itemIdArr:getSize() do
			item_list = getProtoMsg("ProtoPair");
			item_list.key = itemIdArr[i].id;
			item_list.value = itemIdArr[i].count;
			cmd.item_list:addToList(item_list);
		end
	end
	sendMsg(10108121, cmd);
end

-- 请求浣熊跳跳乐任务信息
function Lua_OperationalActivitiesProxy:sJumpingHappyTaskInfo(act_index, type)
	local cmd = ProtoPublic_pb.Proto10108124();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = type; -- 任务类型 1 每日任务 2 累计任务
	sendMsg(10108124, cmd);
end

-- 请求浣熊跳跳乐排行榜信息
function Lua_OperationalActivitiesProxy:sJumpingHappyRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108125();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; 
	sendMsg(10108125, cmd);
end

-- 请求浣熊跳跳乐排行榜奖励
function Lua_OperationalActivitiesProxy:sJumpingHappyRankRewardInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108126();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108126, cmd);
end

-- 请求计算浣熊跳跳乐分数
function Lua_OperationalActivitiesProxy:sJumpingHappyScore(act_index, type_id, state, total_distance, side_distance, detail_x, detail_y, block_index)
	local cmd = ProtoPublic_pb.Proto10108127();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type_id = type_id; -- 关卡id
	cmd.state = state or 1; -- 状态 1 新开游戏   2 正常游戏    3 结算游戏
	cmd.total_distance = total_distance or 0; -- 总跳跃距离
	cmd.side_distance = side_distance or 0; -- 角色距离跳跃方向一侧长S1
	cmd.detail_x = detail_x or 0; -- 间隔x
	cmd.detail_y = detail_y or 0; -- 间隔y
	cmd.block_index = block_index or 0; -- 角色所在方块序号
	sendMsg(10108127, cmd);
end

-- 请求浣熊跳跳乐领取阶段奖励
function Lua_OperationalActivitiesProxy:sJumpingHappyStageReward(act_index, type)
	local cmd = ProtoPublic_pb.Proto10108128();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = type; -- 难度
	sendMsg(10108128, cmd);
end

-- 请求浣熊跳跳乐领取任务奖励
function Lua_OperationalActivitiesProxy:sJumpingHappyTaskReward(act_index, type, task_id)
	local cmd = ProtoPublic_pb.Proto10108129();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.type = type; -- 任务类型 1 每日 2 累计
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108129, cmd);
end

-- 请求浣熊跳跳乐购买次数
function Lua_OperationalActivitiesProxy:sJumpingHappyPlayCount(act_index, times)
	local cmd = ProtoPublic_pb.Proto10108130();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.times = times; -- 购买次数
	sendMsg(10108130, cmd);
end

-- 请求购买豪礼兑换奖励
function Lua_OperationalActivitiesProxy:sBuyLuxuryCashReward(act_index, reward_id, buy_times, shop_grade)
	local cmd = ProtoPublic_pb.Proto10108132();
	cmd.act_index = act_index; -- 活动索引
	cmd.reward_id = reward_id; -- 奖励配置id
	cmd.buy_times = buy_times; -- 购买次数
	cmd.shop_grade = shop_grade; -- 商店档位 1普通 2高级
	sendMsg(10108132, cmd);
end

-- 请求豪礼兑换礼包界面
function Lua_OperationalActivitiesProxy:sLuxuryCashGiftInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108133();
	cmd.act_index = act_index; -- 活动索引
	sendMsg(10108133, cmd);
end

-- 请求豪礼兑换领取礼包
function Lua_OperationalActivitiesProxy:sGetLuxuryCashGift(act_index, conf_id)
	local cmd = ProtoPublic_pb.Proto10108134();
	cmd.act_index = act_index; -- 活动索引
	cmd.conf_id = conf_id; -- 礼包配置id
	sendMsg(10108134, cmd);
end

-- 请求豪礼兑换任务界面
function Lua_OperationalActivitiesProxy:sGetLuxuryCashTaskInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108135();
	cmd.act_index = act_index; -- 活动索引
	sendMsg(10108135, cmd);
end

-- 请求豪礼兑换领取任务奖励
function Lua_OperationalActivitiesProxy:sDrawGetLuxuryCashTaskReward(act_index, type, task_id)
	local cmd = ProtoPublic_pb.Proto10108136();
	cmd.act_index = act_index; -- 活动索引
	cmd.type = type; -- 任务类型 1每日 2累计
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108136, cmd);
end

























------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_OperationalActivitiesProxy:updateItemInfo(dic)
	DataCenter.totemRecruitData:updateTotemRecruitRed(dic); -- 图腾招募
end

function Lua_OperationalActivitiesProxy:updateActivitiesInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108001();
		msg:ParseFromString(mp.data);
		DataCenter.backstageActData:fromServer80108001(msg);
	end
end

function Lua_OperationalActivitiesProxy:updateActivitiesRedDot(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108002();
		msg:ParseFromString(mp.data);
		DataCenter.backstageActData:fromServer80108002(msg);
	end
end

function Lua_OperationalActivitiesProxy:rCumulateRechargeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108003();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CUMULATE_RECHARGE_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rUpStarOfCycleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108005();
		msg:ParseFromString(mp.data);
		DataCenter.upStarOfCycleData:fromServer50108005(msg);
		Lua_MsgUtil.callFunc("UPDATE_UPSTAROFCYCLE_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rCustomGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108007();
		msg:ParseFromString(mp.data);
		DataCenter.customGiftData:fromServer50108007(msg);
		Lua_MsgUtil.callFunc("UPDATE_CUSTOMGIFT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rLuckyGiftBoxInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108012();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer50108012(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rBestGiftBoxInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108017();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer50108017(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_BESTGIFT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rLuckyGiftBoxDetailInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108018();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_DETAIL_INFO", msg.lucky_box_info);
	end
end

function Lua_OperationalActivitiesProxy:rSpecialDiscountGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108010();
		msg:ParseFromString(mp.data);
		DataCenter.specialDiscountGiftData:fromServer50108010(msg);
		Lua_MsgUtil.callFunc("UPDATE_SPECIALDISCOUNTGIFT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rSpecialFundsInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197005();
		msg:ParseFromString(mp.data);
		DataCenter.newSpecialFundsData:fromServer50197005(msg);
		Lua_MsgUtil.callFunc("UPDATE_FUNDSITEM_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rQuarterHotSellInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108038();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_QUARTERHOTSELL_PANEL", msg);
	end
end

function Lua_OperationalActivitiesProxy:rBossChallengeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108040();
		msg:ParseFromString(mp.data);
		DataCenter.bossChallengeData:fromServer50108040(msg);
		Lua_MsgUtil.callFunc("UPDATE_BOSSCHALLENGE_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rBossChallengeRankRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108041();
		msg:ParseFromString(mp.data);
		DataCenter.bossChallengeData:fromServer50108041(msg);
		Lua_MsgUtil.callFunc("UPDATE_BOSSCHALLENGE_RANKREWARD_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rBossChallengeRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108043();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_BOSSCHALLENGE_RANK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:updateMoreDoubleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108044();
		msg:ParseFromString(mp.data);
		DataCenter.moreDoubleData:fromServer80108044(msg);
	end
end

function Lua_OperationalActivitiesProxy:rMoreDoubleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108044();
		msg:ParseFromString(mp.data);
		DataCenter.moreDoubleData:fromServer50108044(msg);
		Lua_MsgUtil.callFunc("UPDATE_MORE_DOUBLE_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rWeekCardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108045();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("SHOW_WEEKCARD_PANEL", msg);
	end
end

function Lua_OperationalActivitiesProxy:rLuckyGiftBoxTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108052();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer50108052(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_TASK_INFO");
	end
end

function Lua_OperationalActivitiesProxy:nLuckyGiftBoxTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108054();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer80108054(msg.task_info);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_TASK_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rCrackShotInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108060();
		msg:ParseFromString(mp.data);
		DataCenter.crackShotData:fromServer50108060(msg);
		Lua_MsgUtil.callFunc("UPDATE_CRACKSHOT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rCrackShotTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108061();
		msg:ParseFromString(mp.data);
		DataCenter.crackShotData:fromServer50108061(msg);
		Lua_MsgUtil.callFunc("UPDATE_CRACKSHOT_TASK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rCrackShotRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108062();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_CRACKSHOT_RANK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rCrackShotRankReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108063();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_CRACKSHOT_RANK_REWARD", msg);
	end
end

function Lua_OperationalActivitiesProxy:rComputeCrackShotScore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108064();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_CRACKSHOT_CHALLENGE", msg);
	end
end

function Lua_OperationalActivitiesProxy:rCrackShotLevelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108068();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_CRACKSHOT_ROUNDINFO", msg.level_info);
	end
end

function Lua_OperationalActivitiesProxy:rDiamondShopInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108070();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_DIAMONDSHOP_INFO", msg.gift_bag);
	end
end

-- 请求欧皇召唤界面信息（返回）
function Lua_OperationalActivitiesProxy:rEuropeanRecruitInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108071();
		msg:ParseFromString(mp.data);
		DataCenter.europeanRecruitData:fromServer50108071(msg);
		Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_MAINWININFO");
		Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_RECORDLIST");
	end
end

-- 请求欧皇召唤助力界面信息(返回)
function Lua_OperationalActivitiesProxy:rEuropeanRecruitInvitationInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108072();
		msg:ParseFromString(mp.data);

		if msg.type == 1 then
			Lua_WindowUtil.openWin("Lua_EuropeanRecruitInvitationWindow", Lua_WinParam.ACTION_OPEN, msg);
		else
			Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_INVITATION", msg);
		end
	end
end

-- 请求他人欧皇召唤助力界面信息(返回)
function Lua_OperationalActivitiesProxy:rEuropeanRecruitOtherInvitationInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108073();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_EuropeanRecruitShareWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

-- 请求欧皇招募暂存记录界面(返回)
function Lua_OperationalActivitiesProxy:rEuropeanRecruitRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108074();
		msg:ParseFromString(mp.data);
		DataCenter.europeanRecruitData:fromServer50108074(msg);
		Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_MAINWININFO");
		Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_RECORDLIST");
		if msg.type == 1 then
			Lua_WindowUtil.openWin("Lua_EuropeanRecruitRecordWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

-- 请求欧皇招募保存上一条招募记录(返回)
function Lua_OperationalActivitiesProxy:rSaveEuropeanRecruitRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108075();
		msg:ParseFromString(mp.data);

		if msg.save_flag == 0 then
			OperateAlert.showLangValue(163065);
			return;
		end

		if msg.save_flag == 1 then
			Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_SHOWTIPS");
		end
	end
end

-- 请求欧皇招募分享结束冷却时间(返回)
function Lua_OperationalActivitiesProxy:rEuropeanRecruitShareTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108078();
		msg:ParseFromString(mp.data);

		local endTick = tonumber(msg.share_tick) or 0;
		local residueTime = endTick - DataCenter.roleData.serverTime;
		if residueTime > 0 then
			local str = LanUtil.formateStr(163012, residueTime);
			OperateAlert.show(str);
			return;
		end

		local index = tonumber(msg.index);
		if index == Lua_ChatData.CHANNEL_LEAGUE then
			Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_INVITATION_SHARE_LEAGUE");
		else
			Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_INVITATION_SHARE_FRIEND", tonumber(msg.index));
		end
	end
end

-- 通知欧皇招募首次弹窗
function Lua_OperationalActivitiesProxy:noticeEuropeanRecruitOpen(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108071();
		msg:ParseFromString(mp.data);

		if tonumber(msg.is_pop) == 1 then
			Lua_WindowUtil.openWin("Lua_EuropeanRecruitMainWindow", Lua_WinParam.ACTION_OPEN);
		end
	end
end

-- 通知欧皇招募隐藏
function Lua_OperationalActivitiesProxy:rEuropeanRecruitHide(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108072();
		msg:ParseFromString(mp.data);
		DataCenter.europeanRecruitData:fromServer80108072(msg);
	end
end

function Lua_OperationalActivitiesProxy:rMergeBlockInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108079();
		msg:ParseFromString(mp.data);
		DataCenter.mergeBlockData:fromServer50108079(msg);
		Lua_MsgUtil.callFunc("UPDATE_MERGEBLOCK_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rMergeBlockTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108080();
		msg:ParseFromString(mp.data);
		DataCenter.mergeBlockData:fromServer50108080(msg);
		Lua_MsgUtil.callFunc("UPDATE_MERGEBLOCK_TASK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rMergeBlockRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108081();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_MERGEBLOCK_RANK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rMergeBlockRankReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108082();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_MERGEBLOCK_RANK_REWARD", msg);
	end
end

function Lua_OperationalActivitiesProxy:rComputeMergeBlockScore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108083();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_MERGEBLOCK_CHALLENGE", msg);
	end
end

-- 连充献礼返回
function Lua_OperationalActivitiesProxy:rAlwaysRechargeGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108087();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_ALWAYSRECHARGEGIFT_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rThrowKnifeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108088();
		msg:ParseFromString(mp.data);
		DataCenter.throwKnifeData:fromServer50108088(msg);
		Lua_MsgUtil.callFunc("UPDATE_THROWTKNIFE_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rThrowKnifeTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108089();
		msg:ParseFromString(mp.data);
		DataCenter.throwKnifeData:fromServer50108089(msg);
		Lua_MsgUtil.callFunc("UPDATE_THROWTKNIFE_TASK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rThrowKnifeRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108090();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_THROWTKNIFE_RANK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rThrowKnifeRankReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108091();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_THROWTKNIFE_RANK_REWARD", msg);
	end
end

function Lua_OperationalActivitiesProxy:rComputeThrowKnifeScore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108092();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_THROWTKNIFE_CHALLENGE", msg);
	end
end

function Lua_OperationalActivitiesProxy:rThrowKnifeLevelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108095();
		msg:ParseFromString(mp.data);
		DataCenter.throwKnifeData:fromServer50108095(msg);
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108096();
		msg:ParseFromString(mp.data);
		DataCenter.endlessLevelData:fromServer50108096(msg);
		Lua_MsgUtil.callFunc("UPDATE_ENDLESSLEVEL_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelRankRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108098();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_ENDLESSLEVEL_RANK_REWARD", msg.ranking_award);
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelAssistMyInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108099();
		msg:ParseFromString(mp.data);
		DataCenter.endlessLevelData:fromServer50108099(msg);
		Lua_MsgUtil.callFunc("UPDATE_ENDLESSLEVEL_ASSIS_MY_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelAssistOtherInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108100();
		msg:ParseFromString(mp.data);
		if not Lua_WindowUtil.isWindowShowing("Lua_EndlessLevelInviteWindow") then
			Lua_WindowUtil.openWin("Lua_EndlessLevelInviteWindow", Lua_WinParam.ACTION_OPEN, msg);
		else
			Lua_MsgUtil.callFunc("UPDATE_ENDLESSLEVEL_ASSIST_OTHER_INFO", msg);
		end
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelAssistShare(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108101();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_ENDLESSLEVEL_ASSIST_SHARE", msg);
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108102();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_ENDLESSLEVEL_RANK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:nEndlessLevelSkipInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108103();
		msg:ParseFromString(mp.data);
		DataCenter.endlessLevelData.isNeedSkip = true;
		DataCenter.endlessLevelData:fromServer80108103(msg);
	end
end

function Lua_OperationalActivitiesProxy:rEndlessLevelKeepFighting(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108104();
		msg:ParseFromString(mp.data);
		DataCenter.endlessLevelData:fromServer50108104(msg);
	end
end

function Lua_OperationalActivitiesProxy:rLoginRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108105();
		msg:ParseFromString(mp.data);
		DataCenter.loginRewardData:fromServer50108105(msg);
		Lua_MsgUtil.callFunc("UPDATE_LOGINREWARD_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rTotemRecruitInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108106();
		msg:ParseFromString(mp.data);
		DataCenter.totemRecruitData:fromServer50108106(msg);
		Lua_MsgUtil.callFunc("UPDATE_TOTEMRECRUIT_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rTotemRecruitPreviewInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108107();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_TOTEMRECRUIT_PREVIEW_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rTotemRecruitRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108108();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_TOTEMRECRUIT_RECORD_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:nTotemRecruitRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108108();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_TOTEMRECRUIT_RECORD_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rTotemRecruitDrawRecruitReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108109();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_TotemRecruitShowRewardWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_OperationalActivitiesProxy:rTotemRecruitTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108110();
		msg:ParseFromString(mp.data);
		DataCenter.totemRecruitData:fromServer50108110(msg);
		Lua_MsgUtil.callFunc("UPDATE_TOTEMRECRUIT_TASK_INFO", msg);
	end
end

-- 请求异兽争胜界面（返回）
function Lua_OperationalActivitiesProxy:rStrangeBeastMatchInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108112();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STRANGEBEASTMATCH_INFO", msg);
	end
end

-- 请求异兽争胜排行界面（返回）
function Lua_OperationalActivitiesProxy:rStrangeBeastMatchRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108113();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STRANGEBEASTMATCH_RANK_INFO", msg);
	end
end

-- 请求异兽争胜排行奖励界面（返回）
function Lua_OperationalActivitiesProxy:rStrangeBeastMatchRankRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108114();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STRANGEBEASTMATCH_RANK_REWARD_INFO", msg);
	end
end

-- 请求异兽争胜日常任务界面（返回）
function Lua_OperationalActivitiesProxy:rStrangeBeastMatchTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108115();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STRANGEBEASTMATCH_TASK_INFO", msg);
	end
end

-- 请求皮肤直购活动界面(返回)
function Lua_OperationalActivitiesProxy:rSkinPurchaseInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108118();
		msg:ParseFromString(mp.data);
		DataCenter.skinPurchaseData:fromServer50108118(msg);
		Lua_MsgUtil.callFunc("UPDATE_SKINPURCHASE_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rHalfMonthGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108119();
		msg:ParseFromString(mp.data);
		DataCenter.halfMonthGiftData:fromServer50108119(msg);
		Lua_MsgUtil.callFunc("UPDATE_HALFMONTHGIFT_INFO");
	end
end

-- 请求浣熊跳跳乐界面(返回)
function Lua_OperationalActivitiesProxy:rJumpingHappyInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108123();
		msg:ParseFromString(mp.data);
		DataCenter.jumpingHappyData:fromServer50108123(msg);
		Lua_MsgUtil.callFunc("UPDATE_JUMPHAPPY_PANEL_INFO");
	end
end

-- 请求浣熊跳跳乐任务信息（返回）
function Lua_OperationalActivitiesProxy:rJumpingHappyTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108124();
		msg:ParseFromString(mp.data);
		DataCenter.jumpingHappyData:fromServer50108124(msg);
		Lua_MsgUtil.callFunc("UPDATE_JUMPINGHAPPY_TASK_INFO", msg);
	end
end

-- 请求浣熊跳跳乐排行榜信息（返回）
function Lua_OperationalActivitiesProxy:rJumpingHappyRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108125();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_JUMPINGHAPPY_RANK_INFO", msg);
	end
end

-- 请求浣熊跳跳乐排行榜奖励（返回）
function Lua_OperationalActivitiesProxy:rJumpingHappyRankRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108126();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_JUMPINGHAPPY_RANK_REWARD_INFO", msg);
	end
end

-- 请求计算浣熊跳跳乐分数（返回）
function Lua_OperationalActivitiesProxy:rJumpingHappyScore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108127();
		msg:ParseFromString(mp.data);
		DataCenter.jumpingHappyData:fromServer50108127(msg);

		if msg.state == 1 then
			Lua_WindowUtil.openWin("Lua_JumpHappyPlayWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

-- 请求豪礼兑换奖励界面(返回)
function Lua_OperationalActivitiesProxy:rLuxuryCashInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108131();
		msg:ParseFromString(mp.data);
		DataCenter.luxuryCashData:fromServer50108131(msg);
	end
end

-- 请求豪礼兑换礼包界面(返回)
function Lua_OperationalActivitiesProxy:rLuxuryCashGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108133();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LUXURYCASH_GIFT_INFO", msg);
	end
end

-- 请求豪礼兑换任务界面（返回）
function Lua_OperationalActivitiesProxy:rGetLuxuryCashTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108135();
		msg:ParseFromString(mp.data);
		DataCenter.luxuryCashData:fromServer50108135(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUXURYCASH_TASK_INFO", msg);
	end
end