-- 每日礼包
checkRequire("Lua_DailyGiftVo");
Lua_DailyGiftData = class("Lua_DailyGiftData");
function Lua_DailyGiftData:ctor()
end

function Lua_DailyGiftData:dispose()
	self._dailyGiftArr = nil;
	self.dailyGiftDic = nil;
end

function Lua_DailyGiftData:fromServer50197043(msg)
	if msg == nil then
		return;
	end

	self._nextDay = msg.next_day; -- 明日刷新时间戳
	self:updateDailyGiftInfo(msg.grade_state); -- 各档位剩余领取次数 key礼包id value剩余次数
end

function Lua_DailyGiftData.Get:nextDay()
	return self._nextDay or 0;
end

function Lua_DailyGiftData:updateDailyGiftInfo(msg)
	if self._dailyGiftArr == nil then
		self._dailyGiftArr = Array();
	else
		self._dailyGiftArr:clear();
	end
	self.isNeedSort = true;

	local obj;
	local vo;
	local redShowState = false;
	for i = 1, #msg do
		obj = msg[i];
		vo = self:getDailyGiftVo(obj.key);
		if vo == nil then
			local config = getConfig("daily_gift_new", obj.key);
			if config ~= nil then
				vo = Lua_DailyGiftVo.new(obj.key, config);
				self.dailyGiftDic[obj.key] = vo;
			end
		end
		
		if vo ~= nil then
			vo.curLimitTimes = obj.value;
			self._dailyGiftArr:add(obj.key);
			if not redShowState and vo.money == 0 and vo.curLimitTimes > 0 then
				redShowState = true;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_GiftShop_DailyGift, redShowState);
end

function Lua_DailyGiftData:getDailyGiftVo(id)
	if self.dailyGiftDic == nil then
		self.dailyGiftDic = {};
	end
	return self.dailyGiftDic[id];
end

function Lua_DailyGiftData.Get:dailyGiftArr()
	if self.isNeedSort then
		self.isNeedSort = false;
		self._dailyGiftArr:sortf(self, self.sortFun);
	end
	return self._dailyGiftArr;
end

function Lua_DailyGiftData:sortFun(a, b)
	local voA = self:getDailyGiftVo(a);
	local voB = self:getDailyGiftVo(b);
	local _a = voA.curLimitTimes;
	local _b = voB.curLimitTimes;
	if (_a > 0 and _b > 0) or (_a <= 0 and _b <= 0) then
		if voA.sort > voB.sort then
			return false;
		end
	elseif _b > 0 then
		return false;
	end
	return true;
end