-- 每周礼包
checkRequire("Lua_WeeklyGiftVo");
Lua_WeeklyGiftData = class("Lua_WeeklyGiftData");
function Lua_WeeklyGiftData:ctor()
end

function Lua_WeeklyGiftData:dispose()
	self._weeklyGiftArr = nil;
	self.weeklyGiftDic = nil;
end

function Lua_WeeklyGiftData:fromServer50197012(msg)
	if msg == nil then
		return;
	end

	self._nextWeek = msg.next_week; -- 下周刷新时间戳
	self:updateWeeklyGiftInfo(msg.grade_state); -- 各档位剩余领取次数 key礼包id value剩余次数
end

function Lua_WeeklyGiftData.Get:nextWeek()
	return self._nextWeek or 0;
end

function Lua_WeeklyGiftData:updateWeeklyGiftInfo(msg)
	if self._weeklyGiftArr == nil then
		self._weeklyGiftArr = Array();
	else
		self._weeklyGiftArr:clear();
	end
	self.isNeedSort = true;

	local obj;
	local vo;
	local redShowState = false;
	for i = 1, #msg do
		obj = msg[i];
		vo = self:getWeeklyGiftVo(obj.key);
		if vo == nil then
			local config = getConfig("week_gift", obj.key);
			if config ~= nil then
				vo = Lua_WeeklyGiftVo.new(obj.key, config);
				self.weeklyGiftDic[obj.key] = vo;
			end
		end
		
		if vo ~= nil then
			vo.curLimitTimes = obj.value;
			self._weeklyGiftArr:add(obj.key);
			if not redShowState and vo.money == 0 and vo.curLimitTimes > 0 then
				redShowState = true;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_GiftShop_WeeklyGift, redShowState);
end

function Lua_WeeklyGiftData:getWeeklyGiftVo(id)
	if self.weeklyGiftDic == nil then
		self.weeklyGiftDic = {};
	end
	return self.weeklyGiftDic[id];
end

function Lua_WeeklyGiftData.Get:weeklyGiftArr()
	if self.isNeedSort then
		self.isNeedSort = false;
		self._weeklyGiftArr:sortf(self, self.sortFun);
	end
	return self._weeklyGiftArr;
end

function Lua_WeeklyGiftData:sortFun(a, b)
	local voA = self:getWeeklyGiftVo(a);
	local voB = self:getWeeklyGiftVo(b);
	local _a = voA.curLimitTimes;
	local _b = voB.curLimitTimes;
	if (_a > 0 and _b > 0) or (_a <= 0 and _b <= 0) then
		if voA.sort > voB.sort then
			return false;
		end
	elseif _b > 0 then
		return false;
	end
	return true;
end