Lua_DailyGiftVo = class("Lua_DailyGiftVo")
function Lua_DailyGiftVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_DailyGiftVo:dispose()
	self._curLimitTimes = nil;
end

function Lua_DailyGiftVo.Get:config()
	if self._config == nil then
		self._config = getConfig("daily_gift_new", self.id);
	end
	return self._config;
end

-- 购买金额
function Lua_DailyGiftVo.Get:money()
	local money = 0;
	if self.config.recharge_type ~= 1 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.id);
		if rechargeInfo then
			money = tonumber(rechargeInfo.money);
		end
	end
	return money;
end

-- 限制购买次数
function Lua_DailyGiftVo.Get:curLimitTimes()
	if self._curLimitTimes == nil then
		self._curLimitTimes = self.limit_times;
	end
	return self._curLimitTimes or 0;
end

function Lua_DailyGiftVo.Set:curLimitTimes(val)
	self._curLimitTimes = val;
end

-- 排序
function Lua_DailyGiftVo.Get:sort()
	return self.config.sort or 0;
end

-- 限购总次数
function Lua_DailyGiftVo.Get:limit_times()
	return self.config.limit_times;
end

-- 奖励
function Lua_DailyGiftVo.Get:reward()
	return self.config.reward;
end

-- 奖励icon
function Lua_DailyGiftVo.Get:reward_icon()
	return self.config.reward_icon;
end

-- 道具比列
function Lua_DailyGiftVo.Get:rate()
	return #self.reward < 4 and 0.5 or 0.4;
end