checkRequire("Lua_RecruitTypeVo");
Lua_RecruitUtil = class("Lua_RecruitUtil");

function Lua_RecruitUtil:ctor()
    self:dispose();
end

function Lua_RecruitUtil:ctor()
    self._checkHeroNew = false;
end

function Lua_RecruitUtil:initRecruitInfo()
    if self._recruitTypeDic == nil then
        self._recruitTypeDic = {};
        self._recruitTypeArr = Array();
        local config = getConfig("hero_recruit");
        for k, v in pairs(config) do
            self._recruitTypeDic[k] = Lua_RecruitTypeVo.new(k, v);
            self._recruitTypeArr:add(k);
        end
    end
end

function Lua_RecruitUtil.Get:recruitTypeDic()
    self:initRecruitInfo();
    return self._recruitTypeDic;
end

function Lua_RecruitUtil.Get:recruitTypeArr()
    self:initRecruitInfo();
    return self._recruitTypeArr;
end

function Lua_RecruitUtil:getRecruitTypeVo(id)
    return self.recruitTypeDic[id];
end









------------------------------ 心愿单 ------------------------------

function Lua_RecruitUtil:getWishListConfig(name)
    if self._wishListConfig == nil then
        self._wishListConfig = getConfig("wish_list", 1);
    end
    return self._wishListConfig[name];
end

function Lua_RecruitUtil:getWishListHeroArr(camp)
    local config = self:getWishListConfig("show_limit_hero");
    local star = DataCenter.heroUtil:getHeroAwakenStarByQuality(config[1], config[2]);
    local idArr = DataCenter.heroUtil:getHeroIdArr(star, camp);
    local arr = Array();
    if idArr ~= nil then
        local vo;
        local tempStar;
        local uidArr;
        local uidVo;

        local openState, openDay;
        local limitDay = getConfig("recruit_const", "new_hero_show_limit", "value");
        for i = 1, idArr:getSize() do
            vo = Lua_HeroVo.new(idArr[i]);
            if vo.isShowWish then
                if DataCenter.heroData:isExistHeroById(idArr[i]) then
                    vo.isHasHero = true;
                    uidArr = DataCenter.heroData:getHeroUidArrById(idArr[i]);
                    if uidArr ~= nil then
                        tempStar = 0;
                        for i = 1, uidArr:getSize() do
                            uidVo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
                            if uidVo.star > tempStar and uidVo.is_league_transaction == false and not uidVo.trial_state then
                                vo.quality = uidVo.quality;
                                vo.quality_star = uidVo.quality_star;
                                vo.unique_id = uidVo.unique_id;
                                tempStar = uidVo.star;
                            end
                        end
                    end
                end

                openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(idArr[i], Lua_NewHeroFuncOpen.advance_recruit); -- 达到开服天数限制才显示
                if openState then
                    vo.isShowNew = openDay ~= 0 and DataCenter.roleData.open_days - openDay <= limitDay;
                    arr:add(vo);
                end
            end
        end
    end

    -- 检测New状态，防止不同步
    local state = self:checkNewHeroShow();
    if state ~= self._checkHeroNew then
        self._checkHeroNew = state;
        Lua_MsgUtil.callFunc("UPDATE_RECRUIT_NEWHERO");
    end
    return arr;
end

function Lua_RecruitUtil:checkNewHeroShow()
    local arr = DataCenter.heroUtil:getNewHeroUnlockArrByType(Lua_NewHeroFuncOpen.advance_recruit);
    local limitDay = getConfig("recruit_const", "new_hero_show_limit", "value");
    for i = 1, arr:getSize() do
        if DataCenter.roleData.open_days - arr[i].day <= limitDay then
            return true;
        end
    end
    return false;
end

function Lua_RecruitUtil:checkNewHeroShowByHeroId(heroId)
    if heroId == nil then
        return false;
    end

    local state, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(heroId, Lua_NewHeroFuncOpen.advance_recruit);
    if state ~= true or openDay == 0 then
        return false;
    end

    local limitDay = getConfig("recruit_const", "new_hero_show_limit", "value");
    return DataCenter.roleData.open_days - openDay <= limitDay;
end






-------------------------小卖部规则说明匹配------------------------------

function Lua_RecruitUtil.Get:getRecruitRuleDic()
    if self._recruitRuleDic == nil then
        self._recruitRuleDic = {};
        local config = getConfig("recruit_rule");
        for k, v in pairs(config) do
            if self._recruitRuleDic[v.rule_type] == nil then
                self._recruitRuleDic[v.rule_type] = Array();
            end
            self._recruitRuleDic[v.rule_type]:add(v);
        end
    end
    return self._recruitRuleDic;
end

function Lua_RecruitUtil:getRecruitRuleTypeArr(ruleType)
    local arr = self.getRecruitRuleDic[ruleType];
    if arr ~= nil then
        arr:sort("sort", false);
        return arr;
    end
    return nil;
end











------------------------------ 老客回顾 ------------------------------

function Lua_RecruitUtil:openWishBlessType(bShowTips)-- 开启条件: 1:未开启 2：刚好开启 3：已开启
    local advTypeVo = self:getRecruitTypeVo(Lua_RecruitData.SENIOR);
    local openNeedNum = self:getWishListConfig("open_times");
    local residueNum = advTypeVo == nil and 1 or openNeedNum - advTypeVo.adv_draw_times;
    if residueNum > 0 then
        if advTypeVo ~= nil and bShowTips then
            OperateAlert.show(LanUtil.formateStr(140339, residueNum));
        end
        return 1;
    elseif residueNum == 0 then
        return 2;
    else 
        return 3
    end
end








------------------------------ 先知召唤 ------------------------------

function Lua_RecruitUtil.Get:type_list() -- 面板要显示的类型列表
    if self.typeList == nil then
        self.typeList = Array()
        local typeConfig = getConfig("scoutType");
        for k, v in pairs(typeConfig) do
            if v.scout_sort ~= nil and tonumber(v.scout_sort) > 0 then
                local vo = {}
                vo.type = k;
                vo.name = v.name;
                vo.scout_sort = v.scout_sort;
                vo.sprite = v.sprite;
                self.typeList:add(vo)
            end
        end
        self.typeList:sort("scout_sort", false);
    end
    return self.typeList;
end 

function Lua_RecruitUtil:getScoutRateArr(id)
    if self.scoutRateDic == nil then
        self.scoutRateDic = {};
    end
    if self.scoutRateDic[id] == nil then
        local arr = Array();
        local list = getConfig("scout_rate", id, "rate_list");
        local vo;
        for i = 1, #list do
            vo = Lua_ToolVo.createToolVo(list[i][1], list[i][2]);
            vo.itemRate = list[i][3];
            arr:add(vo);
        end
        arr:sort("sort_weight", false);
        self.scoutRateDic[id] = arr;
    end
    return self.scoutRateDic[id];
end













-------------------------小卖部盲盒机兑换------------------------------

function Lua_RecruitUtil:getExchangeCampArr(campType)
    if self._exchangeCampDic == nil then
        self._exchangeCampDic = {};
        self._exchangeCampDic[Lua_HeroUtil.All_TYPE] = Array();

        local config = getConfig("recruit_shop");
        for k, v in pairs(config) do
            if self._exchangeCampDic[v.camp] == nil then
                self._exchangeCampDic[v.camp] = Array();
            end
            self._exchangeCampDic[v.camp]:add(v);
            self._exchangeCampDic[Lua_HeroUtil.All_TYPE]:add(v);
        end
    end

    local arr = self._exchangeCampDic[campType];
    if arr ~= nil then
        arr:sort("sort", false);
        return arr;
    end
    return Array();
end

function Lua_RecruitUtil.Get:scoutDelayTime()
    local time = getConfig("star_recruit", "delay_time", "float_value");
    time = time ~= nil and time >= 0 and time or 2.2;
    return time;  
end











------------------------------动画------------------------------

--老客回顾、心愿单动画
function Lua_RecruitUtil.Get:recruitTweenId()
    if self._recruitTweenId == nil then
        self._recruitTweenId = getConfig("recruit_const", "recruit_tween_id", "value");
    end
    return self._recruitTweenId;
end

--小卖部规则说明动画
function Lua_RecruitUtil.Get:recruitRuleTweenId()
    if self._recruitRuleTweenId == nil then
        self._recruitRuleTweenId = getConfig("recruit_const", "recruit_rule_tween_id", "value");
    end
    return self._recruitRuleTweenId;
end

--小卖部排行榜top3动画idlist
function Lua_RecruitUtil.Get:recruitRankTweenList()
    if self._recruitRankTweenList == nil then
        self._recruitRankTweenList = getConfig("recruit_const", "recruit_rank_tween_list", "jsonvalue");
    end
    return self._recruitRankTweenList;
end

--小卖部排行榜非top3动画id
function Lua_RecruitUtil.Get:recruitRankTweenId()
    if self._recruitRankTweenId == nil then
        self._recruitRankTweenId = getConfig("recruit_const", "recruit_rank_tween_id", "value");
    end
    return self._recruitRankTweenId;
end

function Lua_RecruitUtil.Get:danchouCrumbEffArr()
    if self._danchouCrumbEffArr == nil then
        self._danchouCrumbEffArr = Array();
        local config = getConfig("recruit_tween", "danchou_crumb_effect_list", "arr_value");
        for i = 1, #config do
            self._danchouCrumbEffArr:add(config[i]);
        end
    end
    return self._danchouCrumbEffArr;
end

function Lua_RecruitUtil.Get:duochouCrumbEffArr()
    if self._duochouCrumbEffArr == nil then
        self._duochouCrumbEffArr = Array();
        local config = getConfig("recruit_tween", "duochou_crumb_effect_list", "arr_value");
        for i = 1, #config do
            self._duochouCrumbEffArr:add(config[i]);
        end
    end
    return self._duochouCrumbEffArr;
end

function Lua_RecruitUtil:getCrumbEffCfg(t, num)
    local arr;
    if t == 1 then
        arr = self.danchouCrumbEffArr;
    else
        arr = self.duochouCrumbEffArr;
    end

    local config;
    for i = 1, arr:getSize() do
        config = arr[i];
        if num == config[1] or num < config[1] then
            break;
        end
    end
    return config;
end

function Lua_RecruitUtil:getCrumbEffLimit(t)
    local arr;
    if t == 1 then
        arr = self.danchouCrumbEffArr;
    else
        arr = self.duochouCrumbEffArr;
    end
    local config = arr[arr:getSize()];
    return config[1];
end