checkRequire("Lua_ArtifactVo");
-- checkRequire("Lua_ArtifactClothesVo");
Lua_ArtifactData = class("Lua_ArtifactData");
function Lua_ArtifactData:ctor()
	self.artifactDic = {};
	-- self.clothesDic = {};
	self.checkItemDic = {};
end

function Lua_ArtifactData:dispose()
	if self.artifactDic then
		for _, v in pairs(self.artifactDic) do
			v:fromServer(nil);
		end
	end
	if self.checkItemDic then
		table.clear(self.checkItemDic);
	end
end

function Lua_ArtifactData:getArtifactVoById(id)
	if self.artifactDic[id] == nil then
		local config = getConfig("artifact", id);
		if config == nil then
			return nil;
		end
		self.artifactDic[id] = Lua_ArtifactVo.new(id, config);
	end
	return self.artifactDic[id];
end

function Lua_ArtifactData:getClothesVoById(id)
	-- if self.clothesDic[id] == nil then
	-- 	local config = getConfig("artifact_clothes", id);
	-- 	if config == nil then
	-- 		return nil;
	-- 	end
	-- 	self.clothesDic[id] = Lua_ArtifactClothesVo.new(id);
	-- end
	-- return self.clothesDic[id];
end

-- 免费重铸剩余次数
function Lua_ArtifactData.Get:reset_free_times()
	return self._reset_free_times or 0
end

function Lua_ArtifactData.Set:reset_free_times(value)
	self._reset_free_times = value;
end

 -- 最近提升的神器id
function Lua_ArtifactData.Get:last_artifact()
	return self._last_artifact or 0;
end

function Lua_ArtifactData.Set:last_artifact(value)
	self._last_artifact = value;
end

-- 浣熊界面显示
function Lua_ArtifactData.Get:show_artifact()
	if self._show_artifact == nil or self._show_artifact == 0 then
		return DataCenter.artifactUtil.look_id;
	end
	return self._show_artifact;
end

function Lua_ArtifactData.Set:show_artifact(value)
	self._show_artifact = value;
end

function Lua_ArtifactData:fromServer50181001(msg)
	if msg == nil then
		return;
	end
	
	local list = msg.actifact_list;
	local vo;
	for i = 1, #list do
		vo = self:getArtifactVoById(list[i].artifact_id);
		vo:fromServer(list[i]);
	end
	self._reset_free_times = msg.free_times;
	self._last_artifact = msg.last_artifact;

	self:checkRedPoint();
	self:checkLineupRedPoint();
end

function Lua_ArtifactData:updateSingleArtifact(data)
	if data == nil then
		return;
	end

	local vo = self:getArtifactVoById(data.artifact_id);
	vo:fromServer(data);
	Lua_MsgUtil.callFunc("UPDATE_SINGLE_ARTIFACT_INFO");

	self:checkRedPoint();
end

-- function Lua_ArtifactData:fromServer50181008(msg)
-- 	if msg == nil then
-- 		return;
-- 	end
	
-- 	local list = msg.clothes_list;
-- 	local vo;
-- 	for i = 1, #list do
-- 		vo = self:getClothesVoById(list[i].cloth_id);
-- 		vo:fromServer(list[i]);
-- 	end

-- 	self:checkClothesRedPoint();
-- end

-- function Lua_ArtifactData:updateSingleClothes(data)
-- 	if data == nil then
-- 		return;
-- 	end

-- 	local vo = self:getClothesVoById(data.cloth_id);
-- 	if vo ~= nil then
-- 		vo:fromServer(data);
-- 		if vo.is_activate == 1 then
-- 	        Lua_WindowUtil.openWin("Lua_ArtifactClothesUnlockWindow", WinParam.ACTION_OPEN, vo);
-- 	    end
-- 	end
-- 	Lua_MsgUtil.callFunc("UPDATE_ARTIFACT_CLOTHES");
	
-- 	self:checkClothesRedPoint();
-- end

function Lua_ArtifactData:fromServer80181015(msg)
	if msg == nil then
		return;
	end

	local obj;
	local vo;
	for i = 1, #msg.artifact_list do
		obj = msg.artifact_list[i];
		vo = self:getArtifactVoById(obj.artifact_id);
		vo:fromServer(obj);
	end

	self:checkRedPoint();
end

-- function Lua_ArtifactData:fromServer80181016(msg)
-- 	if msg == nil then
-- 		return;
-- 	end

-- 	local obj;
-- 	local vo;
-- 	for i = 1, #msg.task_list do
-- 		obj = msg.task_list[i];
-- 		vo = self:getClothesVoById(obj.value);
-- 		if vo ~= nil then
-- 			vo:setTaskState(obj.key, 1);
-- 		end
-- 	end
-- 	self:checkClothesRedPoint();
-- end

-- 获取碎片上限数量
function Lua_ArtifactData:getChipLimitNum(id)
	local vo = self:getArtifactVoById(id);
	if vo.is_activate == 1 then
		if not vo.bMaxStar and vo.starConfig then
			local cost = vo.starConfig.star_up_cost;
			return cost and cost[1] and cost[1][2] or 0;
		end
	else
		if vo.unlock_way == 2 then
			return vo.unlock_cond[1][2];
		end
	end
	return 0;
end










function Lua_ArtifactData:checkRedPoint()
	DataCenter.packData:checkChipRedPoint();
	
	local state = false;
	local arr = DataCenter.artifactUtil:getArtifactList();
	local vo;
	for i = 1, arr:getSize() do
		vo = self:getArtifactVoById(arr[i]);
		if vo.canUp then
			state = true;
			break;
		end
		self:setCheckItem(vo:getCheckId())
		self:setCheckItem(vo:getUpStarCheckId())
	end
	if state then -- 红点显示情况下不检测道具变化
		table.clear(self.checkItemDic);
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Artifact_Up, state);
end

function Lua_ArtifactData:checkClothesRedPoint()
	-- local arr = DataCenter.artifactUtil:getArtifactClothesList();
	-- local vo;
	-- local state = false;
	-- for i = 1, arr:getSize() do
	-- 	vo = self:getClothesVoById(arr[i]);
	-- 	if vo.canWear or  vo.canReceive or vo.canUnlock then
	-- 		state = true;
	-- 		break;
	-- 	end
	-- end
	-- DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Artifact_Clothes, state);
end

function Lua_ArtifactData:checkLineupRedPoint()
	local state = false
	local vo = DataCenter.heroLineupData:getLineupVo(Lua_HeroUtil.LINEUP_MAIN_TYPE)
	local artifactId = DataCenter.heroLineupData:getUnWearArtifact(vo.artifactDic, 1)
	if artifactId then
		local list = DataCenter.artifactUtil.unlock_level
		for i = 1, #list do
			if DataCenter.roleData.level >= list[i] then
				if vo:getArtifactId(1, i) == 0 then
					state = true
					break
				end
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Artifact_Lineup, state)
end

function Lua_ArtifactData:setCheckItem(id, count)
	if id and count then
		if self.checkItemDic[id] == nil or self.checkItemDic[id] > count then
			self.checkItemDic[id] = count;
		end
	end
end

function Lua_ArtifactData:checkRedPointByItem(tab)
	local needCheck = false;
	for k,v in pairs(self.checkItemDic) do
		if tab[k] and DataCenter.packData:getItemCountById(k) >= v then
			needCheck = true;
			break;
		end
	end
	if needCheck then
		table.clear(self.checkItemDic);
		self:checkRedPoint();
		self:checkClothesRedPoint();
	end
end