-- 场景
Lua_SceneUtil = class("Lua_SceneUtil");
function Lua_SceneUtil:ctor()
	self:superCall("ctor");
	self.sceneDataWinDic = {};
	self.sceneDataDic = {};
end

function Lua_SceneUtil:dispose()
	self.sceneDataWinDic = {};
	self.sceneDataDic = {};
end

function Lua_SceneUtil:getGridCfg(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end
	return getConfig("tb_hexagonMapCell", gridId);
end


function Lua_SceneUtil:getGridCube(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end
	
	local gridCfg = getConfig("tb_hexagonMapCell", gridId);
	if gridCfg ~= nil then
		return gridCfg.cube;
	end
	return nil;
end

function Lua_SceneUtil:getGridPosition(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end

	local gridCfg = getConfig("tb_hexagonMapCell", gridId);
	if gridCfg ~= nil then
		return gridCfg.position;
	end
	return nil;
end

function Lua_SceneUtil:getGridNeighbors(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end
	
	local gridCfg = getConfig("tb_hexagonMapCell", gridId);
	if gridCfg ~= nil then
		return gridCfg.neighbors;
	end
	return nil;
end

function Lua_SceneUtil:getGridType(gridId)
	if gridId == nil or gridId <= 0 then
		return 0;
	end
	
	local gridCfg = getConfig("tb_hexagonMapCell", gridId);
	if gridCfg ~= nil and gridCfg.grid_type ~= nil then
		return gridCfg.grid_type;
	end
	return 0;
end

-- 场景装饰物
function Lua_SceneUtil:getOrnamentsBySceneId(sceneId)
	if self._sceneOrnamentsTab == nil then
		self._sceneOrnamentsTab = {};
		local config = getConfig("tb_scene_ornaments");
		for k, v in pairs(config) do
			local sid = v.sceneId;
			local arr = self._sceneOrnamentsTab[sid];
			if arr == nil then 
				arr = Array(); 
				self._sceneOrnamentsTab[sid] = arr;
			end
			arr:add(k);
		end
	end
	return self._sceneOrnamentsTab[sceneId];
end

-- 场景装饰物
function Lua_SceneUtil:getOrnamentById(id)
	return getConfig("tb_scene_ornaments", id);
end

-- 场景装饰物行为id
function Lua_SceneUtil:getOrnamentBehaviorById(id)
	return getConfig("tb_scene_ornaments_behavior", id);
end

-- 场景装饰物气泡
function Lua_SceneUtil:getOrnamentBubbleById(id)
	return getConfig("tb_scene_ornaments_bubble", id);
end

function Lua_SceneUtil:setSceneDataExtendVal(winName, key, value)
	if strIsNullOrEmpty(winName) or self.sceneDataWinDic[winName] == value then
		return;
	end
	self.sceneDataWinDic[winName] = value;

	local num = self.sceneDataDic[key] or 0;
	if value then
		num = num + 1;
	else
		num = num - 1;
	end
	if num > 0 then
		self.sceneDataDic[key] = num;
	else
		self.sceneDataDic[key] = 0;
	end
	LuaUtil.setSceneDataExtendVal(key, num > 0);
end