-- 单个建筑物Vo
Lua_StructureVo = class("Lua_StructureVo")
function Lua_StructureVo:ctor(id, config)
	self:superCall("ctor");
	self._id = id;
	self._config = config;
end

function Lua_StructureVo.Get:id()
	return self._id;
end

function Lua_StructureVo.Get:config()
	if self._config == nil then
		self._config = getConfig("structure", self.id);
	end
	return self._config;
end

function Lua_StructureVo.Get:bGray()
	return false;
end

function Lua_StructureVo.Get:canBuild()
	if self.isShield ~= 1 and self.needBuild == 1 then
		if self.id == 10101009 then
			return not DataCenter.hundredCeremonyData.isActEnd;
		end
	end
	return false;
end

function Lua_StructureVo.Get:hangerEffId()
	return nil;
end

function Lua_StructureVo.Get:scenePosTab()
	if self._scenePosTab == nil then
		if self.scene_pos ~= nil then
			local x = #self.scene_pos > 0 and self.scene_pos[1] or 0;
			local y = #self.scene_pos > 1 and self.scene_pos[2] or 0;
			local z = #self.scene_pos > 2 and self.scene_pos[3] or 0;
			self._scenePosTab = {x, y, z};
		else
			self._scenePosTab = {0, 0, 0};
		end
	end
	return self._scenePosTab;
end

function Lua_StructureVo.Get:scenePos()
	if self._scenePos == nil then
		if self.scene_pos ~= nil then
			local x = #self.scene_pos > 0 and self.scene_pos[1] or 0;
			local y = #self.scene_pos > 1 and self.scene_pos[2] or 0;
			local z = #self.scene_pos > 2 and self.scene_pos[3] or 0;
			self._scenePos = Vector3(x * 0.01, y * 0.01, z * 0.01);
		else
			self._scenePos = Vector3.zero;
		end
	end
	return self._scenePos;
end

function Lua_StructureVo.Get:namePos()
	if self._namePos == nil then
		if self.name_pos ~= nil then
			local x = #self.name_pos > 0 and self.name_pos[1] or 0;
			local y = #self.name_pos > 1 and self.name_pos[2] or 0;
			local z = #self.name_pos > 2 and self.name_pos[3] or 0;
			self._namePos = Vector3(x, y, z);
		else
			self._namePos = Vector3.zero;
		end
	end
	return self._namePos;
end

function Lua_StructureVo.Get:nameOffset()
	if self._nameOffset == nil then
		if self.name_offset ~= nil then
			local x = #self.name_offset > 0 and self.name_offset[1] or 0;
			local y = #self.name_offset > 1 and self.name_offset[2] or 0;
			local z = #self.name_offset > 2 and self.name_offset[3] or 0;
			self._nameOffset = {x * 0.01, y * 0.01, z * 0.01};
		else
			self._nameOffset = {0, 0, 0};
		end
	end
	return self._nameOffset;
end

function Lua_StructureVo.Get:redPointId()
	if self._redPointId == nil and self.pathId and self.pathId > 0 then
		local vo = DataCenter.funcPathUtil:getFuncPathVo(self.pathId)
		self._redPointId = vo.red_point_id
	end
	return self._redPointId
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_StructureVo.Get:name()
	return self.config.name;
end

function Lua_StructureVo.Get:sceneId()
	return self.config.scene_id or 0;
end

function Lua_StructureVo.Get:isShield()
	return self.config.is_shield;
end

function Lua_StructureVo.Get:jid()
	return self.config.jid;
end

function Lua_StructureVo.Get:defaultJid()
	return self.config.default_jid;
end

function Lua_StructureVo.Get:modelSrc()
	return self.config.modelSrc;
end

function Lua_StructureVo.Get:defaultModelSrc()
	return self.config.default_modelSrc;
end

function Lua_StructureVo.Get:scene_pos()
	return self.config.scene_pos;
end

function Lua_StructureVo.Get:dir()
	return self.config.dir or 0;
end

function Lua_StructureVo.Get:name_pos()
	return self.config.name_pos;
end

function Lua_StructureVo.Get:needBuild()
	return self.config.need_build or 0;
end

function Lua_StructureVo.Get:name_offset()
	return self.config.name_offset;
end

function Lua_StructureVo.Get:pathId()
	return self.config.path_id;
end

function Lua_StructureVo.Get:sort()
	return self.config.sort or 0;
end

function Lua_StructureVo.Get:templateList()
	if self._templateList == nil  then
		if self.config.template_list == nil then
			if self.pathId and self.pathId > 0 then
				local vo = DataCenter.funcPathUtil:getFuncPathVo(self.pathId)
				self._templateList = vo.template_list
			end
		else
			self._templateList = self.config.template_list
		end
	end
	return self._templateList
end

function Lua_StructureVo.Get:scaleVec()
	if self._scaleVec == nil then
		local list = self.config.scale;
		local vx = (list ~= nil and #list > 0) and list[1] or 1;
		local vy = (list ~= nil and #list > 1) and list[2] or 1;
		local vz = (list ~= nil and #list > 2) and list[3] or 1;
		self._scaleVec = Vector3(vx, vy, vz);
	end
	return self._scaleVec;
end

function Lua_StructureVo.Get:daytimeLightMapSrc()
	if self._daytimeLightMapSrc == nil then
		self._daytimeLightMapSrc = self.config.daytimeLightMapSrc;
		if not strIsNullOrEmpty(self._daytimeLightMapSrc) then
			self._daytimeLightMapSrc = "/model/structure/"..self._daytimeLightMapSrc;
		end
		if self._daytimeLightMapSrc == nil then
			self._daytimeLightMapSrc = "";
		end
	end
	return self._daytimeLightMapSrc;
end

function Lua_StructureVo.Get:nightLightMapSrc()
	if self._nightLightMapSrc == nil then
		self._nightLightMapSrc = self.config.nightLightMapSrc;
		if not strIsNullOrEmpty(self._nightLightMapSrc) then
			self._nightLightMapSrc = "/model/structure/"..self._nightLightMapSrc;
		end
		if self._nightLightMapSrc == nil then
			self._nightLightMapSrc = "";
		end
	end
	return self._nightLightMapSrc;
end

function Lua_StructureVo.Get:aniSrcPath()
	if self._aniSrcPath == nil then
		self._aniSrcPath = self.config.aniSrcPath;
		if not strIsNullOrEmpty(self._aniSrcPath) then
			self._aniSrcPath = "/model/structure/"..self._aniSrcPath;
		end
		if self._aniSrcPath == nil then
			self._aniSrcPath = "";
		end
	end
	return self._aniSrcPath;
end

function Lua_StructureVo.Get:defaultAniSrcPath()
	if self._defaultAniSrcPath == nil then
		self._defaultAniSrcPath = self.config.defaultAniSrcPath;
		if not strIsNullOrEmpty(self._defaultAniSrcPath) then
			self._defaultAniSrcPath = "/model/structure/"..self._defaultAniSrcPath;
		end
		if self._defaultAniSrcPath == nil then
			self._defaultAniSrcPath = "";
		end
	end
	return self._defaultAniSrcPath;
end

function Lua_StructureVo.Get:aniModelName()
	return self.config.aniModelName;
end

function Lua_StructureVo.Get:defaultAniModelName()
	return self.config.defaultAniModelName;
end

function Lua_StructureVo.Get:playEffect()
	if self.config.play_effect == nil then
		return 0;
	end
	return self.config.play_effect;
end

function Lua_StructureVo.Get:defaultHangerPosOffset()
	if self._defaultHangerPosOffset == nil then
		local list = self.config.defaultHangerPosOffset;
		local vx = (list ~= nil and #list > 0) and list[1] or 1;
		local vy = (list ~= nil and #list > 1) and list[2] or 1;
		local vz = (list ~= nil and #list > 2) and list[3] or 1;
		self._defaultHangerPosOffset = Vector3(vx, vy, vz);
	end
	return self._defaultHangerPosOffset;
end

function Lua_StructureVo.Get:hangerPosOffset()
	if self._hangerPosOffset == nil then
		local list = self.config.hangerPosOffset;
		if list == nil then return nil; end
		local vx = (list ~= nil and #list > 0) and list[1] or 1;
		local vy = (list ~= nil and #list > 1) and list[2] or 1;
		local vz = (list ~= nil and #list > 2) and list[3] or 1;
		self._hangerPosOffset = Vector3(vx, vy, vz);
	end
	return self._hangerPosOffset;
end