checkRequire("Lua_StarTrialData");
checkRequire("Lua_StarTrialUtil");
Lua_StarTrialProxy = class("Lua_StarTrialProxy");
function Lua_StarTrialProxy:ctor()
	DataCenter.starTrialData = Lua_StarTrialData.new();
	DataCenter.starTrialUitl = Lua_StarTrialUtil.new();

	Lua_MsgUtil.addLuaMsg(50194001, self, self.rStarTrialInfo); -- 请求星魂试炼界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50194002, self, self.rGetStarReward); -- 请求领取星魂试炼星数奖励（返回）
	Lua_MsgUtil.addLuaMsg(50194003, self, self.rGetDailyReward); -- 请求领取星魂试炼每日奖励（返回）
	Lua_MsgUtil.addLuaMsg(50194004, self, self.rStarTrialRankInfo); -- 请求星魂试炼排行信息（返回）
	Lua_MsgUtil.addLuaMsg(50194005, self, self.rChapterInfo); -- 请求星魂试炼章节信息界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50194006, self, self.rNoMaxStarChapterInfo) -- 请求未满星章节信息（返回）
end

-- 请求星魂试炼界面信息
function Lua_StarTrialProxy:sStarTrialInfo(curr_chapter)
	local cmd = ProtoPublic_pb.Proto10194001();
	cmd.curr_chapter = curr_chapter;
	sendMsg(10194001, cmd);
end

-- 请求领取星魂试炼星数奖励
function Lua_StarTrialProxy:sGetStarReward(chapter, index)
	local cmd = ProtoPublic_pb.Proto10194002();
	cmd.chapter = chapter;
	cmd.index = index;
	sendMsg(10194002, cmd);
end

-- 请求领取星魂试炼每日奖励
function Lua_StarTrialProxy:sGetDailyReward()
	sendMsg(10194003);
end

-- 请求星魂试炼排行信息
function Lua_StarTrialProxy:sStarTrialRankInfo(page)
	local cmd = ProtoPublic_pb.Proto10194004();
	cmd.page = page;
	sendMsg(10194004, cmd);
end

-- 请求星魂试炼章节信息界面信息
function Lua_StarTrialProxy:sChapterInfo()
	sendMsg(10194005);
end

-- 请求未满星章节信息
function Lua_StarTrialProxy:sNoMaxStarChapterInfo()
	sendMsg(10194006);
end










-- 请求星魂试炼界面信息（返回）
function Lua_StarTrialProxy:rStarTrialInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194001();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:fromServer50194001(msg);
	end
end

-- 请求领取星魂试炼星数奖励（返回）
function Lua_StarTrialProxy:rGetStarReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194002();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:fromServer50194002(msg);
	end
end

-- 请求扫荡（返回）
function Lua_StarTrialProxy:rGetDailyReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194003();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:updateSweepState(msg.day_reward);
	end
end

-- 请求星魂试炼排行信息（返回）
function Lua_StarTrialProxy:rStarTrialRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194004();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_RANK", msg);
	end
end

-- 请求星魂试炼章节信息界面信息（返回）
function Lua_StarTrialProxy:rChapterInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194005();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:fromServer50194005(msg);
	end
end

-- 请求未满星章节信息（返回）
function Lua_StarTrialProxy:rNoMaxStarChapterInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_NOMAXCHAPTER_DATA", msg.lose_chapter);
	end
end