-- 异兽配置表数据
Lua_StrangeBeastConfigData = class("Lua_StrangeBeastConfigData");
function Lua_StrangeBeastConfigData.getConfig(id)
	if id == nil then
		return nil;
	end
	
	id = tonumber(id);
	if Lua_StrangeBeastConfigData.configDic == nil then
		Lua_StrangeBeastConfigData.configDic = {};
	end

	if Lua_StrangeBeastConfigData.configDic[id] == nil then
		local cfg = getConfig("strange_beasts", id);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_StrangeBeastConfigData.configDic[id] = Lua_StrangeBeastConfigData.new(id, cfg);
	end
	return Lua_StrangeBeastConfigData.configDic[id];
end

function Lua_StrangeBeastConfigData:ctor(id, config)
	self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
	    self.config = getConfig("strange_beasts", id);
	end
end


-------------------------------------------------------------
-- 异兽名称
function Lua_StrangeBeastConfigData.Get:name()
	return self.config.name;
end

-- 本体道具id
function Lua_StrangeBeastConfigData.Get:item_id()
	return self.config.item_id;
end

-- 初始星级
function Lua_StrangeBeastConfigData.Get:star()
	return self.config.star;
end

-- 最大星级
function Lua_StrangeBeastConfigData.Get:max_star()
	return self.config.max_star;
end

-- 初始品质
function Lua_StrangeBeastConfigData.Get:quality()
	return self.config.quality;
end

function Lua_StrangeBeastConfigData.Get:color()
	return self.config.color;
end

-- 重复获得本体时转换道具
function Lua_StrangeBeastConfigData.Get:transfer_item()
	return self.config.transfer_item;
end

-- 本体碎片转换为道具时的特效类型
function Lua_StrangeBeastConfigData.Get:effect_type()
	return self.config.effect_type;
end

-- 基础评分
function Lua_StrangeBeastConfigData.Get:score()
	return self.config.score;
end

-- 引用图集
function Lua_StrangeBeastConfigData.Get:atlas()
	return self.config.atlas;
end

-- 引用图标
function Lua_StrangeBeastConfigData.Get:sprite()
	return self.config.sprite;
end

-- 布阵小头像图集
function Lua_StrangeBeastConfigData.Get:embattle_atlas()
	return self.config.embattle_atlas;
end

-- 布阵小头像图标
function Lua_StrangeBeastConfigData.Get:embattle_sprite()
	return self.config.embattle_sprite;
end

-- 布阵小头像item底图图集
function Lua_StrangeBeastConfigData.Get:embattle_bg_atlas()
	return "common_altas_5";
end

-- 布阵小头像item底图图标
function Lua_StrangeBeastConfigData.Get:embattle_bg_sprite()
	if self._embattle_bg_sprite == nil then
		if self.quality == 1 then
			self._embattle_bg_sprite = "xui_ys_itembg_4";
		elseif self.quality == 2 then
			self._embattle_bg_sprite = "xui_ys_itembg_5";
		elseif self.quality == 3 then
			self._embattle_bg_sprite = "xui_ys_itembg_6";
		end
	end
	return self._embattle_bg_sprite;
end

--立绘路径
function Lua_StrangeBeastConfigData.Get:show_img()
	return self.config.show_img;
end

--卡牌路径
function Lua_StrangeBeastConfigData.Get:card_img()
	return self.config.card_img;
end

--图鉴路径
function Lua_StrangeBeastConfigData.Get:atlas_img()
	return self.config.atlas_img;
end

-- spine路径
function Lua_StrangeBeastConfigData.Get:spine_path()
	return self.config.spine_path;
end

-- spine资源名
function Lua_StrangeBeastConfigData.Get:spine_name()
	return self.config.spine_name;
end

-- 模型默认待机特效
function Lua_StrangeBeastConfigData.Get:poseActEffs()
	return self.config.poseActEffs;
end

--模型展示特效
function Lua_StrangeBeastConfigData.Get:showActEffs()
    return self.config.showActEffs;
end

function Lua_StrangeBeastConfigData.Get:floder()--jta代替ID
	return self.config.floder or "/model/";
end

function Lua_StrangeBeastConfigData.Get:uiModelSrc()
	return self.config.uiModelSrc;
end

function Lua_StrangeBeastConfigData.Get:uiModelUrl()
	if self._uiModelUrl == nil then
		self._uiModelUrl = LanUtil.StringProfile(self.floder, self.uiModelSrc);
	end
	return self._uiModelUrl;
end

function Lua_StrangeBeastConfigData.Get:uiModelAvatarName()
    return self.config.uiModelAvatarName;
end

function Lua_StrangeBeastConfigData.Get:uiModelCamController()
	return self.config.uiModelCamController;
end

function Lua_StrangeBeastConfigData.Get:uiShowAct()
	if self.config == nil or self.config.uiShowAct == nil then
		return Lua_ThingDefine.UIWAIT;
	end
    return self.config.uiShowAct;
end

function Lua_StrangeBeastConfigData.Get:uiModelDir()
    return 0;
end

function Lua_StrangeBeastConfigData.Get:uiModelScale()
	return self.config.uiModelScale or 1;
end

function Lua_StrangeBeastConfigData.Get:uiSceneId()
    return self.config.uiSceneId;
end

function Lua_StrangeBeastConfigData.Get:desc_title()
    return self.config.desc_title;
end

function Lua_StrangeBeastConfigData.Get:desc_content()
    return self.config.desc_content;
end

-- 图鉴背景框
function Lua_StrangeBeastConfigData.Get:show_atlasBg()
	if self._show_atlasBg == nil then
		local bgCfg = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(16);
		self._show_atlasBg = bgCfg and bgCfg[self.quality] or "/images/strange_beast/xui_ys_window_2.png";
	end
	return self._show_atlasBg;
end

-- 上阵背景框
function Lua_StrangeBeastConfigData.Get:show_lineupBg()
	if self._show_lineupBg == nil then
		local bgCfg = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(17);
		self._show_lineupBg = bgCfg and bgCfg[self.quality] or "/images/strange_beast/xui_ys_window_12.png";
	end
	return self._show_lineupBg;
end

-- 心愿单兑换所需积分
function Lua_StrangeBeastConfigData.Get:need_wish_score()
	return self.config.need_wish_score;
end

-- 圆形头像
function Lua_StrangeBeastConfigData.Get:avatar_atlas()
	return self.config.avatar_atlas;
end

-- 圆形头像
function Lua_StrangeBeastConfigData.Get:avatar_sprite()
	return self.config.avatar_sprite;
end

-- 品质：珍惜，稀有，极品
function Lua_StrangeBeastConfigData.Get:quality_atlas()
	return "strange_beast_atlas";
end

-- 品质：珍惜，稀有，极品
function Lua_StrangeBeastConfigData.Get:quality_sprite()
	if self._quality_sprite == nil then
		if self.quality == 1 then
			self._quality_sprite = "xui_ys_label_3";
		elseif self.quality == 2 then
			self._quality_sprite = "xui_ys_label_2";
		elseif self.quality == 3 then
			self._quality_sprite = "xui_ys_label_1";
		end
	end
	
	return self._quality_sprite;
end

-- spine缩放值
function Lua_StrangeBeastConfigData.Get:spine_scale()
	if self.config.spine_scale then
		return self.config.spine_scale;
	end

	return 1;
end

-- spine偏移值
function Lua_StrangeBeastConfigData.Get:spine_offset()
	if self.config.spine_offset then
		return self.config.spine_offset;
	end
end

-- 战力对比相关描述
function Lua_StrangeBeastConfigData.Get:force_ratio_desc()
	if self.config ~= nil then
		return self.config.force_ratio_desc;
	end
end
