-- 异兽
checkRequire("Lua_StrangeBeastVo");
checkRequire("Lua_StrangeBeastHatchNestVo");
Lua_StrangeBeastData = class("Lua_StrangeBeastData")
function Lua_StrangeBeastData:ctor()
end

function Lua_StrangeBeastData:dispose()
	self.privilegeState = nil;
	self.privilegeEndTick = nil;
	self.privilegeNextTick = nil;
	-- self.hatchNum = nil;
	self.hatchSettingDic = nil;
	self.treeLineupDic = nil; -- 扶桑树上的排列信息
	self.lastTreeId = nil;
	self.treeUpCostIds = nil;
	self.treeUpCostIdNum = nil;
	self.fetterDic = nil;
	self.fettterIndex = nil;
	self.rewardDic = nil;
	self.rewardIds = nil;
	self.hatchEggId = nil;
	self.checkLogin_1 = false;
	self.checkLogin_2 = false;
	self.bInitNeedCostRes = nil;
	self.beastCostItemNumDic = nil;


	-- 异兽
	if self.strangeBeastDic ~= nil then
		for k, v in pairs(self.strangeBeastDic) do
			v:dispose();
			v = nil;
		end
		self.strangeBeastDic = nil;
	end
	if self.strangeBeastArr ~= nil then -- 已激活异兽id
		self.strangeBeastArr:dispose();
		self.strangeBeastArr:clear();
		self.strangeBeastArr = nil;
	end
	if self.strangeBeastStarDic ~= nil then -- 按星级存储已有的beastId
		for k, v in pairs(self.strangeBeastStarDic) do
			local arr = v;
			if arr then
				arr:dispose();
				arr:clear();
				arr = nil;
			end
			v = nil;
		end
		self.strangeBeastStarDic = nil;
	end
	if self.beastCostItemIdArr ~= nil then -- 异兽激活或升星资源id
		self.beastCostItemIdArr:dispose();
		self.beastCostItemIdArr:clear();
		self.beastCostItemIdArr = nil;
	end
	if self.beastCostDic ~= nil then -- 异兽激活或升星资源
		for k, v in pairs(self.beastCostDic) do
			v:dispose();
			v:clear();
			v = nil;
		end
		self.beastCostDic = nil;
	end

	-- 培养
	if self.treePropArr ~= nil then
		self.treePropArr:dispose();
		self.treePropArr:clear();
		self.treePropArr = nil;
	end


	-- 孵化
	if self.hatchSettingIdArr ~= nil then
		self.hatchSettingIdArr:dispose();
		self.hatchSettingIdArr:clear();
		self.hatchSettingIdArr = nil;
	end
	if self.hatchNestDic ~= nil then -- 孵化巢vo
		for k, v in pairs(self.hatchNestDic) do
			v:dispose();
			v = nil;
		end
		self.hatchNestDic = nil;
	end


	-- 羁绊
	if self.fetterBeasts ~= nil then
		for k, v in pairs(self.fetterBeasts) do
			v:dispose();
			v:clear();
			v = nil;
		end
		self.fetterBeasts = nil;
	end
	if self.totalFPropArr ~= nil then
		self.totalFPropArr:dispose();
		self.totalFPropArr:clear();
		self.totalFPropArr = nil;
	end
end

-- 请求异兽信息（返回）
function Lua_StrangeBeastData:fromServer50217001(msg)
	self:initNeedCostRes();
	if msg == nil then
		return;
	end

	local star;
	local beastId;
	local dic = {};
	local obj = msg.stange_beasts_list;
	for i = 1, #obj do
		beastId, star = self:addStrangeBeast(obj[i]);
		if beastId ~= nil and star ~= nil then
			dic[beastId] = star;
		end
	end
	self:updateRedPointInBeastChange(dic);
	Lua_MsgUtil.callFunc("STRANGEBEAST_UPDATE_INFO", dic);

	self:checkRedPointWhenLogin();
end

-- 通知激活异兽
function Lua_StrangeBeastData:fromServer80217001(msg)
	if msg == nil then
		return;
	end

	local star;
	local beastId;
	local dic = {};
	local obj = msg.strange_beasts_list;
	for i = 1, #obj do
		if obj[i].type == 0 then
			beastId, star = self:addStrangeBeast(obj[i]);
			if beastId ~= nil and star ~= nil then
				dic[beastId] = star;
			end
		end
	end
	self:updateRedPointInBeastChange(dic);
	Lua_MsgUtil.callFunc("STRANGEBEAST_UPDATE_INFO", dic);

	self:checkBeastUpRedPoint();
	self:checkTreeLineupRedPoint();
end

--请求异兽升星（返回）
function Lua_StrangeBeastData:fromServer50217002(msg)
	if msg == nil then
		return;
	end

	local obj = msg.strange_beasts;
	local beastId, star = self:addStrangeBeast(obj);
	if beastId ~= nil and star ~= nil then
		local dic = {};
		dic[beastId] = star;

		self:updateRedPointInBeastChange(dic);
		Lua_MsgUtil.callFunc("STRANGEBEAST_UPDATE_INFO", dic);
	end

	self:checkBeastUpRedPoint();
end

--通知异兽特权状态
function Lua_StrangeBeastData:fromServer80217002(msg)
	if msg == nil then
		return;
	end

	self.privilegeState = msg.privilege_state; -- 0:未激活,1:激活
	self.privilegeEndTick = tonumber(msg.expire_tick); 
	self.privilegeNextTick = tonumber(msg.next_tick); -- 下一次可购买时间
end

--请求孵化巢信息（返回）
function Lua_StrangeBeastData:fromServer50217003(msg)
	if msg == nil then
		return;
	end

	local obj = msg.hatch_nest_list;
	for i = 1, #obj do
		self:updateSingleHatchNestData(obj[i]);
	end

	self:checkNestRedPoint();
	self:checkNestCanReceiveRedPoint();

	self:updateHatchSetting(msg.quality_list);
	-- self.hatchNum = msg.hatch_times or 0; -- 已孵化次数
end 

--请求异兽召唤信息（返回）
function Lua_StrangeBeastData:fromServer50217008(msg)
	if msg == nil then
		return;
	end

	self.recruitFreeNum = msg.free_times;
	self.nextFreeTime = tonumber(msg.next_free_tick);
	self.accumulateScore = msg.score;
	self.recruitRecords = msg.record_list;
	self.recruitWishList = msg.wish_list;
	self.diamondResidueNum = msg.last_draw_times;
	self.wishScore = msg.wish_score;
	self:updateRewardData(msg.reward_list);

	self:checkFreeRecruitRedPoint();
	self:checkTenRecruitRedPoint();
end 

--请求设置心愿单（返回）
function Lua_StrangeBeastData:fromServer50217009(msg)
	if msg == nil then
		return;
	end

	self.recruitWishList = msg.wish_list;
end

--请求进行异兽召唤（返回）
function Lua_StrangeBeastData:fromServer50217010(msg)
	if msg == nil then
		return;
	end

	self.recruitFreeNum = msg.free_times;
	self.nextFreeTime = tonumber(msg.next_free_tick);
	self.accumulateScore = msg.score;
	self.recruitRecords = msg.record_list;
	self.diamondResidueNum = msg.last_draw_times;
	self.wishScore = msg.wish_score;
	self:updateRewardData(msg.reward_list);

	self:checkFreeRecruitRedPoint();
	self:checkTenRecruitRedPoint();
	self:openRecruitTipWin(msg);
end

--请求扶桑树信息（返回）
function Lua_StrangeBeastData:fromServer50217011(msg)
	if msg == nil then
		return;
	end

	self.treeStage = msg.order;
	self.treeLevel = msg.level;
	self.treeForce = tonumber(msg.force);

	self:calTreeCostInfo();
	self:updateTreeProps(msg.prop);
	self:updateTreeLinupData(msg.lineup_list);
	self:checkUpTreeRedPoint();
end

--请求升级扶桑树（返回）
function Lua_StrangeBeastData:fromServer50217012(msg)
	if msg == nil then
		return;
	end

	self.treeStage = msg.order;
	self.treeLevel = msg.level;
	self.treeForce = tonumber(msg.force);

	self:calTreeCostInfo();
	self:updateTreeProps(msg.prop);
	self:updateTreeLinupData(msg.lineup_list);
	self:checkUpTreeRedPoint();
end

--请求扶桑树上阵异兽（返回)
function Lua_StrangeBeastData:fromServer50217013(msg)
	if msg == nil then
		return;
	end

	self:updateTreeLinupData(msg.lineup_list);
end

--请求异兽羁绊信息（返回）
function Lua_StrangeBeastData:fromServer50217014(msg)
	if msg == nil then
		return;
	end

	local obj = msg.fetter_list;
	for i = 1, #obj do
		self:updateSingleFetterData(obj[i]);
	end

	self:checkFetterRedPoint();
	self:calCurPropArr();
end

--请求解锁异兽羁绊（返回）
function Lua_StrangeBeastData:fromServer50217015(msg)
	if msg == nil then
		return;
	end

	local obj = msg.fetter_info;
	self:updateSingleFetterData(obj);
	self:checkFetterRedPoint();
	self:calCurPropArr();
end

--请求升级异兽羁绊（返回）
function Lua_StrangeBeastData:fromServer50217016(msg)
	if msg == nil then
		return;
	end

	local obj = msg.fetter_info;
	self:updateSingleFetterData(obj);
	self:checkFetterRedPoint();
	self:calCurPropArr();
end

--请求领取异兽召唤积分奖励（返回)
function Lua_StrangeBeastData:fromServer50217017(msg)
	if msg == nil then
		return;
	end

	self.accumulateScore = msg.score;
	self:updateRewardData(msg.reward_list);
end

--请求进行心愿召唤（返回）
function Lua_StrangeBeastData:fromServer50217018(msg)
	if msg == nil then
		return;
	end

	self.wishScore = msg.wish_score;
end























function Lua_StrangeBeastData:addStrangeBeast(serverData)
	if self.strangeBeastDic == nil then
		self.strangeBeastDic = {};
	end

	if self.strangeBeastArr == nil then
		self.strangeBeastArr = Array();
	end

	if serverData == nil then
		return;
	end

	local strangeBeastId = tonumber(serverData.id);
	local strangeBeastStar = serverData.star;
	local beastVo = self.strangeBeastDic[strangeBeastId];
	if beastVo == nil then
		beastVo = self:getStrangeBeastVoById(strangeBeastId);
	-- else
	end

	if beastVo == nil then
		return;
	end

	if self.strangeBeastArr:indexOf(strangeBeastId) == -1 then
		self.strangeBeastArr:add(strangeBeastId);
	end

	self:recordBeastStarArr(strangeBeastStar, strangeBeastId);

	self:removeNeedCostResById(strangeBeastId)
	beastVo:fromServer(serverData);
	self:addNeedCostResById(strangeBeastId);
	return strangeBeastId, strangeBeastStar;
end

-- 移除异兽过期所需的激活或升星资源
function Lua_StrangeBeastData:removeNeedCostResById(beastId)
	if self.beastCostItemIdArr == nil or self.beastCostDic == nil then
		return;
	end

	local beastVo = self:getStrangeBeastVoById(beastId);
	if beastVo == nil then
		return;
	end

	local cur_cost_item = beastVo.cur_cost_item;
	if cur_cost_item == nil or #cur_cost_item <= 0 then
		return;
	end

	local costId;
	local costNum;
	local costInfo;
	for i = 1, #cur_cost_item do
		costInfo = cur_cost_item[i];
		costId = costInfo[1];
		costNum = costInfo[2];

		local arr = self.beastCostDic[costId];
		if arr ~= nil then
			local index = arr:indexOf(beastId);
			if index ~= -1 then
				arr:remove(index);
				if arr:getSize() <= 0 then
					arr:dispose();
					arr:clear();
					arr = nil;

					self.beastCostItemIdArr:removeItem(costId);
					if self.beastCostItemIdArr:getSize() <= 0 then
						self.beastCostItemIdArr:dispose();
						self.beastCostItemIdArr:clear();
						self.beastCostItemIdArr = nil;
					end
				end

				self.beastCostItemNumDic[beastId] = nil;
				if arr ~= nil and arr:getSize() >= 2 then
					arr:sortf(self, self.sortfCostRes, costId);
				end
			end
		end
	end
end

function Lua_StrangeBeastData:initNeedCostRes()
	if self.bInitNeedCostRes ~= true then
		self.bInitNeedCostRes = true;
		local list = DataCenter.strangeBeastUtil:getStrangeBeastAtlasIds();
		if list ~= nil and #list > 0 then
			for i = 1, #list do
				self:addNeedCostResById(list[i]);
			end
		end
	end
end

-- 增加异兽激活或升星的资源
function Lua_StrangeBeastData:addNeedCostResById(beastId)
	if self.beastCostItemIdArr == nil then
		self.beastCostItemIdArr = Array();
	end

	if self.beastCostDic == nil then
		self.beastCostDic = {};
	end

	if self.beastCostItemNumDic == nil then 
		self.beastCostItemNumDic = {};
	end


	local beastVo = self:getStrangeBeastVoById(beastId);
	if beastVo == nil then
		return;
	end

	local cur_cost_item = beastVo.cur_cost_item;
	if cur_cost_item == nil or #cur_cost_item <= 0 then
		return;
	end

	local costId;
	local costNum;
	local costInfo;
	for i = 1, #cur_cost_item do
		costInfo = cur_cost_item[i];
		costId = costInfo[1];
		costNum = costInfo[2];
		if self.beastCostItemIdArr:indexOf(costId) == -1 then
			self.beastCostItemIdArr:add(costId);
		end

		local arr = self.beastCostDic[costId];
		if arr == nil then
			arr = Array();
			self.beastCostDic[costId] = arr;
		end
		arr:add(beastId);

		local dic = self.beastCostItemNumDic[beastId];
		if dic == nil then
			dic = {};
			self.beastCostItemNumDic[beastId] = dic;
		end
		dic[costId] = costNum;

		if arr ~= nil and arr:getSize() >= 2 then
			arr:sortf(self, self.sortfCostRes, costId);
		end
	end
end

function Lua_StrangeBeastData:sortfCostRes(aBeastId, bBeastId, param)
	local aBeastNum = self.beastCostItemNumDic[aBeastId][param];
	local bBeastNum = self.beastCostItemNumDic[bBeastId][param];
	return aBeastNum < bBeastNum;
end

-- 按星级存储已有的异兽id
function Lua_StrangeBeastData:recordBeastStarArr(curStar, beastId)
	if self.strangeBeastStarDic == nil then
		self.strangeBeastStarDic = {};
	end

	local index;
	local lastBeastStar = curStar - 1;
	local arr;
	if lastBeastStar >= 0 then
		arr = self.strangeBeastStarDic[lastBeastStar];
		if arr ~= nil and arr:getSize() > 0 then
			index = arr:indexOf(beastId);
			if index ~= -1 then
				arr:remove(index);
			end
		end
	end

	arr = self.strangeBeastStarDic[curStar];
	if arr == nil then
		arr = Array();
		self.strangeBeastStarDic[curStar] = arr;
	end

	if arr:indexOf(beastId) == -1 then
		arr:add(beastId);
	end
end

function Lua_StrangeBeastData:getCurBeastIdArrByStar(star)
	star = star or 0;
	if self.strangeBeastStarDic == nil then
		self.strangeBeastStarDic = {};
	end

	local arr = self.strangeBeastStarDic[star];
	return arr or Array();
end

function Lua_StrangeBeastData:getCurBeastIdNumByStar(star)
	local arr = self:getCurBeastIdArrByStar(star);
	return arr:getSize();
end

function Lua_StrangeBeastData:getCurAllBeastIdArr()
	if self.strangeBeastArr == nil then
		self.strangeBeastArr = Array();
	end

	return self.strangeBeastArr;
end

function Lua_StrangeBeastData:getStrangeBeastVoById(id)
	if id == nil then
		return;
	end
	id = tonumber(id);
	if self.strangeBeastDic == nil then
		self.strangeBeastDic = {};
	end

	local vo = self.strangeBeastDic[id];
	if vo == nil then
		local cfg = getConfig("strange_beasts", id);
		if cfg == nil then
			return;
		end

		vo = Lua_StrangeBeastVo.new(id);
		self.strangeBeastDic[id] = vo;
	end
	return vo;
end














-- 培养
function Lua_StrangeBeastData:updateTreeProps(props)
	if self.treePropArr ~= nil and self.treePropArr:getSize() > 0 then
		self.treePropArr:dispose();
		self.treePropArr:clear();
		self.treePropArr = nil;
	end

	self.treePropArr = DataCenter.attributesUtil:getAttrArrByServer(props);
end

-- 检测扶桑树上阵位可供选择的idArr
function Lua_StrangeBeastData:checkSelectedBeastIdsByTreeId(treeId)
	local selectBeastId;
	local selectIds = {};
	local curAllArr = self:getCurAllBeastIdArr();
	local beastId;
	local beastVo;
	for i = 1, curAllArr:getSize() do
		beastId = curAllArr[i];
		beastVo = self:getStrangeBeastVoById(beastId);
		local bCheck = beastVo ~= nil and beastVo.bActive and self:checkTreeBeastByBeastId(beastId) == nil;
		if bCheck then
			selectIds[#selectIds + 1] = beastId;
		end
	end
	table.sort(selectIds, function(a, b)
			local aVo = self:getStrangeBeastVoById(a);
			local bVo = self:getStrangeBeastVoById(b);
			if aVo.score == bVo.score then
				return aVo.id < bVo.id;
			end
			return aVo.score > bVo.score;
		end
		);

	local treeLineupData = self:getLinupDataByIndex(treeId);
	local bCheck = treeLineupData ~= nil and treeLineupData.state == 1 and treeLineupData.strangeBeastId > 0;
	if bCheck then
		selectBeastId = treeLineupData.strangeBeastId;
		table.insert(selectIds, 1, selectBeastId);
	end

	return selectIds, selectBeastId;
end

function Lua_StrangeBeastData:updateTreeSingleLinupData(serverData)
	if self.treeLineupDic == nil then
		self.treeLineupDic = {};
	end

	if serverData == nil then
		return;
	end

	local index = serverData.index;
	local strangeBeastId = tonumber(serverData.id);
	local state = serverData.state; -- 解锁状态：0未解锁，1已解锁。
	local data = self.treeLineupDic[index];
	if data == nil then
		data = {index = index, strangeBeastId = strangeBeastId, state = state};
		self.treeLineupDic[index] = data;
	else
		data.strangeBeastId = strangeBeastId;
		data.state = state;
	end
end

function Lua_StrangeBeastData:updateTreeLinupData(serverData)
	self.checkTreeBeastIdDic = {}; -- 异兽是否在扶桑树上
	if self.treeLineupDic == nil then
		self.treeLineupDic = {};
	end

	if serverData == nil then
		return;
	end

	local info;
	local index;
	local strangeBeastId;
	local state;
	for i = 1, #serverData do
		info = serverData[i];
		index = info.index;
		strangeBeastId = tonumber(info.id);
		state = info.state; -- 解锁状态：0未解锁，1已解锁。
		if strangeBeastId ~= nil and strangeBeastId > 0 and state == 1 then
			self.checkTreeBeastIdDic[strangeBeastId] = index;
		end

		self:updateTreeSingleLinupData(info);
	end

	self:checkTreeLineupRedPoint();
end

function Lua_StrangeBeastData:getLinupDataByIndex(index)
	if self.treeLineupDic == nil or self.treeLineupDic[index] == nil then
		return;
	end

	return self.treeLineupDic[index];
end

-- 异兽是否在扶桑树上
function Lua_StrangeBeastData:checkTreeBeastByBeastId(beastId)
	if self.checkTreeBeastIdDic == nil or self.checkTreeBeastIdDic[beastId] == nil then
		return;
	end

	return self.checkTreeBeastIdDic[beastId];
end

function Lua_StrangeBeastData:checkTreeLineupState(treeLineupId, type) -- 1:只需开启状态 nil:开启状态、开启条件
	local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(10305);
	if vo and vo.isOpen ~= true then
		return false, vo.advanceMessage;
	end

	local openState = false;
	local tipStr;
	local lineData = self:getLinupDataByIndex(treeLineupId); 
	if lineData ~= nil then
		openState = lineData.state == 1;
	end

	if type == nil then
		tipStr = DataCenter.strangeBeastUtil:getStrangeBeastLineUpCfgById(treeLineupId, 1);
	end
	return openState, tipStr;
end

function Lua_StrangeBeastData:checkLineupState(lineupIdx, pos, type) -- type:1:只需开启状态 nil:开启状态、开启条件
	local treeLineupId = DataCenter.strangeBeastUtil:getStrangeBeastTreeLineupId(lineupIdx, pos); -- 扶桑树id
	return DataCenter.strangeBeastData:checkTreeLineupState(treeLineupId, type);
end

-- 检测空闲异兽
function Lua_StrangeBeastData:checkIdleBeast()
	local bCheck = false;
	local curAllArr = self:getCurAllBeastIdArr();
	if curAllArr:getSize() > 0 then
		local beastId;
		local beastData;
		for i = 1, curAllArr:getSize() do
			beastId = curAllArr[i];
			beastData = self:getStrangeBeastVoById(beastId);
			if beastData ~= nil and beastData.bActive and self:checkTreeBeastByBeastId(beastId) == nil then
				bCheck = true;
				break;
			end
		end
	end
	return bCheck;
end

function Lua_StrangeBeastData:calTreeCostInfo()
	if self.lastTreeId ~= self.curTreeId then
		self.treeUpCostIds, self.treeUpCostIdNum = DataCenter.strangeBeastUtil:getUpTreeCostItems(self.curTreeId);
	end
end

function Lua_StrangeBeastData:getTreeCostIds()
	return self.treeUpCostIds;
end

function Lua_StrangeBeastData:getTreeUpCostIdNum()
	return self.treeUpCostIdNum;
end

function Lua_StrangeBeastData.Get:curTreeId()
	local treeLevel = self.treeLevel or 0;
	local treeStage = self.treeStage or 0;
	local treeId = DataCenter.strangeBeastUtil:calStrangeBeastTreeId(treeStage, treeLevel);
	return treeId;
end



















---------孵化巢---------
function Lua_StrangeBeastData:updateSingleHatchNestData(serverData)
	if self.hatchNestDic == nil then
		self.hatchNestDic = {};
	end

	if serverData == nil then
		return;
	end

	local id = serverData.index;
	local nestVo = self:getHatchNestVoById(id);
	if nestVo then
		nestVo:fromServer(serverData);
	end
end

function Lua_StrangeBeastData:getHatchNestVoById(id)
	if self.hatchNestDic == nil then
		self.hatchNestDic = {};
	end

	local vo = self.hatchNestDic[id];
	if vo == nil then
		local cfg = getConfig("strange_beasts_hatch_nest", id);
		if cfg == nil then
			return;
		end

		vo = Lua_StrangeBeastHatchNestVo.new(id, cfg);
		self.hatchNestDic[id] = vo;
	end

	return vo;
end

function Lua_StrangeBeastData:updateHatchSetting(settings)
	self.hatchSettingDic = {};
	if self.hatchSettingIdArr ~= nil then
		self.hatchSettingIdArr:dispose();
		self.hatchSettingIdArr:clear();
	else
		self.hatchSettingIdArr = Array();
	end

	if settings == nil or #settings <= 0 then
		return;
	end

	local qualityId;
	for i = 1, #settings do
		qualityId = settings[i] or 0;
		self.hatchSettingDic[qualityId] = true;
		self.hatchSettingIdArr:add(qualityId);
	end
end

function Lua_StrangeBeastData:getHatchSettingIdArr()
	return self.hatchSettingIdArr or Array();
end

function Lua_StrangeBeastData:checkHatchSettingByQualityId(qualityId)
	if self.hatchSettingDic == nil or self.hatchSettingDic[qualityId] == nil then
		return;
	end

	return self.hatchSettingDic[qualityId];
end

function Lua_StrangeBeastData:setHatchSetting(qualityId, value)
	if self.hatchSettingDic == nil then
		self.hatchSettingDic = {};
	end

	self.hatchSettingDic[qualityId] = value;

	if self.hatchSettingIdArr ~= nil then
		local index = self.hatchSettingIdArr:indexOf(qualityId);
		if value and index == -1 then
			self.hatchSettingIdArr:add(qualityId);
		elseif value ~= true and index ~= -1 then
			self.hatchSettingIdArr:remove(index);
		end
	end
end

function Lua_StrangeBeastData:getHatchEggId()
	return self.hatchEggId;
end

function Lua_StrangeBeastData:setHatchEggId(eggId)
	self.hatchEggId = eggId;
end

function Lua_StrangeBeastData:checkBeastEggNum()
	local bCheck = false;
	local ids = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(11);
	if ids ~= nil then
		local eggId;
		local num;
		for i = 1, #ids do
			eggId = ids[i];
			num = DataCenter.packData:getItemCountById(eggId);
			if num > 0 then
				bCheck = true;
			end
		end
	end
	return bCheck;
end

























--召唤
-- -- 剩余孵化次数必出
-- function Lua_StrangeBeastData:getResidueCount()
-- 	local count = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(1) or 0;
-- 	local residueNum = count - (self.hatchNum or 0);
-- 	residueNum = residueNum < 0 and 0 or residueNum;
-- 	return residueNum;
-- end

function Lua_StrangeBeastData:updateRewardData(rewardData)
	self.rewardDic = {};
	self.rewardIds = {};

	if rewardData == nil or #rewardData <= 0 then
		return;
	end

	local key;
	local value;
	for i = 1, #rewardData do
		key = rewardData[i].key;
		value = rewardData[i].value; -- 0不可领，1可领，2已领
		self.rewardDic[key] = value;
		self.rewardIds[#self.rewardIds + 1] = key;
	end

	table.sort( self.rewardIds, function(a, b)
			return a < b;
		end
	 );

	self:checkBeastRewardRedPoint();
end 

function Lua_StrangeBeastData:getRewardDataById(rewardId)
	if self.rewardDic == nil or self.rewardDic[rewardId] == nil then
		return;
	end

	return self.rewardDic[rewardId];
end

function Lua_StrangeBeastData:getRecruitWishId()
	if self.recruitWishList ~= nil and #self.recruitWishList > 0 then
		return self.recruitWishList[1];
	end
end

function Lua_StrangeBeastData:openRecruitTipWin(msg)
	if msg and msg.item_list ~= nil and #msg.item_list > 0 then
		Lua_WindowUtil.openWin("Lua_StrangeBeastRecruitRewardWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

-- 心愿单是否开启
function Lua_StrangeBeastData:checkWishOpenState()
	return true;
end

function Lua_StrangeBeastData:checkPrivilegeState()
	return self.privilegeState == 1, self.privilegeEndTick or 0;
end
	
function Lua_StrangeBeastData:getLastestRecordInfo()
	if self.recruitRecords == nil or #self.recruitRecords <= 0 then
		return;
	end

	return self.recruitRecords[1];
end












--------------羁绊--------------
function Lua_StrangeBeastData:updateSingleFetterData(fetterData)
	if self.fetterDic == nil then
		self.fetterDic = {};
	end

	if fetterData == nil then
		return;
	end

	local fetterId = tonumber(fetterData.id);
	local level = fetterData.level;
	local state = fetterData.state; -- 解锁状态：0未解锁，1已解锁

	local curFetterLevelId = DataCenter.strangeBeastUtil:calFetterLevelId(fetterId, level);
   	local bMaxFetterLevelId = DataCenter.strangeBeastUtil:checkMaxFetterLevelId(curFetterLevelId);

	local data = self.fetterDic[fetterId];
	if data == nil then
		data = {fetterId = fetterId, level = level, state = state, checkRedPoint = false};
		self.fetterDic[fetterId] = data;

		if bMaxFetterLevelId ~= true then
			self:addRecordFetterBeasts(fetterId);
		end
	else
		data.level = level;
		data.state = state;

		if bMaxFetterLevelId == true then
			self:removeRecordFetterBeasts(fetterId);
		end
	end

	data.checkRedPoint = self:checkSingleFetterRedPoint(fetterId);
end

function Lua_StrangeBeastData:addRecordFetterBeasts(fetterId)
	if self.fetterBeasts == nil then
		self.fetterBeasts = {};
	end

	local cfg = DataCenter.strangeBeastUtil:getStrangeBeastFetterCfgByFetterId(fetterId, 4)
	if cfg ~= nil then 
		local beastId;
		for i = 1, #cfg do
			beastId = cfg[i];
			if self.fetterBeasts[beastId] == nil then
				self.fetterBeasts[beastId] = Array();
			end
			if self.fetterBeasts[beastId]:indexOf(fetterId) == -1 then
				self.fetterBeasts[beastId]:add(fetterId);
			end
		end
	end
end

function Lua_StrangeBeastData:removeRecordFetterBeasts(fetterId)
	if self.fetterBeasts == nil or fetterId == nil then
		return;
	end

	local cfg = DataCenter.strangeBeastUtil:getStrangeBeastFetterCfgByFetterId(fetterId, 4)
	if cfg ~= nil then 
		local beastId;
		for i = 1, #cfg do
			beastId = cfg[i];
			if self.fetterBeasts[beastId] ~= nil and self.fetterBeasts[beastId]:getSize() > 0 then
				local index = self.fetterBeasts[beastId]:indexOf(fetterId);
				if index ~= -1 then
					self.fetterBeasts[beastId]:remove(index);
					if self.fetterBeasts[beastId]:getSize() <= 0 then
						self.fetterBeasts[beastId]:dispose();
						self.fetterBeasts[beastId]:clear();
						self.fetterBeasts[beastId] = nil;
					end
				end
			end
		end
	end
end

function Lua_StrangeBeastData:getFetterDataByFetterId(fetterId)
	if self.fetterDic == nil or self.fetterDic[fetterId] == nil then
		return;
	end

	return self.fetterDic[fetterId];
end

function Lua_StrangeBeastData:getShowFetterLevelIdByFetterId(fetterId)
	local data = self:getFetterDataByFetterId(fetterId);
	if data == nil then
		return;
	end

	local level = data.level or 0;
	local validFetterLevelId = DataCenter.strangeBeastUtil:calFetterLevelId(fetterId, level);
	if data.state ~= 0 then
		local bMaxFetterLevelId = DataCenter.strangeBeastUtil:checkMaxFetterLevelId(validFetterLevelId);
		if bMaxFetterLevelId ~= true then
			validFetterLevelId = validFetterLevelId + 1;
		end
	end

	if DataCenter.strangeBeastUtil:getStrangeBeastFetterLevelCfgByFetterLevelId(validFetterLevelId, nil) then
		return validFetterLevelId;
	end
end

function Lua_StrangeBeastData:getCurPropArr()
	return self.totalFPropArr or Array();
end

function Lua_StrangeBeastData:calCurPropArr()
	local fetterIds = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(2);
	if fetterIds == nil or #fetterIds <= 0 then
		return Array();
	end

	local data;
	local props;
	local fetterLevelId;
	local totalProps = {};
	props = DataCenter.strangeBeastUtil:getStrangeBeastFetterPropsByFetterLevelId(0, true);
	totalProps = DataCenter.attributesUtil:getAttrDic(props, totalProps);
	for i = 1, #fetterIds do
		data = self:getFetterDataByFetterId(fetterIds[i]);
		if data ~= nil and data.state ~= 0 then
			fetterLevelId = DataCenter.strangeBeastUtil:calFetterLevelId(fetterIds[i], data.level);
			props = DataCenter.strangeBeastUtil:getStrangeBeastFetterPropsByFetterLevelId(fetterLevelId);
			if props ~= nil then
				totalProps = DataCenter.attributesUtil:getAttrDic(props, totalProps);
			end
		end
	end
	
	self.totalFPropArr = DataCenter.attributesUtil:getAttrArrByDic(totalProps);
end

function Lua_StrangeBeastData:getFetterIndex()
	return self.fettterIndex or 1;
end






























-------------------------------红点-------------------------------
-- 空的孵化巢红点
function Lua_StrangeBeastData:checkNestRedPoint()
	local bCheck = false;
	if self:checkBeastEggNum() then
		local list = DataCenter.strangeBeastUtil:getHatchNestIndex();
		if list ~= nil then
			local nestVo;
			for i = 1, #list do
				nestVo = self:getHatchNestVoById(list[i]);
				if nestVo ~= nil and nestVo.can_hatch then
					bCheck = true;
					break;
				end
			end
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_CheckNest, bCheck, false);
end

function Lua_StrangeBeastData:checkNestCanReceiveRedPoint()
	if self.checkLogin_2 ~= true then
		self.checkLogin_2 = true;

		local bCheck = false;
		local list = DataCenter.strangeBeastUtil:getHatchNestIndex();
		if list ~= nil then
			local nestVo;
			for i = 1, #list do
				nestVo = self:getHatchNestVoById(list[i]);
				if nestVo ~= nil and nestVo.can_receive then
					bCheck = true;
					break;
				end
			end
		end

		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_Login, bCheck, false);
	end
end

function Lua_StrangeBeastData:checkNestRedPointInPackUpdate(dic)
	if DataCenter.funcOpenData:isOpened(10305) ~= true then
		return
	end

	if dic == nil or 
		(dic[Lua_StrangeBeastUtil.RARESTRANGEBEAST] == nil and 
		dic[Lua_StrangeBeastUtil.PRECIOUSSTRANGEBEAST] == nil and 
		dic[Lua_StrangeBeastUtil.PREMIUMSTRANGEBEAST] == nil) then
		return;
	end

	self:checkNestRedPoint();
end

-- 扶桑树升级红点
function Lua_StrangeBeastData:checkUpTreeRedPoint(dic)
	local bCheck = false;
	if self.treeUpCostIds ~= nil and #self.treeUpCostIds > 0 then
		bCheck = true;

		local num;
		local costId;
		local bPackUpdate = dic ~= nil;
		if bPackUpdate then
			local needNum;
			local hasCostItemChange;
			for k, v in pairs(dic) do
				costId = k;
				needNum = self.treeUpCostIdNum[costId];
				if needNum ~= nil then
					hasCostItemChange = true;
					break;
				end
			end

			if hasCostItemChange ~= true then
				return;
			end
		end

		for i = 1, #self.treeUpCostIds do
			costId = self.treeUpCostIds[i];
			num = DataCenter.packData:getItemCountById(costId);
			if num < self.treeUpCostIdNum[costId] then
				bCheck = false;
				break;
			end
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_UpTree, bCheck, false);
end

-- 可上阵异兽红点  第二队可上阵异兽红点
function Lua_StrangeBeastData:checkTreeLineupRedPoint()
	local bCheck = false;
	local bCheckLine = false;
	local bCheckLine_2 = false;
	local curAllArr = self:getCurAllBeastIdArr();
	if curAllArr:getSize() > 0 then
		bCheck = self:checkIdleBeast();
		if bCheck then
			local list = DataCenter.strangeBeastUtil:getTreeLineIds(1) or {};
			for i = 1, #list do
				local treeId = list[i];
				local treeLineupData = self:getLinupDataByIndex(treeId);
				if treeLineupData ~= nil and treeLineupData.state == 1 and (treeLineupData.strangeBeastId == nil or treeLineupData.strangeBeastId <= 0) then
					bCheckLine = true;
				end
			end
			
			list = DataCenter.strangeBeastUtil:getTreeLineIds(-1) or {};
			for i = 1, #list do
				local treeId = list[i];
				local teamIndex = DataCenter.strangeBeastUtil:getStrangeBeastLineUpCfgById(treeId, 3);
				if teamIndex ~= nil and teamIndex ~= 1 then
					local treeLineupData = self:getLinupDataByIndex(treeId);
					if treeLineupData ~= nil and treeLineupData.state == 1 and (treeLineupData.strangeBeastId == nil or treeLineupData.strangeBeastId <= 0) then
						bCheckLine = true;
						bCheckLine_2 = true;
					end
				end
			end
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_checkLine, bCheckLine, false);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_checkSecLine, bCheckLine_2, false);
end

-- 奖励可领取红点
function Lua_StrangeBeastData:checkBeastRewardRedPoint()
	local bCheck = false;
	if self.rewardIds ~= nil then
		for i = 1, #self.rewardIds do
			local state = self:getRewardDataById(self.rewardIds[i]);-- 0不可领，1可领，2已领
			if state == 1 then
				bCheck = true;
				break;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_Reward, bCheck, false);
end

-- 免费召唤红点
function Lua_StrangeBeastData:checkFreeRecruitRedPoint()
	local freeNum = self.recruitFreeNum or 0;
	local bCheck = freeNum > 0;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_FreeRecruit, bCheck, false);
end

--道具足够招募十次红点
function Lua_StrangeBeastData:checkTenRecruitRedPoint(dic)
	local bCheck = false;
	local costId, costNum;
	local costCfg = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(10);
	if costCfg ~= nil then
		costId = costCfg.json_value and costCfg.json_value[1] or 0;
		costNum = costCfg.json_value and costCfg.json_value[2] or 0;
	end

	if costId == nil or costId <= 0 or costNum == nil or costNum <= 0 then
		return;
	end

	if dic == nil then
		bCheck = DataCenter.packData:getItemCountById(costId) >= costNum;
	else
		if dic[costId] == nil then
			return;
		else
			bCheck = DataCenter.packData:getItemCountById(costId) >= costNum;
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_TenRecruit, bCheck, false);
end

function Lua_StrangeBeastData:checkRedPointWhenLogin()
	if self.checkLogin_1 ~= true then
		self.checkLogin_1 = true;
		self:checkBeastUpRedPoint();
		DataCenter.packData:checkChipRedPoint();
	end
end

function Lua_StrangeBeastData:checkBeastUpRedPoint(dic)
	local bCheck = false;
	local itemIdArr = self.beastCostItemIdArr;
	if itemIdArr == nil or itemIdArr:getSize() <= 0 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_UpBeast, bCheck, false);
		return;
	end

	local arr;
	local itemId;
	local bPackUpdate = dic ~= nil;
	if bPackUpdate then
		local hasItemChange = false;
		for k, v in pairs(dic) do
			itemId = k;
			arr = self.beastCostDic and self.beastCostDic[itemId] or nil;
			if arr ~= nil and arr:getSize() > 0 then
				hasItemChange = true
				break;
			end
		end

		if hasItemChange ~= true then
			return;
		end
	end

	local beastId;
	local beastVo;
	for i = 1, itemIdArr:getSize() do
		itemId = itemIdArr[i];
		arr = self.beastCostDic and self.beastCostDic[itemId] or nil;
		if arr ~= nil and arr:getSize() > 0 then
			beastId = arr[1];
			beastVo = self:getStrangeBeastVoById(beastId);
			if beastVo and beastVo.show_redpoint then
				bCheck = true;
				break;
			end
		end
	end

	DataCenter.packData:checkChipRedPoint();
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_UpBeast, bCheck, false);
end

function Lua_StrangeBeastData:onPackUpdate(dic)
	if DataCenter.funcOpenData:isOpened(10305) ~= true or dic == nil then
		return
	end

	self:checkUpTreeRedPoint(dic);
	self:checkNestRedPointInPackUpdate(dic);
	self:checkTenRecruitRedPoint(dic);

	self:checkBeastUpRedPoint(dic);
end



-- 羁绊
function Lua_StrangeBeastData:checkSingleFetterRedPoint(fetterId)
	local fetterData = self:getFetterDataByFetterId(fetterId);
	if fetterData == nil then
    	return false;
    end

    local curFetterLevelId = DataCenter.strangeBeastUtil:calFetterLevelId(fetterId, fetterData.level);
   	local bMaxFetterLevelId = DataCenter.strangeBeastUtil:checkMaxFetterLevelId(curFetterLevelId);
   	if bMaxFetterLevelId then
   		return false;
   	end

   	local showBeasts = DataCenter.strangeBeastUtil:getStrangeBeastFetterCfgByFetterId(fetterId, 4)
    if showBeasts == nil then
    	return false;
    end

    local showFetterId = self:getShowFetterLevelIdByFetterId(fetterId);
    local cfg = DataCenter.strangeBeastUtil:getStrangeBeastFetterLevelCfgByFetterLevelId(showFetterId);
    if cfg == nil then
    	return false;
    end

    local id;
	local beastVo;
    local needStar = cfg.level or 0;
    local bCheck = true;
    for i = 1, #showBeasts do
    	id = showBeasts[i];
    	beastVo = self:getStrangeBeastVoById(id);
    	if beastVo == nil or beastVo.bActive ~= true or beastVo.star < needStar then
			bCheck = false;
			break;
		end
    end

    return bCheck;
end

function Lua_StrangeBeastData:checkFetterRedPoint()
	local bShow = false;
	self.fettterIndex = 1;
	local list = DataCenter.strangeBeastUtil:getStrangeBeastConstCfgByType(2) or {};
	if self.fetterDic ~= nil then
		for i = 1, #list do
			local fetterData = DataCenter.strangeBeastData:getFetterDataByFetterId(list[i]);
		    if fetterData and fetterData.checkRedPoint then
		    	self.fettterIndex = i;
		    	bShow = true;
		    	break;
		    end
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StrangeBeast_FetterTab, bShow, false);
end

function Lua_StrangeBeastData:checkFetterRPInBeastChange(dic)
	if self.fetterBeasts == nil or dic == nil then
		return;
	end

	local arr;
	local bCheck;
	local fetterId;
	for k, v in pairs(dic) do
		arr = self.fetterBeasts[k];
		if arr and arr:getSize() > 0 then
			for i = 1, arr:getSize() do
				fetterId = arr[i];
				local fetterData = self:getFetterDataByFetterId(fetterId);
				if fetterData then
					local showRedPoint = self:checkSingleFetterRedPoint(fetterId);
					fetterData.checkRedPoint = showRedPoint;
					if bCheck ~= true and showRedPoint then
						bCheck = true;
					end
				end
			end
		end
	end

	if bCheck then
		self:checkFetterRedPoint();
	end
end

function Lua_StrangeBeastData:updateRedPointInBeastChange(dic)
	self:checkFetterRPInBeastChange(dic);
end













---------------------------------------------------------------
-- 当前异兽所需合成碎片数量
function Lua_StrangeBeastData:getDebrisMergeNum(beastId)
	local beastVo = self:getStrangeBeastVoById(beastId);
	if beastVo == nil then
		return 0;
	end

	if beastVo.bMaxStar == true then
		return 0;
	end

	local num = 0;
	if beastVo.bActive then
		local costCfg = beastVo.cost_item;
		num = costCfg and costCfg[1] and costCfg[1][2] or 0;
	else
		num = beastVo.active_debris_num or 0;
	end

	return num;
end



---------------------------------------------------------------
-- 异兽激活或升星资源打印
function Lua_StrangeBeastData:outputBeastRes()
	local costIdArr = DataCenter.strangeBeastData.beastCostItemIdArr;
 	print("现需资源数为：", costIdArr and costIdArr:getSize() or 0 )
	if costIdArr and costIdArr:getSize() > 0 then
		for i = 1, costIdArr:getSize() do
			local costId = costIdArr[i];
			local tvo = Lua_ToolVo.createToolVo(costId);
			print("***现需资源id为:", i, tvo.name);
			local str = ""
			local arr = DataCenter.strangeBeastData.beastCostDic[costId];
			for j = 1, arr:getSize() do
				local beastId = arr[j];
				local beastVo = DataCenter.strangeBeastData:getStrangeBeastVoById(beastId);
				local num = DataCenter.strangeBeastData.beastCostItemNumDic[beastId][costId] or 0;
				str = str.."  "..beastId..beastVo.name .. "<color=#FF0000>"..num.."</color>";
			end
			print("******", str)
		end
	end
end
