-- 异兽Vo
checkRequire("Lua_StrangeBeastConfigData");
Lua_StrangeBeastVo = class("Lua_StrangeBeastVo", Lua_ToolVo);
function Lua_StrangeBeastVo:ctor(id, config)
	-- self:distinguishType(id, config);
	self:setData(id, config);
end

-- function Lua_StrangeBeastVo:distinguishType(id, config)
-- 	if DataCenter.strangeBeastUtil:getStrangeBeastStarCfgById(id) then
-- 		self.strangeBeastStarId = id;
-- 		id = DataCenter.strangeBeastUtil:getStrangeBeastId(id);
-- 		config = nil;
-- 	elseif string.len(id) > 9 then
-- 		LogManager.LogError("no strange_beasts_star-异兽星级相关配置 id = " .. id, false);
-- 	end
--     self:setData(id, config);
-- end

function Lua_StrangeBeastVo:setData(id, config)
	self:clean();
	self.id = tonumber(id);
	self.config = config;
	if self.config == nil then
		self.config = Lua_StrangeBeastConfigData.getConfig(self.id);
	end

	if self.config == nil and id ~= 0 then
        LogManager.LogError("no strange_beasts-异兽表 id = " .. id, false);
    end
end

function Lua_StrangeBeastVo:clean()
	self:resetServerData()
	self.id = nil;
	self.config = nil;
	self._color = nil;
	self._bInitDebrisData = nil;
	self._active_cost_Ids = nil;
	self._active_cost_items = nil;
end

function Lua_StrangeBeastVo:dispose()
	self:clean();
end

function Lua_StrangeBeastVo:resetServerData()
	self:resetStrangeBeastStarData();
	self._star = nil;
	self.strangeBeastProp = nil;
	self.strangeBeastStarId = nil;
	self.strangeBeastForce = 0;
end

-- 异兽星级数据
function Lua_StrangeBeastVo:resetStrangeBeastStarData()
	if self.strangeBeastPropArr ~= nil and self.strangeBeastProp ~= nil and #self.strangeBeastProp > 0 then
		self.strangeBeastPropArr:dispose();
		self.strangeBeastPropArr:clear();
	end
	self.strangeBeastPropArr = nil;
	self._strangeBeastStarCfg = nil;
	self._nextStarId = nil;
	self.skillLevel = nil;
	self._upstar_cost_ids = nil;
end

function Lua_StrangeBeastVo:fromServer(serverData)
	if serverData == nil then
		self:resetServerData();
		return;
	end

	self.strangeBeastStarId = DataCenter.strangeBeastUtil:getStrangeBeastStarId(self.id, serverData.star or 0);
	self.strangeBeastProp = serverData.prop; -- 异兽属性
	self.strangeBeastForce = tonumber(serverData.force) or 0; -- 异兽战力
end

function Lua_StrangeBeastVo.Get:bActive()
	return self.strangeBeastProp ~= nil and #self.strangeBeastProp > 0;
end

function Lua_StrangeBeastVo:getStrangeBeastPropArr()
	if self.strangeBeastPropArr == nil then
		if self.strangeBeastProp == nil or #self.strangeBeastProp <= 0 then
			self.strangeBeastPropArr = DataCenter.strangeBeastUtil:getStrangeBeastStarPropArrById(self.strangeBeastStarId);
		else
			self.strangeBeastPropArr = DataCenter.attributesUtil:getAttrArrByServer(self.strangeBeastProp); 
		end
	end
	return self.strangeBeastPropArr;
end

function Lua_StrangeBeastVo.Get:strangeBeastStarId()
	if self._strangeBeastStarId == nil then
		return DataCenter.strangeBeastUtil:getStrangeBeastStarId(self.id, 0);
	else
		return self._strangeBeastStarId;
	end
end

function Lua_StrangeBeastVo.Set:strangeBeastStarId(value) 
	if self._strangeBeastStarId ~= value then
		self:resetStrangeBeastStarData();
	end
	self._strangeBeastStarId = value;
end

function Lua_StrangeBeastVo.Get:strangeBeastStarCfg()
	if self._strangeBeastStarCfg == nil then
		self._strangeBeastStarCfg = getConfig("strange_beasts_star", self.strangeBeastStarId);
	end

	return self._strangeBeastStarCfg;
end

function Lua_StrangeBeastVo.Get:star()
	-- if self._star == nil then
	-- 	return self.strangeBeastStarCfg and self.strangeBeastStarCfg.star or 0;
	-- end
	-- return self._star or 0;
	return self.strangeBeastStarCfg and self.strangeBeastStarCfg.star or 0;
end

function Lua_StrangeBeastVo.Set:star(value)
	if self.star ~= value then
		self.strangeBeastStarId = DataCenter.strangeBeastUtil:getStrangeBeastStarId(self.id, value or 0);
	end
end

function Lua_StrangeBeastVo.Get:skillId()
	return self.skill_list and self.skill_list[1] or nil;
end

function Lua_StrangeBeastVo.Get:maxSkillLevel()
	return self.maxStar + 1;
end

function Lua_StrangeBeastVo.Set:skillLevel(value)
	self._skillLevel = value;
end

function Lua_StrangeBeastVo.Get:skillLevel()
	if self._skillLevel == nil then
		self._skillLevel = self.bActive and self.star + 1 or 0;
	end
	return self._skillLevel;
end

function Lua_StrangeBeastVo.Get:color()
	if self._color == nil then
		self._color = self.config.color;
	end

	return self._color or 0;
end

function Lua_StrangeBeastVo.Set:color(value)
	self._color = value;
end

-- 异兽碎片
function Lua_StrangeBeastVo.Get:debris_id()
	if self.transfer_item ~= nil then
		return self.transfer_item[1];
	end
end

function Lua_StrangeBeastVo.Get:bMaxStar()
	return self.star >= self.maxStar;
end

-- 下一星级id
function Lua_StrangeBeastVo.Get:nextStarId()
	if self._nextStarId == nil then
		if self.bMaxStar then 
			self._nextStarId = 0;
		else
			local starId = DataCenter.strangeBeastUtil:getStrangeBeastStarId(self.id, self.star + 1);
			if DataCenter.strangeBeastUtil:getStrangeBeastStarCfgById(starId) then
				self._nextStarId = starId;
			else
				self._nextStarId = 0;
			end
		end
	end
	return self._nextStarId;
end

function Lua_StrangeBeastVo.Get:showStarId()
	if self.bMaxStar then
		return self.strangeBeastStarId;
	else
		return self.nextStarId;
	end
end


function Lua_StrangeBeastVo:initDebrisData()
	if self._bInitDebrisData ~= true then
		self._bInitDebrisData = true;

		self._active_cost_Ids = {};
		self._active_cost_items = {};
		local tvo = Lua_ToolVo.createToolVo(self.debris_id);
		if tvo ~= nil and tvo.compound then -- 激活时消耗的本体碎片
			num = tvo.compound[2] or 0;
			self._active_debris_num = num;
			self._active_cost_Ids[#self._active_cost_Ids + 1] = self.debris_id;
			self._active_cost_items[#self._active_cost_items + 1] = {self.debris_id, num};
		end

		if tvo ~= nil and tvo.consume_item then
			local consume_item = tvo.consume_item;
			for i = 1, #consume_item do
				self._active_cost_Ids[#self._active_cost_Ids + 1] = consume_item[i][1];
				self._active_cost_items[#self._active_cost_items + 1] = consume_item[i];
			end
		end
	end
end

function Lua_StrangeBeastVo.Get:active_cost_Ids()
	if self._active_cost_Ids == nil then
		self:initDebrisData();
	end
	return self._active_cost_Ids;
end

function Lua_StrangeBeastVo.Get:active_cost_items()
	if self._active_cost_items == nil then
		self:initDebrisData();
	end
	return self._active_cost_items;
end

function Lua_StrangeBeastVo.Get:active_debris_num()
	if self._active_debris_num == nil then
		self:initDebrisData();
	end
	return self._active_debris_num;
end

function Lua_StrangeBeastVo.Get:upstar_cost_ids()
	if self._upstar_cost_ids == nil then
		self._upstar_cost_ids = {};

		local cost_item = self.cost_item;
		if cost_item ~= nil and #cost_item > 0 then
			for i = 1, #cost_item do
				self._upstar_cost_ids[#self._upstar_cost_ids + 1] = cost_item[i][1];
			end
		end
	end

	return self._upstar_cost_ids;
end

function Lua_StrangeBeastVo.Get:cost_ids()
	if self.bActive then
		if self.bMaxStar then
			return nil;
		else
			return self.upstar_cost_ids;
		end
	else
		return self.active_cost_Ids;
	end
end

function Lua_StrangeBeastVo.Get:cur_cost_item()
	if self.bActive then
		if self.bMaxStar then
			return nil;
		else
			return self.cost_item;
		end
	else
		return self.active_cost_items;
	end
end

function Lua_StrangeBeastVo.Get:can_active()
	if self.bActive then
		return false;
	end

	local bCheck = true;
	for i = 1, #self.active_cost_items do
		local costId = tonumber(self.active_cost_items[i][1]);
		local costNum = self.active_cost_items[i][2];
		local hasNum = DataCenter.packData:getItemCountById(costId);
		if hasNum < costNum then
			bCheck = false;
			break;
		end
	end
	return bCheck;
end

function Lua_StrangeBeastVo.Get:can_upstar()
	if self.bMaxStar or self.nextStarId == 0 then
		return false;
	end

	local cost_item = self.cost_item;
	if cost_item == nil or #cost_item <= 0 then
		return;
	end

	local bCheck = true;
	for i = 1, #cost_item do
		local costId = cost_item[i][1];
		local costNum = cost_item[i][2];
		local hasNum = DataCenter.packData:getItemCountById(costId);
		if hasNum < costNum then
			bCheck = false;
			break;
		end
	end
	return bCheck;
end

function Lua_StrangeBeastVo.Get:show_redpoint()
	if self.bActive then
		return self.can_upstar == true;
	else
		return self.can_active == true;
	end
end









----------------------------------异兽表strange_beasts------------------------------------------
-- 异兽名称
function Lua_StrangeBeastVo.Get:name()
	if self.config ~= nil then
		return self.config.name;
	end
end

-- 初始星级
function Lua_StrangeBeastVo.Get:initial_star()
	if self.config ~= nil then
		return self.config.star;
	end
end

function Lua_StrangeBeastVo.Get:maxStar()
	if self.config ~= nil then
		return self.config.max_star;
	end
end

-- 本体道具id
function Lua_StrangeBeastVo.Get:item_id()
	if self.config ~= nil then
		return self.config.item_id;
	end
end

-- 初始品质
function Lua_StrangeBeastVo.Get:initial_quality()
	if self.config ~= nil then
		return self.config.quality;
	end
end

-- 初始品质
function Lua_StrangeBeastVo.Get:quality()
	if self.config ~= nil then
		return self.initial_quality;
	end
end

-- 重复获得本体时转换道具
function Lua_StrangeBeastVo.Get:transfer_item()
	if self.config ~= nil then
		return self.config.transfer_item;
	end
end

-- 本体碎片转换为道具时的特效类型
function Lua_StrangeBeastVo.Get:effectType()
	if self.config ~= nil then
		return self.config.effect_type;
	end
end

-- 基础评分
function Lua_StrangeBeastVo.Get:score()
	if self.config ~= nil then
		return self.config.score;
	end
end

function Lua_StrangeBeastVo.Get:atlas()
	if self.config ~= nil then
		return self.config.atlas;
	end
end

function Lua_StrangeBeastVo.Get:sprite()
	if self.config ~= nil then
		return self.config.sprite;
	end
end

-- 布阵小头像图集
function Lua_StrangeBeastVo.Get:embattle_atlas()
	if self.config ~= nil then
		return self.config.embattle_atlas;
	end
end

-- 布阵小头像图标
function Lua_StrangeBeastVo.Get:embattle_sprite()
	if self.config ~= nil then
		return self.config.embattle_sprite;
	end
end

-- 布阵小头像item底图图集
function Lua_StrangeBeastVo.Get:embattle_bg_atlas()
	if self.config ~= nil then
		return self.config.embattle_bg_atlas;
	end
end

-- 布阵小头像item底图图标
function Lua_StrangeBeastVo.Get:embattle_bg_sprite()
	if self.config ~= nil then
		return self.config.embattle_bg_sprite;
	end
end

--立绘路径
function Lua_StrangeBeastVo.Get:showImg()
	if self.config ~= nil then
		return self.config.show_img;
	end
end

--卡牌路径
function Lua_StrangeBeastVo.Get:cardImg()
	if self.config ~= nil then
		return self.config.card_img;
	end
end

--图鉴路径
function Lua_StrangeBeastVo.Get:atlasImg()
	if self.config ~= nil then
		return self.config.atlas_img;
	end
end

-- spine路径
function Lua_StrangeBeastVo.Get:spine_path()
	if self.config ~= nil then
    	return self.config.spine_path;
    end
end

-- spine资源名
function Lua_StrangeBeastVo.Get:spine_name()
	if self.config ~= nil then
    	return self.config.spine_name;
    end
end

--模型默认待机特效
function Lua_StrangeBeastVo.Get:poseActEffs()
	if self.config ~= nil then
		return self.config.poseActEffs;
	end
end

-- 模型展示特效
function Lua_StrangeBeastVo.Get:showActEffs()
	if self.config ~= nil then
    	return self.config.showActEffs;
    end
end

function Lua_StrangeBeastVo.Get:floder()--jta代替ID
	if self.config ~= nil then
		return self.config.floder or "/model/";
	end
end

function Lua_StrangeBeastVo.Get:uiModelSrc()
	if self.config ~= nil then
		return self.config.uiModelSrc;
	end
end

function Lua_StrangeBeastVo.Get:uiModelUrl()
	if self.config ~= nil then
		return self.config.uiModelUrl;
	end
end

function Lua_StrangeBeastVo.Get:uiModelAvatarName()
	if self.config ~= nil then
    	return self.config.uiModelAvatarName;
    end
end

function Lua_StrangeBeastVo.Get:uiModelCamController()
	if self.config ~= nil then
		return self.config.uiModelCamController;
	end
end

function Lua_StrangeBeastVo.Get:uiShowAct()
	if self.config ~= nil then
    	return self.config.uiShowAct;
    end
end

function Lua_StrangeBeastVo.Get:uiModelDir()
	if self.config ~= nil then
    	return self.config.uiModelDir;
    end
end

function Lua_StrangeBeastVo.Get:uiModelScale()
	if self.config ~= nil then
		return self.config.uiModelScale;
	end
end

function Lua_StrangeBeastVo.Set:uiSceneId(value)
	if self.config ~= nil then
   		self._uiSceneId = value
   	end
end

function Lua_StrangeBeastVo.Get:uiSceneId()
	if self.config ~= nil then
	    if self._uiSceneId == nil then
	    	self._uiSceneId = self.config.uiSceneId;
	    end

	    return self._uiSceneId;
	end
end

function Lua_StrangeBeastVo.Get:desc_title()
	if self.config ~= nil then
    	return self.config.desc_title;
    end
end

function Lua_StrangeBeastVo.Get:desc_content()
	if self.config ~= nil then
    	return self.config.desc_content;
    end
end

-- 图鉴背景框
function Lua_StrangeBeastVo.Get:show_atlasBg()
	if self.config ~= nil then
		return self.config.show_atlasBg;
	end
end

-- 上阵背景框
function Lua_StrangeBeastVo.Get:show_lineupBg()
	if self.config ~= nil then
		return self.config.show_lineupBg;
	end
end

-- 心愿单兑换所需积分
function Lua_StrangeBeastVo.Get:need_wish_score()
	if self.config ~= nil then
		return self.config.need_wish_score or 0;
	end
	return 0;
end

-- 圆形头像
function Lua_StrangeBeastVo.Get:avatar_atlas()
	if self.config ~= nil then
		return self.config.avatar_atlas;
	end
end

-- 圆形头像
function Lua_StrangeBeastVo.Get:avatar_sprite()
	if self.config ~= nil then
		return self.config.avatar_sprite;
	end
end

-- 品质：珍惜，稀有，极品
function Lua_StrangeBeastVo.Get:quality_atlas()
	if self.config ~= nil then
		return self.config.quality_atlas;
	end
end

-- 品质：珍惜，稀有，极品
function Lua_StrangeBeastVo.Get:quality_sprite()
	if self.config ~= nil then
		return self.config.quality_sprite;
	end
end

-- spine缩放值
function Lua_StrangeBeastVo.Get:spine_scale()
	if self.config ~= nil then
		return self.config.spine_scale;
	end
end

-- spine偏移值
function Lua_StrangeBeastVo.Get:spine_offset()
	if self.config ~= nil then
		return self.config.spine_offset;
	end
end

-- 战力对比相关描述
function Lua_StrangeBeastVo.Get:force_ratio_desc()
	if self.config ~= nil then
		return self.config.force_ratio_desc;
	end
end




----------------------------------异兽星级配置表strange_beasts_star-----------------------------------------
-- 升星消耗资源
function Lua_StrangeBeastVo.Get:cost_item()
	if self.strangeBeastStarCfg ~= nil then
		return self.strangeBeastStarCfg.cost_item;
	end
end

--技能列表
function Lua_StrangeBeastVo.Get:skill_list()
	if self.strangeBeastStarCfg ~= nil then
		return self.strangeBeastStarCfg.skill_list;
	end
end

--攻击
function Lua_StrangeBeastVo.Get:attack()
	if self.strangeBeastStarCfg ~= nil then
		return self.strangeBeastStarCfg.attack;
	end
end

--防御
function Lua_StrangeBeastVo.Get:defence()
	if self.strangeBeastStarCfg ~= nil then
		return self.strangeBeastStarCfg.defence;
	end
end

--生命
function Lua_StrangeBeastVo.Get:health()
	if self.strangeBeastStarCfg ~= nil then
		return self.strangeBeastStarCfg.health;
	end
end

--速度
function Lua_StrangeBeastVo.Get:speed()
	if self.strangeBeastStarCfg ~= nil then
		return self.strangeBeastStarCfg.speed;
	end
end

-- -- 基础评分
-- function Lua_StrangeBeastVo.Get:score()
-- 	if self.strangeBeastStarCfg ~= nil then
-- 		return self.strangeBeastStarCfg.score;
-- 	end

-- 	return 0;
-- end
