-- 异兽
checkRequire("Lua_StrangeBeastData");
checkRequire("Lua_StrangeBeastUtil");
Lua_StrangeBeastProxy = class("Lua_StrangeBeastProxy")
function Lua_StrangeBeastProxy:ctor()
	DataCenter.strangeBeastData = Lua_StrangeBeastData:new();
	DataCenter.strangeBeastUtil = Lua_StrangeBeastUtil.new();

	Lua_MsgUtil.addLuaMsg(50217001, self, self.rGetStrangeBeastInfo); --请求异兽信息（返回）
	Lua_MsgUtil.addLuaMsg(50217002, self, self.rGetStrangeBeastUpStar); --请求异兽升星（返回）
	Lua_MsgUtil.addLuaMsg(50217003, self, self.rGetStrangeBeastNestInfo); --请求孵化巢信息（返回）
    Lua_MsgUtil.addLuaMsg(50217006, self, self.rGetReceiveStrangeBeast); --请求领取已孵化的异兽蛋（返回）
	Lua_MsgUtil.addLuaMsg(50217008, self, self.rGetStrangeBeastRecruitInfo); --请求异兽召唤信息（返回）
	Lua_MsgUtil.addLuaMsg(50217009, self, self.rGetStrangeBeastWishBless); --请求设置心愿单（返回）
	Lua_MsgUtil.addLuaMsg(50217010, self, self.rRecruitStrangeBeast); --请求进行异兽召唤（返回）
	Lua_MsgUtil.addLuaMsg(50217011, self, self.rGetStrangeTreeInfo); --请求扶桑树信息（返回）
	Lua_MsgUtil.addLuaMsg(50217012, self, self.rGetStrangeTreeUpLevel); --请求升级扶桑树（返回）
	Lua_MsgUtil.addLuaMsg(50217013, self, self.rGetStrangeBeastLineupInfo); --请求扶桑树上阵异兽（返回)
	Lua_MsgUtil.addLuaMsg(50217014, self, self.rGetStrangeFetter); --请求异兽羁绊信息（返回）
	Lua_MsgUtil.addLuaMsg(50217015, self, self.rUnlockStrangeBeastFetter); --请求解锁异兽羁绊（返回）
	Lua_MsgUtil.addLuaMsg(50217016, self, self.rUpLevelStrangeBeastFetter); --请求升级异兽羁绊（返回）
	Lua_MsgUtil.addLuaMsg(50217017, self, self.rReceivedStrangeBeastReward); --请求领取异兽召唤积分奖励（返回)
    Lua_MsgUtil.addLuaMsg(50217018, self, self.rRecruitWish); --请求进行心愿召唤（返回）

	Lua_MsgUtil.addLuaMsg(80217001, self, self.noticeActiveStrangeBeast); --通知激活异兽
	Lua_MsgUtil.addLuaMsg(80217002, self, self.noticeStrangeBeastSpecialPower); --通知异兽特权状态


    Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.onPackUpdate);--获取道具更新红点
    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onPackUpdate);--获取货币更新红点
end

---------------------------------------请求--------------------------------
-- 请求异兽信息
function Lua_StrangeBeastProxy:sGetStrangeBeastInfo()
    sendMsg(10217001);
end

-- 请求异兽升星
function Lua_StrangeBeastProxy:sGetStrangeBeastUpStar(id) --异兽id
	local cmd = ProtoPublic_pb.Proto10217002();
    cmd.id = id;
    sendMsg(10217002, cmd);
end

-- 请求孵化巢信息
function Lua_StrangeBeastProxy:sGetStrangeBeastNestInfo()
    sendMsg(10217003);
end

-- 请求设置孵化巢一键孵化
function Lua_StrangeBeastProxy:sGetStrangeBeastOneKeyIncubate(quality_list) 
	local cmd = ProtoPublic_pb.Proto10217004();
	if quality_list ~= nil and #quality_list > 0 then
		for i = 1, #quality_list do
			cmd.quality_list:append(tonumber(quality_list[i]));
		end
	end
    sendMsg(10217004, cmd);
end

-- 请求孵化异兽蛋
function Lua_StrangeBeastProxy:sGetStrangeBeastIncubateEgg(list) -- list:{ {index:填孵化巢索引, eggId = {{key:道具id, value:道具数量}，}     }}
	local cmd = ProtoPublic_pb.Proto10217005();
	if list ~= nil and #list > 0 then
		local info;
		for i = 1, #list do
			info = list[i];
			local hatch_egg_list = getProtoMsg("ProtoPairStruct");
			hatch_egg_list.type = info.index;
			if info.eggId ~= nil and #info.eggId > 0 then
				for j = 1, #info.eggId do
					local map_list = getProtoMsg("ProtoPair");
					map_list.key = info.eggId[j].key;
					map_list.value = info.eggId[j].value;
					hatch_egg_list.map_list:addToList(map_list);
				end
			end
			cmd.hatch_egg_list:addToList(hatch_egg_list);
		end
	end
    sendMsg(10217005, cmd);
end

-- 请求领取已孵化的异兽蛋
function Lua_StrangeBeastProxy:sReceiveStrangeBeast(index) --孵化巢索引
	local cmd = ProtoPublic_pb.Proto10217006();
    cmd.index = index;
    sendMsg(10217006, cmd);
end

-- 请求加速孵化异兽蛋
function Lua_StrangeBeastProxy:sAccelateStrangeBeast(index, item_id) --孵化巢索引, 要加速的异兽蛋
	local cmd = ProtoPublic_pb.Proto10217007();
    cmd.index = index;
    cmd.item_id = item_id;
    sendMsg(10217007, cmd);
end

-- 请求异兽召唤信息
function Lua_StrangeBeastProxy:sGetStrangeBeastRecruitInfo()
    sendMsg(10217008);
end

-- 请求设置心愿单
function Lua_StrangeBeastProxy:sGetStrangeBeastWishBless(id_list) 
	local cmd = ProtoPublic_pb.Proto10217009();
	if id_list ~= nil and #id_list > 0 then
		for i = 1, #id_list do
			cmd.id_list:append(tonumber(id_list[i]));
		end
	end
    sendMsg(10217009, cmd);
end

-- 请求进行异兽召唤
function Lua_StrangeBeastProxy:sRecruitStrangeBeast(type) 
	local cmd = ProtoPublic_pb.Proto10217010();
	cmd.type = type;
    sendMsg(10217010, cmd);
end

-- 请求扶桑树信息
function Lua_StrangeBeastProxy:sGetStrangeTreeInfo()
    sendMsg(10217011);
end

-- 请求升级扶桑树
function Lua_StrangeBeastProxy:sGetStrangeTreeUpLevel()
    sendMsg(10217012);
end

-- 请求扶桑树上阵异兽
function Lua_StrangeBeastProxy:sGetStrangeBeastLineupInfo(list) -- {{key, value}}
	local cmd = ProtoPublic_pb.Proto10217013();
    if list ~= nil and #list > 0 then
        local info;
        for i = 1, #list do
            info = list[i];
            local lineup_list = getProtoMsg("ProtoPair");
            lineup_list.key = info.key;
            lineup_list.value = info.value;
            cmd.lineup_list:addToList(lineup_list);
        end
    end

    sendMsg(10217013, cmd);
end

-- 请求异兽羁绊信息
function Lua_StrangeBeastProxy:sGetStrangeFetter()
    sendMsg(10217014);
end

-- 请求解锁异兽羁绊
function Lua_StrangeBeastProxy:sUnlockStrangeBeastFetter(id) --id 要解锁的羁绊id
	local cmd = ProtoPublic_pb.Proto10217015();
	cmd.id = id;
    sendMsg(10217015, cmd);
end

-- 请求升级异兽羁绊（返回）
function Lua_StrangeBeastProxy:sUpLevelStrangeBeastFetter(id) --id 羁绊id
	local cmd = ProtoPublic_pb.Proto10217016();
	cmd.id = id;
    sendMsg(10217016, cmd);
end

-- 请求领取异兽召唤积分奖励
function Lua_StrangeBeastProxy:sReceivedStrangeBeastReward(id) --奖励id
	local cmd = ProtoPublic_pb.Proto10217017();
	-- cmd.id = id;
    sendMsg(10217017, cmd);
end

-- 请求进行心愿召唤
function Lua_StrangeBeastProxy:sRecruitWish(id) --异兽本体id
    local cmd = ProtoPublic_pb.Proto10217018();
    cmd.id = id;
    sendMsg(10217018, cmd);
end




---------------------------------------返回--------------------------------
--请求异兽信息（返回）
function Lua_StrangeBeastProxy:rGetStrangeBeastInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217001();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217001(msg);
    end
end

--请求异兽升星（返回）
function Lua_StrangeBeastProxy:rGetStrangeBeastUpStar(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217002();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217002(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_UP_STAR_INFO");

        local obj = msg.strange_beasts;
        if obj ~= nil then
            local strangeBeastId = tonumber(obj.id);
            local star = obj.star;
            local starId =  DataCenter.strangeBeastUtil:getStrangeBeastStarId(strangeBeastId, star)
            Lua_WindowUtil.openWin("Lua_StrangeBeastUpStarWindow", Lua_WinParam.ACTION_OPEN, starId);
        end
    end
end

--请求孵化巢信息（返回）
function Lua_StrangeBeastProxy:rGetStrangeBeastNestInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217003();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217003(msg);

        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_HATCH_PANEL_INFO");
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_HATCH_SETTING_WINDOW_INFO");
    end
end

--请求领取已孵化的异兽蛋（返回）
function Lua_StrangeBeastProxy:rGetReceiveStrangeBeast(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217006();
        msg:ParseFromString(mp.data);
       
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_HATCH_RECEIVE_EGG", msg.index);
    end
end

--请求异兽召唤信息（返回）
function Lua_StrangeBeastProxy:rGetStrangeBeastRecruitInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217008();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217008(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_RECRUIT_PLANE_INFO");
    end
end

--请求设置心愿单（返回）
function Lua_StrangeBeastProxy:rGetStrangeBeastWishBless(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217009();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217009(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_RECRUIT_WISH_INFO");
    end
end

--请求进行异兽召唤（返回）
function Lua_StrangeBeastProxy:rRecruitStrangeBeast(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217010();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217010(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_RECRUIT_PLANE_INFO", true);
    end
end

--请求扶桑树信息（返回）
function Lua_StrangeBeastProxy:rGetStrangeTreeInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217011();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217011(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_TREE_PANEL_INFO");
    end
end

--请求升级扶桑树（返回）
function Lua_StrangeBeastProxy:rGetStrangeTreeUpLevel(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217012();
        msg:ParseFromString(mp.data);

        local lastTreeStage = DataCenter.strangeBeastData.treeStage or 0;
        local lastTreeId = DataCenter.strangeBeastData.curTreeId;
        DataCenter.strangeBeastData:fromServer50217012(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_TREE_PANEL_INFO");

        local curtreeStage = DataCenter.strangeBeastData.treeStage or 0;
        local curTreeId = DataCenter.strangeBeastData.curTreeId;
        if curtreeStage ~= lastTreeStage and lastTreeId ~= curTreeId then
            Lua_WindowUtil.openWin("Lua_StrangeBeastTreeUpStageWindow", Lua_WinParam.ACTION_OPEN, lastTreeId);
        elseif lastTreeId ~= curTreeId then
            Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_TREE_UPLEVEL");
        end

    end
end

--请求扶桑树上阵异兽（返回)
function Lua_StrangeBeastProxy:rGetStrangeBeastLineupInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217013();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217013(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_TREE_LINEUP_INFO");
    end
end

--请求异兽羁绊信息（返回）
function Lua_StrangeBeastProxy:rGetStrangeFetter(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217014();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217014(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_FETTER_PANEL_INFO");
    end
end

--请求解锁异兽羁绊（返回）
function Lua_StrangeBeastProxy:rUnlockStrangeBeastFetter(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217015();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217015(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_FETTER_PANEL_INFO");

        Lua_WindowUtil.openWin("Lua_StrangeBeastFetterUpStageWindow", Lua_WinParam.ACTION_OPEN, msg.fetter_info.id);
    end
end

--请求升级异兽羁绊（返回）
function Lua_StrangeBeastProxy:rUpLevelStrangeBeastFetter(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217016();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217016(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_FETTER_PANEL_INFO");

        Lua_WindowUtil.openWin("Lua_StrangeBeastFetterUpStageWindow", Lua_WinParam.ACTION_OPEN, msg.fetter_info.id);
    end
end



--通知激活异兽
function Lua_StrangeBeastProxy:noticeActiveStrangeBeast(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80217001();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer80217001(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_ACTIVE_BREAST_INFO");

        local star;
        local starId;
        local beastId;
        local info;
        local list = msg.strange_beasts_list;
        if list ~= nil and #list then
            for i = 1, #list do
                info = list[i];
                beastId = tonumber(info.id);
                star = info.star;
                starId = DataCenter.strangeBeastUtil:getStrangeBeastStarId(beastId, star);
                Lua_WindowUtil.openWin("Lua_StrangeBeastObtainNewBeastWindow", Lua_WinParam.ACTION_OPEN, starId);
            end
        end
    end
end

--通知异兽特权状态
function Lua_StrangeBeastProxy:noticeStrangeBeastSpecialPower(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80217002();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer80217002(msg);

        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_PRIVILEGE_WINDOW_INFO");
    end
end

--请求领取异兽召唤积分奖励（返回）
function Lua_StrangeBeastProxy:rReceivedStrangeBeastReward(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217017();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217017(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_RECRUIT_REWARD_INFO");
    end
end

--请求进行心愿召唤（返回）
function Lua_StrangeBeastProxy:rRecruitWish(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50217018();
        msg:ParseFromString(mp.data);
        DataCenter.strangeBeastData:fromServer50217018(msg);
        Lua_MsgUtil.callFunc("UPDATE_STRANGEBEAST_WISH_RECRUIT_INFO");
    end
end


function Lua_StrangeBeastProxy:onPackUpdate(dic)
    DataCenter.strangeBeastData:onPackUpdate(dic);
end