-- 异兽
Lua_StrangeBeastUtil = class("Lua_StrangeBeastUtil")
Lua_StrangeBeastUtil.RARESTRANGEBEAST = 203030016; -- 稀有异兽蛋 
Lua_StrangeBeastUtil.PRECIOUSSTRANGEBEAST = 203030017; -- 珍稀异兽蛋 
Lua_StrangeBeastUtil.PREMIUMSTRANGEBEAST = 203030018; -- 极品异兽蛋 
function Lua_StrangeBeastUtil:ctor()
end

function Lua_StrangeBeastUtil:dispose()
	self:superCall("dispose");
end

function Lua_StrangeBeastUtil:getStrangeBeastCfgById(id, type)
	id = tonumber(id);
	if id == nil then
		return;
	end

	local cfg = getConfig("strange_beasts", id);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then
		return id;
	elseif type == 2 then
		return cfg.name;
	elseif type == 3 then
		return cfg.star;
	elseif type == 4 then
		return cfg.quality;
	elseif type == 5 then
		return cfg.transfer_item;
	elseif type == 6 then
		return cfg.score;
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastTreeCfgById(id, type)
	id = tonumber(id);
	if id == nil then
		return;
	end

	local cfg = getConfig("strange_beasts_tree", id);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then -- 阶级
		return cfg.order;
	elseif type == 2 then -- 等级
		return cfg.level;
	elseif type == 3 then -- 升阶消耗
		return cfg.order_cost;
	elseif type == 4 then -- 升级消耗
		return cfg.level_cost;
	elseif type == 5 then -- 攻击
		return cfg.attack;
	elseif type == 6 then -- 防御
		return cfg.defence;
	elseif type == 7 then -- 生命
		return cfg.health;
	elseif type == 8 then -- 速度
		return cfg.speed;
	elseif type == 9 then -- 生命百分比
		return cfg.health_multi;
	elseif type == 10 then -- 攻击百分比
		return cfg.attack_multi;
	elseif type == 11 then -- 解封系数
		return cfg.coefficient;
	elseif type == 12 then -- 固定战力
		return cfg.fixed_force;
	elseif type == 13 then -- 当前阶级的最大等级
		return cfg.max_level;
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastStarCfgById(id, type)
	id = tonumber(id);
	if id == nil then
		return;
	end

	local cfg = getConfig("strange_beasts_star", id);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then
		return id;
	elseif type == 2 then
		return cfg.star;
	elseif type == 3 then
		return cfg.cost_item;
	elseif type == 4 then
		return cfg.skill_list;
	elseif type == 5 then
		return cfg.score;
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastStarPropArrById(id)
	if self.strangeBeastStarPropArrDic == nil then
		self.strangeBeastStarPropArrDic = {};
	end

	local propArr = self.strangeBeastStarPropArrDic[id];
	if propArr == nil then
		local cfg = self:getStrangeBeastStarCfgById(id, nil);
		if cfg ~= nil then
			local props = {};
			if cfg.attack ~= nil then
				props.attack = tonumber(cfg.attack);
			end
			if cfg.defence ~= nil then
				props.defence = tonumber(cfg.defence);
			end
			if cfg.health ~= nil then
				props.health = tonumber(cfg.health);
			end
			if cfg.speed ~= nil then
				props.speed = tonumber(cfg.speed);
			end
			if cfg.health_multi ~= nil then
				props.health_multi = tonumber(cfg.health_multi);
			end
			if cfg.attack_multi ~= nil then
				props.attack_multi = tonumber(cfg.attack_multi);
			end

			propArr = DataCenter.attributesUtil:getAttrArrByDic(props);
			self.strangeBeastStarPropArrDic[id] = propArr;
		end
	end

	return propArr;
end

function Lua_StrangeBeastUtil:calStrangeBeastTreeId(stage, level)
	stage = stage or 0;
	level = level or 0;
	return 100000 + stage * 1000 + level;
end

function Lua_StrangeBeastUtil:getStrangeBeastTreePropArrById(id)
	if self.strangeBeastTreePropArrDic == nil then
		self.strangeBeastTreePropArrDic = {};
	end

	local propArr = self.strangeBeastTreePropArrDic[id];
	if propArr == nil then
		local cfg = self:getStrangeBeastTreeCfgById(id, nil);
		if cfg ~= nil then
			local props = {};
			if cfg.attack ~= nil then
				props.attack = tonumber(cfg.attack);
			end
			if cfg.defence ~= nil then
				props.defence = tonumber(cfg.defence);
			end
			if cfg.health ~= nil then
				props.health = tonumber(cfg.health);
			end
			if cfg.speed ~= nil then
				props.speed = tonumber(cfg.speed);
			end
			-- if cfg.health_multi ~= nil then
			-- 	props.health_multi = tonumber(cfg.health_multi);
			-- end
			-- if cfg.attack_multi ~= nil then
			-- 	props.attack_multi = tonumber(cfg.attack_multi);
			-- end


			propArr = DataCenter.attributesUtil:getAttrArrByDic(props);
			self.strangeBeastTreePropArrDic[id] = propArr;
		end
	end

	return propArr;
end

function Lua_StrangeBeastUtil:getHatchNestIndex()
	return self:getStrangeBeastConstCfgByType(14);
end

-- 异兽星级id
function Lua_StrangeBeastUtil:getStrangeBeastStarId(id, star)
	if id == nil or star == nil then
		return;
	end

	return id * 100 + star;
end

-- 异兽id
function Lua_StrangeBeastUtil:getStrangeBeastId(starId)
	if starId == nil or type(starId) ~= "number" then
		return;
	end

	return Mathf.Floor(starId / 100);
end

-- 扶桑树上阵位
function Lua_StrangeBeastUtil:getStrangeBeastTreeLineupId(lineupIndex, pos)
	if lineupIndex == nil or pos == nil then
		return;
	end

	return lineupIndex * 100 + pos;
end

function Lua_StrangeBeastUtil:getStrangeBeastConstCfgByType(type)
	if type == nil then
		return getConfig("strange_beasts_const");
	elseif type == 1 then -- 孵化保底次数
		return getConfig("strange_beasts_const", "hatch_guaranty_times", "value");
	elseif type == 2 then -- 羁绊id列表
		return getConfig("strange_beasts_const", "fetter_ids", "json_value");
	elseif type == 3 then -- 心愿单数量限制
		return getConfig("strange_beasts_const", "wish_limit", "value");
	elseif type == 4 then -- 心愿单可选列表
		return getConfig("strange_beasts_const", "wish_select_list", "json_value");
	elseif type == 5 then -- 特权内容设置
		return getConfig("strange_beasts_const", "privilege_content_list", "json_value");
	elseif type == 6 then -- 特权充值id
		return getConfig("strange_beasts_const", "privilege_conf_id", "value");
	elseif type == 7 then -- 扶桑树英雄基础属性解封阶级
		return getConfig("strange_beasts_const", "tree_prop_unlock", "value");	
	elseif type == 8 then -- 扶桑树阶级id列表
		return getConfig("strange_beasts_const", "tree_stage_ids", "json_value");
	elseif type == 9 then -- 1次召唤消耗
		return getConfig("strange_beasts_const", "one_draw_cost");
	elseif type == 10 then -- 10次召唤消耗
		return getConfig("strange_beasts_const", "ten_draw_cost");
	elseif type == 11 then -- 一键孵化设置窗口中异兽ids
		return getConfig("strange_beasts_const", "hatch_setting_egg_ids", "json_value");
	elseif type == 12 then -- 钻石召唤次数限制
		return getConfig("strange_beasts_const", "money_draw_limit", "value");
	elseif type == 13 then -- 孵化异兽蛋描述
		return getConfig("strange_beasts_const", "hatch_beast_egg_desc", "json_value");
	elseif type == 14 then -- 孵化巢位置索引
		return getConfig("strange_beasts_const", "hatch_nest_indexes", "json_value");
	elseif type == 15 then -- 召唤获得奖励排列在最末
		return getConfig("strange_beasts_const", "draw_sort_ids", "json_value");
	elseif type == 16 then -- 图鉴Item品质背景框配置
		return getConfig("strange_beasts_const", "show_atlas_bgs", "json_value");
	elseif type == 17 then -- 上阵item品质背景框配置
		return getConfig("strange_beasts_const", "show_lineup_bgs", "json_value");
	elseif type == 18 then -- 心愿积分上限
		return getConfig("strange_beasts_const", "wish_score_limit", "value");
	elseif type == 19 then -- 召唤动画时长
		return getConfig("strange_beasts_const", "draw_play_time", "float_value");
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastHatchNestCfgById(id, type)
	id = tonumber(id);
	if id == nil then
		return;
	end

	local cfg = getConfig("strange_beasts_hatch_nest", id);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then -- 可孵化数量
		return cfg.amount;
	elseif type == 2 then -- 解锁所需指定异兽数量
		return cfg.quality_cond;
	elseif type == 3 then -- 解锁需要激活异兽特权
		return cfg.privilege_cond;
	elseif type == 4 then -- 加速消耗资源
		return cfg.quicken_cost;
	elseif type == 5 then -- 解锁描述
		return cfg.unlock_desc;
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastLineUpCfgById(id, type)
	id = tonumber(id);
	if id == nil then
		return;
	end

	local cfg = getConfig("strange_beasts_lineup", id);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then -- 解锁描述
		return cfg.unlock_desc;
	elseif type == 2 then -- 是否显示
		return cfg.show;
	elseif type == 3 then -- 所属队伍
		return cfg.team_index;
	end
end

function Lua_StrangeBeastUtil:getShowRecruitRecordStr(msg)
	if msg == nil then
		return;
	end

	local str 
	local name = msg.key;
	local strangeBeastId = tonumber(msg.value) or 0;
	local cfg = self:getStrangeBeastCfgById(strangeBeastId);
	if cfg ~= nil then
		local qualityStr = self:getQualityById(cfg.quality);
		str = LanUtil.formateStr("恭喜{1}召唤出{2}异兽{3}", name, qualityStr, cfg.name);
	end

	return str;
end

function Lua_StrangeBeastUtil:getQualityById(id)
	local str;
	if id == 1 then
		str = LanUtil.getValue(782130);
	elseif id == 2 then
		str = LanUtil.getValue(782131);
	elseif id == 3 then
		str = LanUtil.getValue(782132);
	end

	return str;
end

function Lua_StrangeBeastUtil:getRecruitWishIds()
	if self.recruitWishIds == nil then
		local ids = {};
		local cfg = self:getStrangeBeastConstCfgByType(4);
		if cfg ~= nil then
			for i = 1, #cfg do
				ids[#ids + 1] = cfg[i];
			end

			table.sort( ids, function(a, b)
					local aQuality = self:getStrangeBeastCfgById(a, 4) or 0;
					local bQuality = self:getStrangeBeastCfgById(b, 4) or 0;
					if aQuality ~= bQuality then
						return aQuality > bQuality;
					else
						return a < b;
					end
				end 
			);
		end
		self.recruitWishIds = ids;
	end

	return self.recruitWishIds;
end

function Lua_StrangeBeastUtil:getEggQuailtyIds()
	if self._eggQuailtyIds == nil then
		self._eggQuailtyIds = {};
		local list = self:getStrangeBeastConstCfgByType(11) or {};
		local tvo;
		for i = 1, #list do
			tvo = Lua_ToolVo.createToolVo(list[i]);
			self._eggQuailtyIds[#self._eggQuailtyIds + 1] = tvo.quality;
		end
	end

	return self._eggQuailtyIds;
end




--------------羁绊--------------
function Lua_StrangeBeastUtil:getStrangeBeastFetterLevelCfgByFetterLevelId(fetterLevelId, type)
	if fetterLevelId == nil then
		return;
	end

	local cfg = getConfig("strange_beasts_fetter_level", fetterLevelId);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then
		return fetterLevelId;
	elseif type == 2 then
		return cfg.level;
	elseif type == 3 then
		return cfg.attack;
	elseif type == 4 then
		return cfg.health;
	elseif type == 5 then
		return cfg.desc;
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastFetterCfgByFetterId(fetterId, type)
	if fetterId == nil then
		return;
	end

	local cfg = getConfig("strange_beasts_fetter", fetterId);
	if cfg == nil then
		return;
	end

	if type == nil then
		return cfg;
	elseif type == 1 then -- 羁绊名字
		return cfg.name;
	elseif type == 2 then -- 羁绊初始等级
		return cfg.level;
	elseif type == 3 then -- 羁绊激活基础数量
		return cfg.amount;
	elseif type == 4 then -- 异兽列表
		return cfg.strange_beasts_list;
	end
end

-- 羁绊加成
function Lua_StrangeBeastUtil:getStrangeBeastFetterPropArrByFetterLevelId(fetterLevelId)
	if self.strangeBeastFetterPropArrDic == nil then
		self.strangeBeastFetterPropArrDic = {};
	end

	local propArr = self.strangeBeastFetterPropArrDic[fetterLevelId];
	if propArr == nil then
		local props = self:getStrangeBeastFetterPropsByFetterLevelId(fetterLevelId);
		if props ~= nil then
			propArr = DataCenter.attributesUtil:getAttrArrByDic(props);
			self.strangeBeastFetterPropArrDic[fetterLevelId] = propArr;
		end
	end

	return propArr;
end

function Lua_StrangeBeastUtil:getStrangeBeastFetterPropsByFetterLevelId(fetterLevelId, checkZero)
	if self.strangeBeastFetterPropsDic == nil then
		self.strangeBeastFetterPropsDic = {};
	end

	local props = self.strangeBeastFetterPropsDic[fetterLevelId];
	if props == nil then
		local cfg = self:getStrangeBeastFetterLevelCfgByFetterLevelId(fetterLevelId, nil);
		if cfg ~= nil then
			props = {};
			if cfg.attack ~= nil then
				props.attack = tonumber(cfg.attack);
			end
			if cfg.health ~= nil then
				props.health = tonumber(cfg.health);
			end
			if cfg.defence ~= nil then
				props.defence = tonumber(cfg.defence);
			end
			if cfg.speed ~= nil then
				props.speed = tonumber(cfg.speed);
			end
			if cfg.attack_multi ~= nil then
				props.attack_multi = cfg.attack_multi;
			end
			if cfg.health_multi ~= nil then
				props.health_multi = cfg.health_multi;
			end

			self.strangeBeastFetterPropsDic[fetterLevelId] = props;
		elseif fetterLevelId == 0 and checkZero then
			props = {};
			local cfg = getConfig("strange_beasts_const", "show_fetter_props", "json_value");
			if cfg then
				local key;
				for i = 1, #cfg do
					key = cfg[i];
					props[key] = 0;
				end
			end
			self.strangeBeastFetterPropsDic[fetterLevelId] = props;
		end
	end

	if fetterLevelId == 0 and checkZero ~= true then
		props = nil;
	end

	return props;
end

function Lua_StrangeBeastUtil:calFetterLevelId(fetterId, level)
	level = level or 0;
	fetterId = fetterId or 0;

	return fetterId * 100 + level;
end

function Lua_StrangeBeastUtil:checkMaxFetterLevelId(fetterLevelId)
	fetterLevelId = fetterLevelId or 0;
	local cfg = self:getStrangeBeastFetterLevelCfgByFetterLevelId(fetterLevelId + 1, nil);
	return cfg == nil;
end



--------------图鉴--------------
function Lua_StrangeBeastUtil:initStrangeBeastAtlas()
	if self.strangeBeastAtlasIds == nil then
		self.strangeBeastAtlasIds = {};
		local cfg = getConfig("strange_beasts");
		if cfg then
			for k, v in pairs(cfg) do
				self.strangeBeastAtlasIds[#self.strangeBeastAtlasIds + 1] = k;
			end
		end

		table.sort(self.strangeBeastAtlasIds, function(a, b)
				return a > b;end
			);
	end
end

function Lua_StrangeBeastUtil:getStrangeBeastAtlasIds()
	if self.strangeBeastAtlasIds == nil then
		self:initStrangeBeastAtlas();
	end

	return self.strangeBeastAtlasIds;
end

-- 升星
function Lua_StrangeBeastUtil:getBeastUpStarProps(curBeastStarId)
	local cfg = self:getStrangeBeastStarCfgById(curBeastStarId);
	if cfg == nil then
		return;
	end

	local curStar = cfg.star or 0;
	local lastBeastStarId = curBeastStarId - 1;
	local lastCfg = self:getStrangeBeastStarCfgById(lastBeastStarId);
	if lastCfg == nil or lastCfg.star ~= (curStar - 1) then
		return;
	end

	local totalProps = {};
	local curValue;
	local lastValue;
	-- 攻击
	curValue = cfg.attack or 0;
	lastValue = lastCfg.attack or 0;
	totalProps[#totalProps + 1] = {propStr = "attack", curValue = curValue, lastValue = lastValue};
	-- 防御
	curValue = cfg.defence or 0;
	lastValue = lastCfg.defence or 0;
	totalProps[#totalProps + 1] = {propStr = "defence", curValue = curValue, lastValue = lastValue};
	-- 生命
	curValue = cfg.health or 0;
	lastValue = lastCfg.health or 0;
	totalProps[#totalProps + 1] = {propStr = "health", curValue = curValue, lastValue = lastValue};
	-- 速度
	curValue = cfg.speed or 0;
	lastValue = lastCfg.speed or 0;
	totalProps[#totalProps + 1] = {propStr = "speed", curValue = curValue, lastValue = lastValue};

	return totalProps;
end

-- 扶桑树升阶
function Lua_StrangeBeastUtil:getBeastTreeUpStageProps(lastTreeId)
	local lastCfg = self:getStrangeBeastTreeCfgById(lastTreeId);
	if lastCfg == nil then
		return;
	end

	local level = lastCfg.level or 0;
	local order = lastCfg.order or 0;
	local bMaxLevel = level == (lastCfg.max_level or 0);
	if bMaxLevel then
		order = order + 1;
	end
	level = level + 1;
	local curTreeId = self:calStrangeBeastTreeId(order, level);
	local curCfg = self:getStrangeBeastTreeCfgById(curTreeId);
	if curCfg == nil then
		return;
	end 

	local totalProps = {};
	local len;
	local curValue;
	local lastValue;
	-- 等级上限
	curValue = curCfg.max_level or 0;
	lastValue = lastCfg.max_level or 0;
	len = #totalProps + 1;
	totalProps[len] = {propStr = "max_level", curValue = curValue, lastValue = lastValue, index = len};

	-- 攻击
	curValue = curCfg.attack or 0;
	lastValue = lastCfg.attack or 0;
	len = #totalProps + 1;
	totalProps[len] = {propStr = "attack", curValue = curValue, lastValue = lastValue, index = len};
	-- 防御
	curValue = curCfg.defence or 0;
	lastValue = lastCfg.defence or 0;
	len = #totalProps + 1;
	totalProps[len] = {propStr = "defence", curValue = curValue, lastValue = lastValue, index = len};
	-- 生命
	curValue = curCfg.health or 0;
	lastValue = lastCfg.health or 0;
	len = #totalProps + 1;
	totalProps[len] = {propStr = "health", curValue = curValue, lastValue = lastValue, index = len};
	-- 速度
	curValue = curCfg.speed or 0;
	lastValue = lastCfg.speed or 0;
	len = #totalProps + 1;
	totalProps[len] = {propStr = "speed", curValue = curValue, lastValue = lastValue, index = len};
	-- -- 生命百分比
	-- curValue = curCfg.health_multi or 0;
	-- lastValue = lastCfg.health_multi or 0;
	-- len = #totalProps + 1;
	-- totalProps[len] = {propStr = "health_multi", curValue = curValue, lastValue = lastValue, index = len};
	-- -- 攻击百分比
	-- curValue = curCfg.attack_multi or 0;
	-- lastValue = lastCfg.attack_multi or 0;
	-- len = #totalProps + 1;
	-- totalProps[len] = {propStr = "attack_multi", curValue = curValue, lastValue = lastValue, index = len};

	-- -- 解封系数
	-- curValue = curCfg.coefficient or 0;
	-- lastValue = lastCfg.coefficient or 0;
	-- len = #totalProps + 1;
	-- totalProps[len] = {propStr = "coefficient", curValue = curValue, lastValue = lastValue, index = len};

	return totalProps;
end

function Lua_StrangeBeastUtil:getTreeLineIds(lineupNum) -- 1:第一队列 2:第二队列 -1:全部
	if self.treeLineIds == nil then
		self.showLineupNum = 0;
		self.treeLineIds = {};
		local cfg = getConfig("strange_beasts_lineup");
		local team_index, pos;
		local bShow;
		for k, v in pairs(cfg) do
			team_index = v.team_index or 0;
			pos = v.pos or 0;
			bShow = v.show == 1;
			if self.treeLineIds[team_index] == nil then
				self.treeLineIds[team_index] = {};
			end
			self.treeLineIds[team_index][pos] = k;

			if bShow and self.showLineupNum < team_index then
				self.showLineupNum = team_index;
			end
		end
	end

	if lineupNum == -1 then
		if self.totalShowIds == nil then
			self.totalShowIds = {};
			local ids;
			for i = 1, self.showLineupNum do
				ids = self.treeLineIds[i];
				for j = 1, #ids do
					self.totalShowIds[#self.totalShowIds + 1] = ids[j];
				end
			end
			table.sort( self.totalShowIds, function(a, b) return a < b; end );
		end
		return self.totalShowIds;
	else
		return self.treeLineIds[lineupNum];
	end
end

function Lua_StrangeBeastUtil:getShowMaxLineNum()
	if self.showLineupNum == nil then
		self:getTreeLineIds(-1);
	end
	return self.showLineupNum or 0;
end

function Lua_StrangeBeastUtil:getUpTreeCostItems(treeId)
	local costIds = {};
	local costItems = {};
	local costId, costNum;
	local data;
	local bMaxLevel = self:checkTreeMaxLevel(treeId);
	if bMaxLevel then
		return costIds, costItems;
	end

	local param = self:getStrangeBeastTreeCfgById(treeId, 4); -- 升级消耗
	if param ~= nil and #param > 0 then
		for i = 1, #param do
			costId = param[i][1];
			costNum = param[i][2];
			data = costItems[costId];
			if data == nil then
				costItems[costId] = costNum;
				costIds[#costIds + 1] = costId;
			else
				costItems[costId] = costNum + data;
			end
		end
	end

	param = self:getStrangeBeastTreeCfgById(treeId, 3); -- 升阶消耗
	if param ~= nil and #param > 0 then
		for i = 1, #param do
			costId = param[i][1];
			costNum = param[i][2];
			data = costItems[costId];
			if data == nil then
				costItems[costId] = costNum;
				costIds[#costIds + 1] = costId;
			else
				costItems[costId] = costNum + data;
			end
		end
	end

	return costIds, costItems;
end

function Lua_StrangeBeastUtil:checkTreeMaxLevel(treeId)
	local bCheck = true;
	local cfg = self:getStrangeBeastTreeCfgById(treeId);
	if cfg ~= nil then
		local order = cfg.order or 0;
		local level = cfg.level or 0;
		local max_level = cfg.max_level or 0;
		if level == max_level then
			order = order + 1;
			level = level + 1;
			local nextTreeId = self:calStrangeBeastTreeId(order, level);
			local nextCfg = self:getStrangeBeastTreeCfgById(nextTreeId);
			if nextCfg ~= nil then
				bCheck = false;
			end
		elseif level < max_level then
			bCheck = false;
		end
	end
	return bCheck;
end

function Lua_StrangeBeastUtil:checkTreeLineupShowState(treeLineupId)
	local openState = self:getStrangeBeastLineUpCfgById(treeLineupId, 2);
	return openState == 1;
end

function Lua_StrangeBeastUtil:getRecruitSortIdDic()
	if self._recruitSortIds == nil then
		local sortItemIds = self:getStrangeBeastConstCfgByType(15);
		if sortItemIds and #sortItemIds then
			self._recruitSortIds = {};
			local itemId;
			for i = 1, #sortItemIds do
				itemId = sortItemIds[i];
				self._recruitSortIds[itemId] = true;
			end
		end
	end

	return self._recruitSortIds;
end

function Lua_StrangeBeastUtil:getFetterUpPopsVoArr(fetterId)
	local propList = self:getStrangeBeastFetterPropsByFetterLevelId(fetterId);
	local dic = DataCenter.attributesUtil:getAttrDic(propList);

	local nextDic;
	propList = self:getStrangeBeastFetterPropsByFetterLevelId(fetterId + 1);
	if propList then
		 nextDic = DataCenter.attributesUtil:getAttrDic(propList);
	end

	if dic ~= nil then
		return DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
	else
		return Array();
	end
end

function Lua_StrangeBeastUtil:getFetterUnLockPropVoArr(fetterId)
    local propList = self:getStrangeBeastFetterPropsByFetterLevelId(fetterId);
    local dic = DataCenter.attributesUtil:getAttrDic(propList);
    if dic ~= nil then
        return DataCenter.attributesUtil:getAttrArrByDic(dic);
    else
        return Array();
    end
end