-- 攻略
Lua_StrategyData = class("Lua_StrategyData");
function Lua_StrategyData:ctor()
end

function Lua_StrategyData:dispose()
	self.stratetyHeroForceDic = nil; -- 评分
	self.stratetyLineupStegeDic = nil; -- 未领取的阶段
	self.stratetyLineupRewardDic = nil;
end

function Lua_StrategyData:fromServer50214001(msg)
	if msg == nil then
		return;
	end

	if self.stratetyHeroForceDic == nil then
		self.stratetyHeroForceDic = {};
	end

	local obj;
	self._totalPower = 0;
	for i = 1, #msg.hero_info do
		obj = msg.hero_info[i]; -- key 配置id，value 战力，功能未开启为0
		self.stratetyHeroForceDic[obj.key] = obj.value;
		self._totalPower = self._totalPower + obj.value;
	end
end

function Lua_StrategyData.Get:totalPower()
	return self._totalPower or 0;
end

function Lua_StrategyData:getStratetyHeroInfo(id)
	if self.stratetyHeroForceDic == nil or id == nil then
		return 0;
	end
	return self.stratetyHeroForceDic[id] or 0;
end

function Lua_StrategyData:fromServer50214002(msg)
	if msg == nil then
		return;
	end
	if self.stratetyLineupStegeDic == nil then
		self.stratetyLineupStegeDic = {};
	end
	for i = 1, #msg.lineup_id_list do -- key阵容id value=>已领取的进度值列表
		self.stratetyLineupStegeDic[msg.lineup_id_list[i].key] = #msg.lineup_id_list[i].list + 1; -- 未领取的阶段
	end
	self:updateStrategyLineupRedDot(2);
end

-- 1图鉴更新，2攻略更新，3收藏册闪卡更新(目前逻辑并没有更新图鉴)
function Lua_StrategyData:updateStrategyLineupRedDot(updateIdx)
	if not DataCenter.funcOpenData:isOpened(10302) then
		return;
	end
	if self.stratetyLineupRewardDic == nil then
		self.stratetyLineupRewardDic = {};
	end

	local lockStageRewardList = DataCenter.strategyUtil.lockStageRewardList;
	local arr = DataCenter.strategyUtil.strategyLineupArr;
	local notDrawStage, lockVal, list, heroAtlasVo;
	local redState = false;
	for i = 1, arr:getSize() do
		notDrawStage = self:getStrategyLineupStageInfo(arr[i]);
		if notDrawStage <= #lockStageRewardList then -- 还有没领的阶段
			list = DataCenter.strategyUtil:getStrategyLineupInfo(arr[i]).lineup_list;
			lockVal = 0;
			for j = 1, #list do
				heroAtlasVo = DataCenter.heroAtlasData:getAtlasVoById(list[j]);
				if not heroAtlasVo.isActivate then
					if updateIdx == 1 or updateIdx == 2 then
						lockVal = lockVal + 1;
					elseif updateIdx == 3 then
						if not heroAtlasVo.heroVo.bHeroCardRedDot then
							lockVal = lockVal + 1;
						end
					end
				end
			end
			if lockStageRewardList[notDrawStage] <= #list - lockVal then
				redState = true;
			end
			self.stratetyLineupRewardDic[arr[i]] = #list - lockVal; -- 已解锁的数量
		else
			self.stratetyLineupRewardDic[arr[i]] = -1; -- 已领取对应阵容奖励
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Strategy_Lineup, redState);
	Lua_MsgUtil.callFunc("UPDATE_STRATEPY_LINEUP_INFO");
end

-- 未领取的阶段
function Lua_StrategyData:getStrategyLineupStageInfo(lineupId)
	if lineupId == nil or self.stratetyLineupStegeDic == nil or self.stratetyLineupStegeDic[lineupId] == nil then
		return 1;
	end
	return self.stratetyLineupStegeDic[lineupId];
end

-- 已解锁的数量
function Lua_StrategyData:getStratetyLineupRewardInfo(lineupId)
	if lineupId == nil or self.stratetyLineupRewardDic == nil or self.stratetyLineupRewardDic[lineupId] == nil then
		return 0;
	end
	return self.stratetyLineupRewardDic[lineupId];
end