checkRequire("Lua_StrategyData");
checkRequire("Lua_StrategyUtil");
Lua_StrategyProxy = class("Lua_StrategyProxy");
function Lua_StrategyProxy:ctor()
	DataCenter.strategyData = Lua_StrategyData.new();
	DataCenter.strategyUtil = Lua_StrategyUtil.new();

	Lua_MsgUtil.addLuaMsg(50214001, self, self.rStrategyInfo);
	Lua_MsgUtil.addLuaMsg(50214002, self, self.rStrategyLineupInfo);

	Lua_MsgUtil.addEventListener("UPDATE_STAR_ATLAS_INFO", self, self.updateStrategyLineupRedDot); -- 英雄图鉴更新，更新攻略英雄阵容红点
end

-- 请求获取英雄攻略信息（返回）
function Lua_StrategyProxy:rStrategyInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50214001();
		msg:ParseFromString(mp.data);
		DataCenter.strategyData:fromServer50214001(msg);
		Lua_MsgUtil.callFunc("UPDATE_SHOW_STRATEGY_HERO_INFO");
	end
end

-- 获取攻略阵容解锁状态（通知）
function Lua_StrategyProxy:rStrategyLineupInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50214002();
		msg:ParseFromString(mp.data);
		DataCenter.strategyData:fromServer50214002(msg);
	end
end

function Lua_StrategyProxy:updateStrategyLineupRedDot()
	DataCenter.strategyData:updateStrategyLineupRedDot(1);
end

-- 请求获取英雄攻略信息
function Lua_StrategyProxy:sStrategyInfo(hero_uid)
	local cmd = ProtoPublic_pb.Proto10214001();
	cmd.hero_uid = hero_uid; -- 英雄唯一id
	sendMsg(10214001, cmd);
end

-- 请求领取阵容解锁奖励
function Lua_StrategyProxy:sDrawStrategyLineupLockReward(lineup_id)
	local cmd = ProtoPublic_pb.Proto10214002();
	cmd.lineup_id = lineup_id; -- 阵容id
	sendMsg(10214002, cmd);
end