Lua_StrategyUtil = class("Lua_StrategyUtil");
function Lua_StrategyUtil:ctor()
end

function Lua_StrategyUtil:dispose()
	self._strategyHeroArr = nil;
	self._strategyResourceArr = nil;
	self._strategyLineupArr = nil;
end

function Lua_StrategyUtil:getStrategyConstConfig(id, param)
	local config = getConfig("strategy_const", id);
	local info;
	if config then
		if param == 1 then
			info = config["value_string"];
		elseif param == 2 then
			info = config["value_int"];
		elseif param == 3 then
			info = config["value_float"];
		else
			info = config["value_json"];
		end
	end
	return info;
end

function Lua_StrategyUtil:getBarInfo(heroInitStar)
	return self:getStrategyConstConfig("grade_list_" .. heroInitStar, 4);
end

-- 英雄上限战力值
function Lua_StrategyUtil.Get:maxPowerNum()
	return self:getStrategyConstConfig("max_power_num", 2);
end

-- 能力显示排序
function Lua_StrategyUtil.Get:heroPowerGradeDic()
	return self:getStrategyConstConfig("grade_sort_list", 4);
end

-- 进度条移动速度
function Lua_StrategyUtil.Get:barSpeed()
	return self:getStrategyConstConfig("bar_speed", 2);
end

-- 解锁阶段奖励
function Lua_StrategyUtil.Get:lockStageRewardList()
	return self:getStrategyConstConfig("lock_stage_reward", 4);
end

function Lua_StrategyUtil:getShowArr(heroVo)
	local arr = Array();
	local info;
	for i = 1, self.strategyHeroArr:getSize() do
		info = self:getStrategyHeroInfo(self.strategyHeroArr[i]);
		if info.is_show_special == 3 then -- 符石
			if DataCenter.runesUtil:RunesPartUnlock(1, heroVo.level, heroVo.star) then
				arr:add(self.strategyHeroArr[i]);
			end
		elseif info.is_show_special == 4 then -- 图腾
			if DataCenter.heroUtil:getTabState(7, heroVo) then
				arr:add(self.strategyHeroArr[i]);
			end
		elseif info.is_show_special == 5 then -- 天赋
			-- if DataCenter.heroGeniusData:checkExistGenius(heroVo.id) then -- 是否显示
			if DataCenter.heroGeniusData:checkHeroGeniusIsUnlock(heroVo, false) then -- 是否开启
				arr:add(self.strategyHeroArr[i]);
			end
		elseif info.is_show_special == 6 then -- 神兵
			if DataCenter.heroUtil:getTabState(6, heroVo) and heroVo.weaponId ~= 0 then
				arr:add(self.strategyHeroArr[i]);
			end
		else
			if (info.func_id == nil or DataCenter.funcOpenData:isOpened(info.func_id)) then
				arr:add(self.strategyHeroArr[i]);
			end
		end
	end
	arr:sortf(self, self.sortHeroFun);
	return arr;
end

function Lua_StrategyUtil:sortHeroFun(a, b)
	local voA = self:getStrategyHeroInfo(a);
	local voB = self:getStrategyHeroInfo(b);
	return voA.sort < voB.sort;
end

function Lua_StrategyUtil.Get:strategyHeroArr()
	if self._strategyHeroArr == nil then
		self._strategyHeroArr = Array();

		local config = getConfig("strategy_hero");
		for k,v in pairs(config) do
			if v.is_shield ~= 1 then
				self._strategyHeroArr:add(k);
			end
		end
		self._strategyHeroArr:sort(nil, false);
	end
	return self._strategyHeroArr;
end

function Lua_StrategyUtil:getStrategyHeroInfo(id)
	return getConfig("strategy_hero", id);
end

function Lua_StrategyUtil.Get:strategyResourceArr()
	if self._strategyResourceArr == nil then
		self._strategyResourceArr = Array();

		local config = getConfig("strategy_resource");
		for k,v in pairs(config) do
			self._strategyResourceArr:add(k);
		end
		self._strategyResourceArr:sortf(self, self.sortResourceFun);
	end
	return self._strategyResourceArr;
end

function Lua_StrategyUtil:sortResourceFun(a, b)
	local voA = self:getStrategyResourceInfo(a);
	local voB = self:getStrategyResourceInfo(b);
	return voA.sort < voB.sort;
end

function Lua_StrategyUtil:getStrategyResourceInfo(id)
	return getConfig("strategy_resource", id);
end

function Lua_StrategyUtil.Get:strategyLineupArr()
	if self._strategyLineupArr == nil then
		self._strategyLineupArr = Array();

		local config = getConfig("strategy_lineup");
		for k,v in pairs(config) do
			self._strategyLineupArr:add(k);
		end
		self._strategyLineupArr:sort(nil, false);
	end
	return self._strategyLineupArr;
end

function Lua_StrategyUtil:getStrategyLineupInfo(id)
	return getConfig("strategy_lineup", id);
end