-- 日常任务-活跃战令Vo
Lua_ActiveWarVo = class("Lua_ActiveWarVo.Lua")
function Lua_ActiveWarVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_ActiveWarVo:dispose()
	self._primaryRewardState = nil;
	self._seniorRewardState = nil;
	self._config = nil;
	self._primaryList = nil;
	self._seniorList = nil;
end
	
function Lua_ActiveWarVo:updateActiveWarVoInfo(obj)
	self._primaryRewardState = obj.normal_reward_state; -- 初级奖励领取状态
	self._seniorRewardState = obj.stage_reward_state; -- 高级奖励领取状态

	for i = 1, #self.primaryList do
		self.primaryList[i].lockState = DataCenter.taskData.primaryLockState;
		self.primaryList[i].rewardState = self.primaryRewardState;
	end
	for i = 1, #self.seniorList do
		self.seniorList[i].lockState = DataCenter.taskData.seniorLockState;
		self.seniorList[i].rewardState = self.seniorRewardState;
	end
end

function Lua_ActiveWarVo.Get:primaryRewardState()
	return self._primaryRewardState or 0; -- 0不可领取 1可领取 2已领取
end

function Lua_ActiveWarVo.Get:seniorRewardState()
	return self._seniorRewardState or 0; -- 0不可领取 1可领取 2已领取
end

function Lua_ActiveWarVo.Get:primaryList()
	if self._primaryList == nil then
		self._primaryList = {};

		for i = 1, #self.primaryRewardList do
			self._primaryList[i] = {
				id = self.id,
				warType = Lua_TaskData.primaryWarStyle,
				itemList = self.primaryRewardList[i],
				lockState = DataCenter.taskData.primaryLockState,
				rewardState = self.primaryRewardState
			};
		end
	end
	return self._primaryList;
end

function Lua_ActiveWarVo.Get:seniorList()
	if self._seniorList == nil then
		self._seniorList = {};

		for i = 1, #self.seniorRewardList do
			self._seniorList[i] = {
				id = self.id,
				warType = Lua_TaskData.seniorWarStyle,
				itemList = self.seniorRewardList[i],
				lockState = DataCenter.taskData.seniorLockState,
				rewardState = self.seniorRewardState
			};
		end
	end
	return self._seniorList;
end

function Lua_ActiveWarVo.Get:config()
	if self._config == nil then
		self._config = getConfig("active_war_order", self.id);
	end
	return self._config;
end

-- 轮次
function Lua_ActiveWarVo.Get:round()
	return self.config.round;
end

-- 进度值
function Lua_ActiveWarVo.Get:process()
	return self.config.process;
end

-- 初级奖励道具列表
function Lua_ActiveWarVo.Get:primaryRewardList()
	return self.config.reward_item;
end

-- 高级奖励道具列表
function Lua_ActiveWarVo.Get:seniorRewardList()
	return self.config.stage_reward_item;
end