Lua_TaskInfoVo = class("Lua_TaskInfoVo")
function Lua_TaskInfoVo:ctor(id, config)
	self.id = id;
	self._config = config;
	self.conditionInfo = getConfig("total_task", self.conditionId);
end

function Lua_TaskInfoVo:dispose()
	if self.rewardInfo ~= nil then
		self.rewardInfo:dispose();
		self.rewardInfo:clear();
	end
	self._advanceMessage = nil;
	self._conditionId = nil;
	self._receiveStage = nil;
end

---------------------------------------- 配置表 ----------------------------------------
function Lua_TaskInfoVo.Get:config()
	if self._config == nil then
		self._config = getConfig("task", self.id);
	end
	return self._config;
end

-- 开启等级
function Lua_TaskInfoVo.Get:level()
	return self.config.level;
end

-- 排序
function Lua_TaskInfoVo.Get:sortIndex()
	return self.config.sortIndex;
end

-- 主类型
function Lua_TaskInfoVo.Get:mainType()
	return self.conditionInfo.task_type;
end

-- 描述
function Lua_TaskInfoVo.Get:desc()
	return self.conditionInfo.desc;
end

-- 参数个数
function Lua_TaskInfoVo.Get:count()
	return self.conditionInfo.count;
end

-- 条件数组值
function Lua_TaskInfoVo.Get:arrValue()
	return self.conditionInfo.condition;
end

-- 跳转界面或事件
function Lua_TaskInfoVo.Get:eventId()
	return self.conditionInfo.eventId;
end

-- 对应系统功能是否开启
function Lua_TaskInfoVo.Get:isOpen()
	return DataCenter.funcOpenData:isOpened(self.config.open_id, false);
end

-- 对应系统功能未开启时，显示信息
function Lua_TaskInfoVo.Get:advanceMessage()
	if self._advanceMessage == nil then
		local openVo = DataCenter.funcOpenUtil:getFuncOpenVoById(self.config.open_id);
		self._advanceMessage = openVo and openVo.advanceMessage or nil;
	end
	return self._advanceMessage;
end

-- 奖励
function Lua_TaskInfoVo.Get:reward()
	if self.rewardInfo == nil then
		self.rewardInfo = Array();

		local tvo, obj;
		for i = 1, #self.conditionInfo.reward do
			obj = self.conditionInfo.reward[i];
			tvo = Lua_ToolVo.createToolVo(obj[1], obj[2]);
			self.rewardInfo:add(tvo);
		end
	end
	return self.rewardInfo;
end










---------------------------------------- 服务端数据 ----------------------------------------
-- 更新服务端数据
function Lua_TaskInfoVo:updateTaskVoInfo(progressValue, flag, conditionId)	
	self._curProgress = progressValue; -- 每日、每周单个任务的活跃进度
	self._receiveStage = flag; -- 领取状态：0未完成 1完成 2已领取
	self.conditionId = conditionId; -- 任务总表的id
end

function Lua_TaskInfoVo.Get:receiveStage()
	return self._receiveStage or 0;
end

function Lua_TaskInfoVo.Get:curProgress()
	return self._curProgress or 0;
end

-- 日常、周常、成绩任务奖励的领取状态：0未完成 1完成 2已领取
function Lua_TaskInfoVo.Get:curReceiveState()
	return not self.isOpen and 0 or self.receiveStage;
end

-- 任务进阶（成就任务）
function Lua_TaskInfoVo.Set:conditionId(value)
	if self._conditionId == value then
		return;
	end
	self._conditionId = value;
	self.conditionInfo = getConfig("total_task", self.conditionId);
	self.rewardInfo = nil;
end

-- 任务条件id
function Lua_TaskInfoVo.Get:conditionId()
	if self._conditionId == nil then
		self._conditionId = self.config.condition_id;
	end
	return self._conditionId;
end

-- 进度条完成程度的文本
function Lua_TaskInfoVo.Get:progressTxt()
	local langId = self.mainType == Lua_TaskData.achievementTaskTask and 202811 or 202812;
	return LanUtil.formateStr(langId, self.curProgressVal, self.maxProgressVal);
end

-- 每日、每周单个任务的活跃进度
function Lua_TaskInfoVo.Get:curProgressVal()
	local _curProgressVal;
	if self.eventId == 1005 then -- 主线关卡显示几关、排除挂机等
		_curProgressVal = getConfig("mainline_game_level", self.curProgress, "number");
		_curProgressVal = _curProgressVal or self.curProgress;
	else
		_curProgressVal = self.curProgress;
	end
	return _curProgressVal or 0;
end

-- 进度条的totalValue，如"x/totalValue"
function Lua_TaskInfoVo.Get:maxProgressVal()
	local _maxProgressVal;
	if self.eventId == 1005 then -- 主线关卡显示几关、排除挂机等
		_maxProgressVal = getConfig("mainline_game_level", self.conditionInfo.progress, "number");
		_maxProgressVal = _maxProgressVal or self.conditionInfo.progress;
	else
		_maxProgressVal = self.conditionInfo.progress;
	end
	return _maxProgressVal;
end