checkRequire("Lua_ExploreTourTaskVo");
Lua_TaskUtil = class("Lua_TaskUtil");
function Lua_TaskUtil:ctor()
end

function Lua_TaskUtil:dispose()
end










------------------------- 常量配置 -------------------------
function Lua_TaskUtil:getConstConfig(key, type)
	local config = getConfig("task_const", key);
	if config ~= nil then
		if type == 1 then
			return config.value;
		elseif type == 2 then
			return config.arr_value;
		end
	end
	return nil;
end










------------------------- 活跃度信息（日常、周常）-------------------------
-- 初始化（日常、周常）活跃度各阶段配置信息
function Lua_TaskUtil.Get:activePointIdsDic()
	if self._activePointIdsDic == nil then
		self._activePointIdsDic = {};

		local config = getConfig("task_progress");
		for k, v in pairs(config) do
			if self._activePointIdsDic[v.main_type] == nil then
				self._activePointIdsDic[v.main_type] = Array();
			end
			self._activePointIdsDic[v.main_type]:add(k);
		end
		for k,v in pairs(self._activePointIdsDic) do
			v:sort(nil, false);
		end
	end
	return self._activePointIdsDic;
end










------------------------- 日常、周常、成就任务 -------------------------
function Lua_TaskUtil.Get:taskIdsDic()
	if self._taskIdsDic == nil then
		self._taskIdsDic = {};

		local config = getConfig("task");
		local vo;
		for k, v in pairs(config) do
			vo = DataCenter.taskData:getSingleTaskVoById(k);
			if self._taskIdsDic[vo.mainType] == nil then
				self._taskIdsDic[vo.mainType] = Array();
			end
			self._taskIdsDic[vo.mainType]:add(k);
		end
	end
	return self._taskIdsDic;
end










------------------------- 活跃战令 -------------------------
-- 活跃战令功能开启id
function Lua_TaskUtil.Get:activeWarOpenId()
	return self:getConstConfig("activeWar_func_id", 1);
end

-- 活跃战令充值Id
function Lua_TaskUtil.Get:activeWarRechargeId()
	return self:getConstConfig("activeWar_recharge_id", 1);
end

-- 解锁初级战令所需道具
function Lua_TaskUtil.Get:lockRewardlist()
	local itemList = self:getConstConfig("activeWar_lock_reward", 2);
	return itemList[1];
end










------------------------- 冒险之旅 -------------------------
-- 初始化冒险之旅任务信息
function Lua_TaskUtil:initExploreTourTaskInfo()
	local vo;
	local config = getConfig("mainline_task");
	self._exploreTourTaskDic = {};
	self._exploreTourTaskList = {};
	for k, v in pairs(config) do
		vo = Lua_ExploreTourTaskVo.new(k, v);
		self._exploreTourTaskDic[k] = vo;

		if self._exploreTourTaskList[v.stage] == nil then
			self._exploreTourTaskList[v.stage] = Array();
		end
		self._exploreTourTaskList[v.stage]:add(vo);
	end
end

-- 获取冒险之旅任务Vo
function Lua_TaskUtil:getExploreTourTaskVo(id)
	if self._exploreTourTaskDic == nil then
		self:initExploreTourTaskInfo();
	end
	return self._exploreTourTaskDic[id];
end

-- 获取冒险之旅阶段任务列表
function Lua_TaskUtil:getExploreTourTaskArr(stage)
	if self._exploreTourTaskList == nil then
		self:initExploreTourTaskInfo();
	end
	return self._exploreTourTaskList[stage];
end

-- 获取冒险之旅阶段配置
function Lua_TaskUtil.Get:exploreTourStageConfig()
	return getConfig("mainline_task_stage_reward");
end

-- 获取冒险之旅显示阶段配置
function Lua_TaskUtil.Get:exploreTourStageArr()
	local arr = Array();
	local maxStage = self:getConstConfig("max_stage", 1);
	for k, v in pairs(self.exploreTourStageConfig) do
		if k <= maxStage then
			arr:add(v);
		end
	end
	return arr;
end

-- 获取冒险之旅阶段信息字段
function Lua_TaskUtil:getExploreTourStageInfo(stage, key)
	local config = self.exploreTourStageConfig[stage];
	if config ~= nil then
		return config[key];
	end
	return nil;
end