Lua_PlayerHangerConfigData = class("Lua_PlayerHangerConfigData");
function Lua_PlayerHangerConfigData.getConfig(cId)
	if cId == nil then return nil; end
	if Lua_PlayerHangerConfigData.configDic == nil then
		Lua_PlayerHangerConfigData.configDic = {};
	end

	if Lua_PlayerHangerConfigData.configDic[cId] == nil then
		local cfg = getConfig("tb_playerHanger", cId);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_PlayerHangerConfigData.configDic[cId] = Lua_PlayerHangerConfigData.new(cId, cfg);
	end
	return Lua_PlayerHangerConfigData.configDic[cId];
end

function Lua_PlayerHangerConfigData:ctor(id, config)
	self:superCall("ctor");
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("tb_playerHanger", self.id);
	end
	if self.config == nil then
		LogManager.LogError("no tb_playerHanger id = " .. id, false);
	end
end

function Lua_PlayerHangerConfigData.Get:offsetPos()
	return self.config.offset_pos;
end

function Lua_PlayerHangerConfigData.Get:offsetSca()
	return self.config.offset_sca;
end

function Lua_PlayerHangerConfigData.Get:mirrorType()
	if self.config.mirrorType == nil then
		return 0;
	end
	return self.config.mirrorType;
end

function Lua_PlayerHangerConfigData.Get:effects()
	return self.config.effects;
end

function Lua_PlayerHangerConfigData.Get:shenbingEffs()
	return self.config.shenbing_effects;
end

function Lua_PlayerHangerConfigData.Get:actAdd()
	if self.config.actAdd == nil then
		return 0;
	end
	return self.config.actAdd;
end

function Lua_PlayerHangerConfigData.Get:playStyle()
	if self.config.playStyle == nil then
		return 0;
	end
	return self.config.playStyle;
end

function Lua_PlayerHangerConfigData.Get:floder()
	return self.config.floder;
end

function Lua_PlayerHangerConfigData.Get:fileName()
	return self.config.fileName;
end

function Lua_PlayerHangerConfigData.Get:hideShader()
	return self.config.hide_shader;
end

function Lua_PlayerHangerConfigData.Get:modelName()
	return self.config.modelName;
end

function Lua_PlayerHangerConfigData.Get:hang()
	return self.config.hang;
end

function Lua_PlayerHangerConfigData.Get:nameOffset()
	return self.config.nameOffset;
end

function Lua_PlayerHangerConfigData.Get:offsetPos()
    if self._offsetPosVec == nil then
        local list = self.config.offset_pos;
        local vx = (list ~= nil and #list > 0) and list[1] or 0;
        local vy = (list ~= nil and #list > 1) and list[2] or 0;
        local vz = (list ~= nil and #list > 2) and list[3] or 0;
        self._offsetPosVec = Vector3(vx, vy, vz);
    end
    return _offsetPosVec;
end

function Lua_PlayerHangerConfigData.Get:femaleOffsetPos()
    if self._femaleOffsetPosVec == nil then
        local list = self.config.offset_pos_female;
        local vx = (list ~= nil and #list > 0) and list[1] or 0;
        local vy = (list ~= nil and #list > 1) and list[2] or 0;
        local vz = (list ~= nil and #list > 2) and list[3] or 0;
        self._femaleOffsetPosVec = Vector3(vx, vy, vz);
    end
    return _femaleOffsetPosVec;
end

function Lua_PlayerHangerConfigData:getGenderPos(gender)
    return gender == Lua_ThingDefine.FEMALE and self.femaleOffsetPos or self.offsetPos;
end

function Lua_PlayerHangerConfigData.Get:offsetScaVec()
    if self._offsetScaVec == nil then
        local list = self.config.offset_sca;
        local vx = (list ~= nil and #list > 0) and list[1] or 0;
        local vy = (list ~= nil and #list > 1) and list[2] or 0;
        local vz = (list ~= nil and #list > 2) and list[3] or 0;
        self._offsetScaVec = Vector3(vx, vy, vz);
    end
    return _offsetScaVec;
end

function Lua_PlayerHangerConfigData.Get:femaleOffsetScaVec()
    if self._femaleOffsetScaVec == nil then
        local list = self.config.offset_sca_female;
        local vx = (list ~= nil and #list > 0) and list[1] or 0;
        local vy = (list ~= nil and #list > 1) and list[2] or 0;
        local vz = (list ~= nil and #list > 2) and list[3] or 0;
        self._femaleOffsetScaVec = Vector3(vx, vy, vz);
    end
    return _femaleOffsetScaVec;
end

function Lua_PlayerHangerConfigData:getGenderSca(gender)
    return gender == Lua_ThingDefine.FEMALE and self.femaleOffsetScaVec or self.offsetScaVec;
end

function Lua_PlayerHangerConfigData.Get:offsetRotVec()
    if self._offsetRotVec == nil then
        local list = self.config.offset_rot;
        local vx = (list ~= nil and #list > 0) and list[1] or 0;
        local vy = (list ~= nil and #list > 1) and list[2] or 0;
        local vz = (list ~= nil and #list > 2) and list[3] or 0;
        self._offsetRotVec = Vector3(vx, vy, vz);
    end
    return _offsetRotVec;
end

function Lua_PlayerHangerConfigData.Get:femaleOffsetRotVec()
    if self._femaleOffsetRotVec == nil then
        local list = self.config.offset_rot_female;
        local vx = (list ~= nil and #list > 0) and list[1] or 0;
        local vy = (list ~= nil and #list > 1) and list[2] or 0;
        local vz = (list ~= nil and #list > 2) and list[3] or 0;
        self._femaleOffsetRotVec = Vector3(vx, vy, vz);
    end
    return _femaleOffsetRotVec;
end

function Lua_PlayerHangerConfigData:getGenderRot(gender)
    return gender == Lua_ThingDefine.FEMALE and self.femaleOffsetRotVec or self.offsetRotVec;
end

function Lua_PlayerHangerConfigData.Get:showStateByAct()
	return self.config.showStateByAct;
end

function Lua_PlayerHangerConfigData.Get:isPermanent() -- 是否常驻显示
	return self.config == nil or self.config.showStateByAct == nil or #self.config.showStateByAct <= 0;
end

function Lua_PlayerHangerConfigData:checkStateAction(act) --根据动作id显隐
	if not self.isPermanent then
		for i = 1, #self.showStateByAct do 
			if self.showStateByAct[i] == act then
				return true;
			end
		end
	end
    return false;
end