-- 见缝插刀
Lua_ThrowKnifeData = class("Lua_ThrowKnifeData");
function Lua_ThrowKnifeData:ctor()
end

function Lua_ThrowKnifeData:dispose()
	self._topLevel = nil;
	self._topGrade = nil;
	self._saveLevel = nil;
	self._allTimes = nil;
	self._itemCostId = nil;
	self._itemUseList = nil;
	self._knifeMinMinusAngle = nil;
	self._itemMinMinusAngle = nil;
	self._knifeTime = nil;
	self._rotateInfoDic = nil;
	self._isThrowKnifeTween = nil;
end

function Lua_ThrowKnifeData:fromServer50108088(msg)
	if msg == nil then
		return;
	end

	self._topLevel = msg.top_level; -- 历史最高关卡
	self._topGrade = msg.top_grade; -- 历史最高得分
	self._saveLevel = msg.save_level; -- 保存关卡
	self._allTimes = msg.all_times; -- 总血量
	self._itemCostId = msg.item_cost_id; -- 血量消耗道具id
	self._itemUseList = msg.item_use; -- 血量购买消耗
	self._knifeMinMinusAngle = msg.knife_min_minus_angle; -- 小刀最小相差角度
	self._itemMinMinusAngle = msg.item_min_minus_angle; -- 水果最小相差角度
	self._knifeTime = msg.knife_time; -- 小刀到靶子的时间
end

function Lua_ThrowKnifeData.Get:topLevel()
	return self._topLevel or 0;
end

function Lua_ThrowKnifeData.Get:topGrade()
	return self._topGrade or 0;
end

function Lua_ThrowKnifeData.Get:saveLevel()
	return self._saveLevel or 0;
end

function Lua_ThrowKnifeData.Get:allTimes()
	return self._allTimes or 0;
end

function Lua_ThrowKnifeData.Get:itemCostId()
	return self._itemCostId or 0;
end

function Lua_ThrowKnifeData.Get:itemUseList()
	return self._itemUseList or {};
end

function Lua_ThrowKnifeData.Get:knifeMinMinusAngle()
	return self._knifeMinMinusAngle or 7.0;
end

function Lua_ThrowKnifeData.Get:itemMinMinusAngle()
	return self._itemMinMinusAngle or 8.5;
end

function Lua_ThrowKnifeData.Get:knifeTime()
	return self._knifeTime or 0.3;
end

function Lua_ThrowKnifeData:fromServer50108089(msg)
	if msg == nil then
		return;
	end

	local obj;
	local redState = false;
	for i = 1, #msg.task_info do
		obj = msg.task_info[i];
		if not redState and obj.info1 == 1 then
			redState = true;
			break;
		end
	end
	if msg.type == 1 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ThrowKnife_Task_Daily, redState);
	else
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ThrowKnife_Task_Cumulate, redState);
	end
end

function Lua_ThrowKnifeData:fromServer50108095(msg)
	if msg == nil then
		return;
	end

	-- 关卡信息
	self.levelInfoList = msg.level_info;
	-- 转动信息
	if self._rotateInfoDic == nil then
		self._rotateInfoDic = {};
	end
	for i = 1, #msg.rotate_info do
		self._rotateInfoDic[msg.rotate_info[i].id] = msg.rotate_info[i];
	end
end

function Lua_ThrowKnifeData:getRotateInfo(id)
	if id == nil or self._rotateInfoDic == nil then
		return nil;
	end
	return self._rotateInfoDic[id];
end

function Lua_ThrowKnifeData.Get:isThrowKnifeTween()
	return self._isThrowKnifeTween or false;
end

function Lua_ThrowKnifeData.Set:isThrowKnifeTween(val)
	if self._isThrowKnifeTween ~= val then
		self._isThrowKnifeTween = val;
		-- DataCenter.loginData:checkFpsState();
		if not val then
			DataCenter.popupWinManager:checkPopupWin();
		end
	end
end