Lua_TimeSpaceRaceData = class("Lua_TimeSpaceRaceData")
function Lua_TimeSpaceRaceData:ctor()
	
end

function Lua_TimeSpaceRaceData:dispose()
	self._spaceType = 0;
	self._end_tick = 0;
	self._left_fight_times = 0;
	self._left_buy_times = 0;
	self._fight_times = 0;
end

function Lua_TimeSpaceRaceData.Get:sceneId()
	local config = DataCenter.timeSpaceRaceUtil:getTimeSpaceConfig(self.spaceType);
	return config.scene_id or 40123;
end

-- 时空类型
function Lua_TimeSpaceRaceData.Get:spaceType()
	if self._spaceType == nil or self._spaceType == 0 then
		return 1;
	end
	return self._spaceType;
end

function Lua_TimeSpaceRaceData.Set:spaceType(value)
	if self._spaceType == nil or self._spaceType == 0 or value == 0 then
		self._spaceType = value;
	end
end

function Lua_TimeSpaceRaceData.Get:isInTime()
	return DataCenter.roleData:checkInTime(self.startTick, self.endTick);
end

-- 开始时间
function Lua_TimeSpaceRaceData.Get:startTick()
	return self._start_tick or 0;
end

-- 结束时间
function Lua_TimeSpaceRaceData.Get:endTick()
	return self._end_tick or 0;
end

-- 剩余挑战次数
function Lua_TimeSpaceRaceData.Get:leftFightTimes()
	return self._left_fight_times or 0;
end

-- 剩余购买次数
function Lua_TimeSpaceRaceData.Get:leftBuyTimes()
	return self._left_buy_times or 0;
end

-- 历史排名
function Lua_TimeSpaceRaceData.Get:hisRank()
	return self._his_rank or 0;
end

-- 剩余购买次数
function Lua_TimeSpaceRaceData.Get:fightTimes()
	return self._fight_times or 0;
end

function Lua_TimeSpaceRaceData:fromServer50213001(msg)
	if msg == nil then
		return;
	end
	self.spaceType = msg.type; -- 时空类型
	self._start_tick = msg.start_tick; -- 开始时间
	self._end_tick = msg.end_tick; -- 结束时间
	self._left_fight_times = msg.left_fight_times; -- 剩余挑战次数
	self._left_buy_times = msg.left_buy_times; -- 剩余购买次数
	self._his_rank = msg.his_rank; -- 历史排名
	self._role_list = msg.role_list; -- 匹配角色列表

	self:checkFightTimesRed();
end

function Lua_TimeSpaceRaceData:fromServer50213004(msg)
	if msg == nil then
		return;
	end
	self._left_fight_times = msg.left_fight_times; -- 剩余挑战次数
	self._left_buy_times = msg.left_buy_times; -- 剩余购买次数

	self:checkFightTimesRed();
end

function Lua_TimeSpaceRaceData:fromServer50213007(msg)
	if msg == nil then
		return;
	end
	
	self._fight_times = msg.fight_times; -- 赛季总挑战次数

	self.activeRewardState = {};
	local info;
	for i = 1, #msg.reward_info do
		info = msg.reward_info[i];
		self.activeRewardState[info.key] = info.other;
	end
end

function Lua_TimeSpaceRaceData:fromServer50213008(msg)
	if msg == nil or self.activeRewardState == nil then
		return;
	end
	self.activeRewardState[msg.id] = msg.state;
end

function Lua_TimeSpaceRaceData:fromServer80213014(msg)
	if msg == nil then
		return;
	end
	
	local info = msg.red_point_state;
	if info.key == 1 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TimeSpaceRace_Reward, info.value == 1);
	end
end

function Lua_TimeSpaceRaceData:initEnemyList()
	if self.enemyArr == nil then
		self.enemyArr = Array();
		self.enemyDic = {};
	else
		local len = self.enemyArr:getSize();
		while len > 0 do
			uniqueId = self.enemyArr:remove();
			self.enemyDic[uniqueId] = nil;
			len = len - 1;
		end
	end

	if self._role_list then
		local info;
		local uniqueId;
		for i = 1, #self._role_list do
			info = self._role_list[i];
			uniqueId = tonumber(info.id);
			self.enemyArr:add(uniqueId);
			self.enemyDic[uniqueId] = info;
		end
	end
	return self.enemyArr;
end

function Lua_TimeSpaceRaceData:getEnemyInfo(uniqueId)
	if self.enemyDic == nil then
		return;
	end
	return self.enemyDic[uniqueId];
end

function Lua_TimeSpaceRaceData:getActiveRewardState(id)
	if self.activeRewardState == nil then
		return 0;
	end
	return self.activeRewardState[id] or 0;
end










function Lua_TimeSpaceRaceData:checkFightTimesRed()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TimeSpaceRace_Fight, self.isInTime and self.leftFightTimes > 0)
end