-- 时空争霸
checkRequire("Lua_TimeSpaceRaceData");
checkRequire("Lua_TimeSpaceRaceUtil");
Lua_TimeSpaceRaceProxy = class("Lua_TimeSpaceRaceProxy")
function Lua_TimeSpaceRaceProxy:ctor()
	DataCenter.timeSpaceRaceData = Lua_TimeSpaceRaceData.new();
	DataCenter.timeSpaceRaceUtil = Lua_TimeSpaceRaceUtil.new();

	Lua_MsgUtil.addLuaMsg(50213001, self, self.rWinInfo); -- 请求时空争霸界面信息返回
	Lua_MsgUtil.addLuaMsg(50213004, self, self.rBuyFightTimes); -- 请求购买时空争霸挑战次数返回
	Lua_MsgUtil.addLuaMsg(50213005, self, self.rRankInfo); -- 请求时空争霸排名返回
	Lua_MsgUtil.addLuaMsg(50213006, self, self.rRankLike); -- 请求时空争霸排名点赞返回
	Lua_MsgUtil.addLuaMsg(50213007, self, self.rActiveReward); -- 请求时空争霸活跃奖励信息返回
	Lua_MsgUtil.addLuaMsg(50213008, self, self.rReceiveActiveReward); -- 请求领取时空争霸活跃奖励返回
	Lua_MsgUtil.addLuaMsg(50213009, self, self.rFightRecord); -- 请求时空争霸战斗记录返回
	Lua_MsgUtil.addLuaMsg(50213010, self, self.rFightDetails); -- 请求时空争霸战斗详情返回
	Lua_MsgUtil.addLuaMsg(50213012, self, self.rResultReward); -- 请求时空争霸战斗生涯奖励返回
	Lua_MsgUtil.addLuaMsg(50213015, self, self.rCheckNewSpace); -- 请求新时空开启信息返回
	Lua_MsgUtil.addLuaMsg(50213016, self, self.rFightCheck); -- 请求时空争霸战前检验返回

	Lua_MsgUtil.addLuaMsg(80213014, self, self.updateRedPoint); -- 通知时空争霸红点
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求时空争霸界面信息
function Lua_TimeSpaceRaceProxy:sWinInfo(type)
	local cmd = ProtoPublic_pb.Proto10213001();
	cmd.type = type;
	sendMsg(10213001, cmd);	
end

-- 请求选择时空争霸
function Lua_TimeSpaceRaceProxy:sChooseType(type)
	local cmd = ProtoPublic_pb.Proto10213002();
	cmd.type = type;
	sendMsg(10213002, cmd);
end

-- 请求刷新时空争霸
function Lua_TimeSpaceRaceProxy:sRefresh()
	sendMsg(10213003);
end

-- 请求购买时空争霸挑战次数
function Lua_TimeSpaceRaceProxy:sBuyFightTimes(buy_times)
	local cmd = ProtoPublic_pb.Proto10213004();
	cmd.buy_times = buy_times;
	sendMsg(10213004, cmd);
end

-- 请求时空争霸排名
function Lua_TimeSpaceRaceProxy:sRankInfo(type, page)
	local cmd = ProtoPublic_pb.Proto10213005();
	cmd.type = type;
	cmd.page = page;
	sendMsg(10213005, cmd);
end

-- 请求时空争霸排名点赞
function Lua_TimeSpaceRaceProxy:sRankLike(type, role_id)
	local cmd = ProtoPublic_pb.Proto10213006();
	cmd.type = type;
	cmd.role_id = tonumber(role_id);
	sendMsg(10213006, cmd);
end

-- 请求时空争霸活跃奖励信息
function Lua_TimeSpaceRaceProxy:sActiveReward()
	sendMsg(10213007);
end

-- 请求领取时空争霸活跃奖励
function Lua_TimeSpaceRaceProxy:sReceiveActiveReward(reward_id)
	local cmd = ProtoPublic_pb.Proto10213008();
	cmd.reward_id = reward_id;
	sendMsg(10213008, cmd);
end

-- 请求时空争霸战斗记录
function Lua_TimeSpaceRaceProxy:sFightRecord()
	sendMsg(10213009);
end

-- 请求时空争霸战斗详情
function Lua_TimeSpaceRaceProxy:sFightDetails(record_id)
	local cmd = ProtoPublic_pb.Proto10213010();
	cmd.record_id = tonumber(record_id);
	sendMsg(10213010, cmd);
end

-- 请求时空争霸扫荡
function Lua_TimeSpaceRaceProxy:sMopup()
	sendMsg(10213011);
end

-- 请求时空争霸战斗生涯奖励信息
function Lua_TimeSpaceRaceProxy:sResultReward()
	sendMsg(10213012);
end

-- 请求新时空开启信息
function Lua_TimeSpaceRaceProxy:sCheckNewSpace()
	sendMsg(10213015);
end

-- 请求时空争霸战前检验
function Lua_TimeSpaceRaceProxy:sFightCheck(role_id, type)
	local cmd = ProtoPublic_pb.Proto10213016();
	cmd.role_id = tonumber(role_id);
	cmd.type = type;
	sendMsg(10213016, cmd);
end






------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
-- 请求时空争霸界面信息返回
function Lua_TimeSpaceRaceProxy:rWinInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213001();
		msg:ParseFromString(mp.data);
		DataCenter.timeSpaceRaceData:fromServer50213001(msg);
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_INFO", msg);
	end
end

-- 请求购买时空争霸挑战次数返回
function Lua_TimeSpaceRaceProxy:rBuyFightTimes(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213004();
		msg:ParseFromString(mp.data);
		DataCenter.timeSpaceRaceData:fromServer50213004(msg);
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_TIMES", msg);
		OperateAlert.showLangValue(770026);
	end
end

-- 请求时空争霸排名返回
function Lua_TimeSpaceRaceProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213005();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_RANK", msg);
	end
end

-- 请求时空争霸排名点赞返回
function Lua_TimeSpaceRaceProxy:rRankLike(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_LIKE", msg);
	end
end

-- 请求时空争霸活跃奖励信息返回
function Lua_TimeSpaceRaceProxy:rActiveReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213007();
		msg:ParseFromString(mp.data);
		DataCenter.timeSpaceRaceData:fromServer50213007(msg);
		Lua_MsgUtil.callFunc("TIME_SPACE_ACTIVE_REWARD");
	end
end

-- 请求领取时空争霸活跃奖励返回
function Lua_TimeSpaceRaceProxy:rReceiveActiveReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213008();
		msg:ParseFromString(mp.data);
		DataCenter.timeSpaceRaceData:fromServer50213008(msg);
		Lua_MsgUtil.callFunc("TIME_SPACE_ACTIVE_REWARD");
	end
end

-- 请求时空争霸战斗记录返回
function Lua_TimeSpaceRaceProxy:rFightRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213009();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_FIHGT_RECORD", msg);
	end
end

-- 请求时空争霸战斗详情返回
function Lua_TimeSpaceRaceProxy:rFightDetails(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213010();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_FIHGT_DETAILS", msg);
	end
end

-- 请求时空争霸战斗生涯奖励返回
function Lua_TimeSpaceRaceProxy:rResultReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213012();
		msg:ParseFromString(mp.data);
		if msg.is_have == 1 then
			Lua_WindowUtil.openWin("Lua_TimeSpaceRaceResultWindow", Lua_WinParam.ACTION_OPEN, msg);
		else
			Lua_ProxyManager.getProxy("Lua_TimeSpaceRaceProxy"):sCheckNewSpace();
		end
	end
end

-- 通知时空争霸红点
function Lua_TimeSpaceRaceProxy:updateRedPoint(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80213014();
		msg:ParseFromString(mp.data);
		DataCenter.timeSpaceRaceData:fromServer80213014(msg);
	end
end

-- 请求新时空开启信息返回
function Lua_TimeSpaceRaceProxy:rCheckNewSpace(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213015();
		msg:ParseFromString(mp.data);
		if msg.type > 0 then
			Lua_WindowUtil.openWin("Lua_TimeSpaceRaceEnterWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

-- 请求新时空开启信息返回
function Lua_TimeSpaceRaceProxy:rFightCheck(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50213016();
		msg:ParseFromString(mp.data);
		if msg.is_can_fight == 1 then
			Lua_MsgUtil.callFunc("TIME_SPACE_FIGHT_CHECK", msg.type);
		else
			if msg.type == 1 then
				OperateAlert.showLangValue(770032);
				self:sRefresh();
			elseif msg.type == 2 then
				Lua_MsgUtil.callFunc("TIME_SPACE_FIGHT_CHECK_ERROR");
			end
		end
	end
end