Lua_TimeSpaceRaceUtil = class("Lua_TimeSpaceRaceUtil")
function Lua_TimeSpaceRaceUtil:ctor()

end

function Lua_TimeSpaceRaceUtil:dispose()

end

-- 挑战次数购买消耗
function Lua_TimeSpaceRaceUtil.Get:buyTimesCost()
	return getConfig("time_space_race_const", "buy_times_cost", "arr_value");
end

-- 点赞上限
function Lua_TimeSpaceRaceUtil.Get:limitLikeTimes()
	return getConfig("time_space_race_const", "praise_times", "value") or 0;
end

-- 刷新间隔
function Lua_TimeSpaceRaceUtil.Get:refreshInterval()
	return getConfig("time_space_race_const", "refresh_interval", "value") or 0;
end

function Lua_TimeSpaceRaceUtil.Get:timeSpaceList()
	return getConfig("time_space_race_type");
end

function Lua_TimeSpaceRaceUtil:getTimeSpaceConfig(id)
	return getConfig("time_space_race_type", id);
end

function Lua_TimeSpaceRaceUtil.Get:rankList()
	if self._timeSpaceRankList == nil then
		self._timeSpaceRankList = Array();
		local config = getConfig("time_space_race_type");
		local info;
		for i, v in ipairs(config) do
			info = {
				textAtlas = "time_space_atlas",
				textNormalSprite = "xui_skzb_zgnbutton_"..i.."_n",
				textSelectedSprite = "xui_skzb_zgnbutton_"..i.."_p",
				textUnOpenSprite = "xui_skzb_zgnbutton_"..i.."_d",
				openId = v.open_id,
				name = v.name
			};
			self._timeSpaceRankList:add(info);
		end
	end
	return self._timeSpaceRankList;
end

function Lua_TimeSpaceRaceUtil:getDailyRewardList()
	if self.dailyRewardList == nil then
		self.dailyRewardList = Array();
		local config = getConfig("time_space_rank_reward");
		local info;
		for _, v in ipairs(config) do
			info = {
				rank_range = v.rank_range;
				rank_label = v.rank_label;
				item_list = v.daily_reward;
			};
			self.dailyRewardList:add(info);
		end
	end
	return self.dailyRewardList;
end

function Lua_TimeSpaceRaceUtil:getRankRewardList()
	if self.rankRewardList == nil then
		self.rankRewardList = Array();
		local config = getConfig("time_space_rank_reward");
		local info;
		for _, v in ipairs(config) do
			info = {
				rank_range = v.rank_range;
				rank_label = v.rank_label;
				item_list = v.season_reward;
			};
			self.rankRewardList:add(info);
		end
	end
	return self.rankRewardList;
end

function Lua_TimeSpaceRaceUtil:getActiveRewardList()
	if self.activeRewardList == nil then
		self.activeRewardList = Array();
		local config = getConfig("time_space_active_reward");
		for k, v in pairs(config) do
			self.activeRewardList:add(k);
		end
	end
	self.activeRewardList:sortf(self, self.onActiveRewardSort);
	return self.activeRewardList;
end

function Lua_TimeSpaceRaceUtil:onActiveRewardSort(a, b)
	local state_a = DataCenter.timeSpaceRaceData:getActiveRewardState(a);
	local state_b = DataCenter.timeSpaceRaceData:getActiveRewardState(b);
	if state_a == state_b then
		if a > b then
			return false;
		end
	elseif state_a == 2 and state_b ~= 2 then
		return false;
	elseif state_a ~= 1 and state_b == 1 then
		return false;
	end
	return true;
end