-- 图腾招募
Lua_TotemRecruitData = class("Lua_TotemRecruitData");
function Lua_TotemRecruitData:ctor()
	self:superCall("ctor");
end

function Lua_TotemRecruitData:dispose()
	self.recruitInfoDic = nil;
	self.isCanUpdate = nil;
	self:superCall("dispose");
end

function Lua_TotemRecruitData:fromServer50108106(msg)
	if msg == nil then
		return;
	end

	if self.recruitInfoDic == nil then
		self.recruitInfoDic = {};
	end
	self.recruitInfoDic[msg.index] = msg;
	self.isCanUpdate = true;

	local hasCount = DataCenter.packData:getItemCountById(msg.act_item);
	local oneRedState = hasCount >= 1;
	local moreRedState = hasCount >= msg.act_multi_cost;
	if msg.index == 1 then -- 初级
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Primary_One, oneRedState);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Primary_More, moreRedState);
	elseif msg.index == 2 then -- 中级
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Intermediate_One, oneRedState);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Intermediate_More, moreRedState);
	else -- 高级
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Senior_One, oneRedState);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Senior_More, moreRedState);
	end
end

function Lua_TotemRecruitData:getCurTypeRecruitInfo(idx)
	if idx == nil or self.recruitInfoDic == nil or self.recruitInfoDic[idx] == nil then
		return nil;
	end
	return self.recruitInfoDic[idx];
end

function Lua_TotemRecruitData:fromServer50108110(msg)
	if msg == nil then
		return;
	end

	local obj;
	local redState = false;
	for i = 1, #msg.task_state do
		obj = msg.task_state[i];
		if not redState and obj.info1 == 1 then
			redState = true;
			break;
		end
	end
	if msg.task_type == 1 then -- 任务类型 1日常任务 2累积任务
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Task_Daily, redState);
	else
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Task_Cumulate, redState);
	end
end

function Lua_TotemRecruitData:updateTotemRecruitRed(dic)
	if self.isCanUpdate then
		local info_1 = self:getCurTypeRecruitInfo(1);
		local info_2 = self:getCurTypeRecruitInfo(2);
		local info_3 = self:getCurTypeRecruitInfo(3);
		local hasCount, oneRedState, moreRedState;
		if info_1 and dic[tonumber(tostring(info_1.act_item))] then -- 初级
			hasCount = DataCenter.packData:getItemCountById(tonumber(tostring(info_1.act_item)));
			oneRedState = hasCount >= 1;
			moreRedState = hasCount >= info_1.act_multi_cost;
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Primary_One, oneRedState);
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Primary_More, moreRedState);
		elseif info_2 and dic[tonumber(tostring(info_2.act_item))] then -- 中级
			hasCount = DataCenter.packData:getItemCountById(tonumber(tostring(info_2.act_item)));
			oneRedState = hasCount >= 1;
			moreRedState = hasCount >= info_2.act_multi_cost;
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Intermediate_One, oneRedState);
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Intermediate_More, moreRedState);
		elseif info_3 and dic[tonumber(tostring(info_3.act_item))] then -- 高级
			hasCount = DataCenter.packData:getItemCountById(tonumber(tostring(info_3.act_item)));
			oneRedState = hasCount >= 1;
			moreRedState = hasCount >= info_3.act_multi_cost;
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Senior_One, oneRedState);
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TotemRecruit_Senior_More, moreRedState);
		end
	end
end