-- 战令 任务Vo
Lua_WarOrderTaskVo = class("Lua_WarOrderTaskVo");

function Lua_WarOrderTaskVo:ctor(id)
	self.id = id;
	self.config = getConfig("war_order_task", id);
end

function Lua_WarOrderTaskVo:fromServerInfo(msg)
	self.count = msg.process; -- 进度
	self.drawTime = msg.draw_times; -- 已领取次数
	self.finishTime = msg.over_times; -- 完成次数
end

-- 任务状态：0未完成 1可领取 2已领取
function Lua_WarOrderTaskVo.Get:state()
	if self.drawTime < self.limit then
		if self.drawTime < self.finishTime then
			return 1;
		else
			return 0;
		end
	else
		return 2;
	end
end

function Lua_WarOrderTaskVo.Get:sort()
	if self.state == 2 then
		return self.id + self.state * 100;
	else
		return self.id - self.state * 100;
	end
end

function Lua_WarOrderTaskVo.Get:process()
	if self.state == 0 then
		return self.count;
	else
		return self.target;
	end
end

function Lua_WarOrderTaskVo.Get:remainTime()
	return self.limit - self.drawTime;
end


------------------------- 配置数据 -------------------------

-- 标题
function Lua_WarOrderTaskVo.Get:title()
	return self.config.title;
end

-- 战令类型
function Lua_WarOrderTaskVo.Get:war_order()
	return self.config.war_order;
end

-- 目标进度
function Lua_WarOrderTaskVo.Get:target()
	return self.config.target;
end

-- 可完成次数
function Lua_WarOrderTaskVo.Get:limit()
	return self.config.limit;
end

-- 获取经验值
function Lua_WarOrderTaskVo.Get:exp()
	if self.config == nil or self.config.exp == nil then
		return 0;
	end
	return self.config.exp;
end

-- 周期
function Lua_WarOrderTaskVo.Get:round()
	if self.config == nil or self.config.round == nil then
		return 0;
	end
	return self.config.round;
end

-- 跳转id
function Lua_WarOrderTaskVo.Get:func_path_id()
	return self.config.func_path_id;
end

-- 奖励经验id
function Lua_WarOrderTaskVo.Get:exp_id()
	return self.config.exp_id;
end