--战令 Proxy
checkRequire("Lua_WarOrderUtil");
checkRequire("Lua_WarOrderData");
Lua_WarOrderProxy = class("Lua_WarOrderProxy");
function Lua_WarOrderProxy:ctor()
	DataCenter.warOrderUtil = Lua_WarOrderUtil.new();
	DataCenter.warOrderData = Lua_WarOrderData.new();

	Lua_MsgUtil.addLuaMsg(50197021, self, self.rWarOrderInfo);
	Lua_MsgUtil.addLuaMsg(80197021, self, self.mTaskFinish);
end

function Lua_WarOrderProxy:resetRedPoint()
	if DataCenter.funcOpenData:isOpened(10026) == false then
		return;
	end

	if DataCenter.funcOpenData:isOpened(10263) then
		self:sWarOrderInfo(Lua_WarOrderData.LightTower);
	end
	if DataCenter.funcOpenData:isOpened(10261) then
		self:sWarOrderInfo(Lua_WarOrderData.Expedition);
	end
	if DataCenter.funcOpenData:isOpened(10284) then
		self:sWarOrderInfo(Lua_WarOrderData.PeakDuel);
	end
	if DataCenter.funcOpenData:isOpened(10262) then
		self:sWarOrderInfo(Lua_WarOrderData.EquipCopyWarMakes);
	end
	if DataCenter.funcOpenData:isOpened(10246) then
		self:sWarOrderInfo(Lua_WarOrderData.KunXuHolyLandWarMakes);
	end
	if DataCenter.funcOpenData:isOpened(10315) then
		self:sWarOrderInfo(Lua_WarOrderData.CollectionCabinet);
	end
	if DataCenter.funcOpenData:isOpened(10319) then
		self:sWarOrderInfo(Lua_WarOrderData.GodSeaPeak);
	end
end

-- 请求战令界面信息
function Lua_WarOrderProxy:sWarOrderInfo(type)
	local cmd = ProtoPublic_pb.Proto10197021();
	cmd.type = type; -- 1光之塔 2边境远征 4巅峰对决 5寂灭岛 6昆墟圣地
	sendMsg(10197021, cmd);
end

-- 请求领取战令奖励
function Lua_WarOrderProxy:sWarOrderReward(type, step)
	local cmd = ProtoPublic_pb.Proto10197022();
	cmd.type = type; -- 1光之塔 2边境远征 4巅峰对决 5寂灭岛 6昆墟圣地
	cmd.step = step; -- 阶段（阶段0:领取每日奖励）
	sendMsg(10197022, cmd);
end

-- 请求购买战令经验
function Lua_WarOrderProxy:sBuyWarOrderExp(type, amount)
	local cmd = ProtoPublic_pb.Proto10197045();
	cmd.type = type; -- 1光之塔 2边境远征 4巅峰对决 5寂灭岛 6昆墟圣地
	cmd.amount = amount; -- 购买数量
	sendMsg(10197045, cmd);
end

-- 请求购买战令经验
function Lua_WarOrderProxy:sGetTaskReward(task_id, draw_times)
	if draw_times == nil then
		draw_times = 1;
	end

	local cmd = ProtoPublic_pb.Proto10197062();
	cmd.task_id = task_id; -- 任务id
	cmd.draw_times = draw_times; -- 领取次数
	sendMsg(10197062, cmd);
end





-- 请求战令界面信息(返回)
function Lua_WarOrderProxy:rWarOrderInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197021();
		msg:ParseFromString(mp.data);
		DataCenter.warOrderData:fromServer50197021(msg);
	end
end

-- 通知战令任务完成
function Lua_WarOrderProxy:mTaskFinish(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80197021();
		msg:ParseFromString(mp.data);
		DataCenter.warOrderData:fromServer80197021(msg);
	end
end