Lua_WarOrderUtil = class("Lua_WarOrderUtil");

function Lua_WarOrderUtil:ctor()
end

function Lua_WarOrderUtil:getConfigInfo(id, key)
	if self._config == nil then
		self._config = getConfig("war_order");
	end

	local config = self._config[id];
	if config ~= nil then
		return config[key];
	end
	return nil;
end

function Lua_WarOrderUtil:getInfoByType(type)
	if self._typeInfo == nil then
		self._typeInfo = {};

		local config = getConfig("war_order_type");
		for k,v in pairs(config) do
			self._typeInfo[k] = v;
		end
	end
	return self._typeInfo[type];
end

function Lua_WarOrderUtil:getMaxStep(type)
	return getConfig("war_order_type", type, "max_step");
end

function Lua_WarOrderUtil:getFuncPath(type)
	return getConfig("war_order_type", type, "func_path_id");
end

function Lua_WarOrderUtil:getRechargeId(type, step)
	local config = getConfig("war_order_type", type, "step_recharge_id");
	if config ~= nil then
		return config[step];
	end
	return nil;
end

function Lua_WarOrderUtil:getRechargeReward(type, step)
	local config = getConfig("war_order_type", type, "step_recharge_reward");
	if config ~= nil then
		return config[step];
	end
	return nil;
end

function Lua_WarOrderUtil:getLvBgInfo(type)
	return getConfig("war_order_type", type, "level_bg");
end

function Lua_WarOrderUtil:getNameDes(type)
	return getConfig("war_order_type", type, "buy_title");
end

function Lua_WarOrderUtil:getIconInfo(type)
	return getConfig("war_order_type", type, "buy_icon");
end



-------------------------------- 战令任务 --------------------------------

function Lua_WarOrderUtil:getTaskInfo(id)
	return getConfig("war_order_task", id);
end

function Lua_WarOrderUtil:getTaskOrderType(id)
	return getConfig("war_order_task", id, "war_order");
end