Lua_WildMineRegionVo = class("Lua_WildMineRegionVo")
function Lua_WildMineRegionVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_WildMineRegionVo:fromServer(msg)
	if msg == nil then
		self._flag = 0;
		self._lock_flag = 0;
		self._role_num = 0;
		self._show_role = nil;
	else
		self._flag = msg.flag; -- 是否在该区域中 1：是 0：否
		self._lock_flag = msg.lock_flag; -- 是否解锁 1：解锁 0：未解锁
		self._role_num = msg.num; -- 区域内玩家数量
		self._show_role = msg.show_role; -- 角色
	end
end

function Lua_WildMineRegionVo.Get:flag()
	return self._flag or 0;
end

function Lua_WildMineRegionVo.Get:lockFlag()
	return self._lock_flag or 0;
end

function Lua_WildMineRegionVo.Get:roleNum()
	return self._role_num or 0;
end

function Lua_WildMineRegionVo.Get:showRole()
	return self._show_role;
end

function Lua_WildMineRegionVo.Get:config()
	if self._config == nil then
		return getConfig("wild_secret_mine_region", self.id);
	end
	return self._config;
end

function Lua_WildMineRegionVo.Get:name()
	return self.config.name;
end

function Lua_WildMineRegionVo.Get:isSecure()
	return self.config.is_secure_region == 1;
end

function Lua_WildMineRegionVo.Get:mapNum()
	return self.config.map_num or 0;
end

function Lua_WildMineRegionVo.Get:teamNum()
	return self.config.team_num or 0;
end

function Lua_WildMineRegionVo.Get:floorId()
	return self.config.floor_id or 0;
end

function Lua_WildMineRegionVo.Get:bgSprite()
	return self.config.bg_sprite;
end

function Lua_WildMineRegionVo.Get:bgPath()
	return self.config.bg_path;
end

function Lua_WildMineRegionVo.Get:pointPos()
	return self.config.point_pos or {};
end