checkRequire("Lua_WildSecretUtil");
checkRequire("Lua_WildSecretData");
Lua_WildSecretProxy = class("Lua_WildSecretProxy")
function Lua_WildSecretProxy:ctor()
	DataCenter.wildSecretUtil = Lua_WildSecretUtil.new();
	DataCenter.wildSecretData = Lua_WildSecretData.new();

	Lua_MsgUtil.addLuaMsg(50218002, self, self.rStageInfo); -- 请求蛮荒跃境关卡信息返回
	Lua_MsgUtil.addLuaMsg(50218003, self, self.rStageReward); -- 请求莽荒跃境关卡奖励信息返回
	Lua_MsgUtil.addLuaMsg(50218005, self, self.rReceiveDailyReward); -- 请求领取蛮荒跃境关卡每日奖励返回
	Lua_MsgUtil.addLuaMsg(50218006, self, self.rFriendInfo); -- 请求蛮荒跃境关卡好友通关信息返回
	Lua_MsgUtil.addLuaMsg(50218007, self, self.rStageRank); -- 求蛮荒秘境关卡排行榜返回
	Lua_MsgUtil.addLuaMsg(50218008, self, self.rStageRankLike); -- 请求蛮荒秘境关卡排行榜点赞

	Lua_MsgUtil.addLuaMsg(50218001, self, self.rLodePointInfo); -- 请求蛮荒秘境矿点信息返回
	Lua_MsgUtil.addLuaMsg(50218009, self, self.rLodeSelfInfo); -- 请求查看自己矿位信息返回
	Lua_MsgUtil.addLuaMsg(50218010, self, self.rLodeGiveUp); -- 请求放弃蛮荒秘境矿位返回
	Lua_MsgUtil.addLuaMsg(50218011, self, self.rLodeFightRecord); -- 请求蛮荒秘境战斗记录返回
	Lua_MsgUtil.addLuaMsg(50218012, self, self.rLodeRecommInfo); -- 请求蛮荒秘境匹配信息返回
	Lua_MsgUtil.addLuaMsg(50218015, self, self.rLodeMapInfo); -- 请求蛮荒秘境矿区信息返回
	Lua_MsgUtil.addLuaMsg(50218016, self, self.rLodePointLineup); -- 请求矿点玩家阵容信息返回
	Lua_MsgUtil.addLuaMsg(50218017, self, self.rLodeRevengeRecord); -- 请求蛮荒秘境复仇列表信息返回
	Lua_MsgUtil.addLuaMsg(50218018, self, self.rLodeRank); -- 请求蛮荒秘境积分排行返回
	Lua_MsgUtil.addLuaMsg(50218019, self, self.rLodeRankLike); -- 请求蛮荒秘境积分排行点赞返回
	Lua_MsgUtil.addLuaMsg(50218020, self, self.rLodeUnlockInfo); -- 请求蛮荒秘境矿位解锁信息
	Lua_MsgUtil.addLuaMsg(50218021, self, self.rLodeRegionInfo); -- 请求蛮荒秘境矿脉信息返回
	Lua_MsgUtil.addLuaMsg(50218022, self, self.rLodeIncomeInfo); -- 请求蛮荒秘境矿位收益信息返回
	Lua_MsgUtil.addLuaMsg(50218023, self, self.rLodeFriendInfo); -- 请求蛮荒秘境区域角色信息返回
	Lua_MsgUtil.addLuaMsg(50218024, self, self.rLodeFightCheck); -- 请求蛮荒秘境矿点战前检测返回

	Lua_MsgUtil.addLuaMsg(80218014, self, self.updateReport); -- 通知蛮荒秘境矿场报告
	Lua_MsgUtil.addLuaMsg(80218025, self, self.updateRedPoint); -- 通知蛮荒秘境红点
end

------------------ 上行 ------------------
-- 请求蛮荒跃境关卡信息
function Lua_WildSecretProxy:sStageInfo(bCheckWin)
	if bCheckWin == true and not Lua_WindowUtil.isWindowShowing("Lua_WildSecretWindow") then
		return;
	end
	sendMsg(10218002);
end

-- 请求莽荒跃境关卡奖励信息
function Lua_WildSecretProxy:sStageReward()
	sendMsg(10218003);
end

-- 请求领取蛮荒跃境关卡奖励
function Lua_WildSecretProxy:sReceiveStageReward(reward_id)
	local cmd = ProtoPublic_pb.Proto10218004();
	cmd.reward_id = reward_id;
	sendMsg(10218004, cmd);
end

-- 请求领取蛮荒跃境关卡每日奖励
function Lua_WildSecretProxy:sReceiveDailyReward()
	sendMsg(10218005);
end

-- 请求蛮荒跃境关卡好友通关信息
function Lua_WildSecretProxy:sFriendInfo(stage)
	local cmd = ProtoPublic_pb.Proto10218006();
	cmd.stage = stage;
	sendMsg(10218006, cmd);
end

-- 请求蛮荒秘境关卡排行榜
function Lua_WildSecretProxy:sStageRank(page)
	local cmd = ProtoPublic_pb.Proto10218007();
	cmd.page = page;
	sendMsg(10218007, cmd);
end

-- 请求蛮荒秘境关卡排行榜点赞
function Lua_WildSecretProxy:sStageRankLike(id)
	local cmd = ProtoPublic_pb.Proto10218008();
	cmd.id = tonumber(id);
	sendMsg(10218008, cmd);
end

-- 请求蛮荒秘境矿点信息
function Lua_WildSecretProxy:sLodePointInfo(region, map_id)
	local cmd = ProtoPublic_pb.Proto10218001();
	cmd.region = region;
	cmd.map_id = map_id;
	sendMsg(10218001, cmd);
end

-- 请求查看自己矿位信息
function Lua_WildSecretProxy:sLodeSelfInfo()
	sendMsg(10218009);
end

-- 请求放弃蛮荒秘境矿位
function Lua_WildSecretProxy:sLodeGiveUp(num)
	local cmd = ProtoPublic_pb.Proto10218010();
	cmd.num = num;
	sendMsg(10218010, cmd);
end

-- 请求蛮荒秘境战斗记录
function Lua_WildSecretProxy:sLodeFightRecord()
	sendMsg(10218011);
end

-- 请求蛮荒秘境匹配信息
function Lua_WildSecretProxy:sLodeRecommInfo()
	sendMsg(10218012);
end

-- 请求刷新蛮荒秘境匹配信息
function Lua_WildSecretProxy:sLodeRecommRefresh()
	sendMsg(10218013);
end

-- 请求蛮荒秘境矿区信息
function Lua_WildSecretProxy:sLodeMapInfo(region)
	local cmd = ProtoPublic_pb.Proto10218015();
	cmd.region = region;
	sendMsg(10218015, cmd);
end

-- 请求矿点玩家阵容信息
function Lua_WildSecretProxy:sLodePointLineup(region_id)
	local cmd = ProtoPublic_pb.Proto10218016();
	cmd.region_id = region_id;
	sendMsg(10218016, cmd);
end

-- 请求蛮荒秘境复仇列表信息
function Lua_WildSecretProxy:sLodeRevengeRecord()
	sendMsg(10218017);
end

-- 请求蛮荒秘境积分排行
function Lua_WildSecretProxy:sLodeRank(page)
	local cmd = ProtoPublic_pb.Proto10218018();
	cmd.page = page;
	sendMsg(10218018, cmd);
end

-- 请求蛮荒秘境积分排行点赞
function Lua_WildSecretProxy:sLodeRankLike(id)
	local cmd = ProtoPublic_pb.Proto10218019();
	cmd.role_id = tonumber(id);
	sendMsg(10218019, cmd);
end

-- 请求蛮荒秘境矿位解锁信息
function Lua_WildSecretProxy:sLodeUnlockInfo()
	sendMsg(10218020);
end

-- 请求蛮荒秘境矿点区域信息
function Lua_WildSecretProxy:sLodeRegionInfo()
	sendMsg(10218021);
end

-- 请求蛮荒秘境矿位收益信息
function Lua_WildSecretProxy:sLodeIncomeInfo()
	sendMsg(10218022);
end

-- 请求蛮荒秘境区域角色信息
function Lua_WildSecretProxy:sLodeFriendInfo(regoin)
	local cmd = ProtoPublic_pb.Proto10218023();
	cmd.regoin = regoin;
	sendMsg(10218023, cmd);
end

-- 请求蛮荒秘境矿点战前检测
function Lua_WildSecretProxy:sLodeFightCheck(mine_site_id, player_id, type)
	local cmd = ProtoPublic_pb.Proto10218024();
	cmd.mine_site_id = mine_site_id;
	cmd.player_id = tonumber(player_id);
	cmd.type = type;
	sendMsg(10218024, cmd);
end

-- 请求确认蛮荒秘境矿点报告信息
function Lua_WildSecretProxy:sLodeTips(mine_site_id)
	local cmd = ProtoPublic_pb.Proto10218026();
	cmd.mine_site_id = mine_site_id;
	sendMsg(10218026, cmd);
end

------------------ 下行 ------------------
-- 请求蛮荒跃境关卡信息返回
function Lua_WildSecretProxy:rStageInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218002();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer50218002(msg);
		Lua_MsgUtil.callFunc("WILD_SECRET_STAGE_INFO");
	end
end

-- 请求莽荒跃境关卡奖励信息返回
function Lua_WildSecretProxy:rStageReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218003();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer50218003(msg);
		Lua_MsgUtil.callFunc("WILD_SECRET_STAGE_REWARD");
	end
end

-- 请求领取蛮荒跃境关卡每日奖励返回
function Lua_WildSecretProxy:rReceiveDailyReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218005();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer50218005(msg);
		Lua_WindowUtil.openWin("Lua_WildStageDailyRewardWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

-- 请求蛮荒跃境关卡好友通关信息返回
function Lua_WildSecretProxy:rFriendInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_STAGE_FRIEND", msg);
	end
end

-- 请求蛮荒跃境关卡好友通关信息返回
function Lua_WildSecretProxy:rStageRank(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_RANK", msg);
	end
end

-- 请求蛮荒跃境关卡好友通关信息返回
function Lua_WildSecretProxy:rStageRankLike(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218008();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LIKE", msg);
	end
end

-- 请求蛮荒秘境矿点信息返回
function Lua_WildSecretProxy:rLodePointInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218001();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer50218001(msg);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_POINT");
	end
end

-- 请求查看自己矿位信息返回
function Lua_WildSecretProxy:rLodeSelfInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218009();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer50218009(msg);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_SELF", msg);
	end
end

-- 请求放弃蛮荒秘境矿位返回
function Lua_WildSecretProxy:rLodeGiveUp(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_GIVEUP");
	end
end

-- 请求蛮荒秘境战斗记录返回
function Lua_WildSecretProxy:rLodeFightRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218011();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_RECORD", msg);
	end
end

-- 请求蛮荒秘境匹配信息返回
function Lua_WildSecretProxy:rLodeRecommInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218012();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_RECOMM", msg);
	end
end

-- 请求蛮荒秘境矿区信息返回
function Lua_WildSecretProxy:rLodeMapInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218015();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_MAP", msg);
	end
end

-- 请求矿点玩家阵容信息返回
function Lua_WildSecretProxy:rLodePointLineup(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218016();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_POINT_LINEUP", msg);
	end
end

-- 请求蛮荒秘境复仇列表信息返回
function Lua_WildSecretProxy:rLodeRevengeRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218017();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_RECORD", msg);
	end
end

-- 请求蛮荒秘境积分排行返回
function Lua_WildSecretProxy:rLodeRank(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218018();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_RANK", msg);
	end
end

-- 请求蛮荒秘境积分排行点赞返回
function Lua_WildSecretProxy:rLodeRankLike(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218019();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LIKE", msg);
	end
end

-- 请求蛮荒秘境矿位解锁信息
function Lua_WildSecretProxy:rLodeUnlockInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218020();
		msg:ParseFromString(mp.data);
		if msg.num > 0 then
			Lua_WindowUtil.openWin("Lua_WildLodeUnlockWindow", Lua_WinParam.ACTION_OPEN, msg);
		else
			self:sStageInfo(true);
		end
	end
end

-- 请求蛮荒秘境矿脉信息返回
function Lua_WildSecretProxy:rLodeRegionInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218021();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer50218021(msg);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_REGION");
	end
end

-- 请求蛮荒秘境矿位收益信息返回
function Lua_WildSecretProxy:rLodeIncomeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218022();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_INCOME", msg);
	end
end

-- 请求蛮荒秘境区域角色信息返回
function Lua_WildSecretProxy:rLodeFriendInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218023();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_FRIEND", msg);
	end
end

-- 请求蛮荒秘境矿点战前检测返回
function Lua_WildSecretProxy:rLodeFightCheck(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50218024();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_FIGHT_CHECK", msg);
	end
end

-- 通知蛮荒秘境矿场报告
function Lua_WildSecretProxy:updateReport(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80218014();
		msg:ParseFromString(mp.data);
		DataCenter.wildSecretData:fromServer80218014(msg);
		Lua_MsgUtil.callFunc("WILD_SECRET_LODE_REPORT");
	end
end

-- 通知蛮荒秘境红点
function Lua_WildSecretProxy:updateRedPoint(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80218025();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.WildSecret_Lode_Record, state == 1);
		end
	end
end