Lua_WildSecretUtil = class("Lua_WildSecretUtil")
function Lua_WildSecretUtil:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_WildSecretUtil:dispose()
	self.bStageRewardSort = true;
end

function Lua_WildSecretUtil.Get:tabList()
	if self._tabList == nil then
		self._tabList = Array();
		self._tabList:add({ textAtlas = "wild_secret_atlas", textNormalSprite = "xui_mhyj_zgnbutton_1_n", textSelectedSprite = "xui_mhyj_zgnbutton_1_p",
			panel = "Lua_WildStagePanel", redPointId = Lua_RedPointList.WildSecret_Stage });
		self._tabList:add({ textAtlas = "wild_secret_atlas", textNormalSprite = "xui_mhyj_zgnbutton_2_n", textSelectedSprite = "xui_mhyj_zgnbutton_2_p",
			panel = "Lua_WildLodePanel", redPointId = Lua_RedPointList.WildSecret_Lode });
		self._tabList:add({ textAtlas = "wild_secret_atlas", textNormalSprite = "xui_mhyj_zgnbutton_3_n", textSelectedSprite = "xui_mhyj_zgnbutton_3_p",
			funcPathId = 1163 });
	end
	return self._tabList;
end

function Lua_WildSecretUtil.Get:rankList()
	if self._rankList == nil then
		self._rankList = Array();
		self._rankList:add({ textAtlas = "wild_secret_atlas", textNormalSprite = "xui_mhyj_zgnbutton_1_n", textSelectedSprite = "xui_mhyj_zgnbutton_1_p"});
		self._rankList:add({ textAtlas = "wild_secret_atlas", textNormalSprite = "xui_mhyj_zgnbutton_2_n", textSelectedSprite = "xui_mhyj_zgnbutton_2_p"});
	end
	return self._rankList;
end

function Lua_WildSecretUtil.Get:luckValue()
	return getConfig("wild_secret_const", "luck_value", "value") or 0;
end

function Lua_WildSecretUtil.Get:restTick()
	return getConfig("wild_secret_const", "rest_tick", "jsonvalue");
end

-- 点赞上限
function Lua_WildSecretUtil.Get:limitLikeTimes()
	return getConfig("wild_secret_const", "praise_num", "value") or 0;
end

-- 抢夺百分比
function Lua_WildSecretUtil.Get:grabRate()
	return getConfig("wild_secret_const", "grab_rate", "value") / 100 or 0;
end

-- PVE关卡自动挑战下一关层数要求
function Lua_WildSecretUtil.Get:nextFightLimit()
	return getConfig("wild_secret_const", "stage_next_fight_limit", "value") or 1;
end

-- 每日通关上限
function Lua_WildSecretUtil.Get:dailyStageLimit()
	return getConfig("wild_secret_const", "daily_stage_limit", "value") or 40;
end

-- PVE关卡战斗跳过限制
function Lua_WildSecretUtil.Get:fightSkipLimit()
	return getConfig("wild_secret_const", "stage_fight_skip_limit", "value") or 1001;
end

function Lua_WildSecretUtil.Get:stageRewardList()
	if self._stageRewardList == nil then
		self._stageRewardList = Array();
		local config = getConfig("wild_secret_stage_extra_reward");
		for k, _ in pairs(config) do
			self._stageRewardList:add(k);
		end
	end
	if self.bStageRewardSort then
		self.bStageRewardSort = false;
		self._stageRewardList:sortf(self, self.onStageRewardSort);
	end
	return self._stageRewardList;
end

function Lua_WildSecretUtil:onStageRewardSort(a, b)
	local state_a = DataCenter.wildSecretData:getStageRewardState(a);
	local state_b = DataCenter.wildSecretData:getStageRewardState(b);
	if state_a == state_b then
		if a > b then
			return false;
		end
	elseif state_a == 2 and state_a > state_b then
		return false;
	end
	return true;
end

function Lua_WildSecretUtil:getStageRewardConfig(id)
	return getConfig("wild_secret_stage_extra_reward", id);
end

function Lua_WildSecretUtil:getStageRewardInfo()
	local arr = self.stageRewardList;
	local id = arr[1];
	local state = DataCenter.wildSecretData:getStageRewardState(id);
	if state == 1 then
		return id, LanUtil.getValue(701003);
	end

	local curIdx = DataCenter.wildSecretData.curIdx;
	local config;
	for i = 1, arr:getSize() do
		id = arr[i];
		state = DataCenter.wildSecretData:getStageRewardState(id);
		if state == 0 then
			config = DataCenter.wildSecretUtil:getStageRewardConfig(id);
			config = DataCenter.wildSecretUtil:getStageConfig(config.stage_id);
			return id, LanUtil.formateStr(701004, config.index - curIdx);
		end
	end
	return nil;
end

function Lua_WildSecretUtil:getStageList(floor)
	if self._stageDic == nil then
		self._stageDic = {};
		local config = getConfig("wild_secret_stage");
		for k, v in pairs(config) do
			if self._stageDic[v.floor] == nil then
				self._stageDic[v.floor] = Array();
				self._stageDic[v.floor]:add(99999);
			end
			self._stageDic[v.floor]:add(k);
		end
		for _, v in pairs(self._stageDic) do
			quickSort(v, nil, false);
		end
	end
	return self._stageDic[floor];
end

function Lua_WildSecretUtil:getStageConfig(id)
	return getConfig("wild_secret_stage", id);
end





------------------------------
function Lua_WildSecretUtil:getLodePointConfig(id)
	return getConfig("wild_secret_mine_site", id);
end