-- 时空争霸
Lua_TimeSpaceRaceItem = class("Lua_TimeSpaceRaceItem", Lua_DisplayObject)
function Lua_TimeSpaceRaceItem:ctor(p)
	self:superCall("ctor", p, "TimeSpaceRaceItem_skin");
end

function Lua_TimeSpaceRaceItem:buildShowItem()
	self:superCall("buildShowItem");
	self.btnFight:addClickFuntion(self, self.onFight);
end

function Lua_TimeSpaceRaceItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_TimeSpaceRaceItem:setData(data)
	self.data = data;
	if data.rank > 3 then
		self.rankIcon:setEnable(false);
		self.rankText:setEnable(true);
		self.rankText.text = data.rank;
	else
		self.rankIcon:setEnable(true);
		self.rankIcon:setAltas("championship_1", "xui_jys_label_"..(data.rank + 16));
		self.rankText:setEnable(false);
	end
	if data.type == 2 or data.type == 3 then
		self.nameText.text = data.show_role.name;
		self.bubbleBg:setEnable(true);
		self.bubbleText:setEnable(true);
		self.bubbleText:setLangValue(770033 + data.type);
	else
		if data.type == 1 then
			self.nameText.text = data.show_role.name;
		else
			self.nameText.text = LanUtil.formateStr(10051, data.show_role.server_prev, data.show_role.name);
		end
		self.bubbleBg:setEnable(false);
		self.bubbleText:setEnable(false);
	end
	self.nameText:resetSize();
	self.forceText.text = data.show_role.force;
	self.selfIcon:setEnable(DataCenter.roleData:isMyself(data));
	self.selfIcon:setLocation(self.nameText.width / 2 + 40, -41, 0);
	self.btnFight:setEnable(data.is_can_fight == 1);
end

function Lua_TimeSpaceRaceItem:onFight(go)
	if DataCenter.timeSpaceRaceData.leftFightTimes > 0 then
		Lua_MsgUtil.callFunc("TIME_SPACE_RACE_FIGHT", tonumber(self.data.id));
	elseif DataCenter.timeSpaceRaceData.leftBuyTimes > 0 then
		Lua_WindowUtil.openWin("Lua_TimeSpaceBuyTimesWindow", Lua_WinParam.ACTION_OPEN);
	else
		OperateAlert.showLangValue(770009);
	end
end